/*
 * -------------------------------------------
 *    MSP432 DriverLib - v01_03_00_17 
 * -------------------------------------------
 *
 * --COPYRIGHT--,BSD,BSD
 * Copyright (c) 2014, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/
/* Remap existing defines to new names */
#define AES256_ACTL0 (HWREG16(0x40003C00))
#define AES256_ACTL1 (HWREG16(0x40003C02))
#define AES256_ADIN (HWREG16(0x40003C08))
#define AES256_ADOUT (HWREG16(0x40003C0A))
#define AES256_AKEY (HWREG16(0x40003C06))
#define AES256_ASTAT (HWREG16(0x40003C04))
#define AES256_AXDIN (HWREG16(0x40003C0C))
#define AES256_AXIN (HWREG16(0x40003C0E))
#define COMP_E0_CTL0 (HWREG16(0x40003400))
#define COMP_E0_CTL1 (HWREG16(0x40003402))
#define COMP_E0_CTL2 (HWREG16(0x40003404))
#define COMP_E0_CTL3 (HWREG16(0x40003406))
#define COMP_E0_INT (HWREG16(0x4000340C))
#define COMP_E0_IV (HWREG16(0x4000340E))
#define CS_ACC (HWREG32(0x40010400))
#define CS_CLKEN (HWREG32(0x40010430))
#define CS_CLRIFG (HWREG32(0x40010450))
#define CS_CTL0 (HWREG32(0x40010404))
#define CS_CTL1 (HWREG32(0x40010408))
#define CS_CTL2 (HWREG32(0x4001040C))
#define CS_CTL3 (HWREG32(0x40010410))
#define CS_CTL4 (HWREG32(0x40010414))
#define CS_CTL5 (HWREG32(0x40010418))
#define CS_CTL6 (HWREG32(0x4001041C))
#define CS_CTL7 (HWREG32(0x40010420))
#define CS_DCOERCAL (HWREG32(0x40010460))
#define CS_IE (HWREG32(0x40010440))
#define CS_IFG (HWREG32(0x40010448))
#define CS_SETIFG (HWREG32(0x40010458))
#define CS_STAT (HWREG32(0x40010434))
//#define P10_DIR (HWREG16(0x40004C85))
//#define P10_IE (HWREG16(0x40004C9B))
//#define P10_IES (HWREG16(0x40004C99))
//#define P10_IFG (HWREG16(0x40004C9D))
//#define P10_IN (HWREG16(0x40004C81))
//#define P10_OUT (HWREG16(0x40004C83))
//#define P10_REN (HWREG16(0x40004C87))
//#define P10_SEL0 (HWREG16(0x40004C8B))
//#define P10_SEL1 (HWREG16(0x40004C8D))
//#define P1_DIR (HWREG16(0x40004C04))
//#define P1_IE (HWREG16(0x40004C1A))
//#define P1_IES (HWREG16(0x40004C18))
//#define P1_IFG (HWREG16(0x40004C1C))
//#define P1_IN (HWREG16(0x40004C00))
//#define P1_OUT (HWREG16(0x40004C02))
//#define P1_REN (HWREG16(0x40004C06))
//#define P1_SEL0 (HWREG16(0x40004C0A))
//#define P1_SEL1 (HWREG16(0x40004C0C))
//#define P2_DIR (HWREG16(0x40004C05))
//#define P2_IE (HWREG16(0x40004C1B))
//#define P2_IES (HWREG16(0x40004C19))
//#define P2_IFG (HWREG16(0x40004C1D))
//#define P2_IN (HWREG16(0x40004C01))
//#define P2_OUT (HWREG16(0x40004C03))
//#define P2_REN (HWREG16(0x40004C07))
//#define P2_SEL0 (HWREG16(0x40004C0B))
//#define P2_SEL1 (HWREG16(0x40004C0D))
//#define P3_DIR (HWREG16(0x40004C24))
//#define P3_IE (HWREG16(0x40004C3A))
//#define P3_IES (HWREG16(0x40004C38))
//#define P3_IFG (HWREG16(0x40004C3C))
//#define P3_IN (HWREG16(0x40004C20))
//#define P3_OUT (HWREG16(0x40004C22))
//#define P3_REN (HWREG16(0x40004C26))
//#define P3_SEL0 (HWREG16(0x40004C2A))
//#define P3_SEL1 (HWREG16(0x40004C2C))
//#define P4_DIR (HWREG16(0x40004C25))
//#define P4_IE (HWREG16(0x40004C3B))
//#define P4_IES (HWREG16(0x40004C39))
//#define P4_IFG (HWREG16(0x40004C3D))
//#define P4_IN (HWREG16(0x40004C21))
//#define P4_OUT (HWREG16(0x40004C23))
//#define P4_REN (HWREG16(0x40004C27))
//#define P4_SEL0 (HWREG16(0x40004C2B))
//#define P4_SEL1 (HWREG16(0x40004C2D))
//#define P5_DIR (HWREG16(0x40004C44))
//#define P5_IE (HWREG16(0x40004C5A))
//#define P5_IES (HWREG16(0x40004C58))
//#define P5_IFG (HWREG16(0x40004C5C))
//#define P5_IN (HWREG16(0x40004C40))
//#define P5_OUT (HWREG16(0x40004C42))
//#define P5_REN (HWREG16(0x40004C46))
//#define P5_SEL0 (HWREG16(0x40004C4A))
//#define P5_SEL1 (HWREG16(0x40004C4C))
//#define P6_DIR (HWREG16(0x40004C45))
//#define P6_IE (HWREG16(0x40004C5B))
//#define P6_IES (HWREG16(0x40004C59))
//#define P6_IFG (HWREG16(0x40004C5D))
//#define P6_IN (HWREG16(0x40004C41))
//#define P6_OUT (HWREG16(0x40004C43))
//#define P6_REN (HWREG16(0x40004C47))
//#define P6_SEL0 (HWREG16(0x40004C4B))
//#define P6_SEL1 (HWREG16(0x40004C4D))
//#define P7_DIR (HWREG16(0x40004C64))
//#define P7_IE (HWREG16(0x40004C7A))
//#define P7_IES (HWREG16(0x40004C78))
//#define P7_IFG (HWREG16(0x40004C7C))
//#define P7_IN (HWREG16(0x40004C60))
//#define P7_OUT (HWREG16(0x40004C62))
//#define P7_REN (HWREG16(0x40004C66))
//#define P7_SEL0 (HWREG16(0x40004C6A))
//#define P7_SEL1 (HWREG16(0x40004C6C))
//#define P8_DIR (HWREG16(0x40004C65))
//#define P8_IE (HWREG16(0x40004C7B))
//#define P8_IES (HWREG16(0x40004C79))
//#define P8_IFG (HWREG16(0x40004C7D))
//#define P8_IN (HWREG16(0x40004C61))
//#define P8_OUT (HWREG16(0x40004C63))
//#define P8_REN (HWREG16(0x40004C67))
//#define P8_SEL0 (HWREG16(0x40004C6B))
//#define P8_SEL1 (HWREG16(0x40004C6D))
//#define P9_DIR (HWREG16(0x40004C84))
//#define P9_IE (HWREG16(0x40004C9A))
//#define P9_IES (HWREG16(0x40004C98))
//#define P9_IFG (HWREG16(0x40004C9C))
//#define P9_IN (HWREG16(0x40004C80))
//#define P9_OUT (HWREG16(0x40004C82))
//#define P9_REN (HWREG16(0x40004C86))
//#define P9_SEL0 (HWREG16(0x40004C8A))
//#define P9_SEL1 (HWREG16(0x40004C8C))
//#define PA_DIR (HWREG16(0x40004C04))
//#define PA_IE (HWREG16(0x40004C1A))
//#define PA_IES (HWREG16(0x40004C18))
//#define PA_IFG (HWREG16(0x40004C1C))
//#define PA_IN (HWREG16(0x40004C00))
//#define PA_OUT (HWREG16(0x40004C02))
//#define PA_REN (HWREG16(0x40004C06))
//#define PA_SEL0 (HWREG16(0x40004C0A))
//#define PA_SEL1 (HWREG16(0x40004C0C))
//#define PB_DIR (HWREG16(0x40004C24))
//#define PB_IE (HWREG16(0x40004C3A))
//#define PB_IES (HWREG16(0x40004C38))
//#define PB_IFG (HWREG16(0x40004C3C))
//#define PB_IN (HWREG16(0x40004C20))
//#define PB_OUT (HWREG16(0x40004C22))
//#define PB_REN (HWREG16(0x40004C26))
//#define PB_SEL0 (HWREG16(0x40004C2A))
//#define PB_SEL1 (HWREG16(0x40004C2C))
//#define PC_DIR (HWREG16(0x40004C44))
//#define PC_IE (HWREG16(0x40004C5A))
//#define PC_IES (HWREG16(0x40004C58))
//#define PC_IFG (HWREG16(0x40004C5C))
//#define PC_IN (HWREG16(0x40004C40))
//#define PC_OUT (HWREG16(0x40004C42))
//#define PC_REN (HWREG16(0x40004C46))
//#define PC_SEL0 (HWREG16(0x40004C4A))
//#define PC_SEL1 (HWREG16(0x40004C4C))
//#define PD_DIR (HWREG16(0x40004C64))
//#define PD_IN (HWREG16(0x40004C60))
//#define PD_OUT (HWREG16(0x40004C62))
//#define PD_REN (HWREG16(0x40004C66))
//#define PD_SEL0 (HWREG16(0x40004C6A))
//#define PD_SEL1 (HWREG16(0x40004C6C))
//#define PE_DIR (HWREG16(0x40004C84))
//#define PE_IN (HWREG16(0x40004C80))
//#define PE_OUT (HWREG16(0x40004C82))
//#define PE_REN (HWREG16(0x40004C86))
//#define PE_SEL0 (HWREG16(0x40004C8A))
//#define PE_SEL1 (HWREG16(0x40004C8C))
//#define PJ_DIR (HWREG16(0x40004D24))
//#define PJ_IN (HWREG16(0x40004D20))
//#define PJ_OUT (HWREG16(0x40004D22))
//#define PJ_REN (HWREG16(0x40004D26))
//#define PJ_SEL0 (HWREG16(0x40004D2A))
//#define PJ_SEL1 (HWREG16(0x40004D2C))
#define PMAP_CTL (HWREG16(0x40005002))
#define PMAP_KEYID (HWREG16(0x40005000))
#define REF_A_CTL0 (HWREG16(0x40003000))
#define RTC_C_ADAY (HWREG8_H(RTCADOWDAY))
#define RTC_C_ADOW (HWREG8_L(RTCADOWDAY))
#define RTC_ADAY (HWREG8_H(RTCADOWDAY))
#define RTC_ADOW (HWREG8_L(RTCADOWDAY))
#define RTC_C_AHOUR (HWREG8_H(RTCAMINHR))
#define RTC_C_AMIN (HWREG8_L(RTCAMINHR))
//#define RTCAMINHR_L (HWREG16(0x40004418))
#define RTC_AHOUR (HWREG8_H(RTCAMINHR))
#define RTC_AMIN (HWREG8_L(RTCAMINHR))
#define RTC_C_CTL0 (HWREG16(0x40004400))
#define RTC_C_CTL1 (HWREG8_L(RTCCTL13))
#define RTC_C_CTL3 (HWREG8_H(RTCCTL13))
//#define RTCDATE_L (HWREG16(0x40004414))
#define RTC_MON (HWREG8_H(RTCDATE))
#define RTC_DAY (HWREG8_L(RTCDATE))
#define RTC_C_DAY (HWREG8_L(RTCDATE))
#define RTC_C_DOW (HWREG8_H(RTCTIM1))
#define RTC_C_HOUR (HWREG8_L(RTCTIM1))
#define RTC_C_IV (HWREG16(0x4000440E))
#define RTC_C_MIN (HWREG8_H(RTCTIM0))
#define RTC_C_MON (HWREG8_H(RTCDATE))
#define RTC_C_OCAL (HWREG16(0x40004404))
#define RTCPS (HWREG16(0x4000440C))
#define RTC_C_PS0CTL (HWREG16(0x40004408))
#define RTC_C_PS1CTL (HWREG16(0x4000440A))
#define RTCPS1 (HWREG8_H(RTCPS))
#define RTC_C_SEC (HWREG8_L(RTCTIM0))
#define RTC_C_TCMP (HWREG16(0x40004406))
//#define RTCTIM0_L (HWREG16(0x40004410))
#define RTC_MIN (HWREG8_H(RTCTIM0))
#define RTC_DOW (HWREG8_H(RTCTIM1))
#define RTC_HOUR (HWREG8_L(RTCTIM1))
#define RTC_C_YEAR (HWREG16(0x40004416))
#define TA0_CCR0 (HWREG16(0x40000012))
#define TA0_CCR1 (HWREG16(0x40000014))
#define TA0_CCR2 (HWREG16(0x40000016))
#define TA0_CCR3 (HWREG16(0x40000018))
#define TA0_CCR4 (HWREG16(0x4000001A))
#define TA0_CCR5 (HWREG16(0x4000001C))
#define TA0_CCR6 (HWREG16(0x4000001E))
#define TA0_CCTL0 (HWREG16(0x40000002))
#define TA0_CCTL1 (HWREG16(0x40000004))
#define TA0_CCTL2 (HWREG16(0x40000006))
#define TA0_CCTL3 (HWREG16(0x40000008))
#define TA0_CCTL4 (HWREG16(0x4000000A))
#define TA0_CCTL5 (HWREG16(0x4000000C))
#define TA0_CCTL6 (HWREG16(0x4000000E))
#define TA0_CTL (HWREG16(0x40000000))
#define TA0_EX0 (HWREG16(0x40000020))
#define TA0_IV (HWREG16(0x4000002E))
#define TA0_R (HWREG16(0x40000010))
#define TA1_CCR0 (HWREG16(0x40000412))
#define TA1_CCR1 (HWREG16(0x40000414))
#define TA1_CCR2 (HWREG16(0x40000416))
#define TA1_CCR3 (HWREG16(0x40000418))
#define TA1_CCR4 (HWREG16(0x4000041A))
#define TA1_CCR5 (HWREG16(0x4000041C))
#define TA1_CCR6 (HWREG16(0x4000041E))
#define TA1_CCTL0 (HWREG16(0x40000402))
#define TA1_CCTL1 (HWREG16(0x40000404))
#define TA1_CCTL2 (HWREG16(0x40000406))
#define TA1_CCTL3 (HWREG16(0x40000408))
#define TA1_CCTL4 (HWREG16(0x4000040A))
#define TA1_CCTL5 (HWREG16(0x4000040C))
#define TA1_CCTL6 (HWREG16(0x4000040E))
#define TA1_CTL (HWREG16(0x40000400))
#define TA1_EX0 (HWREG16(0x40000420))
#define TA1_IV (HWREG16(0x4000042E))
#define TA1_R (HWREG16(0x40000410))
#define TA2_CCR0 (HWREG16(0x40000812))
#define TA2_CCR1 (HWREG16(0x40000814))
#define TA2_CCR2 (HWREG16(0x40000816))
#define TA2_CCR3 (HWREG16(0x40000818))
#define TA2_CCR4 (HWREG16(0x4000081A))
#define TA2_CCR5 (HWREG16(0x4000081C))
#define TA2_CCR6 (HWREG16(0x4000081E))
#define TA2_CCTL0 (HWREG16(0x40000802))
#define TA2_CCTL1 (HWREG16(0x40000804))
#define TA2_CCTL2 (HWREG16(0x40000806))
#define TA2_CCTL3 (HWREG16(0x40000808))
#define TA2_CCTL4 (HWREG16(0x4000080A))
#define TA2_CCTL5 (HWREG16(0x4000080C))
#define TA2_CCTL6 (HWREG16(0x4000080E))
#define TA2_CTL (HWREG16(0x40000800))
#define TA2_EX0 (HWREG16(0x40000820))
#define TA2_IV (HWREG16(0x4000082E))
#define TA2_R (HWREG16(0x40000810))
#define TA3_CCR0 (HWREG16(0x40000C12))
#define TA3_CCR1 (HWREG16(0x40000C14))
#define TA3_CCR2 (HWREG16(0x40000C16))
#define TA3_CCR3 (HWREG16(0x40000C18))
#define TA3_CCR4 (HWREG16(0x40000C1A))
#define TA3_CCR5 (HWREG16(0x40000C1C))
#define TA3_CCR6 (HWREG16(0x40000C1E))
#define TA3_CCTL0 (HWREG16(0x40000C02))
#define TA3_CCTL1 (HWREG16(0x40000C04))
#define TA3_CCTL2 (HWREG16(0x40000C06))
#define TA3_CCTL3 (HWREG16(0x40000C08))
#define TA3_CCTL4 (HWREG16(0x40000C0A))
#define TA3_CCTL5 (HWREG16(0x40000C0C))
#define TA3_CCTL6 (HWREG16(0x40000C0E))
#define TA3_CTL (HWREG16(0x40000C00))
#define TA3_EX0 (HWREG16(0x40000C20))
#define TA3_IV (HWREG16(0x40000C2E))
#define TA3_R (HWREG16(0x40000C10))
#define EUSCI_A0_UART_ABCTL (HWREG16(0x40001010))
#define UCA0BRW_L (HWREG8_L(UCA0BRW))
#define UCA0BRW_H (HWREG8_H(UCA0BRW))
#define EUSCI_A0_SPI_BRW (HWREG16(0x40001006))
#define UCA0CTLW0_H (HWREG8_L(UCA0CTLW0))
#define UCA0CTLW0_L (HWREG8_H(UCA0CTLW0))
#define EUSCI_A0_SPI_CTLW0 (HWREG16(0x40001000))
#define EUSCI_A0_UART_CTLW1 (HWREG16(0x40001002))
#define EUSCI_A0_SPI_IE (HWREG16(0x4000101A))
#define EUSCI_A0_SPI_IFG (HWREG16(0x4000101C))
#define EUSCI_A0_UART_IRCTL (HWREG16(0x40001012))
#define UCA0IRCTL_H (HWREG8_H(UCA0IRCTL))
#define UCA0IRCTL_L (HWREG8_L(UCA0IRCTL))
#define EUSCI_A0_SPI_IV (HWREG16(0x4000101E))
#define EUSCI_A0_UART_MCTLW (HWREG16(0x40001008))
#define EUSCI_A0_SPI_RXBUF (HWREG16(0x4000100C))
#define EUSCI_A0_SPI_STATW (HWREG16(0x4000100A))
#define EUSCI_A0_SPI_TXBUF (HWREG16(0x4000100E))
#define EUSCI_A1_UART_ABCTL (HWREG16(0x40001410))
#define UCA1BRW_L (HWREG8_L(UCA1BRW))
#define UCA1BRW_H (HWREG8_H(UCA1BRW))
#define EUSCI_A1_SPI_BRW (HWREG16(0x40001406))
#define UCA1CTLW0_H (HWREG8_L(UCA1CTLW0))
#define UCA1CTLW0_L (HWREG8_H(UCA1CTLW0))
#define EUSCI_A1_SPI_CTLW0 (HWREG16(0x40001400))
#define EUSCI_A1_UART_CTLW1 (HWREG16(0x40001402))
#define EUSCI_A1_SPI_IE (HWREG16(0x4000141A))
#define EUSCI_A1_SPI_IFG (HWREG16(0x4000141C))
#define EUSCI_A1_UART_IRCTL (HWREG16(0x40001412))
#define UCA1IRCTL_H (HWREG8_H(UCA1IRCTL))
#define UCA1IRCTL_L (HWREG8_L(UCA1IRCTL))
#define EUSCI_A1_SPI_IV (HWREG16(0x4000141E))
#define EUSCI_A1_UART_MCTLW (HWREG16(0x40001408))
#define EUSCI_A1_SPI_RXBUF (HWREG16(0x4000140C))
#define EUSCI_A1_SPI_STATW (HWREG16(0x4000140A))
#define EUSCI_A1_SPI_TXBUF (HWREG16(0x4000140E))
#define EUSCI_A2_UART_ABCTL (HWREG16(0x40001810))
#define UCA2BRW_L (HWREG8_L(UCA2BRW))
#define UCA2BRW_H (HWREG8_H(UCA2BRW))
#define EUSCI_A2_SPI_BRW (HWREG16(0x40001806))
#define UCA2CTLW0_H (HWREG8_L(UCA2CTLW0))
#define UCA2CTLW0_L (HWREG8_H(UCA2CTLW0))
#define EUSCI_A2_SPI_CTLW0 (HWREG16(0x40001800))
#define EUSCI_A2_UART_CTLW1 (HWREG16(0x40001802))
#define EUSCI_A2_SPI_IE (HWREG16(0x4000181A))
#define EUSCI_A2_SPI_IFG (HWREG16(0x4000181C))
#define EUSCI_A2_UART_IRCTL (HWREG16(0x40001812))
#define UCA2IRCTL_H (HWREG8_H(UCA2IRCTL))
#define UCA2IRCTL_L (HWREG8_L(UCA2IRCTL))
#define EUSCI_A2_SPI_IV (HWREG16(0x4000181E))
#define EUSCI_A2_UART_MCTLW (HWREG16(0x40001808))
#define EUSCI_A2_SPI_RXBUF (HWREG16(0x4000180C))
#define EUSCI_A2_SPI_STATW (HWREG16(0x4000180A))
#define EUSCI_A2_SPI_TXBUF (HWREG16(0x4000180E))
#define EUSCI_A3_UART_ABCTL (HWREG16(0x40001C10))
#define UCA3BRW_L (HWREG8_L(UCA3BRW))
#define UCA3BRW_H (HWREG8_H(UCA3BRW))
#define EUSCI_A3_SPI_BRW (HWREG16(0x40001C06))
#define UCA3CTLW0_H (HWREG8_L(UCA3CTLW0))
#define UCA3CTLW0_L (HWREG8_H(UCA3CTLW0))
#define EUSCI_A3_SPI_CTLW0 (HWREG16(0x40001C00))
#define EUSCI_A3_UART_CTLW1 (HWREG16(0x40001C02))
#define EUSCI_A3_SPI_IE (HWREG16(0x40001C1A))
#define EUSCI_A3_SPI_IFG (HWREG16(0x40001C1C))
#define EUSCI_A3_UART_IRCTL (HWREG16(0x40001C12))
#define UCA3IRCTL_H (HWREG8_H(UCA3IRCTL))
#define UCA3IRCTL_L (HWREG8_L(UCA3IRCTL))
#define EUSCI_A3_SPI_IV (HWREG16(0x40001C1E))
#define EUSCI_A3_UART_MCTLW (HWREG16(0x40001C08))
#define EUSCI_A3_SPI_RXBUF (HWREG16(0x40001C0C))
#define EUSCI_A3_SPI_STATW (HWREG16(0x40001C0A))
#define EUSCI_A3_SPI_TXBUF (HWREG16(0x40001C0E))
#define EUSCI_B0_I2C_ADDMASK (HWREG16(0x4000201E))
#define EUSCI_B0_I2C_ADDRX (HWREG16(0x4000201C))
#define UCB0BRW_L (HWREG8_L(UCB0BRW))
#define UCB0BRW_H (HWREG8_H(UCB0BRW))
#define EUSCI_B0_SPI_BRW (HWREG16(0x40002006))
#define UCB0CTLW0_H (HWREG8_L(UCB0CTLW0))
#define UCB0CTLW0_L (HWREG8_H(UCB0CTLW0))
#define EUSCI_B0_SPI_CTLW0 (HWREG16(0x40002000))
#define EUSCI_B0_I2C_I2COA0 (HWREG16(0x40002014))
#define EUSCI_B0_I2C_I2COA1 (HWREG16(0x40002016))
#define EUSCI_B0_I2C_I2COA2 (HWREG16(0x40002018))
#define EUSCI_B0_I2C_I2COA3 (HWREG16(0x4000201A))
#define EUSCI_B0_I2C_I2CSA (HWREG16(0x40002020))
#define EUSCI_B0_SPI_IE (HWREG16(0x4000202A))
#define EUSCI_B0_SPI_IFG (HWREG16(0x4000202C))
#define EUSCI_B0_SPI_IV (HWREG16(0x4000202E))
#define EUSCI_B0_SPI_RXBUF (HWREG16(0x4000200C))
#define EUSCI_B0_SPI_STATW (HWREG16(0x40002008))
#define EUSCI_B0_SPI_TXBUF (HWREG16(0x4000200E))
#define EUSCI_B1_I2C_ADDMASK (HWREG16(0x4000241E))
#define EUSCI_B1_I2C_ADDRX (HWREG16(0x4000241C))
#define UCB1BRW_L (HWREG8_L(UCB1BRW))
#define UCB1BRW_H (HWREG8_H(UCB1BRW))
#define EUSCI_B1_SPI_BRW (HWREG16(0x40002406))
#define UCB1CTLW0_H (HWREG8_L(UCB1CTLW0))
#define UCB1CTLW0_L (HWREG8_H(UCB1CTLW0))
#define EUSCI_B1_SPI_CTLW0 (HWREG16(0x40002400))
#define EUSCI_B1_I2C_I2COA0 (HWREG16(0x40002414))
#define EUSCI_B1_I2C_I2COA1 (HWREG16(0x40002416))
#define EUSCI_B1_I2C_I2COA2 (HWREG16(0x40002418))
#define EUSCI_B1_I2C_I2COA3 (HWREG16(0x4000241A))
#define EUSCI_B1_I2C_I2CSA (HWREG16(0x40002420))
#define EUSCI_B1_IE (HWREG16(0x4000242A))
#define EUSCI_B1_IFG (HWREG16(0x4000242C))
#define EUSCI_B1_IV (HWREG16(0x4000242E))
#define EUSCI_B1_SPI_RXBUF (HWREG16(0x4000240C))
#define EUSCI_B1_SPI_STATW (HWREG16(0x40002408))
#define EUSCI_B1_SPI_TXBUF (HWREG16(0x4000240E))
#define EUSCI_B2_I2C_ADDMASK (HWREG16(0x4000281E))
#define EUSCI_B2_I2C_ADDRX (HWREG16(0x4000281C))
#define UCB2BRW_L (HWREG8_L(UCB2BRW))
#define UCB2BRW_H (HWREG8_H(UCB2BRW))
#define EUSCI_B2_SPI_BRW (HWREG16(0x40002806))
#define UCB2CTLW0_H (HWREG8_L(UCB2CTLW0))
#define UCB2CTLW0_L (HWREG8_H(UCB2CTLW0))
#define EUSCI_B2_SPI_CTLW0 (HWREG16(0x40002800))
#define EUSCI_B2_I2C_I2COA0 (HWREG16(0x40002814))
#define EUSCI_B2_I2C_I2COA1 (HWREG16(0x40002816))
#define EUSCI_B2_I2C_I2COA2 (HWREG16(0x40002818))
#define EUSCI_B2_I2C_I2COA3 (HWREG16(0x4000281A))
#define EUSCI_B2_I2C_I2CSA (HWREG16(0x40002820))
#define EUSCI_B2_IE (HWREG16(0x4000282A))
#define EUSCI_B2_IFG (HWREG16(0x4000282C))
#define EUSCI_B2_IV (HWREG16(0x4000282E))
#define EUSCI_B2_SPI_RXBUF (HWREG16(0x4000280C))
#define EUSCI_B2_SPI_STATW (HWREG16(0x40002808))
#define EUSCI_B2_SPI_TXBUF (HWREG16(0x4000280E))
#define EUSCI_B3_I2C_ADDMASK (HWREG16(0x40002C1E))
#define EUSCI_B3_I2C_ADDRX (HWREG16(0x40002C1C))
#define UCB3BRW_L (HWREG8_L(UCB3BRW))
#define UCB3BRW_H (HWREG8_H(UCB3BRW))
#define EUSCI_B3_SPI_BRW (HWREG16(0x40002C06))
#define UCB3CTLW0_H (HWREG8_L(UCB3CTLW0))
#define UCB3CTLW0_L (HWREG8_H(UCB3CTLW0))
#define EUSCI_B3_SPI_CTLW0 (HWREG16(0x40002C00))
#define EUSCI_B3_I2C_I2COA0 (HWREG16(0x40002C14))
#define EUSCI_B3_I2C_I2COA1 (HWREG16(0x40002C16))
#define EUSCI_B3_I2C_I2COA2 (HWREG16(0x40002C18))
#define EUSCI_B3_I2C_I2COA3 (HWREG16(0x40002C1A))
#define EUSCI_B3_I2C_I2CSA (HWREG16(0x40002C20))
#define EUSCI_B3_IE (HWREG16(0x40002C2A))
#define EUSCI_B3_IFG (HWREG16(0x40002C2C))
#define EUSCI_B3_IV (HWREG16(0x40002C2E))
#define EUSCI_B3_SPI_RXBUF (HWREG16(0x40002C0C))
#define EUSCI_B3_SPI_STATW (HWREG16(0x40002C08))
#define EUSCI_B3_SPI_TXBUF (HWREG16(0x40002C0E))
#define WDT_A_CTL (HWREG16(0x4000480C))
#define WDTPW_VAL (0x5A00)

/* Previous defines without equivalent in ES2 header files */
#define ADC14BATMAP_0 (0x00000000)
#define ADC14BATMAP_1 (0x00400000)
#define ADC14BUSY_0 (0x00000000)
#define ADC14BUSY_1 (0x00010000)
#define ADC14CAP1M_M (0x00007c00)
#define ADC14CAP1P_M (0x7c000000)
#define ADC14CAP2M_M (0x000003e0)
#define ADC14CAP2P_M (0x03e00000)
#define ADC14CAP3M_M (0x0000001f)
#define ADC14CAP3P_M (0x001f0000)
#define ADC14CAP4M_M (0x7c000000)
#define ADC14CAP4P_M (0x00007c00)
#define ADC14CAP5M_M (0x03e00000)
#define ADC14CAP5P_M (0x000003e0)
#define ADC14CAP6M_M (0x001f0000)
#define ADC14CAP6P_M (0x0000001f)
#define ADC14CAP7M_M (0x00007c00)
#define ADC14CAP7P_M (0x7c000000)
#define ADC14CH0MAP_0 (0x00000000)
#define ADC14CH0MAP_1 (0x01000000)
#define ADC14CH1MAP_0 (0x00000000)
#define ADC14CH1MAP_1 (0x02000000)
#define ADC14CH2MAP_0 (0x00000000)
#define ADC14CH2MAP_1 (0x04000000)
#define ADC14CH3MAP_0 (0x00000000)
#define ADC14CH3MAP_1 (0x08000000)
#define ADC14CLKCTRL (0x00000001)
#define ADC14DBG0 (HWREG32(0x40012340))
#define ADC14DF_0 (0x00000000)
#define ADC14DF_1 (0x00000008)
#define ADC14DIF_0 (0x00000000)
#define ADC14DIF_1 (0x00002000)
#define ADC14DIV_0__1 (0x00000000)
#define ADC14DIV_1__2 (0x00400000)
#define ADC14DIV_2__3 (0x00800000)
#define ADC14DIV_3__4 (0x00c00000)
#define ADC14DIV_4__5 (0x01000000)
#define ADC14DIV_5__6 (0x01400000)
#define ADC14DIV_6__7 (0x01800000)
#define ADC14DIV_7__8 (0x01c00000)
#define ADC14DSCR0 (HWREG32(0x40012380))
#define ADC14ENC_0 (0x00000000)
#define ADC14ENC_0_ADC14_DISABLED (0x00000000)
#define ADC14ENC_1 (0x00000002)
#define ADC14ENC_1_ADC14_ENABLED (0x00000002)
#define ADC14EOS_0 (0x00000000)
#define ADC14EOS_1 (0x00000080)
#define ADC14EOS_1_END_OF_SEQUENCE (0x00000080)
#define ADC14HIIE_0 (0x00000000)
#define ADC14HIIE_1 (0x00000008)
#define ADC14HIIFG_0 (0x00000000)
#define ADC14HIIFG_1 (0x00000008)
#define ADC14IE0_0 (0x00000000)
#define ADC14IE0_1 (0x00000001)
#define ADC14IE10_0 (0x00000000)
#define ADC14IE10_1 (0x00000400)
#define ADC14IE11_0 (0x00000000)
#define ADC14IE11_1 (0x00000800)
#define ADC14IE12_0 (0x00000000)
#define ADC14IE12_1 (0x00001000)
#define ADC14IE13_0 (0x00000000)
#define ADC14IE13_1 (0x00002000)
#define ADC14IE14_0 (0x00000000)
#define ADC14IE14_1 (0x00004000)
#define ADC14IE15_0 (0x00000000)
#define ADC14IE15_1 (0x00008000)
#define ADC14IE16_0 (0x00000000)
#define ADC14IE16_1 (0x00010000)
#define ADC14IE17_0 (0x00000000)
#define ADC14IE17_1 (0x00020000)
#define ADC14IE18_0 (0x00000000)
#define ADC14IE18_1 (0x00040000)
#define ADC14IE19_0 (0x00000000)
#define ADC14IE19_1 (0x00080000)
#define ADC14IE1_0 (0x00000000)
#define ADC14IE1_1 (0x00000002)
#define ADC14IE20_0 (0x00000000)
#define ADC14IE20_1 (0x00100000)
#define ADC14IE21_0 (0x00000000)
#define ADC14IE21_1 (0x00200000)
#define ADC14IE22_0 (0x00000000)
#define ADC14IE22_1 (0x00400000)
#define ADC14IE23_0 (0x00000000)
#define ADC14IE23_1 (0x00800000)
#define ADC14IE24_0 (0x00000000)
#define ADC14IE24_1 (0x01000000)
#define ADC14IE25_0 (0x00000000)
#define ADC14IE25_1 (0x02000000)
#define ADC14IE26_0 (0x00000000)
#define ADC14IE26_1 (0x04000000)
#define ADC14IE27_0 (0x00000000)
#define ADC14IE27_1 (0x08000000)
#define ADC14IE28_0 (0x00000000)
#define ADC14IE28_1 (0x10000000)
#define ADC14IE29_0 (0x00000000)
#define ADC14IE29_1 (0x20000000)
#define ADC14IE2_0 (0x00000000)
#define ADC14IE2_1 (0x00000004)
#define ADC14IE30_0 (0x00000000)
#define ADC14IE30_1 (0x40000000)
#define ADC14IE31_0 (0x00000000)
#define ADC14IE31_1 (0x80000000)
#define ADC14IE3_0 (0x00000000)
#define ADC14IE3_1 (0x00000008)
#define ADC14IE4_0 (0x00000000)
#define ADC14IE4_1 (0x00000010)
#define ADC14IE5_0 (0x00000000)
#define ADC14IE5_1 (0x00000020)
#define ADC14IE6_0 (0x00000000)
#define ADC14IE6_1 (0x00000040)
#define ADC14IE7_0 (0x00000000)
#define ADC14IE7_1 (0x00000080)
#define ADC14IE8_0 (0x00000000)
#define ADC14IE8_1 (0x00000100)
#define ADC14IE9_0 (0x00000000)
#define ADC14IE9_1 (0x00000200)
#define ADC14IFG0_0 (0x00000000)
#define ADC14IFG0_1 (0x00000001)
#define ADC14IFG10_0 (0x00000000)
#define ADC14IFG10_1 (0x00000400)
#define ADC14IFG11_0 (0x00000000)
#define ADC14IFG11_1 (0x00000800)
#define ADC14IFG12_0 (0x00000000)
#define ADC14IFG12_1 (0x00001000)
#define ADC14IFG13_0 (0x00000000)
#define ADC14IFG13_1 (0x00002000)
#define ADC14IFG14_0 (0x00000000)
#define ADC14IFG14_1 (0x00004000)
#define ADC14IFG15_0 (0x00000000)
#define ADC14IFG15_1 (0x00008000)
#define ADC14IFG16_0 (0x00000000)
#define ADC14IFG16_1 (0x00010000)
#define ADC14IFG17_0 (0x00000000)
#define ADC14IFG17_1 (0x00020000)
#define ADC14IFG18_0 (0x00000000)
#define ADC14IFG18_1 (0x00040000)
#define ADC14IFG19_0 (0x00000000)
#define ADC14IFG19_1 (0x00080000)
#define ADC14IFG1_0 (0x00000000)
#define ADC14IFG1_1 (0x00000002)
#define ADC14IFG20_0 (0x00000000)
#define ADC14IFG20_1 (0x00100000)
#define ADC14IFG21_0 (0x00000000)
#define ADC14IFG21_1 (0x00200000)
#define ADC14IFG22_0 (0x00000000)
#define ADC14IFG22_1 (0x00400000)
#define ADC14IFG23_0 (0x00000000)
#define ADC14IFG23_1 (0x00800000)
#define ADC14IFG24_0 (0x00000000)
#define ADC14IFG24_1 (0x01000000)
#define ADC14IFG25_0 (0x00000000)
#define ADC14IFG25_1 (0x02000000)
#define ADC14IFG26_0 (0x00000000)
#define ADC14IFG26_1 (0x04000000)
#define ADC14IFG27_0 (0x00000000)
#define ADC14IFG27_1 (0x08000000)
#define ADC14IFG28_0 (0x00000000)
#define ADC14IFG28_1 (0x10000000)
#define ADC14IFG29_0 (0x00000000)
#define ADC14IFG29_1 (0x20000000)
#define ADC14IFG2_0 (0x00000000)
#define ADC14IFG2_1 (0x00000004)
#define ADC14IFG30_0 (0x00000000)
#define ADC14IFG30_1 (0x40000000)
#define ADC14IFG31_1 (0x80000000)
#define ADC14IFG3_0 (0x00000000)
#define ADC14IFG3_1 (0x00000008)
#define ADC14IFG4_0 (0x00000000)
#define ADC14IFG4_1 (0x00000010)
#define ADC14IFG5_0 (0x00000000)
#define ADC14IFG5_1 (0x00000020)
#define ADC14IFG6_0 (0x00000000)
#define ADC14IFG6_1 (0x00000040)
#define ADC14IFG7_0 (0x00000000)
#define ADC14IFG7_1 (0x00000080)
#define ADC14IFG8_0 (0x00000000)
#define ADC14IFG8_1 (0x00000100)
#define ADC14IFG9_0 (0x00000000)
#define ADC14IFG9_1 (0x00000200)
#define ADC14INIE_0 (0x00000000)
#define ADC14INIE_1 (0x00000002)
#define ADC14INIFG_0 (0x00000000)
#define ADC14INIFG_1 (0x00000002)
#define ADC14ISSH_0 (0x00000000)
#define ADC14ISSH_1 (0x02000000)
#define ADC14LOIE_0 (0x00000000)
#define ADC14LOIE_1 (0x00000004)
#define ADC14LOIFG_0 (0x00000000)
#define ADC14LOIFG_1 (0x00000004)
#define ADC14MSC_0 (0x00000000)
#define ADC14MSC_1 (0x00000080)
#define ADC14ON_0 (0x00000000)
#define ADC14ON_0_ADC14_OFF (0x00000000)
#define ADC14ON_1 (0x00000010)
#define ADC14OVIE_0 (0x00000000)
#define ADC14OVIE_1 (0x00000010)
#define ADC14OVIFG_0 (0x00000000)
#define ADC14OVIFG_1 (0x00000010)
#define ADC14PDIV_0_PREDIVIDE_BY_1 (0x00000000)
#define ADC14PDIV_1_PREDIVIDE_BY_4 (0x40000000)
#define ADC14PDIV_2_PREDIVIDE_BY_32 (0x80000000)
#define ADC14PDIV_3_PREDIVIDE_BY_64 (0xc0000000)
#define ADC14RDYIE_0 (0x00000000)
#define ADC14RDYIE_1 (0x00000040)
#define ADC14RDYIFG_0 (0x00000000)
#define ADC14RDYIFG_1 (0x00000040)
#define ADC14REFBURST_0 (0x00000000)
#define ADC14REFBURST_1 (0x00000004)
#define ADC14SC_0 (0x00000000)
#define ADC14SC_1 (0x00000001)
#define ADC14SHP_0 (0x00000000)
#define ADC14SHP_1 (0x04000000)
#define ADC14SHS_0_ADC14SC_BIT (0x00000000)
#define ADC14SHT0_0_4 (0x00000000)
#define ADC14SHT0_1_8 (0x00000100)
#define ADC14SHT0_2_16 (0x00000200)
#define ADC14SHT0_3_32 (0x00000300)
#define ADC14SHT0_4_64 (0x00000400)
#define ADC14SHT0_5_96 (0x00000500)
#define ADC14SHT0_6_128 (0x00000600)
#define ADC14SHT0_7_192 (0x00000700)
#define ADC14SHT1_0_4 (0x00000000)
#define ADC14SHT1_1_8 (0x00001000)
#define ADC14SHT1_2_16 (0x00002000)
#define ADC14SHT1_3_32 (0x00003000)
#define ADC14SHT1_4_64 (0x00004000)
#define ADC14SHT1_5_96 (0x00005000)
#define ADC14SHT1_6_128 (0x00006000)
#define ADC14SHT1_7_192 (0x00007000)
#define ADC14SSEL_0_MODCLK (0x00000000)
#define ADC14SSEL_1_SYSCLK (0x00080000)
#define ADC14SSEL_2_ACLK (0x00100000)
#define ADC14SSEL_3_MCLK (0x00180000)
#define ADC14SSEL_4_SMCLK (0x00200000)
#define ADC14SSEL_5_HSMCLK (0x00280000)
#define ADC14TCMAP_0 (0x00000000)
#define ADC14TCMAP_1 (0x00800000)
#define ADC14TEST0 (HWREG32(0x40012300))
#define ADC14TEST1 (HWREG32(0x40012304))
#define ADC14TEST2 (HWREG32(0x40012308))
#define ADC14TEST3 (HWREG32(0x4001230C))
#define ADC14TEST4 (HWREG32(0x40012310))
#define ADC14TEST5 (HWREG32(0x40012314))
#define ADC14TEST6 (HWREG32(0x40012318))
#define ADC14TEST7 (HWREG32(0x4001231C))
#define ADC14TOVIE_0 (0x00000000)
#define ADC14TOVIE_1 (0x00000020)
#define ADC14TOVIFG_0 (0x00000000)
#define ADC14TOVIFG_1 (0x00000020)
#define ADC14WINCTH_0 (0x00000000)
#define ADC14WINCTH_1 (0x00008000)
#define ADC14WINC_0 (0x00000000)
#define ADC14WINC_1 (0x00004000)
#define ADC14_CLRIFGR0 (HWREG32(0x4001214C))
#define ADC14_CLRIFGR0_CLRADC14IFG0 (0x00000001)
#define ADC14_CLRIFGR0_CLRADC14IFG0__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG0__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG0__1 (0x00000001)
#define ADC14_CLRIFGR0_CLRADC14IFG1 (0x00000002)
#define ADC14_CLRIFGR0_CLRADC14IFG10 (0x00000400)
#define ADC14_CLRIFGR0_CLRADC14IFG10__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG10__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG10__1 (0x00000400)
#define ADC14_CLRIFGR0_CLRADC14IFG11 (0x00000800)
#define ADC14_CLRIFGR0_CLRADC14IFG11__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG11__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG11__1 (0x00000800)
#define ADC14_CLRIFGR0_CLRADC14IFG12 (0x00001000)
#define ADC14_CLRIFGR0_CLRADC14IFG12__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG12__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG12__1 (0x00001000)
#define ADC14_CLRIFGR0_CLRADC14IFG13 (0x00002000)
#define ADC14_CLRIFGR0_CLRADC14IFG13__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG13__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG13__1 (0x00002000)
#define ADC14_CLRIFGR0_CLRADC14IFG14 (0x00004000)
#define ADC14_CLRIFGR0_CLRADC14IFG14__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG14__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG14__1 (0x00004000)
#define ADC14_CLRIFGR0_CLRADC14IFG15 (0x00008000)
#define ADC14_CLRIFGR0_CLRADC14IFG15__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG15__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG15__1 (0x00008000)
#define ADC14_CLRIFGR0_CLRADC14IFG16 (0x00010000)
#define ADC14_CLRIFGR0_CLRADC14IFG16__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG16__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG16__1 (0x00010000)
#define ADC14_CLRIFGR0_CLRADC14IFG17 (0x00020000)
#define ADC14_CLRIFGR0_CLRADC14IFG17__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG17__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG17__1 (0x00020000)
#define ADC14_CLRIFGR0_CLRADC14IFG18 (0x00040000)
#define ADC14_CLRIFGR0_CLRADC14IFG18__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG18__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG18__1 (0x00040000)
#define ADC14_CLRIFGR0_CLRADC14IFG19 (0x00080000)
#define ADC14_CLRIFGR0_CLRADC14IFG19__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG19__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG19__1 (0x00080000)
#define ADC14_CLRIFGR0_CLRADC14IFG1__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG1__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG1__1 (0x00000002)
#define ADC14_CLRIFGR0_CLRADC14IFG2 (0x00000004)
#define ADC14_CLRIFGR0_CLRADC14IFG20 (0x00100000)
#define ADC14_CLRIFGR0_CLRADC14IFG20__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG20__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG20__1 (0x00100000)
#define ADC14_CLRIFGR0_CLRADC14IFG21 (0x00200000)
#define ADC14_CLRIFGR0_CLRADC14IFG21__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG21__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG21__1 (0x00200000)
#define ADC14_CLRIFGR0_CLRADC14IFG22 (0x00400000)
#define ADC14_CLRIFGR0_CLRADC14IFG22__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG22__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG22__1 (0x00400000)
#define ADC14_CLRIFGR0_CLRADC14IFG23 (0x00800000)
#define ADC14_CLRIFGR0_CLRADC14IFG23__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG23__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG23__1 (0x00800000)
#define ADC14_CLRIFGR0_CLRADC14IFG24 (0x01000000)
#define ADC14_CLRIFGR0_CLRADC14IFG24__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG24__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG24__1 (0x01000000)
#define ADC14_CLRIFGR0_CLRADC14IFG25 (0x02000000)
#define ADC14_CLRIFGR0_CLRADC14IFG25__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG25__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG25__1 (0x02000000)
#define ADC14_CLRIFGR0_CLRADC14IFG26 (0x04000000)
#define ADC14_CLRIFGR0_CLRADC14IFG26__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG26__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG26__1 (0x04000000)
#define ADC14_CLRIFGR0_CLRADC14IFG27 (0x08000000)
#define ADC14_CLRIFGR0_CLRADC14IFG27__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG27__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG27__1 (0x08000000)
#define ADC14_CLRIFGR0_CLRADC14IFG28 (0x10000000)
#define ADC14_CLRIFGR0_CLRADC14IFG28__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG28__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG28__1 (0x10000000)
#define ADC14_CLRIFGR0_CLRADC14IFG29 (0x20000000)
#define ADC14_CLRIFGR0_CLRADC14IFG29__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG29__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG29__1 (0x20000000)
#define ADC14_CLRIFGR0_CLRADC14IFG2__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG2__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG2__1 (0x00000004)
#define ADC14_CLRIFGR0_CLRADC14IFG3 (0x00000008)
#define ADC14_CLRIFGR0_CLRADC14IFG30 (0x40000000)
#define ADC14_CLRIFGR0_CLRADC14IFG30__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG30__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG30__1 (0x40000000)
#define ADC14_CLRIFGR0_CLRADC14IFG31 (0x80000000)
#define ADC14_CLRIFGR0_CLRADC14IFG31__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG31__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG31__1 (0x80000000)
#define ADC14_CLRIFGR0_CLRADC14IFG3__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG3__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG3__1 (0x00000008)
#define ADC14_CLRIFGR0_CLRADC14IFG4 (0x00000010)
#define ADC14_CLRIFGR0_CLRADC14IFG4__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG4__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG4__1 (0x00000010)
#define ADC14_CLRIFGR0_CLRADC14IFG5 (0x00000020)
#define ADC14_CLRIFGR0_CLRADC14IFG5__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG5__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG5__1 (0x00000020)
#define ADC14_CLRIFGR0_CLRADC14IFG6 (0x00000040)
#define ADC14_CLRIFGR0_CLRADC14IFG6__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG6__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG6__1 (0x00000040)
#define ADC14_CLRIFGR0_CLRADC14IFG7 (0x00000080)
#define ADC14_CLRIFGR0_CLRADC14IFG7__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG7__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG7__1 (0x00000080)
#define ADC14_CLRIFGR0_CLRADC14IFG8 (0x00000100)
#define ADC14_CLRIFGR0_CLRADC14IFG8__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG8__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG8__1 (0x00000100)
#define ADC14_CLRIFGR0_CLRADC14IFG9 (0x00000200)
#define ADC14_CLRIFGR0_CLRADC14IFG9__0 (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG9__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR0_CLRADC14IFG9__1 (0x00000200)
#define ADC14_CLRIFGR1 (HWREG32(0x40012150))
#define ADC14_CLRIFGR1_CLRADC14HIIFG (0x00000008)
#define ADC14_CLRIFGR1_CLRADC14HIIFG__0 (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14HIIFG__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14HIIFG__1 (0x00000008)
#define ADC14_CLRIFGR1_CLRADC14INIFG (0x00000002)
#define ADC14_CLRIFGR1_CLRADC14INIFG__0 (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14INIFG__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14INIFG__1 (0x00000002)
#define ADC14_CLRIFGR1_CLRADC14LOIFG (0x00000004)
#define ADC14_CLRIFGR1_CLRADC14LOIFG__0 (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14LOIFG__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14LOIFG__1 (0x00000004)
#define ADC14_CLRIFGR1_CLRADC14OVIFG (0x00000010)
#define ADC14_CLRIFGR1_CLRADC14OVIFG__0 (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14OVIFG__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14OVIFG__1 (0x00000010)
#define ADC14_CLRIFGR1_CLRADC14RDYIFG (0x00000040)
#define ADC14_CLRIFGR1_CLRADC14RDYIFG__0 (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14RDYIFG__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14RDYIFG__1 (0x00000040)
#define ADC14_CLRIFGR1_CLRADC14TOVIFG (0x00000020)
#define ADC14_CLRIFGR1_CLRADC14TOVIFG__0 (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14TOVIFG__0_NO_EFFECT (0x00000000)
#define ADC14_CLRIFGR1_CLRADC14TOVIFG__1 (0x00000020)
#define ADC14_CTL0 (HWREG32(0x40012000))
#define ADC14_CTL0_BUSY (0x00010000)
#define ADC14_CTL0_BUSY__0 (0x00000000)
#define ADC14_CTL0_BUSY__1 (0x00010000)
#define ADC14_CTL0_CONSEQ__0 (0x00000000)
#define ADC14_CTL0_CONSEQ__1 (0x00020000)
#define ADC14_CTL0_CONSEQ__2 (0x00040000)
#define ADC14_CTL0_CONSEQ__3 (0x00060000)
#define ADC14_CTL0_CONSEQ__M (0x00060000)
#define ADC14_CTL0_DIV__0 (0x00000000)
#define ADC14_CTL0_DIV__0__1 (0x00000000)
#define ADC14_CTL0_DIV__1 (0x00400000)
#define ADC14_CTL0_DIV__1__2 (0x00400000)
#define ADC14_CTL0_DIV__2 (0x00800000)
#define ADC14_CTL0_DIV__2__3 (0x00800000)
#define ADC14_CTL0_DIV__3 (0x00c00000)
#define ADC14_CTL0_DIV__3__4 (0x00c00000)
#define ADC14_CTL0_DIV__4 (0x01000000)
#define ADC14_CTL0_DIV__4__5 (0x01000000)
#define ADC14_CTL0_DIV__5 (0x01400000)
#define ADC14_CTL0_DIV__5__6 (0x01400000)
#define ADC14_CTL0_DIV__6 (0x01800000)
#define ADC14_CTL0_DIV__6__7 (0x01800000)
#define ADC14_CTL0_DIV__7 (0x01c00000)
#define ADC14_CTL0_DIV__7__8 (0x01c00000)
#define ADC14_CTL0_DIV__M (0x01c00000)
#define ADC14_CTL0_ENC (0x00000002)
#define ADC14_CTL0_ENC__0 (0x00000000)
#define ADC14_CTL0_ENC__0_ADC14_DISABLED (0x00000000)
#define ADC14_CTL0_ENC__1 (0x00000002)
#define ADC14_CTL0_ENC__1_ADC14_ENABLED (0x00000002)
#define ADC14_CTL0_ISSH (0x02000000)
#define ADC14_CTL0_ISSH__0 (0x00000000)
#define ADC14_CTL0_ISSH__1 (0x02000000)
#define ADC14_CTL0_MSC (0x00000080)
#define ADC14_CTL0_MSC__0 (0x00000000)
#define ADC14_CTL0_MSC__1 (0x00000080)
#define ADC14_CTL0_ON (0x00000010)
#define ADC14_CTL0_ON__0 (0x00000000)
#define ADC14_CTL0_ON__0_ADC14_OFF (0x00000000)
#define ADC14_CTL0_ON__1 (0x00000010)
#define ADC14_CTL0_PDIV__0 (0x00000000)
#define ADC14_CTL0_PDIV__0_PREDIVIDE_BY_1 (0x00000000)
#define ADC14_CTL0_PDIV__1 (0x40000000)
#define ADC14_CTL0_PDIV__1_PREDIVIDE_BY_4 (0x40000000)
#define ADC14_CTL0_PDIV__2 (0x80000000)
#define ADC14_CTL0_PDIV__2_PREDIVIDE_BY_32 (0x80000000)
#define ADC14_CTL0_PDIV__3 (0xc0000000)
#define ADC14_CTL0_PDIV__3_PREDIVIDE_BY_64 (0xc0000000)
#define ADC14_CTL0_PDIV__M (0xc0000000)
#define ADC14_CTL0_SC (0x00000001)
#define ADC14_CTL0_SC__0 (0x00000000)
#define ADC14_CTL0_SC__1 (0x00000001)
#define ADC14_CTL0_SHP (0x04000000)
#define ADC14_CTL0_SHP__0 (0x00000000)
#define ADC14_CTL0_SHP__1 (0x04000000)
#define ADC14_CTL0_SHS__0 (0x00000000)
#define ADC14_CTL0_SHS__0_ADC14SC_BIT (0x00000000)
#define ADC14_CTL0_SHS__1 (0x08000000)
#define ADC14_CTL0_SHS__2 (0x10000000)
#define ADC14_CTL0_SHS__3 (0x18000000)
#define ADC14_CTL0_SHS__4 (0x20000000)
#define ADC14_CTL0_SHS__5 (0x28000000)
#define ADC14_CTL0_SHS__6 (0x30000000)
#define ADC14_CTL0_SHS__7 (0x38000000)
#define ADC14_CTL0_SHS__M (0x38000000)
#define ADC14_CTL0_SHT0__0 (0x00000000)
#define ADC14_CTL0_SHT0__0_4 (0x00000000)
#define ADC14_CTL0_SHT0__1 (0x00000100)
#define ADC14_CTL0_SHT0__1_8 (0x00000100)
#define ADC14_CTL0_SHT0__2 (0x00000200)
#define ADC14_CTL0_SHT0__2_16 (0x00000200)
#define ADC14_CTL0_SHT0__3 (0x00000300)
#define ADC14_CTL0_SHT0__3_32 (0x00000300)
#define ADC14_CTL0_SHT0__4 (0x00000400)
#define ADC14_CTL0_SHT0__4_64 (0x00000400)
#define ADC14_CTL0_SHT0__5 (0x00000500)
#define ADC14_CTL0_SHT0__5_96 (0x00000500)
#define ADC14_CTL0_SHT0__6 (0x00000600)
#define ADC14_CTL0_SHT0__6_128 (0x00000600)
#define ADC14_CTL0_SHT0__7 (0x00000700)
#define ADC14_CTL0_SHT0__7_192 (0x00000700)
#define ADC14_CTL0_SHT0__M (0x00000f00)
#define ADC14_CTL0_SHT1__0 (0x00000000)
#define ADC14_CTL0_SHT1__0_4 (0x00000000)
#define ADC14_CTL0_SHT1__1 (0x00001000)
#define ADC14_CTL0_SHT1__1_8 (0x00001000)
#define ADC14_CTL0_SHT1__2 (0x00002000)
#define ADC14_CTL0_SHT1__2_16 (0x00002000)
#define ADC14_CTL0_SHT1__3 (0x00003000)
#define ADC14_CTL0_SHT1__3_32 (0x00003000)
#define ADC14_CTL0_SHT1__4 (0x00004000)
#define ADC14_CTL0_SHT1__4_64 (0x00004000)
#define ADC14_CTL0_SHT1__5 (0x00005000)
#define ADC14_CTL0_SHT1__5_96 (0x00005000)
#define ADC14_CTL0_SHT1__6 (0x00006000)
#define ADC14_CTL0_SHT1__6_128 (0x00006000)
#define ADC14_CTL0_SHT1__7 (0x00007000)
#define ADC14_CTL0_SHT1__7_192 (0x00007000)
#define ADC14_CTL0_SHT1__M (0x0000f000)
#define ADC14_CTL0_SSEL__0 (0x00000000)
#define ADC14_CTL0_SSEL__0_MODCLK (0x00000000)
#define ADC14_CTL0_SSEL__1 (0x00080000)
#define ADC14_CTL0_SSEL__1_SYSCLK (0x00080000)
#define ADC14_CTL0_SSEL__2 (0x00100000)
#define ADC14_CTL0_SSEL__2_ACLK (0x00100000)
#define ADC14_CTL0_SSEL__3 (0x00180000)
#define ADC14_CTL0_SSEL__3_MCLK (0x00180000)
#define ADC14_CTL0_SSEL__4 (0x00200000)
#define ADC14_CTL0_SSEL__4_SMCLK (0x00200000)
#define ADC14_CTL0_SSEL__5 (0x00280000)
#define ADC14_CTL0_SSEL__5_HSMCLK (0x00280000)
#define ADC14_CTL0_SSEL__M (0x00380000)
#define ADC14_CTL1 (HWREG32(0x40012004))
#define ADC14_CTL1_BATMAP (0x00400000)
#define ADC14_CTL1_BATMAP__0 (0x00000000)
#define ADC14_CTL1_BATMAP__1 (0x00400000)
#define ADC14_CTL1_CH0MAP (0x01000000)
#define ADC14_CTL1_CH0MAP__0 (0x00000000)
#define ADC14_CTL1_CH0MAP__1 (0x01000000)
#define ADC14_CTL1_CH1MAP (0x02000000)
#define ADC14_CTL1_CH1MAP__0 (0x00000000)
#define ADC14_CTL1_CH1MAP__1 (0x02000000)
#define ADC14_CTL1_CH2MAP (0x04000000)
#define ADC14_CTL1_CH2MAP__0 (0x00000000)
#define ADC14_CTL1_CH2MAP__1 (0x04000000)
#define ADC14_CTL1_CH3MAP (0x08000000)
#define ADC14_CTL1_CH3MAP__0 (0x00000000)
#define ADC14_CTL1_CH3MAP__1 (0x08000000)
#define ADC14_CTL1_CSTARTADD__M (0x001f0000)
#define ADC14_CTL1_DF (0x00000008)
#define ADC14_CTL1_DF__0 (0x00000000)
#define ADC14_CTL1_DF__1 (0x00000008)
#define ADC14_CTL1_PWRMD__0 (0x00000000)
#define ADC14_CTL1_PWRMD__2 (0x00000002)
#define ADC14_CTL1_PWRMD__M (0x00000003)
#define ADC14_CTL1_REFBURST (0x00000004)
#define ADC14_CTL1_REFBURST__0 (0x00000000)
#define ADC14_CTL1_REFBURST__1 (0x00000004)
#define ADC14_CTL1_RES__0 (0x00000000)
#define ADC14_CTL1_RES__1 (0x00000010)
#define ADC14_CTL1_RES__2 (0x00000020)
#define ADC14_CTL1_RES__3 (0x00000030)
#define ADC14_CTL1_RES__M (0x00000030)
#define ADC14_CTL1_TCMAP (0x00800000)
#define ADC14_CTL1_TCMAP__0 (0x00000000)
#define ADC14_CTL1_TCMAP__1 (0x00800000)
#define ADC14_DMACTRL (0x00000004)
#define ADC14_EN14BIT (0x00000008)
#define ADC14_HI0 (HWREG32(0x4001200C))
#define ADC14_HI0_HI0__M (0x0000ffff)
#define ADC14_HI1 (HWREG32(0x40012014))
#define ADC14_HI1_HI1__M (0x0000ffff)
#define ADC14_IER0 (HWREG32(0x4001213C))
#define ADC14_IER0_IE0 (0x00000001)
#define ADC14_IER0_IE0__0 (0x00000000)
#define ADC14_IER0_IE0__1 (0x00000001)
#define ADC14_IER0_IE1 (0x00000002)
#define ADC14_IER0_IE10 (0x00000400)
#define ADC14_IER0_IE10__0 (0x00000000)
#define ADC14_IER0_IE10__1 (0x00000400)
#define ADC14_IER0_IE11 (0x00000800)
#define ADC14_IER0_IE11__0 (0x00000000)
#define ADC14_IER0_IE11__1 (0x00000800)
#define ADC14_IER0_IE12 (0x00001000)
#define ADC14_IER0_IE12__0 (0x00000000)
#define ADC14_IER0_IE12__1 (0x00001000)
#define ADC14_IER0_IE13 (0x00002000)
#define ADC14_IER0_IE13__0 (0x00000000)
#define ADC14_IER0_IE13__1 (0x00002000)
#define ADC14_IER0_IE14 (0x00004000)
#define ADC14_IER0_IE14__0 (0x00000000)
#define ADC14_IER0_IE14__1 (0x00004000)
#define ADC14_IER0_IE15 (0x00008000)
#define ADC14_IER0_IE15__0 (0x00000000)
#define ADC14_IER0_IE15__1 (0x00008000)
#define ADC14_IER0_IE16 (0x00010000)
#define ADC14_IER0_IE16__0 (0x00000000)
#define ADC14_IER0_IE16__1 (0x00010000)
#define ADC14_IER0_IE17 (0x00020000)
#define ADC14_IER0_IE17__0 (0x00000000)
#define ADC14_IER0_IE17__1 (0x00020000)
#define ADC14_IER0_IE18 (0x00040000)
#define ADC14_IER0_IE18__0 (0x00000000)
#define ADC14_IER0_IE18__1 (0x00040000)
#define ADC14_IER0_IE19 (0x00080000)
#define ADC14_IER0_IE19__0 (0x00000000)
#define ADC14_IER0_IE19__1 (0x00080000)
#define ADC14_IER0_IE1__0 (0x00000000)
#define ADC14_IER0_IE1__1 (0x00000002)
#define ADC14_IER0_IE2 (0x00000004)
#define ADC14_IER0_IE20 (0x00100000)
#define ADC14_IER0_IE20__0 (0x00000000)
#define ADC14_IER0_IE20__1 (0x00100000)
#define ADC14_IER0_IE21 (0x00200000)
#define ADC14_IER0_IE21__0 (0x00000000)
#define ADC14_IER0_IE21__1 (0x00200000)
#define ADC14_IER0_IE22 (0x00400000)
#define ADC14_IER0_IE22__0 (0x00000000)
#define ADC14_IER0_IE22__1 (0x00400000)
#define ADC14_IER0_IE23 (0x00800000)
#define ADC14_IER0_IE23__0 (0x00000000)
#define ADC14_IER0_IE23__1 (0x00800000)
#define ADC14_IER0_IE24 (0x01000000)
#define ADC14_IER0_IE24__0 (0x00000000)
#define ADC14_IER0_IE24__1 (0x01000000)
#define ADC14_IER0_IE25 (0x02000000)
#define ADC14_IER0_IE25__0 (0x00000000)
#define ADC14_IER0_IE25__1 (0x02000000)
#define ADC14_IER0_IE26 (0x04000000)
#define ADC14_IER0_IE26__0 (0x00000000)
#define ADC14_IER0_IE26__1 (0x04000000)
#define ADC14_IER0_IE27 (0x08000000)
#define ADC14_IER0_IE27__0 (0x00000000)
#define ADC14_IER0_IE27__1 (0x08000000)
#define ADC14_IER0_IE28 (0x10000000)
#define ADC14_IER0_IE28__0 (0x00000000)
#define ADC14_IER0_IE28__1 (0x10000000)
#define ADC14_IER0_IE29 (0x20000000)
#define ADC14_IER0_IE29__0 (0x00000000)
#define ADC14_IER0_IE29__1 (0x20000000)
#define ADC14_IER0_IE2__0 (0x00000000)
#define ADC14_IER0_IE2__1 (0x00000004)
#define ADC14_IER0_IE3 (0x00000008)
#define ADC14_IER0_IE30 (0x40000000)
#define ADC14_IER0_IE30__0 (0x00000000)
#define ADC14_IER0_IE30__1 (0x40000000)
#define ADC14_IER0_IE31 (0x80000000)
#define ADC14_IER0_IE31__0 (0x00000000)
#define ADC14_IER0_IE31__1 (0x80000000)
#define ADC14_IER0_IE3__0 (0x00000000)
#define ADC14_IER0_IE3__1 (0x00000008)
#define ADC14_IER0_IE4 (0x00000010)
#define ADC14_IER0_IE4__0 (0x00000000)
#define ADC14_IER0_IE4__1 (0x00000010)
#define ADC14_IER0_IE5 (0x00000020)
#define ADC14_IER0_IE5__0 (0x00000000)
#define ADC14_IER0_IE5__1 (0x00000020)
#define ADC14_IER0_IE6 (0x00000040)
#define ADC14_IER0_IE6__0 (0x00000000)
#define ADC14_IER0_IE6__1 (0x00000040)
#define ADC14_IER0_IE7 (0x00000080)
#define ADC14_IER0_IE7__0 (0x00000000)
#define ADC14_IER0_IE7__1 (0x00000080)
#define ADC14_IER0_IE8 (0x00000100)
#define ADC14_IER0_IE8__0 (0x00000000)
#define ADC14_IER0_IE8__1 (0x00000100)
#define ADC14_IER0_IE9 (0x00000200)
#define ADC14_IER0_IE9__0 (0x00000000)
#define ADC14_IER0_IE9__1 (0x00000200)
#define ADC14_IER1 (HWREG32(0x40012140))
#define ADC14_IER1_HIIE (0x00000008)
#define ADC14_IER1_HIIE__0 (0x00000000)
#define ADC14_IER1_HIIE__1 (0x00000008)
#define ADC14_IER1_INIE (0x00000002)
#define ADC14_IER1_INIE__0 (0x00000000)
#define ADC14_IER1_INIE__1 (0x00000002)
#define ADC14_IER1_LOIE (0x00000004)
#define ADC14_IER1_LOIE__0 (0x00000000)
#define ADC14_IER1_LOIE__1 (0x00000004)
#define ADC14_IER1_OVIE (0x00000010)
#define ADC14_IER1_OVIE__0 (0x00000000)
#define ADC14_IER1_OVIE__1 (0x00000010)
#define ADC14_IER1_RDYIE (0x00000040)
#define ADC14_IER1_RDYIE__0 (0x00000000)
#define ADC14_IER1_RDYIE__1 (0x00000040)
#define ADC14_IER1_TOVIE (0x00000020)
#define ADC14_IER1_TOVIE__0 (0x00000000)
#define ADC14_IER1_TOVIE__1 (0x00000020)
#define ADC14_IFGR0 (HWREG32(0x40012144))
#define ADC14_IFGR0_IFG0 (0x00000001)
#define ADC14_IFGR0_IFG0__0 (0x00000000)
#define ADC14_IFGR0_IFG0__1 (0x00000001)
#define ADC14_IFGR0_IFG1 (0x00000002)
#define ADC14_IFGR0_IFG10 (0x00000400)
#define ADC14_IFGR0_IFG10__0 (0x00000000)
#define ADC14_IFGR0_IFG10__1 (0x00000400)
#define ADC14_IFGR0_IFG11 (0x00000800)
#define ADC14_IFGR0_IFG11__0 (0x00000000)
#define ADC14_IFGR0_IFG11__1 (0x00000800)
#define ADC14_IFGR0_IFG12 (0x00001000)
#define ADC14_IFGR0_IFG12__0 (0x00000000)
#define ADC14_IFGR0_IFG12__1 (0x00001000)
#define ADC14_IFGR0_IFG13 (0x00002000)
#define ADC14_IFGR0_IFG13__0 (0x00000000)
#define ADC14_IFGR0_IFG13__1 (0x00002000)
#define ADC14_IFGR0_IFG14 (0x00004000)
#define ADC14_IFGR0_IFG14__0 (0x00000000)
#define ADC14_IFGR0_IFG14__1 (0x00004000)
#define ADC14_IFGR0_IFG15 (0x00008000)
#define ADC14_IFGR0_IFG15__0 (0x00000000)
#define ADC14_IFGR0_IFG15__1 (0x00008000)
#define ADC14_IFGR0_IFG16 (0x00010000)
#define ADC14_IFGR0_IFG16__0 (0x00000000)
#define ADC14_IFGR0_IFG16__1 (0x00010000)
#define ADC14_IFGR0_IFG17 (0x00020000)
#define ADC14_IFGR0_IFG17__0 (0x00000000)
#define ADC14_IFGR0_IFG17__1 (0x00020000)
#define ADC14_IFGR0_IFG18 (0x00040000)
#define ADC14_IFGR0_IFG18__0 (0x00000000)
#define ADC14_IFGR0_IFG18__1 (0x00040000)
#define ADC14_IFGR0_IFG19 (0x00080000)
#define ADC14_IFGR0_IFG19__0 (0x00000000)
#define ADC14_IFGR0_IFG19__1 (0x00080000)
#define ADC14_IFGR0_IFG1__0 (0x00000000)
#define ADC14_IFGR0_IFG1__1 (0x00000002)
#define ADC14_IFGR0_IFG2 (0x00000004)
#define ADC14_IFGR0_IFG20 (0x00100000)
#define ADC14_IFGR0_IFG20__0 (0x00000000)
#define ADC14_IFGR0_IFG20__1 (0x00100000)
#define ADC14_IFGR0_IFG21 (0x00200000)
#define ADC14_IFGR0_IFG21__0 (0x00000000)
#define ADC14_IFGR0_IFG21__1 (0x00200000)
#define ADC14_IFGR0_IFG22 (0x00400000)
#define ADC14_IFGR0_IFG22__0 (0x00000000)
#define ADC14_IFGR0_IFG22__1 (0x00400000)
#define ADC14_IFGR0_IFG23 (0x00800000)
#define ADC14_IFGR0_IFG23__0 (0x00000000)
#define ADC14_IFGR0_IFG23__1 (0x00800000)
#define ADC14_IFGR0_IFG24 (0x01000000)
#define ADC14_IFGR0_IFG24__0 (0x00000000)
#define ADC14_IFGR0_IFG24__1 (0x01000000)
#define ADC14_IFGR0_IFG25 (0x02000000)
#define ADC14_IFGR0_IFG25__0 (0x00000000)
#define ADC14_IFGR0_IFG25__1 (0x02000000)
#define ADC14_IFGR0_IFG26 (0x04000000)
#define ADC14_IFGR0_IFG26__0 (0x00000000)
#define ADC14_IFGR0_IFG26__1 (0x04000000)
#define ADC14_IFGR0_IFG27 (0x08000000)
#define ADC14_IFGR0_IFG27__0 (0x00000000)
#define ADC14_IFGR0_IFG27__1 (0x08000000)
#define ADC14_IFGR0_IFG28 (0x10000000)
#define ADC14_IFGR0_IFG28__0 (0x00000000)
#define ADC14_IFGR0_IFG28__1 (0x10000000)
#define ADC14_IFGR0_IFG29 (0x20000000)
#define ADC14_IFGR0_IFG29__0 (0x00000000)
#define ADC14_IFGR0_IFG29__1 (0x20000000)
#define ADC14_IFGR0_IFG2__0 (0x00000000)
#define ADC14_IFGR0_IFG2__1 (0x00000004)
#define ADC14_IFGR0_IFG3 (0x00000008)
#define ADC14_IFGR0_IFG30 (0x40000000)
#define ADC14_IFGR0_IFG30__0 (0x00000000)
#define ADC14_IFGR0_IFG30__1 (0x40000000)
#define ADC14_IFGR0_IFG31 (0x80000000)
#define ADC14_IFGR0_IFG31__1 (0x80000000)
#define ADC14_IFGR0_IFG3__0 (0x00000000)
#define ADC14_IFGR0_IFG3__1 (0x00000008)
#define ADC14_IFGR0_IFG4 (0x00000010)
#define ADC14_IFGR0_IFG4__0 (0x00000000)
#define ADC14_IFGR0_IFG4__1 (0x00000010)
#define ADC14_IFGR0_IFG5 (0x00000020)
#define ADC14_IFGR0_IFG5__0 (0x00000000)
#define ADC14_IFGR0_IFG5__1 (0x00000020)
#define ADC14_IFGR0_IFG6 (0x00000040)
#define ADC14_IFGR0_IFG6__0 (0x00000000)
#define ADC14_IFGR0_IFG6__1 (0x00000040)
#define ADC14_IFGR0_IFG7 (0x00000080)
#define ADC14_IFGR0_IFG7__0 (0x00000000)
#define ADC14_IFGR0_IFG7__1 (0x00000080)
#define ADC14_IFGR0_IFG8 (0x00000100)
#define ADC14_IFGR0_IFG8__0 (0x00000000)
#define ADC14_IFGR0_IFG8__1 (0x00000100)
#define ADC14_IFGR0_IFG9 (0x00000200)
#define ADC14_IFGR0_IFG9__0 (0x00000000)
#define ADC14_IFGR0_IFG9__1 (0x00000200)
#define ADC14_IFGR1 (HWREG32(0x40012148))
#define ADC14_IFGR1_HIIFG (0x00000008)
#define ADC14_IFGR1_HIIFG__0 (0x00000000)
#define ADC14_IFGR1_HIIFG__1 (0x00000008)
#define ADC14_IFGR1_INIFG (0x00000002)
#define ADC14_IFGR1_INIFG__0 (0x00000000)
#define ADC14_IFGR1_INIFG__1 (0x00000002)
#define ADC14_IFGR1_LOIFG (0x00000004)
#define ADC14_IFGR1_LOIFG__0 (0x00000000)
#define ADC14_IFGR1_LOIFG__1 (0x00000004)
#define ADC14_IFGR1_OVIFG (0x00000010)
#define ADC14_IFGR1_OVIFG__0 (0x00000000)
#define ADC14_IFGR1_OVIFG__1 (0x00000010)
#define ADC14_IFGR1_RDYIFG (0x00000040)
#define ADC14_IFGR1_RDYIFG__0 (0x00000000)
#define ADC14_IFGR1_RDYIFG__1 (0x00000040)
#define ADC14_IFGR1_TOVIFG (0x00000020)
#define ADC14_IFGR1_TOVIFG__0 (0x00000000)
#define ADC14_IFGR1_TOVIFG__1 (0x00000020)
#define ADC14_INTCTRL (0x00000002)
#define ADC14_IV (HWREG32(0x40012154))
#define ADC14_LO0 (HWREG32(0x40012008))
#define ADC14_LO0_LO0__M (0x0000ffff)
#define ADC14_LO1 (HWREG32(0x40012010))
#define ADC14_LO1_LO1__M (0x0000ffff)
#define ADC14_MCTL0 (HWREG32(0x40012018))
#define ADC14_MCTL1 (HWREG32(0x4001201C))
#define ADC14_MCTL10 (HWREG32(0x40012040))
#define ADC14_MCTL11 (HWREG32(0x40012044))
#define ADC14_MCTL12 (HWREG32(0x40012048))
#define ADC14_MCTL13 (HWREG32(0x4001204C))
#define ADC14_MCTL14 (HWREG32(0x40012050))
#define ADC14_MCTL15 (HWREG32(0x40012054))
#define ADC14_MCTL16 (HWREG32(0x40012058))
#define ADC14_MCTL17 (HWREG32(0x4001205C))
#define ADC14_MCTL18 (HWREG32(0x40012060))
#define ADC14_MCTL19 (HWREG32(0x40012064))
#define ADC14_MCTL2 (HWREG32(0x40012020))
#define ADC14_MCTL20 (HWREG32(0x40012068))
#define ADC14_MCTL21 (HWREG32(0x4001206C))
#define ADC14_MCTL22 (HWREG32(0x40012070))
#define ADC14_MCTL23 (HWREG32(0x40012074))
#define ADC14_MCTL24 (HWREG32(0x40012078))
#define ADC14_MCTL25 (HWREG32(0x4001207C))
#define ADC14_MCTL26 (HWREG32(0x40012080))
#define ADC14_MCTL27 (HWREG32(0x40012084))
#define ADC14_MCTL28 (HWREG32(0x40012088))
#define ADC14_MCTL29 (HWREG32(0x4001208C))
#define ADC14_MCTL3 (HWREG32(0x40012024))
#define ADC14_MCTL30 (HWREG32(0x40012090))
#define ADC14_MCTL31 (HWREG32(0x40012094))
#define ADC14_MCTL4 (HWREG32(0x40012028))
#define ADC14_MCTL5 (HWREG32(0x4001202C))
#define ADC14_MCTL6 (HWREG32(0x40012030))
#define ADC14_MCTL7 (HWREG32(0x40012034))
#define ADC14_MCTL8 (HWREG32(0x40012038))
#define ADC14_MCTL9 (HWREG32(0x4001203C))
#define ADC14_MCTL_DIF (0x00002000)
#define ADC14_MCTL_DIF__0 (0x00000000)
#define ADC14_MCTL_DIF__1 (0x00002000)
#define ADC14_MCTL_EOS (0x00000080)
#define ADC14_MCTL_EOS__0 (0x00000000)
#define ADC14_MCTL_EOS__1 (0x00000080)
#define ADC14_MCTL_EOS__1_END_OF_SEQUENCE (0x00000080)
#define ADC14_MCTL_INCH__0 (0x00000000)
#define ADC14_MCTL_INCH__1 (0x00000001)
#define ADC14_MCTL_INCH__10 (0x0000000a)
#define ADC14_MCTL_INCH__11 (0x0000000b)
#define ADC14_MCTL_INCH__12 (0x0000000c)
#define ADC14_MCTL_INCH__13 (0x0000000d)
#define ADC14_MCTL_INCH__14 (0x0000000e)
#define ADC14_MCTL_INCH__15 (0x0000000f)
#define ADC14_MCTL_INCH__16 (0x00000010)
#define ADC14_MCTL_INCH__17 (0x00000011)
#define ADC14_MCTL_INCH__18 (0x00000012)
#define ADC14_MCTL_INCH__19 (0x00000013)
#define ADC14_MCTL_INCH__2 (0x00000002)
#define ADC14_MCTL_INCH__20 (0x00000014)
#define ADC14_MCTL_INCH__21 (0x00000015)
#define ADC14_MCTL_INCH__22 (0x00000016)
#define ADC14_MCTL_INCH__23 (0x00000017)
#define ADC14_MCTL_INCH__24 (0x00000018)
#define ADC14_MCTL_INCH__25 (0x00000019)
#define ADC14_MCTL_INCH__26 (0x0000001a)
#define ADC14_MCTL_INCH__27 (0x0000001b)
#define ADC14_MCTL_INCH__28 (0x0000001c)
#define ADC14_MCTL_INCH__29 (0x0000001d)
#define ADC14_MCTL_INCH__3 (0x00000003)
#define ADC14_MCTL_INCH__30 (0x0000001e)
#define ADC14_MCTL_INCH__31 (0x0000001f)
#define ADC14_MCTL_INCH__4 (0x00000004)
#define ADC14_MCTL_INCH__5 (0x00000005)
#define ADC14_MCTL_INCH__6 (0x00000006)
#define ADC14_MCTL_INCH__7 (0x00000007)
#define ADC14_MCTL_INCH__8 (0x00000008)
#define ADC14_MCTL_INCH__9 (0x00000009)
#define ADC14_MCTL_INCH__M (0x0000001f)
#define ADC14_MCTL_VRSEL__0 (0x00000000)
#define ADC14_MCTL_VRSEL__1 (0x00000100)
#define ADC14_MCTL_VRSEL__14 (0x00000e00)
#define ADC14_MCTL_VRSEL__15 (0x00000f00)
#define ADC14_MCTL_VRSEL__M (0x00000f00)
#define ADC14_MCTL_WINC (0x00004000)
#define ADC14_MCTL_WINCTH (0x00008000)
#define ADC14_MCTL_WINCTH__0 (0x00000000)
#define ADC14_MCTL_WINCTH__1 (0x00008000)
#define ADC14_MCTL_WINC__0 (0x00000000)
#define ADC14_MCTL_WINC__1 (0x00004000)
#define ADC14_MEM0 (HWREG32(0x40012098))
#define ADC14_MEM1 (HWREG32(0x4001209C))
#define ADC14_MEM10 (HWREG32(0x400120C0))
#define ADC14_MEM11 (HWREG32(0x400120C4))
#define ADC14_MEM12 (HWREG32(0x400120C8))
#define ADC14_MEM13 (HWREG32(0x400120CC))
#define ADC14_MEM14 (HWREG32(0x400120D0))
#define ADC14_MEM15 (HWREG32(0x400120D4))
#define ADC14_MEM16 (HWREG32(0x400120D8))
#define ADC14_MEM17 (HWREG32(0x400120DC))
#define ADC14_MEM18 (HWREG32(0x400120E0))
#define ADC14_MEM19 (HWREG32(0x400120E4))
#define ADC14_MEM2 (HWREG32(0x400120A0))
#define ADC14_MEM20 (HWREG32(0x400120E8))
#define ADC14_MEM21 (HWREG32(0x400120EC))
#define ADC14_MEM22 (HWREG32(0x400120F0))
#define ADC14_MEM23 (HWREG32(0x400120F4))
#define ADC14_MEM24 (HWREG32(0x400120F8))
#define ADC14_MEM25 (HWREG32(0x400120FC))
#define ADC14_MEM26 (HWREG32(0x40012100))
#define ADC14_MEM27 (HWREG32(0x40012104))
#define ADC14_MEM28 (HWREG32(0x40012108))
#define ADC14_MEM29 (HWREG32(0x4001210C))
#define ADC14_MEM3 (HWREG32(0x400120A4))
#define ADC14_MEM30 (HWREG32(0x40012110))
#define ADC14_MEM31 (HWREG32(0x40012114))
#define ADC14_MEM4 (HWREG32(0x400120A8))
#define ADC14_MEM5 (HWREG32(0x400120AC))
#define ADC14_MEM6 (HWREG32(0x400120B0))
#define ADC14_MEM7 (HWREG32(0x400120B4))
#define ADC14_MEM8 (HWREG32(0x400120B8))
#define ADC14_MEM9 (HWREG32(0x400120BC))
#define ADC14_MEM_CONVERSION_RESULTS__M (0x0000ffff)
#define ADC14_NUMCH_M (0x00000060)
#define ADC14_TESTPORTSEL20_M (0x00000700)
#define ADC14_TMBOOST (0x02000000)
#define ADC14_TMCLKDEL_M (0xc0000000)
#define ADC14_TMCMRFI (0x00000010)
#define ADC14_TMENCAL_M (0x00c00000)
#define ADC14_TMEXTREF_M (0x00000060)
#define ADC14_TMFINESTORE_M (0x00000300)
#define ADC14_TMHIBW_M (0x00003000)
#define ADC14_TMHPMC (0x00000200)
#define ADC14_TMHPMF (0x00000100)
#define ADC14_TMIBIAS_M (0x00000003)
#define ADC14_TMIPREAMPF_M (0x000f0000)
#define ADC14_TMLPMREF_M (0x0c000000)
#define ADC14_TMMUXON (0x00000080)
#define ADC14_TMPMLATCHC_M (0x70000000)
#define ADC14_TMPMLATCHF_M (0x07000000)
#define ADC14_TMPREAMPC_M (0x000000f0)
#define ADC14_TMPREAMPF_M (0x0000000f)
#define ADC14_TMREF1CTRL_M (0x00001c00)
#define ADC14_TMREF2CTRL_M (0x0000e000)
#define ADC14_TMREFINTPAD (0x00000080)
#define ADC14_TMREFOUTCTRL_M (0x00000007)
#define ADC14_TMSELCAPZ_M (0x30000000)
#define ADC14_TMSPARE_M (0x0000ff00)
#define ADC14_TSTCHEN_M (0x00006000)
#define ADC14_TSTCHSEL3932_M (0x000000ff)
#define AES256_ACTL0 (HWREG16(0x40003C00))
#define AES256_ACTL0_CMEN (0x8000)
#define AES256_ACTL0_CMEN__0 (0x0000)
#define AES256_ACTL0_CMEN__1 (0x8000)
#define AES256_ACTL0_CM__0 (0x0000)
#define AES256_ACTL0_CM__0_ECB (0x0000)
#define AES256_ACTL0_CM__1 (0x0020)
#define AES256_ACTL0_CM__1_CBC (0x0020)
#define AES256_ACTL0_CM__2 (0x0040)
#define AES256_ACTL0_CM__2_OFB (0x0040)
#define AES256_ACTL0_CM__3 (0x0060)
#define AES256_ACTL0_CM__3_CFB (0x0060)
#define AES256_ACTL0_CM__M (0x0060)
#define AES256_ACTL0_ERRFG (0x0800)
#define AES256_ACTL0_ERRFG__0 (0x0000)
#define AES256_ACTL0_ERRFG__0_NO_ERROR (0x0000)
#define AES256_ACTL0_ERRFG__1 (0x0800)
#define AES256_ACTL0_ERRFG__1_ERROR_OCCURRED (0x0800)
#define AES256_ACTL0_KL__0 (0x0000)
#define AES256_ACTL0_KL__1 (0x0004)
#define AES256_ACTL0_KL__2 (0x0008)
#define AES256_ACTL0_KL__M (0x000c)
#define AES256_ACTL0_OP__0 (0x0000)
#define AES256_ACTL0_OP__0_ENCRYPTION (0x0000)
#define AES256_ACTL0_OP__1 (0x0001)
#define AES256_ACTL0_OP__2 (0x0002)
#define AES256_ACTL0_OP__3 (0x0003)
#define AES256_ACTL0_OP__M (0x0003)
#define AES256_ACTL0_RDYIE (0x1000)
#define AES256_ACTL0_RDYIE__0 (0x0000)
#define AES256_ACTL0_RDYIE__1 (0x1000)
#define AES256_ACTL0_RDYIFG (0x0100)
#define AES256_ACTL0_RDYIFG__0 (0x0000)
#define AES256_ACTL0_RDYIFG__1 (0x0100)
#define AES256_ACTL0_SWRST (0x0080)
#define AES256_ACTL0_SWRST__0 (0x0000)
#define AES256_ACTL0_SWRST__0_NO_RESET (0x0000)
#define AES256_ACTL0_SWRST__1 (0x0080)
#define AES256_ACTL1 (HWREG16(0x40003C02))
#define AES256_ACTL1_BLKCNT__M (0x00ff)
#define AES256_ADIN (HWREG16(0x40003C08))
#define AES256_ADIN_DIN0__M (0x00ff)
#define AES256_ADIN_DIN1__M (0xff00)
#define AES256_ADOUT (HWREG16(0x40003C0A))
#define AES256_ADOUT_DOUT0__M (0x00ff)
#define AES256_ADOUT_DOUT1__M (0xff00)
#define AES256_AKEY (HWREG16(0x40003C06))
#define AES256_AKEY_KEY0__M (0x00ff)
#define AES256_AKEY_KEY1__M (0xff00)
#define AES256_ASTAT (HWREG16(0x40003C04))
#define AES256_ASTAT_BUSY (0x0001)
#define AES256_ASTAT_BUSY__0 (0x0000)
#define AES256_ASTAT_BUSY__0_NOT_BUSY (0x0000)
#define AES256_ASTAT_BUSY__1 (0x0001)
#define AES256_ASTAT_BUSY__1_BUSY (0x0001)
#define AES256_ASTAT_DINCNT__M (0x0f00)
#define AES256_ASTAT_DINWR (0x0004)
#define AES256_ASTAT_DINWR__0 (0x0000)
#define AES256_ASTAT_DINWR__1 (0x0004)
#define AES256_ASTAT_DOUTCNT__M (0xf000)
#define AES256_ASTAT_DOUTRD (0x0008)
#define AES256_ASTAT_DOUTRD__0 (0x0000)
#define AES256_ASTAT_DOUTRD__1 (0x0008)
#define AES256_ASTAT_DOUTRD__1_ALL_BYTES_READ (0x0008)
#define AES256_ASTAT_KEYCNT__M (0x00f0)
#define AES256_ASTAT_KEYWR (0x0002)
#define AES256_ASTAT_KEYWR__0 (0x0000)
#define AES256_ASTAT_KEYWR__1 (0x0002)
#define AES256_AXDIN (HWREG16(0x40003C0C))
#define AES256_AXDIN_XDIN0__M (0x00ff)
#define AES256_AXDIN_XDIN1__M (0xff00)
#define AES256_AXIN (HWREG16(0x40003C0E))
#define AES256_AXIN_XIN0__M (0x00ff)
#define AES256_AXIN_XIN1__M (0xff00)
#define AESBLKCNT0_L (0x0001)
#define AESBLKCNT1_L (0x0002)
#define AESBLKCNT2_L (0x0004)
#define AESBLKCNT3_L (0x0008)
#define AESBLKCNT4_L (0x0010)
#define AESBLKCNT5_L (0x0020)
#define AESBLKCNT6_L (0x0040)
#define AESBLKCNT7_L (0x0080)
#define AESBUSY_L (0x0001)
#define AESCM0_L (0x0020)
#define AESCM1_L (0x0040)
#define AESCMEN_H (0x0080)
#define AESDINCNT0_H (0x0001)
#define AESDINCNT1_H (0x0002)
#define AESDINCNT2_H (0x0004)
#define AESDINCNT3_H (0x0008)
#define AESDINWR_L (0x0004)
#define AESDOUTCNT0_H (0x0010)
#define AESDOUTCNT1_H (0x0020)
#define AESDOUTCNT2_H (0x0040)
#define AESDOUTCNT3_H (0x0080)
#define AESDOUTRD_L (0x0008)
#define AESERRFG_H (0x0008)
#define AESKEYCNT0_L (0x0010)
#define AESKEYCNT1_L (0x0020)
#define AESKEYCNT2_L (0x0040)
#define AESKEYCNT3_L (0x0080)
#define AESKEYWR_L (0x0002)
#define AESKL0_L (0x0004)
#define AESKL1_L (0x0008)
#define AESKL__128 (0x0000)
#define AESKL__192 (0x0004)
#define AESKL__256 (0x0008)
#define AESOP0_L (0x0001)
#define AESOP1_L (0x0002)
#define AESRDYIE_H (0x0010)
#define AESRDYIFG_H (0x0001)
#define AESSWRST_L (0x0080)
#define AESTRIG (0x0010)
#define AESTRIG_L (0x0010)
#define AUX3RST (0x0002)
#define BCD2BIN (RTC_C_BCD2BIN)
#define BGMODE_H (0x0008)
#define BIN2BCD (RTC_C_BIN2BCD)
#define CAPES (0x0004)
#define CAPEV (0x0001)
#define CAPSIO (0x0200)
#define CAPSIO0CTL (CAPTIO0_CTL)
#define CAPSIO1CTL (CAPTIO1_CTL)
#define CAPSIOEN (0x0100)
#define CAPSIOEN_H (0x0001)
#define CAPSIOPISEL0 (0x0002)
#define CAPSIOPISEL0_L (0x0002)
#define CAPSIOPISEL1 (0x0004)
#define CAPSIOPISEL1_L (0x0004)
#define CAPSIOPISEL2 (0x0008)
#define CAPSIOPISEL2_L (0x0008)
#define CAPSIOPOSEL0 (0x0010)
#define CAPSIOPOSEL0_L (0x0010)
#define CAPSIOPOSEL1 (0x0020)
#define CAPSIOPOSEL1_L (0x0020)
#define CAPSIOPOSEL2 (0x0040)
#define CAPSIOPOSEL2_L (0x0040)
#define CAPSIOPOSEL3 (0x0080)
#define CAPSIOPOSEL3_L (0x0080)
#define CAPSIO_H (0x0002)
#define CAPTIO0_CTL (HWREG16(0x4000540E))
#define CAPTIO0_CTL_EN (0x0100)
#define CAPTIO0_CTL_EN__0 (0x0000)
#define CAPTIO0_CTL_EN__1 (0x0100)
#define CAPTIO0_CTL_PISEL__0 (0x0000)
#define CAPTIO0_CTL_PISEL__0_PX_0 (0x0000)
#define CAPTIO0_CTL_PISEL__1 (0x0002)
#define CAPTIO0_CTL_PISEL__1_PX_1 (0x0002)
#define CAPTIO0_CTL_PISEL__2 (0x0004)
#define CAPTIO0_CTL_PISEL__2_PX_2 (0x0004)
#define CAPTIO0_CTL_PISEL__3 (0x0006)
#define CAPTIO0_CTL_PISEL__3_PX_3 (0x0006)
#define CAPTIO0_CTL_PISEL__4 (0x0008)
#define CAPTIO0_CTL_PISEL__4_PX_4 (0x0008)
#define CAPTIO0_CTL_PISEL__5 (0x000a)
#define CAPTIO0_CTL_PISEL__5_PX_5 (0x000a)
#define CAPTIO0_CTL_PISEL__6 (0x000c)
#define CAPTIO0_CTL_PISEL__6_PX_6 (0x000c)
#define CAPTIO0_CTL_PISEL__7 (0x000e)
#define CAPTIO0_CTL_PISEL__7_PX_7 (0x000e)
#define CAPTIO0_CTL_PISEL__M (0x000e)
#define CAPTIO0_CTL_POSEL__0 (0x0000)
#define CAPTIO0_CTL_POSEL__0_PX___PJ (0x0000)
#define CAPTIO0_CTL_POSEL__1 (0x0010)
#define CAPTIO0_CTL_POSEL__10 (0x00a0)
#define CAPTIO0_CTL_POSEL__10_PX___P10 (0x00a0)
#define CAPTIO0_CTL_POSEL__11 (0x00b0)
#define CAPTIO0_CTL_POSEL__11_PX___P11 (0x00b0)
#define CAPTIO0_CTL_POSEL__12 (0x00c0)
#define CAPTIO0_CTL_POSEL__12_PX___P12 (0x00c0)
#define CAPTIO0_CTL_POSEL__13 (0x00d0)
#define CAPTIO0_CTL_POSEL__13_PX___P13 (0x00d0)
#define CAPTIO0_CTL_POSEL__14 (0x00e0)
#define CAPTIO0_CTL_POSEL__14_PX___P14 (0x00e0)
#define CAPTIO0_CTL_POSEL__15 (0x00f0)
#define CAPTIO0_CTL_POSEL__15_PX___P15 (0x00f0)
#define CAPTIO0_CTL_POSEL__1_PX___P1 (0x0010)
#define CAPTIO0_CTL_POSEL__2 (0x0020)
#define CAPTIO0_CTL_POSEL__2_PX___P2 (0x0020)
#define CAPTIO0_CTL_POSEL__3 (0x0030)
#define CAPTIO0_CTL_POSEL__3_PX___P3 (0x0030)
#define CAPTIO0_CTL_POSEL__4 (0x0040)
#define CAPTIO0_CTL_POSEL__4_PX___P4 (0x0040)
#define CAPTIO0_CTL_POSEL__5 (0x0050)
#define CAPTIO0_CTL_POSEL__5_PX___P5 (0x0050)
#define CAPTIO0_CTL_POSEL__6 (0x0060)
#define CAPTIO0_CTL_POSEL__6_PX___P6 (0x0060)
#define CAPTIO0_CTL_POSEL__7 (0x0070)
#define CAPTIO0_CTL_POSEL__7_PX___P7 (0x0070)
#define CAPTIO0_CTL_POSEL__8 (0x0080)
#define CAPTIO0_CTL_POSEL__8_PX___P8 (0x0080)
#define CAPTIO0_CTL_POSEL__9 (0x0090)
#define CAPTIO0_CTL_POSEL__9_PX___P9 (0x0090)
#define CAPTIO0_CTL_POSEL__M (0x00f0)
#define CAPTIO0_CTL_STATE (0x0200)
#define CAPTIO0_CTL_STATE__0 (0x0000)
#define CAPTIO0_CTL_STATE__1 (0x0200)
#define CAPTIO1_CTL (HWREG16(0x4000580E))
#define CAPTIO1_CTL_EN (0x0100)
#define CAPTIO1_CTL_EN__0 (0x0000)
#define CAPTIO1_CTL_EN__1 (0x0100)
#define CAPTIO1_CTL_PISEL__0 (0x0000)
#define CAPTIO1_CTL_PISEL__0_PX_0 (0x0000)
#define CAPTIO1_CTL_PISEL__1 (0x0002)
#define CAPTIO1_CTL_PISEL__1_PX_1 (0x0002)
#define CAPTIO1_CTL_PISEL__2 (0x0004)
#define CAPTIO1_CTL_PISEL__2_PX_2 (0x0004)
#define CAPTIO1_CTL_PISEL__3 (0x0006)
#define CAPTIO1_CTL_PISEL__3_PX_3 (0x0006)
#define CAPTIO1_CTL_PISEL__4 (0x0008)
#define CAPTIO1_CTL_PISEL__4_PX_4 (0x0008)
#define CAPTIO1_CTL_PISEL__5 (0x000a)
#define CAPTIO1_CTL_PISEL__5_PX_5 (0x000a)
#define CAPTIO1_CTL_PISEL__6 (0x000c)
#define CAPTIO1_CTL_PISEL__6_PX_6 (0x000c)
#define CAPTIO1_CTL_PISEL__7 (0x000e)
#define CAPTIO1_CTL_PISEL__7_PX_7 (0x000e)
#define CAPTIO1_CTL_PISEL__M (0x000e)
#define CAPTIO1_CTL_POSEL__0 (0x0000)
#define CAPTIO1_CTL_POSEL__0_PX___PJ (0x0000)
#define CAPTIO1_CTL_POSEL__1 (0x0010)
#define CAPTIO1_CTL_POSEL__10 (0x00a0)
#define CAPTIO1_CTL_POSEL__10_PX___P10 (0x00a0)
#define CAPTIO1_CTL_POSEL__11 (0x00b0)
#define CAPTIO1_CTL_POSEL__11_PX___P11 (0x00b0)
#define CAPTIO1_CTL_POSEL__12 (0x00c0)
#define CAPTIO1_CTL_POSEL__12_PX___P12 (0x00c0)
#define CAPTIO1_CTL_POSEL__13 (0x00d0)
#define CAPTIO1_CTL_POSEL__13_PX___P13 (0x00d0)
#define CAPTIO1_CTL_POSEL__14 (0x00e0)
#define CAPTIO1_CTL_POSEL__14_PX___P14 (0x00e0)
#define CAPTIO1_CTL_POSEL__15 (0x00f0)
#define CAPTIO1_CTL_POSEL__15_PX___P15 (0x00f0)
#define CAPTIO1_CTL_POSEL__1_PX___P1 (0x0010)
#define CAPTIO1_CTL_POSEL__2 (0x0020)
#define CAPTIO1_CTL_POSEL__2_PX___P2 (0x0020)
#define CAPTIO1_CTL_POSEL__3 (0x0030)
#define CAPTIO1_CTL_POSEL__3_PX___P3 (0x0030)
#define CAPTIO1_CTL_POSEL__4 (0x0040)
#define CAPTIO1_CTL_POSEL__4_PX___P4 (0x0040)
#define CAPTIO1_CTL_POSEL__5 (0x0050)
#define CAPTIO1_CTL_POSEL__5_PX___P5 (0x0050)
#define CAPTIO1_CTL_POSEL__6 (0x0060)
#define CAPTIO1_CTL_POSEL__6_PX___P6 (0x0060)
#define CAPTIO1_CTL_POSEL__7 (0x0070)
#define CAPTIO1_CTL_POSEL__7_PX___P7 (0x0070)
#define CAPTIO1_CTL_POSEL__8 (0x0080)
#define CAPTIO1_CTL_POSEL__8_PX___P8 (0x0080)
#define CAPTIO1_CTL_POSEL__9 (0x0090)
#define CAPTIO1_CTL_POSEL__9_PX___P9 (0x0090)
#define CAPTIO1_CTL_POSEL__M (0x00f0)
#define CAPTIO1_CTL_STATE (0x0200)
#define CAPTIO1_CTL_STATE__0 (0x0000)
#define CAPTIO1_CTL_STATE__1 (0x0200)
#define CCIS0 (0x1000)
#define CCIS1 (0x2000)
#define CE0CTL0_H (HWREG8_H(CE0CTL0))
#define CE0CTL0_L (HWREG8_L(CE0CTL0))
#define CE0CTL1_H (HWREG8_H(CE0CTL1))
#define CE0CTL1_L (HWREG8_L(CE0CTL1))
#define CE0CTL2_H (HWREG8_H(CE0CTL2))
#define CE0CTL2_L (HWREG8_L(CE0CTL2))
#define CE0CTL3_H (HWREG8_H(CE0CTL3))
#define CE0CTL3_L (HWREG8_L(CE0CTL3))
#define CE0EX (0x0020)
#define CE0EX_L (0x0020)
#define CE0F (0x0004)
#define CE0FDLY0 (0x0040)
#define CE0FDLY0_L (0x0040)
#define CE0FDLY1 (0x0080)
#define CE0FDLY1_L (0x0080)
#define CE0FDLY_0 (0x0000)
#define CE0FDLY_1 (0x0040)
#define CE0FDLY_2 (0x0080)
#define CE0FDLY_3 (0x00C0)
#define CE0F_L (0x0004)
#define CE0IE (0x0100)
#define CE0IES (0x0008)
#define CE0IES_L (0x0008)
#define CE0IE_H (0x0001)
#define CE0IFG (0x0001)
#define CE0IFG_L (0x0001)
#define CE0IIE (0x0200)
#define CE0IIE_H (0x0002)
#define CE0IIFG (0x0002)
#define CE0IIFG_L (0x0002)
#define CE0IMEN (0x8000)
#define CE0IMEN_H (0x0080)
#define CE0IMSEL0 (0x0100)
#define CE0IMSEL0_H (0x0001)
#define CE0IMSEL1 (0x0200)
#define CE0IMSEL1_H (0x0002)
#define CE0IMSEL2 (0x0400)
#define CE0IMSEL2_H (0x0004)
#define CE0IMSEL3 (0x0800)
#define CE0IMSEL3_H (0x0008)
#define CE0IMSEL_0 (0x0000)
#define CE0IMSEL_1 (0x0100)
#define CE0IMSEL_10 (0x0A00)
#define CE0IMSEL_11 (0x0B00)
#define CE0IMSEL_12 (0x0C00)
#define CE0IMSEL_13 (0x0D00)
#define CE0IMSEL_14 (0x0E00)
#define CE0IMSEL_15 (0x0F00)
#define CE0IMSEL_2 (0x0200)
#define CE0IMSEL_3 (0x0300)
#define CE0IMSEL_4 (0x0400)
#define CE0IMSEL_5 (0x0500)
#define CE0IMSEL_6 (0x0600)
#define CE0IMSEL_7 (0x0700)
#define CE0IMSEL_8 (0x0800)
#define CE0IMSEL_9 (0x0900)
#define CE0INT_H (HWREG8_H(CE0INT))
#define CE0INT_L (HWREG8_L(CE0INT))
#define CE0IPEN (0x0080)
#define CE0IPEN_L (0x0080)
#define CE0IPSEL0 (0x0001)
#define CE0IPSEL0_L (0x0001)
#define CE0IPSEL1 (0x0002)
#define CE0IPSEL1_L (0x0002)
#define CE0IPSEL2 (0x0004)
#define CE0IPSEL2_L (0x0004)
#define CE0IPSEL3 (0x0008)
#define CE0IPSEL3_L (0x0008)
#define CE0IPSEL_0 (0x0000)
#define CE0IPSEL_1 (0x0001)
#define CE0IPSEL_10 (0x000A)
#define CE0IPSEL_11 (0x000B)
#define CE0IPSEL_12 (0x000C)
#define CE0IPSEL_13 (0x000D)
#define CE0IPSEL_14 (0x000E)
#define CE0IPSEL_15 (0x000F)
#define CE0IPSEL_2 (0x0002)
#define CE0IPSEL_3 (0x0003)
#define CE0IPSEL_4 (0x0004)
#define CE0IPSEL_5 (0x0005)
#define CE0IPSEL_6 (0x0006)
#define CE0IPSEL_7 (0x0007)
#define CE0IPSEL_8 (0x0008)
#define CE0IPSEL_9 (0x0009)
#define CE0IV_CEIFG (0x0002)
#define CE0IV_CEIIFG (0x0004)
#define CE0IV_CERDYIFG (0x000A)
#define CE0IV_H (HWREG8_H(CE0IV))
#define CE0IV_L (HWREG8_L(CE0IV))
#define CE0IV_NONE (0x0000)
#define CE0MRVL (0x0800)
#define CE0MRVL_H (0x0008)
#define CE0MRVS (0x1000)
#define CE0MRVS_H (0x0010)
#define CE0ON (0x0400)
#define CE0ON_H (0x0004)
#define CE0OUT (0x0001)
#define CE0OUTPOL (0x0002)
#define CE0OUTPOL_L (0x0002)
#define CE0OUT_L (0x0001)
#define CE0PD0 (0x0001)
#define CE0PD0_L (0x0001)
#define CE0PD1 (0x0002)
#define CE0PD10 (0x0400)
#define CE0PD10_H (0x0004)
#define CE0PD11 (0x0800)
#define CE0PD11_H (0x0008)
#define CE0PD12 (0x1000)
#define CE0PD12_H (0x0010)
#define CE0PD13 (0x2000)
#define CE0PD13_H (0x0020)
#define CE0PD14 (0x4000)
#define CE0PD14_H (0x0040)
#define CE0PD15 (0x8000)
#define CE0PD15_H (0x0080)
#define CE0PD1_L (0x0002)
#define CE0PD2 (0x0004)
#define CE0PD2_L (0x0004)
#define CE0PD3 (0x0008)
#define CE0PD3_L (0x0008)
#define CE0PD4 (0x0010)
#define CE0PD4_L (0x0010)
#define CE0PD5 (0x0020)
#define CE0PD5_L (0x0020)
#define CE0PD6 (0x0040)
#define CE0PD6_L (0x0040)
#define CE0PD7 (0x0080)
#define CE0PD7_L (0x0080)
#define CE0PD8 (0x0100)
#define CE0PD8_H (0x0001)
#define CE0PD9 (0x0200)
#define CE0PD9_H (0x0002)
#define CE0PWRMD0 (0x0100)
#define CE0PWRMD0_H (0x0001)
#define CE0PWRMD1 (0x0200)
#define CE0PWRMD1_H (0x0002)
#define CE0PWRMD_0 (0x0000)
#define CE0PWRMD_1 (0x0100)
#define CE0PWRMD_2 (0x0200)
#define CE0PWRMD_3 (0x0300)
#define CE0RDYIE (0x1000)
#define CE0RDYIE_H (0x0010)
#define CE0RDYIFG (0x0010)
#define CE0RDYIFG_L (0x0010)
#define CE0REF00 (0x0001)
#define CE0REF00_L (0x0001)
#define CE0REF01 (0x0002)
#define CE0REF01_L (0x0002)
#define CE0REF02 (0x0004)
#define CE0REF02_L (0x0004)
#define CE0REF03 (0x0008)
#define CE0REF03_L (0x0008)
#define CE0REF04 (0x0010)
#define CE0REF04_L (0x0010)
#define CE0REF0_0 (0x0000)
#define CE0REF0_10 (0x000A)
#define CE0REF0_11 (0x000B)
#define CE0REF0_12 (0x000C)
#define CE0REF0_13 (0x000D)
#define CE0REF0_14 (0x000E)
#define CE0REF0_15 (0x000F)
#define CE0REF0_16 (0x0010)
#define CE0REF0_17 (0x0011)
#define CE0REF0_18 (0x0012)
#define CE0REF0_19 (0x0013)
#define CE0REF0_2 (0x0002)
#define CE0REF0_20 (0x0014)
#define CE0REF0_21 (0x0015)
#define CE0REF0_22 (0x0016)
#define CE0REF0_23 (0x0017)
#define CE0REF0_24 (0x0018)
#define CE0REF0_25 (0x0019)
#define CE0REF0_26 (0x001A)
#define CE0REF0_27 (0x001B)
#define CE0REF0_28 (0x001C)
#define CE0REF0_29 (0x001D)
#define CE0REF0_3 (0x0003)
#define CE0REF0_30 (0x001E)
#define CE0REF0_31 (0x001F)
#define CE0REF0_4 (0x0004)
#define CE0REF0_5 (0x0005)
#define CE0REF0_6 (0x0006)
#define CE0REF0_7 (0x0007)
#define CE0REF0_8 (0x0008)
#define CE0REF0_9 (0x0009)
#define CE0REF10 (0x0100)
#define CE0REF10_H (0x0001)
#define CE0REF11 (0x0200)
#define CE0REF11_H (0x0002)
#define CE0REF12 (0x0400)
#define CE0REF12_H (0x0004)
#define CE0REF13 (0x0800)
#define CE0REF13_H (0x0008)
#define CE0REF14 (0x1000)
#define CE0REF14_H (0x0010)
#define CE0REF1_0 (0x0000)
#define CE0REF1_1 (0x0100)
#define CE0REF1_10 (0x0A00)
#define CE0REF1_11 (0x0B00)
#define CE0REF1_12 (0x0C00)
#define CE0REF1_13 (0x0D00)
#define CE0REF1_14 (0x0E00)
#define CE0REF1_15 (0x0F00)
#define CE0REF1_16 (0x1000)
#define CE0REF1_17 (0x1100)
#define CE0REF1_18 (0x1200)
#define CE0REF1_19 (0x1300)
#define CE0REF1_2 (0x0200)
#define CE0REF1_20 (0x1400)
#define CE0REF1_21 (0x1500)
#define CE0REF1_22 (0x1600)
#define CE0REF1_23 (0x1700)
#define CE0REF1_24 (0x1800)
#define CE0REF1_25 (0x1900)
#define CE0REF1_26 (0x1A00)
#define CE0REF1_27 (0x1B00)
#define CE0REF1_28 (0x1C00)
#define CE0REF1_29 (0x1D00)
#define CE0REF1_3 (0x0300)
#define CE0REF1_30 (0x1E00)
#define CE0REF1_31 (0x1F00)
#define CE0REF1_4 (0x0400)
#define CE0REF1_5 (0x0500)
#define CE0REF1_6 (0x0600)
#define CE0REF1_7 (0x0700)
#define CE0REF1_8 (0x0800)
#define CE0REF1_9 (0x0900)
#define CE0REFACC (0x8000)
#define CE0REFACC_H (0x0080)
#define CE0REFL0 (0x2000)
#define CE0REFL0_H (0x0020)
#define CE0REFL1 (0x4000)
#define CE0REFL1_H (0x0040)
#define CE0REFL_0 (0x0000)
#define CE0REFL_1 (0x2000)
#define CE0REFL_2 (0x4000)
#define CE0REFL_3 (0x6000)
#define CE0RS0 (0x0040)
#define CE0RS0_L (0x0040)
#define CE0RS1 (0x0080)
#define CE0RS1_L (0x0080)
#define CE0RSEL (0x0020)
#define CE0RSEL_L (0x0020)
#define CE0RS_0 (0x0000)
#define CE0RS_2 (0x0080)
#define CE0RS_3 (0x00C0)
#define CE0SHORT (0x0010)
#define CE0SHORT_L (0x0010)
#define CECTL0 (COMP_E0_CTL0)
#define CECTL0_H (HWREG8_H(CECTL0))
#define CECTL0_L (HWREG8_L(CECTL0))
#define CECTL1 (COMP_E0_CTL1)
#define CECTL1_H (HWREG8_H(CECTL1))
#define CECTL1_L (HWREG8_L(CECTL1))
#define CECTL2 (COMP_E0_CTL2)
#define CECTL2_H (HWREG8_H(CECTL2))
#define CECTL2_L (HWREG8_L(CECTL2))
#define CECTL3 (COMP_E0_CTL3)
#define CECTL3_H (HWREG8_H(CECTL3))
#define CECTL3_L (HWREG8_L(CECTL3))
#define CEEX_L (0x0020)
#define CEFDLY0 (0x0040)
#define CEFDLY0_L (0x0040)
#define CEFDLY1 (0x0080)
#define CEFDLY1_L (0x0080)
#define CEF_L (0x0004)
#define CEIES_L (0x0008)
#define CEIE_H (0x0001)
#define CEIFG_L (0x0001)
#define CEIIE_H (0x0002)
#define CEIIFG_L (0x0002)
#define CEIMEN_H (0x0080)
#define CEIMSEL0 (0x0100)
#define CEIMSEL0_H (0x0001)
#define CEIMSEL1 (0x0200)
#define CEIMSEL1_H (0x0002)
#define CEIMSEL2 (0x0400)
#define CEIMSEL2_H (0x0004)
#define CEIMSEL3 (0x0800)
#define CEIMSEL3_H (0x0008)
#define CEIMSEL_0 (0x0000)
#define CEIMSEL_1 (0x0100)
#define CEIMSEL_10 (0x0A00)
#define CEIMSEL_11 (0x0B00)
#define CEIMSEL_12 (0x0C00)
#define CEIMSEL_13 (0x0D00)
#define CEIMSEL_14 (0x0E00)
#define CEIMSEL_15 (0x0F00)
#define CEIMSEL_2 (0x0200)
#define CEIMSEL_3 (0x0300)
#define CEIMSEL_4 (0x0400)
#define CEIMSEL_5 (0x0500)
#define CEIMSEL_6 (0x0600)
#define CEIMSEL_7 (0x0700)
#define CEIMSEL_8 (0x0800)
#define CEIMSEL_9 (0x0900)
#define CEINT (COMP_E0_INT)
#define CEINT_H (HWREG8_H(CEINT))
#define CEINT_L (HWREG8_L(CEINT))
#define CEIPEN_L (0x0080)
#define CEIPSEL0 (0x0001)
#define CEIPSEL0_L (0x0001)
#define CEIPSEL1 (0x0002)
#define CEIPSEL1_L (0x0002)
#define CEIPSEL2 (0x0004)
#define CEIPSEL2_L (0x0004)
#define CEIPSEL3 (0x0008)
#define CEIPSEL3_L (0x0008)
#define CEIPSEL_0 (0x0000)
#define CEIPSEL_1 (0x0001)
#define CEIPSEL_10 (0x000A)
#define CEIPSEL_11 (0x000B)
#define CEIPSEL_12 (0x000C)
#define CEIPSEL_13 (0x000D)
#define CEIPSEL_14 (0x000E)
#define CEIPSEL_15 (0x000F)
#define CEIPSEL_2 (0x0002)
#define CEIPSEL_3 (0x0003)
#define CEIPSEL_4 (0x0004)
#define CEIPSEL_5 (0x0005)
#define CEIPSEL_6 (0x0006)
#define CEIPSEL_7 (0x0007)
#define CEIPSEL_8 (0x0008)
#define CEIPSEL_9 (0x0009)
#define CEIV (COMP_E0_IV)
#define CEIV_CEIFG (0x0002)
#define CEIV_CEIIFG (0x0004)
#define CEIV_CERDYIFG (0x000A)
#define CEIV_H (HWREG8_H(CEIV))
#define CEIV_L (HWREG8_L(CEIV))
#define CEIV_NONE (0x0000)
#define CEMRVL_H (0x0008)
#define CEMRVS_H (0x0010)
#define CEON_H (0x0004)
#define CEOUTPOL_L (0x0002)
#define CEOUT_L (0x0001)
#define CEPD0_L (0x0001)
#define CEPD10_H (0x0004)
#define CEPD11_H (0x0008)
#define CEPD12_H (0x0010)
#define CEPD13_H (0x0020)
#define CEPD14_H (0x0040)
#define CEPD15_H (0x0080)
#define CEPD1_L (0x0002)
#define CEPD2_L (0x0004)
#define CEPD3_L (0x0008)
#define CEPD4_L (0x0010)
#define CEPD5_L (0x0020)
#define CEPD6_L (0x0040)
#define CEPD7_L (0x0080)
#define CEPD8_H (0x0001)
#define CEPD9_H (0x0002)
#define CEPWRMD0 (0x0100)
#define CEPWRMD0_H (0x0001)
#define CEPWRMD1 (0x0200)
#define CEPWRMD1_H (0x0002)
#define CEPWRMD_3 (0x0300)
#define CERDYIE_H (0x0010)
#define CERDYIFG_L (0x0010)
#define CEREF00 (0x0001)
#define CEREF00_L (0x0001)
#define CEREF01 (0x0002)
#define CEREF01_L (0x0002)
#define CEREF02 (0x0004)
#define CEREF02_L (0x0004)
#define CEREF03 (0x0008)
#define CEREF03_L (0x0008)
#define CEREF04 (0x0010)
#define CEREF04_L (0x0010)
#define CEREF0_0 (0x0000)
#define CEREF0_1 (0x0001)
#define CEREF0_10 (0x000A)
#define CEREF0_11 (0x000B)
#define CEREF0_12 (0x000C)
#define CEREF0_13 (0x000D)
#define CEREF0_14 (0x000E)
#define CEREF0_15 (0x000F)
#define CEREF0_16 (0x0010)
#define CEREF0_17 (0x0011)
#define CEREF0_18 (0x0012)
#define CEREF0_19 (0x0013)
#define CEREF0_2 (0x0002)
#define CEREF0_20 (0x0014)
#define CEREF0_21 (0x0015)
#define CEREF0_22 (0x0016)
#define CEREF0_23 (0x0017)
#define CEREF0_24 (0x0018)
#define CEREF0_25 (0x0019)
#define CEREF0_26 (0x001A)
#define CEREF0_27 (0x001B)
#define CEREF0_28 (0x001C)
#define CEREF0_29 (0x001D)
#define CEREF0_3 (0x0003)
#define CEREF0_30 (0x001E)
#define CEREF0_31 (0x001F)
#define CEREF0_4 (0x0004)
#define CEREF0_5 (0x0005)
#define CEREF0_6 (0x0006)
#define CEREF0_7 (0x0007)
#define CEREF0_8 (0x0008)
#define CEREF0_9 (0x0009)
#define CEREF10 (0x0100)
#define CEREF10_H (0x0001)
#define CEREF11 (0x0200)
#define CEREF11_H (0x0002)
#define CEREF12 (0x0400)
#define CEREF12_H (0x0004)
#define CEREF13 (0x0800)
#define CEREF13_H (0x0008)
#define CEREF14 (0x1000)
#define CEREF14_H (0x0010)
#define CEREF1_0 (0x0000)
#define CEREF1_1 (0x0100)
#define CEREF1_10 (0x0A00)
#define CEREF1_11 (0x0B00)
#define CEREF1_12 (0x0C00)
#define CEREF1_13 (0x0D00)
#define CEREF1_14 (0x0E00)
#define CEREF1_15 (0x0F00)
#define CEREF1_16 (0x1000)
#define CEREF1_17 (0x1100)
#define CEREF1_18 (0x1200)
#define CEREF1_19 (0x1300)
#define CEREF1_2 (0x0200)
#define CEREF1_20 (0x1400)
#define CEREF1_21 (0x1500)
#define CEREF1_22 (0x1600)
#define CEREF1_23 (0x1700)
#define CEREF1_24 (0x1800)
#define CEREF1_25 (0x1900)
#define CEREF1_26 (0x1A00)
#define CEREF1_27 (0x1B00)
#define CEREF1_28 (0x1C00)
#define CEREF1_29 (0x1D00)
#define CEREF1_3 (0x0300)
#define CEREF1_30 (0x1E00)
#define CEREF1_31 (0x1F00)
#define CEREF1_4 (0x0400)
#define CEREF1_5 (0x0500)
#define CEREF1_6 (0x0600)
#define CEREF1_7 (0x0700)
#define CEREF1_8 (0x0800)
#define CEREF1_9 (0x0900)
#define CEREFACC_H (0x0080)
#define CEREFL0 (0x2000)
#define CEREFL0_H (0x0020)
#define CEREFL1 (0x4000)
#define CEREFL1_H (0x0040)
#define CERS0 (0x0040)
#define CERS0_L (0x0040)
#define CERS1 (0x0080)
#define CERS1_L (0x0080)
#define CERSEL_L (0x0020)
#define CESHORT_L (0x0010)
#define CLRADC14HIIFG_0 (0x00000000)
#define CLRADC14HIIFG_0_NO_EFFECT (0x00000000)
#define CLRADC14HIIFG_1 (0x00000008)
#define CLRADC14IFG0_0 (0x00000000)
#define CLRADC14IFG0_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG0_1 (0x00000001)
#define CLRADC14IFG10_0 (0x00000000)
#define CLRADC14IFG10_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG10_1 (0x00000400)
#define CLRADC14IFG11_0 (0x00000000)
#define CLRADC14IFG11_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG11_1 (0x00000800)
#define CLRADC14IFG12_0 (0x00000000)
#define CLRADC14IFG12_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG12_1 (0x00001000)
#define CLRADC14IFG13_0 (0x00000000)
#define CLRADC14IFG13_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG13_1 (0x00002000)
#define CLRADC14IFG14_0 (0x00000000)
#define CLRADC14IFG14_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG14_1 (0x00004000)
#define CLRADC14IFG15_0 (0x00000000)
#define CLRADC14IFG15_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG15_1 (0x00008000)
#define CLRADC14IFG16_0 (0x00000000)
#define CLRADC14IFG16_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG16_1 (0x00010000)
#define CLRADC14IFG17_0 (0x00000000)
#define CLRADC14IFG17_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG17_1 (0x00020000)
#define CLRADC14IFG18_0 (0x00000000)
#define CLRADC14IFG18_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG18_1 (0x00040000)
#define CLRADC14IFG19_0 (0x00000000)
#define CLRADC14IFG19_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG19_1 (0x00080000)
#define CLRADC14IFG1_0 (0x00000000)
#define CLRADC14IFG1_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG1_1 (0x00000002)
#define CLRADC14IFG20_0 (0x00000000)
#define CLRADC14IFG20_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG20_1 (0x00100000)
#define CLRADC14IFG21_0 (0x00000000)
#define CLRADC14IFG21_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG21_1 (0x00200000)
#define CLRADC14IFG22_0 (0x00000000)
#define CLRADC14IFG22_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG22_1 (0x00400000)
#define CLRADC14IFG23_0 (0x00000000)
#define CLRADC14IFG23_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG23_1 (0x00800000)
#define CLRADC14IFG24_0 (0x00000000)
#define CLRADC14IFG24_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG24_1 (0x01000000)
#define CLRADC14IFG25_0 (0x00000000)
#define CLRADC14IFG25_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG25_1 (0x02000000)
#define CLRADC14IFG26_0 (0x00000000)
#define CLRADC14IFG26_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG26_1 (0x04000000)
#define CLRADC14IFG27_0 (0x00000000)
#define CLRADC14IFG27_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG27_1 (0x08000000)
#define CLRADC14IFG28_0 (0x00000000)
#define CLRADC14IFG28_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG28_1 (0x10000000)
#define CLRADC14IFG29_0 (0x00000000)
#define CLRADC14IFG29_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG29_1 (0x20000000)
#define CLRADC14IFG2_0 (0x00000000)
#define CLRADC14IFG2_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG2_1 (0x00000004)
#define CLRADC14IFG30_0 (0x00000000)
#define CLRADC14IFG30_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG30_1 (0x40000000)
#define CLRADC14IFG31_0 (0x00000000)
#define CLRADC14IFG31_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG31_1 (0x80000000)
#define CLRADC14IFG3_0 (0x00000000)
#define CLRADC14IFG3_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG3_1 (0x00000008)
#define CLRADC14IFG4_0 (0x00000000)
#define CLRADC14IFG4_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG4_1 (0x00000010)
#define CLRADC14IFG5_0 (0x00000000)
#define CLRADC14IFG5_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG5_1 (0x00000020)
#define CLRADC14IFG6_0 (0x00000000)
#define CLRADC14IFG6_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG6_1 (0x00000040)
#define CLRADC14IFG7_0 (0x00000000)
#define CLRADC14IFG7_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG7_1 (0x00000080)
#define CLRADC14IFG8_0 (0x00000000)
#define CLRADC14IFG8_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG8_1 (0x00000100)
#define CLRADC14IFG9_0 (0x00000000)
#define CLRADC14IFG9_0_NO_EFFECT (0x00000000)
#define CLRADC14IFG9_1 (0x00000200)
#define CLRADC14INIFG_0 (0x00000000)
#define CLRADC14INIFG_0_NO_EFFECT (0x00000000)
#define CLRADC14INIFG_1 (0x00000002)
#define CLRADC14LOIFG_0 (0x00000000)
#define CLRADC14LOIFG_0_NO_EFFECT (0x00000000)
#define CLRADC14LOIFG_1 (0x00000004)
#define CLRADC14OVIFG_0 (0x00000000)
#define CLRADC14OVIFG_0_NO_EFFECT (0x00000000)
#define CLRADC14OVIFG_1 (0x00000010)
#define CLRADC14RDYIFG_0 (0x00000000)
#define CLRADC14RDYIFG_0_NO_EFFECT (0x00000000)
#define CLRADC14RDYIFG_1 (0x00000040)
#define CLRADC14TOVIFG_0 (0x00000000)
#define CLRADC14TOVIFG_0_NO_EFFECT (0x00000000)
#define CLRADC14TOVIFG_1 (0x00000020)
#define CM0 (0x4000)
#define CM1 (0x8000)
#define COMP_E0_CTL0 (HWREG16(0x40003400))
#define COMP_E0_CTL0_IMEN (0x8000)
#define COMP_E0_CTL0_IMEN__0 (0x0000)
#define COMP_E0_CTL0_IMEN__1 (0x8000)
#define COMP_E0_CTL0_IMSEL__M (0x0f00)
#define COMP_E0_CTL0_IPEN (0x0080)
#define COMP_E0_CTL0_IPEN__0 (0x0000)
#define COMP_E0_CTL0_IPEN__1 (0x0080)
#define COMP_E0_CTL0_IPSEL__M (0x000f)
#define COMP_E0_CTL1 (HWREG16(0x40003402))
#define COMP_E0_CTL1_EX (0x0020)
#define COMP_E0_CTL1_F (0x0004)
#define COMP_E0_CTL1_FDLY__0 (0x0000)
#define COMP_E0_CTL1_FDLY__1 (0x0040)
#define COMP_E0_CTL1_FDLY__2 (0x0080)
#define COMP_E0_CTL1_FDLY__3 (0x00c0)
#define COMP_E0_CTL1_FDLY__M (0x00c0)
#define COMP_E0_CTL1_F__0 (0x0000)
#define COMP_E0_CTL1_F__1 (0x0004)
#define COMP_E0_CTL1_IES (0x0008)
#define COMP_E0_CTL1_IES__0 (0x0000)
#define COMP_E0_CTL1_IES__1 (0x0008)
#define COMP_E0_CTL1_MRVL (0x0800)
#define COMP_E0_CTL1_MRVL__0 (0x0000)
#define COMP_E0_CTL1_MRVL__1 (0x0800)
#define COMP_E0_CTL1_MRVS (0x1000)
#define COMP_E0_CTL1_MRVS__0 (0x0000)
#define COMP_E0_CTL1_MRVS__1 (0x1000)
#define COMP_E0_CTL1_ON (0x0400)
#define COMP_E0_CTL1_ON__0 (0x0000)
#define COMP_E0_CTL1_ON__0_OFF (0x0000)
#define COMP_E0_CTL1_ON__1 (0x0400)
#define COMP_E0_CTL1_ON__1_ON (0x0400)
#define COMP_E0_CTL1_OUT (0x0001)
#define COMP_E0_CTL1_OUTPOL (0x0002)
#define COMP_E0_CTL1_OUTPOL__0 (0x0000)
#define COMP_E0_CTL1_OUTPOL__0_NONINVERTED (0x0000)
#define COMP_E0_CTL1_OUTPOL__1 (0x0002)
#define COMP_E0_CTL1_OUTPOL__1_INVERTED (0x0002)
#define COMP_E0_CTL1_PWRMD__0 (0x0000)
#define COMP_E0_CTL1_PWRMD__0_HIGH_SPEED_MODE (0x0000)
#define COMP_E0_CTL1_PWRMD__1 (0x0100)
#define COMP_E0_CTL1_PWRMD__1_NORMAL_MODE (0x0100)
#define COMP_E0_CTL1_PWRMD__2 (0x0200)
#define COMP_E0_CTL1_PWRMD__M (0x0300)
#define COMP_E0_CTL1_SHORT (0x0010)
#define COMP_E0_CTL1_SHORT__0 (0x0000)
#define COMP_E0_CTL1_SHORT__1 (0x0010)
#define COMP_E0_CTL1_SHORT__1_INPUTS_SHORTED (0x0010)
#define COMP_E0_CTL2 (HWREG16(0x40003404))
#define COMP_E0_CTL2_REF0__M (0x001f)
#define COMP_E0_CTL2_REF1__M (0x1f00)
#define COMP_E0_CTL2_REFACC (0x8000)
#define COMP_E0_CTL2_REFACC__0 (0x0000)
#define COMP_E0_CTL2_REFACC__0_STATIC_MODE (0x0000)
#define COMP_E0_CTL2_REFACC__1 (0x8000)
#define COMP_E0_CTL2_REFL__0 (0x0000)
#define COMP_E0_CTL2_REFL__1 (0x2000)
#define COMP_E0_CTL2_REFL__2 (0x4000)
#define COMP_E0_CTL2_REFL__3 (0x6000)
#define COMP_E0_CTL2_REFL__M (0x6000)
#define COMP_E0_CTL2_RSEL (0x0020)
#define COMP_E0_CTL2_RSEL__0 (0x0000)
#define COMP_E0_CTL2_RSEL__1 (0x0020)
#define COMP_E0_CTL2_RS__0 (0x0000)
#define COMP_E0_CTL2_RS__1 (0x0040)
#define COMP_E0_CTL2_RS__2 (0x0080)
#define COMP_E0_CTL2_RS__3 (0x00c0)
#define COMP_E0_CTL2_RS__M (0x00c0)
#define COMP_E0_CTL3 (HWREG16(0x40003406))
#define COMP_E0_CTL3_PD0 (0x0001)
#define COMP_E0_CTL3_PD0__0 (0x0000)
#define COMP_E0_CTL3_PD0__1 (0x0001)
#define COMP_E0_CTL3_PD1 (0x0002)
#define COMP_E0_CTL3_PD10 (0x0400)
#define COMP_E0_CTL3_PD10__0 (0x0000)
#define COMP_E0_CTL3_PD10__1 (0x0400)
#define COMP_E0_CTL3_PD11 (0x0800)
#define COMP_E0_CTL3_PD11__0 (0x0000)
#define COMP_E0_CTL3_PD11__1 (0x0800)
#define COMP_E0_CTL3_PD12 (0x1000)
#define COMP_E0_CTL3_PD12__0 (0x0000)
#define COMP_E0_CTL3_PD12__1 (0x1000)
#define COMP_E0_CTL3_PD13 (0x2000)
#define COMP_E0_CTL3_PD13__0 (0x0000)
#define COMP_E0_CTL3_PD13__1 (0x2000)
#define COMP_E0_CTL3_PD14 (0x4000)
#define COMP_E0_CTL3_PD14__0 (0x0000)
#define COMP_E0_CTL3_PD14__1 (0x4000)
#define COMP_E0_CTL3_PD15 (0x8000)
#define COMP_E0_CTL3_PD15__0 (0x0000)
#define COMP_E0_CTL3_PD15__1 (0x8000)
#define COMP_E0_CTL3_PD1__0 (0x0000)
#define COMP_E0_CTL3_PD1__1 (0x0002)
#define COMP_E0_CTL3_PD2 (0x0004)
#define COMP_E0_CTL3_PD2__0 (0x0000)
#define COMP_E0_CTL3_PD2__1 (0x0004)
#define COMP_E0_CTL3_PD3 (0x0008)
#define COMP_E0_CTL3_PD3__0 (0x0000)
#define COMP_E0_CTL3_PD3__1 (0x0008)
#define COMP_E0_CTL3_PD4 (0x0010)
#define COMP_E0_CTL3_PD4__0 (0x0000)
#define COMP_E0_CTL3_PD4__1 (0x0010)
#define COMP_E0_CTL3_PD5 (0x0020)
#define COMP_E0_CTL3_PD5__0 (0x0000)
#define COMP_E0_CTL3_PD5__1 (0x0020)
#define COMP_E0_CTL3_PD6 (0x0040)
#define COMP_E0_CTL3_PD6__0 (0x0000)
#define COMP_E0_CTL3_PD6__1 (0x0040)
#define COMP_E0_CTL3_PD7 (0x0080)
#define COMP_E0_CTL3_PD7__0 (0x0000)
#define COMP_E0_CTL3_PD7__1 (0x0080)
#define COMP_E0_CTL3_PD8 (0x0100)
#define COMP_E0_CTL3_PD8__0 (0x0000)
#define COMP_E0_CTL3_PD8__1 (0x0100)
#define COMP_E0_CTL3_PD9 (0x0200)
#define COMP_E0_CTL3_PD9__0 (0x0000)
#define COMP_E0_CTL3_PD9__1 (0x0200)
#define COMP_E0_INT (HWREG16(0x4000340C))
#define COMP_E0_INT_IE (0x0100)
#define COMP_E0_INT_IE__0 (0x0000)
#define COMP_E0_INT_IE__1 (0x0100)
#define COMP_E0_INT_IFG (0x0001)
#define COMP_E0_INT_IFG__0 (0x0000)
#define COMP_E0_INT_IFG__1 (0x0001)
#define COMP_E0_INT_IIE (0x0200)
#define COMP_E0_INT_IIE__0 (0x0000)
#define COMP_E0_INT_IIE__1 (0x0200)
#define COMP_E0_INT_IIFG (0x0002)
#define COMP_E0_INT_IIFG__0 (0x0000)
#define COMP_E0_INT_IIFG__1 (0x0002)
#define COMP_E0_INT_RDYIE (0x1000)
#define COMP_E0_INT_RDYIE__0 (0x0000)
#define COMP_E0_INT_RDYIE__1 (0x1000)
#define COMP_E0_INT_RDYIFG (0x0010)
#define COMP_E0_INT_RDYIFG__0 (0x0000)
#define COMP_E0_INT_RDYIFG__1 (0x0010)
#define COMP_E0_IV (HWREG16(0x4000340E))
#define COMP_E1CTL0 (COMP_E1_CTL0)
#define COMP_E1CTL1 (COMP_E1_CTL1)
#define COMP_E1CTL2 (COMP_E1_CTL2)
#define COMP_E1CTL3 (COMP_E1_CTL3)
#define COMP_E1EX (0x0020)
#define COMP_E1EX_0 (0x0000)
#define COMP_E1EX_0_EXCHANGE_OFF (0x0000)
#define COMP_E1EX_1 (0x0020)
#define COMP_E1EX_1_EXCHANGE_ON (0x0020)
#define COMP_E1F (0x0004)
#define COMP_E1FDLY_0 (0x0000)
#define COMP_E1FDLY_1 (0x0040)
#define COMP_E1FDLY_2 (0x0080)
#define COMP_E1FDLY_3 (0x00c0)
#define COMP_E1FDLY_M (0x00c0)
#define COMP_E1F_0 (0x0000)
#define COMP_E1F_1 (0x0004)
#define COMP_E1IE (0x0100)
#define COMP_E1IES (0x0008)
#define COMP_E1IES_0 (0x0000)
#define COMP_E1IES_1 (0x0008)
#define COMP_E1IE_0 (0x0000)
#define COMP_E1IE_1 (0x0100)
#define COMP_E1IFG (0x0001)
#define COMP_E1IFG_0 (0x0000)
#define COMP_E1IFG_1 (0x0001)
#define COMP_E1IIE (0x0200)
#define COMP_E1IIE_0 (0x0000)
#define COMP_E1IIE_1 (0x0200)
#define COMP_E1IIFG (0x0002)
#define COMP_E1IIFG_0 (0x0000)
#define COMP_E1IIFG_1 (0x0002)
#define COMP_E1IMEN (0x8000)
#define COMP_E1IMEN_0 (0x0000)
#define COMP_E1IMEN_1 (0x8000)
#define COMP_E1IMSEL_M (0x0f00)
#define COMP_E1INT (COMP_E1_INT)
#define COMP_E1IPEN (0x0080)
#define COMP_E1IPEN_0 (0x0000)
#define COMP_E1IPEN_1 (0x0080)
#define COMP_E1IPSEL_M (0x000f)
#define COMP_E1IV (COMP_E1_IV)
#define COMP_E1MRVL (0x0800)
#define COMP_E1MRVL_0 (0x0000)
#define COMP_E1MRVL_1 (0x0800)
#define COMP_E1MRVS (0x1000)
#define COMP_E1MRVS_0 (0x0000)
#define COMP_E1MRVS_1 (0x1000)
#define COMP_E1ON (0x0400)
#define COMP_E1ON_0 (0x0000)
#define COMP_E1ON_0_OFF (0x0000)
#define COMP_E1ON_1 (0x0400)
#define COMP_E1ON_1_ON (0x0400)
#define COMP_E1OUT (0x0001)
#define COMP_E1OUTPOL (0x0002)
#define COMP_E1OUTPOL_0 (0x0000)
#define COMP_E1OUTPOL_0_NONINVERTED (0x0000)
#define COMP_E1OUTPOL_1 (0x0002)
#define COMP_E1OUTPOL_1_INVERTED (0x0002)
#define COMP_E1PD0 (0x0001)
#define COMP_E1PD0_0 (0x0000)
#define COMP_E1PD0_1 (0x0001)
#define COMP_E1PD1 (0x0002)
#define COMP_E1PD10 (0x0400)
#define COMP_E1PD10_0 (0x0000)
#define COMP_E1PD10_1 (0x0400)
#define COMP_E1PD11 (0x0800)
#define COMP_E1PD11_0 (0x0000)
#define COMP_E1PD11_1 (0x0800)
#define COMP_E1PD12 (0x1000)
#define COMP_E1PD12_0 (0x0000)
#define COMP_E1PD12_1 (0x1000)
#define COMP_E1PD13 (0x2000)
#define COMP_E1PD13_0 (0x0000)
#define COMP_E1PD13_1 (0x2000)
#define COMP_E1PD14 (0x4000)
#define COMP_E1PD14_0 (0x0000)
#define COMP_E1PD14_1 (0x4000)
#define COMP_E1PD15 (0x8000)
#define COMP_E1PD15_0 (0x0000)
#define COMP_E1PD15_1 (0x8000)
#define COMP_E1PD1_0 (0x0000)
#define COMP_E1PD1_1 (0x0002)
#define COMP_E1PD2 (0x0004)
#define COMP_E1PD2_0 (0x0000)
#define COMP_E1PD2_1 (0x0004)
#define COMP_E1PD3 (0x0008)
#define COMP_E1PD3_0 (0x0000)
#define COMP_E1PD3_1 (0x0008)
#define COMP_E1PD4 (0x0010)
#define COMP_E1PD4_0 (0x0000)
#define COMP_E1PD4_1 (0x0010)
#define COMP_E1PD5 (0x0020)
#define COMP_E1PD5_0 (0x0000)
#define COMP_E1PD5_1 (0x0020)
#define COMP_E1PD6 (0x0040)
#define COMP_E1PD6_0 (0x0000)
#define COMP_E1PD6_1 (0x0040)
#define COMP_E1PD7 (0x0080)
#define COMP_E1PD7_0 (0x0000)
#define COMP_E1PD7_1 (0x0080)
#define COMP_E1PD8 (0x0100)
#define COMP_E1PD8_0 (0x0000)
#define COMP_E1PD8_1 (0x0100)
#define COMP_E1PD9 (0x0200)
#define COMP_E1PD9_0 (0x0000)
#define COMP_E1PD9_1 (0x0200)
#define COMP_E1PWRMD_0 (0x0000)
#define COMP_E1PWRMD_0_HIGH_SPEED_MODE (0x0000)
#define COMP_E1PWRMD_1 (0x0100)
#define COMP_E1PWRMD_1_NORMAL_MODE (0x0100)
#define COMP_E1PWRMD_2 (0x0200)
#define COMP_E1PWRMD_M (0x0300)
#define COMP_E1RDYIE (0x1000)
#define COMP_E1RDYIE_0 (0x0000)
#define COMP_E1RDYIE_1 (0x1000)
#define COMP_E1RDYIFG (0x0010)
#define COMP_E1RDYIFG_0 (0x0000)
#define COMP_E1RDYIFG_1 (0x0010)
#define COMP_E1REF0_M (0x001f)
#define COMP_E1REF1_M (0x1f00)
#define COMP_E1REFACC (0x8000)
#define COMP_E1REFACC_0 (0x0000)
#define COMP_E1REFACC_0_STATIC_MODE (0x0000)
#define COMP_E1REFACC_1 (0x8000)
#define COMP_E1REFL_0 (0x0000)
#define COMP_E1REFL_1 (0x2000)
#define COMP_E1REFL_2 (0x4000)
#define COMP_E1REFL_3 (0x6000)
#define COMP_E1REFL_M (0x6000)
#define COMP_E1RSEL (0x0020)
#define COMP_E1RSEL_0 (0x0000)
#define COMP_E1RSEL_1 (0x0020)
#define COMP_E1RS_0 (0x0000)
#define COMP_E1RS_1 (0x0040)
#define COMP_E1RS_2 (0x0080)
#define COMP_E1RS_3 (0x00c0)
#define COMP_E1RS_M (0x00c0)
#define COMP_E1SHORT (0x0010)
#define COMP_E1SHORT_0 (0x0000)
#define COMP_E1SHORT_1 (0x0010)
#define COMP_E1SHORT_1_INPUTS_SHORTED (0x0010)
#define COMP_E1_CTL0 (HWREG16(0x40003800))
#define COMP_E1_CTL0_IMEN (0x8000)
#define COMP_E1_CTL0_IMEN__0 (0x0000)
#define COMP_E1_CTL0_IMEN__1 (0x8000)
#define COMP_E1_CTL0_IMSEL__M (0x0f00)
#define COMP_E1_CTL0_IPEN (0x0080)
#define COMP_E1_CTL0_IPEN__0 (0x0000)
#define COMP_E1_CTL0_IPEN__1 (0x0080)
#define COMP_E1_CTL0_IPSEL__M (0x000f)
#define COMP_E1_CTL1 (HWREG16(0x40003802))
#define COMP_E1_CTL1_EX (0x0020)
#define COMP_E1_CTL1_F (0x0004)
#define COMP_E1_CTL1_FDLY__0 (0x0000)
#define COMP_E1_CTL1_FDLY__1 (0x0040)
#define COMP_E1_CTL1_FDLY__2 (0x0080)
#define COMP_E1_CTL1_FDLY__3 (0x00c0)
#define COMP_E1_CTL1_FDLY__M (0x00c0)
#define COMP_E1_CTL1_F__0 (0x0000)
#define COMP_E1_CTL1_F__1 (0x0004)
#define COMP_E1_CTL1_IES (0x0008)
#define COMP_E1_CTL1_IES__0 (0x0000)
#define COMP_E1_CTL1_IES__1 (0x0008)
#define COMP_E1_CTL1_MRVL (0x0800)
#define COMP_E1_CTL1_MRVL__0 (0x0000)
#define COMP_E1_CTL1_MRVL__1 (0x0800)
#define COMP_E1_CTL1_MRVS (0x1000)
#define COMP_E1_CTL1_MRVS__0 (0x0000)
#define COMP_E1_CTL1_MRVS__1 (0x1000)
#define COMP_E1_CTL1_ON (0x0400)
#define COMP_E1_CTL1_ON__0 (0x0000)
#define COMP_E1_CTL1_ON__0_OFF (0x0000)
#define COMP_E1_CTL1_ON__1 (0x0400)
#define COMP_E1_CTL1_ON__1_ON (0x0400)
#define COMP_E1_CTL1_OUT (0x0001)
#define COMP_E1_CTL1_OUTPOL (0x0002)
#define COMP_E1_CTL1_OUTPOL__0 (0x0000)
#define COMP_E1_CTL1_OUTPOL__0_NONINVERTED (0x0000)
#define COMP_E1_CTL1_OUTPOL__1 (0x0002)
#define COMP_E1_CTL1_OUTPOL__1_INVERTED (0x0002)
#define COMP_E1_CTL1_PWRMD__0 (0x0000)
#define COMP_E1_CTL1_PWRMD__0_HIGH_SPEED_MODE (0x0000)
#define COMP_E1_CTL1_PWRMD__1 (0x0100)
#define COMP_E1_CTL1_PWRMD__1_NORMAL_MODE (0x0100)
#define COMP_E1_CTL1_PWRMD__2 (0x0200)
#define COMP_E1_CTL1_PWRMD__M (0x0300)
#define COMP_E1_CTL1_SHORT (0x0010)
#define COMP_E1_CTL1_SHORT__0 (0x0000)
#define COMP_E1_CTL1_SHORT__1 (0x0010)
#define COMP_E1_CTL1_SHORT__1_INPUTS_SHORTED (0x0010)
#define COMP_E1_CTL2 (HWREG16(0x40003804))
#define COMP_E1_CTL2_REF0__M (0x001f)
#define COMP_E1_CTL2_REF1__M (0x1f00)
#define COMP_E1_CTL2_REFACC (0x8000)
#define COMP_E1_CTL2_REFACC__0 (0x0000)
#define COMP_E1_CTL2_REFACC__0_STATIC_MODE (0x0000)
#define COMP_E1_CTL2_REFACC__1 (0x8000)
#define COMP_E1_CTL2_REFL__0 (0x0000)
#define COMP_E1_CTL2_REFL__1 (0x2000)
#define COMP_E1_CTL2_REFL__2 (0x4000)
#define COMP_E1_CTL2_REFL__3 (0x6000)
#define COMP_E1_CTL2_REFL__M (0x6000)
#define COMP_E1_CTL2_RSEL (0x0020)
#define COMP_E1_CTL2_RSEL__0 (0x0000)
#define COMP_E1_CTL2_RSEL__1 (0x0020)
#define COMP_E1_CTL2_RS__0 (0x0000)
#define COMP_E1_CTL2_RS__1 (0x0040)
#define COMP_E1_CTL2_RS__2 (0x0080)
#define COMP_E1_CTL2_RS__3 (0x00c0)
#define COMP_E1_CTL2_RS__M (0x00c0)
#define COMP_E1_CTL3 (HWREG16(0x40003806))
#define COMP_E1_CTL3_PD0 (0x0001)
#define COMP_E1_CTL3_PD0__0 (0x0000)
#define COMP_E1_CTL3_PD0__1 (0x0001)
#define COMP_E1_CTL3_PD1 (0x0002)
#define COMP_E1_CTL3_PD10 (0x0400)
#define COMP_E1_CTL3_PD10__0 (0x0000)
#define COMP_E1_CTL3_PD10__1 (0x0400)
#define COMP_E1_CTL3_PD11 (0x0800)
#define COMP_E1_CTL3_PD11__0 (0x0000)
#define COMP_E1_CTL3_PD11__1 (0x0800)
#define COMP_E1_CTL3_PD12 (0x1000)
#define COMP_E1_CTL3_PD12__0 (0x0000)
#define COMP_E1_CTL3_PD12__1 (0x1000)
#define COMP_E1_CTL3_PD13 (0x2000)
#define COMP_E1_CTL3_PD13__0 (0x0000)
#define COMP_E1_CTL3_PD13__1 (0x2000)
#define COMP_E1_CTL3_PD14 (0x4000)
#define COMP_E1_CTL3_PD14__0 (0x0000)
#define COMP_E1_CTL3_PD14__1 (0x4000)
#define COMP_E1_CTL3_PD15 (0x8000)
#define COMP_E1_CTL3_PD15__0 (0x0000)
#define COMP_E1_CTL3_PD15__1 (0x8000)
#define COMP_E1_CTL3_PD1__0 (0x0000)
#define COMP_E1_CTL3_PD1__1 (0x0002)
#define COMP_E1_CTL3_PD2 (0x0004)
#define COMP_E1_CTL3_PD2__0 (0x0000)
#define COMP_E1_CTL3_PD2__1 (0x0004)
#define COMP_E1_CTL3_PD3 (0x0008)
#define COMP_E1_CTL3_PD3__0 (0x0000)
#define COMP_E1_CTL3_PD3__1 (0x0008)
#define COMP_E1_CTL3_PD4 (0x0010)
#define COMP_E1_CTL3_PD4__0 (0x0000)
#define COMP_E1_CTL3_PD4__1 (0x0010)
#define COMP_E1_CTL3_PD5 (0x0020)
#define COMP_E1_CTL3_PD5__0 (0x0000)
#define COMP_E1_CTL3_PD5__1 (0x0020)
#define COMP_E1_CTL3_PD6 (0x0040)
#define COMP_E1_CTL3_PD6__0 (0x0000)
#define COMP_E1_CTL3_PD6__1 (0x0040)
#define COMP_E1_CTL3_PD7 (0x0080)
#define COMP_E1_CTL3_PD7__0 (0x0000)
#define COMP_E1_CTL3_PD7__1 (0x0080)
#define COMP_E1_CTL3_PD8 (0x0100)
#define COMP_E1_CTL3_PD8__0 (0x0000)
#define COMP_E1_CTL3_PD8__1 (0x0100)
#define COMP_E1_CTL3_PD9 (0x0200)
#define COMP_E1_CTL3_PD9__0 (0x0000)
#define COMP_E1_CTL3_PD9__1 (0x0200)
#define COMP_E1_INT (HWREG16(0x4000380C))
#define COMP_E1_INT_IE (0x0100)
#define COMP_E1_INT_IE__0 (0x0000)
#define COMP_E1_INT_IE__1 (0x0100)
#define COMP_E1_INT_IFG (0x0001)
#define COMP_E1_INT_IFG__0 (0x0000)
#define COMP_E1_INT_IFG__1 (0x0001)
#define COMP_E1_INT_IIE (0x0200)
#define COMP_E1_INT_IIE__0 (0x0000)
#define COMP_E1_INT_IIE__1 (0x0200)
#define COMP_E1_INT_IIFG (0x0002)
#define COMP_E1_INT_IIFG__0 (0x0000)
#define COMP_E1_INT_IIFG__1 (0x0002)
#define COMP_E1_INT_RDYIE (0x1000)
#define COMP_E1_INT_RDYIE__0 (0x0000)
#define COMP_E1_INT_RDYIE__1 (0x1000)
#define COMP_E1_INT_RDYIFG (0x0010)
#define COMP_E1_INT_RDYIFG__0 (0x0000)
#define COMP_E1_INT_RDYIFG__1 (0x0010)
#define COMP_E1_IV (HWREG16(0x4000380E))
#define CRCDI (CRC32DI)
#define CRCDIRB (CRC32DIRB)
#define CRCDIRB_H (HWREG8_H(CRCDIRB))
#define CRCDIRB_L (HWREG8_L(CRCDIRB))
#define CRCDI_H (HWREG8_H(CRCDI))
#define CRCDI_L (HWREG8_L(CRCDI))
#define CRCINIRES (CRC32INIRES_LO)
#define CRCINIRES_H (HWREG8_H(CRC_INIRES))
#define CRCINIRES_L (HWREG8_L(CRC_INIRES))
#define CRCRESR (CRC32RESR_LO)
#define CRCRESR_H (HWREG8_H(CRCRESR))
#define CRCRESR_L (HWREG8_L(CRCRESR))
#define CSKEY (0x0000695A)
#define CS_ACC (HWREG32(0x40010400))
#define CS_ACC_KEY_VAL (0x0000695A)
#define CS_ACC_KEY__M (0x0000ffff)
#define CS_CLKEN (HWREG32(0x40010430))
#define CS_CLKEN_ACLK_EN (0x00000001)
#define CS_CLKEN_ACLK_EN__0 (0x00000000)
#define CS_CLKEN_ACLK_EN__1 (0x00000001)
#define CS_CLKEN_HSMCLK_EN (0x00000004)
#define CS_CLKEN_HSMCLK_EN__0 (0x00000000)
#define CS_CLKEN_HSMCLK_EN__1 (0x00000004)
#define CS_CLKEN_MCLK_EN (0x00000002)
#define CS_CLKEN_MCLK_EN__0 (0x00000000)
#define CS_CLKEN_MCLK_EN__1 (0x00000002)
#define CS_CLKEN_MODOSC_EN (0x00000400)
#define CS_CLKEN_MODOSC_EN__0 (0x00000000)
#define CS_CLKEN_MODOSC_EN__1 (0x00000400)
#define CS_CLKEN_MODOSC_EN__1_MODOSC_IS_ON (0x00000400)
#define CS_CLKEN_REFOFSEL (0x00008000)
#define CS_CLKEN_REFOFSEL__0 (0x00000000)
#define CS_CLKEN_REFOFSEL__0_32_KHZ (0x00000000)
#define CS_CLKEN_REFOFSEL__1 (0x00008000)
#define CS_CLKEN_REFOFSEL__1_128_KHZ (0x00008000)
#define CS_CLKEN_REFO_EN (0x00000200)
#define CS_CLKEN_REFO_EN__0 (0x00000000)
#define CS_CLKEN_REFO_EN__1 (0x00000200)
#define CS_CLKEN_REFO_EN__1_REFO_IS_ON (0x00000200)
#define CS_CLKEN_SMCLK_EN (0x00000008)
#define CS_CLKEN_SMCLK_EN__0 (0x00000000)
#define CS_CLKEN_SMCLK_EN__1 (0x00000008)
#define CS_CLKEN_VLO_EN (0x00000100)
#define CS_CLKEN_VLO_EN__0 (0x00000000)
#define CS_CLKEN_VLO_EN__1 (0x00000100)
#define CS_CLKEN_VLO_EN__1_VLO_IS_ON (0x00000100)
#define CS_CLRIFG (HWREG32(0x40010450))
#define CS_CLRIFG_CLR_CALIFG (0x00000080)
#define CS_CLRIFG_CLR_CALIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_CALIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_CALIFG__1 (0x00000080)
#define CS_CLRIFG_CLR_DCOMAXIFG (0x00000020)
#define CS_CLRIFG_CLR_DCOMAXIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_DCOMAXIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_DCOMAXIFG__1 (0x00000020)
#define CS_CLRIFG_CLR_DCOMINIFG (0x00000010)
#define CS_CLRIFG_CLR_DCOMINIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_DCOMINIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_DCOMINIFG__1 (0x00000010)
#define CS_CLRIFG_CLR_DCORIFG (0x00000040)
#define CS_CLRIFG_CLR_DCORIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_DCORIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_DCORIFG__1 (0x00000040)
#define CS_CLRIFG_CLR_FCNTHF2IFG (0x00000400)
#define CS_CLRIFG_CLR_FCNTHF2IFG__0 (0x00000000)
#define CS_CLRIFG_CLR_FCNTHF2IFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_FCNTHF2IFG__1 (0x00000400)
#define CS_CLRIFG_CLR_FCNTHFIFG (0x00000200)
#define CS_CLRIFG_CLR_FCNTHFIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_FCNTHFIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_FCNTHFIFG__1 (0x00000200)
#define CS_CLRIFG_CLR_FCNTLFIFG (0x00000100)
#define CS_CLRIFG_CLR_FCNTLFIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_FCNTLFIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_FCNTLFIFG__1 (0x00000100)
#define CS_CLRIFG_CLR_HFXT2IFG (0x00000004)
#define CS_CLRIFG_CLR_HFXT2IFG__0 (0x00000000)
#define CS_CLRIFG_CLR_HFXT2IFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_HFXT2IFG__1 (0x00000004)
#define CS_CLRIFG_CLR_HFXTIFG (0x00000002)
#define CS_CLRIFG_CLR_HFXTIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_HFXTIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_HFXTIFG__1 (0x00000002)
#define CS_CLRIFG_CLR_LFXTIFG (0x00000001)
#define CS_CLRIFG_CLR_LFXTIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_LFXTIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_LFXTIFG__1 (0x00000001)
#define CS_CLRIFG_CLR_PLLLOSIFG (0x00002000)
#define CS_CLRIFG_CLR_PLLLOSIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_PLLLOSIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_PLLLOSIFG__1 (0x00002000)
#define CS_CLRIFG_CLR_PLLOOLIFG (0x00001000)
#define CS_CLRIFG_CLR_PLLOOLIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_PLLOOLIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_PLLOOLIFG__1 (0x00001000)
#define CS_CLRIFG_CLR_PLLOORIFG (0x00004000)
#define CS_CLRIFG_CLR_PLLOORIFG__0 (0x00000000)
#define CS_CLRIFG_CLR_PLLOORIFG__0_NO_EFFECT (0x00000000)
#define CS_CLRIFG_CLR_PLLOORIFG__1 (0x00004000)
#define CS_CTL0 (HWREG32(0x40010404))
#define CS_CTL0_DCOEN (0x00800000)
#define CS_CTL0_DCOEN__0 (0x00000000)
#define CS_CTL0_DCOEN__1 (0x00800000)
#define CS_CTL0_DCOEN__1_DCO_IS_ON (0x00800000)
#define CS_CTL0_DCORES (0x00400000)
#define CS_CTL0_DCORES__0 (0x00000000)
#define CS_CTL0_DCORES__1 (0x00400000)
#define CS_CTL0_DCORSEL__0 (0x00000000)
#define CS_CTL0_DCORSEL__1 (0x00010000)
#define CS_CTL0_DCORSEL__2 (0x00020000)
#define CS_CTL0_DCORSEL__3 (0x00030000)
#define CS_CTL0_DCORSEL__4 (0x00040000)
#define CS_CTL0_DCORSEL__5 (0x00050000)
#define CS_CTL0_DCORSEL__M (0x00070000)
#define CS_CTL0_DCOTUNE__M (0x00001fff)
#define CS_CTL0_DIS_DCO_DELAY_CNT (0x01000000)
#define CS_CTL1 (HWREG32(0x40010408))
#define CS_CTL1_DIVA__0 (0x00000000)
#define CS_CTL1_DIVA__0_F_ACLK__1 (0x00000000)
#define CS_CTL1_DIVA__1 (0x01000000)
#define CS_CTL1_DIVA__1_F_ACLK__2 (0x01000000)
#define CS_CTL1_DIVA__2 (0x02000000)
#define CS_CTL1_DIVA__2_F_ACLK__4 (0x02000000)
#define CS_CTL1_DIVA__3 (0x03000000)
#define CS_CTL1_DIVA__3_F_ACLK__8 (0x03000000)
#define CS_CTL1_DIVA__4 (0x04000000)
#define CS_CTL1_DIVA__4_F_ACLK__16 (0x04000000)
#define CS_CTL1_DIVA__5 (0x05000000)
#define CS_CTL1_DIVA__5_F_ACLK__32 (0x05000000)
#define CS_CTL1_DIVA__6 (0x06000000)
#define CS_CTL1_DIVA__6_F_ACLK__64 (0x06000000)
#define CS_CTL1_DIVA__7 (0x07000000)
#define CS_CTL1_DIVA__7_F_ACLK__128 (0x07000000)
#define CS_CTL1_DIVA__M (0x07000000)
#define CS_CTL1_DIVHS__0 (0x00000000)
#define CS_CTL1_DIVHS__0_F_HSMCLK__1 (0x00000000)
#define CS_CTL1_DIVHS__1 (0x00100000)
#define CS_CTL1_DIVHS__1_F_HSMCLK__2 (0x00100000)
#define CS_CTL1_DIVHS__2 (0x00200000)
#define CS_CTL1_DIVHS__2_F_HSMCLK__4 (0x00200000)
#define CS_CTL1_DIVHS__3 (0x00300000)
#define CS_CTL1_DIVHS__3_F_HSMCLK__8 (0x00300000)
#define CS_CTL1_DIVHS__4 (0x00400000)
#define CS_CTL1_DIVHS__4_F_HSMCLK__16 (0x00400000)
#define CS_CTL1_DIVHS__5 (0x00500000)
#define CS_CTL1_DIVHS__5_F_HSMCLK__32 (0x00500000)
#define CS_CTL1_DIVHS__6 (0x00600000)
#define CS_CTL1_DIVHS__6_F_HSMCLK__64 (0x00600000)
#define CS_CTL1_DIVHS__7 (0x00700000)
#define CS_CTL1_DIVHS__7_F_HSMCLK__128 (0x00700000)
#define CS_CTL1_DIVHS__M (0x00700000)
#define CS_CTL1_DIVM__0 (0x00000000)
#define CS_CTL1_DIVM__0_F_MCLK__1 (0x00000000)
#define CS_CTL1_DIVM__1 (0x00010000)
#define CS_CTL1_DIVM__1_F_MCLK__2 (0x00010000)
#define CS_CTL1_DIVM__2 (0x00020000)
#define CS_CTL1_DIVM__2_F_MCLK__4 (0x00020000)
#define CS_CTL1_DIVM__3 (0x00030000)
#define CS_CTL1_DIVM__3_F_MCLK__8 (0x00030000)
#define CS_CTL1_DIVM__4 (0x00040000)
#define CS_CTL1_DIVM__4_F_MCLK__16 (0x00040000)
#define CS_CTL1_DIVM__5 (0x00050000)
#define CS_CTL1_DIVM__5_F_MCLK__32 (0x00050000)
#define CS_CTL1_DIVM__6 (0x00060000)
#define CS_CTL1_DIVM__6_F_MCLK__64 (0x00060000)
#define CS_CTL1_DIVM__7 (0x00070000)
#define CS_CTL1_DIVM__7_F_MCLK__128 (0x00070000)
#define CS_CTL1_DIVM__M (0x00070000)
#define CS_CTL1_DIVS__0 (0x00000000)
#define CS_CTL1_DIVS__0_F_SMCLK__1 (0x00000000)
#define CS_CTL1_DIVS__1 (0x10000000)
#define CS_CTL1_DIVS__1_F_SMCLK__2 (0x10000000)
#define CS_CTL1_DIVS__2 (0x20000000)
#define CS_CTL1_DIVS__2_F_SMCLK__4 (0x20000000)
#define CS_CTL1_DIVS__3 (0x30000000)
#define CS_CTL1_DIVS__3_F_SMCLK__8 (0x30000000)
#define CS_CTL1_DIVS__4 (0x40000000)
#define CS_CTL1_DIVS__4_F_SMCLK__16 (0x40000000)
#define CS_CTL1_DIVS__5 (0x50000000)
#define CS_CTL1_DIVS__5_F_SMCLK__32 (0x50000000)
#define CS_CTL1_DIVS__6 (0x60000000)
#define CS_CTL1_DIVS__6_F_SMCLK__64 (0x60000000)
#define CS_CTL1_DIVS__7 (0x70000000)
#define CS_CTL1_DIVS__7_F_SMCLK__128 (0x70000000)
#define CS_CTL1_DIVS__M (0x70000000)
#define CS_CTL1_SELA__0 (0x00000000)
#define CS_CTL1_SELA__1 (0x00000100)
#define CS_CTL1_SELA__1_VLOCLK (0x00000100)
#define CS_CTL1_SELA__2 (0x00000200)
#define CS_CTL1_SELA__2_REFOCLK (0x00000200)
#define CS_CTL1_SELA__M (0x00000700)
#define CS_CTL1_SELB (0x00001000)
#define CS_CTL1_SELB__0 (0x00000000)
#define CS_CTL1_SELB__0_LFXTCLK (0x00000000)
#define CS_CTL1_SELB__1 (0x00001000)
#define CS_CTL1_SELB__1_REFOCLK (0x00001000)
#define CS_CTL1_SELM__0 (0x00000000)
#define CS_CTL1_SELM__1 (0x00000001)
#define CS_CTL1_SELM__1_VLOCLK (0x00000001)
#define CS_CTL1_SELM__2 (0x00000002)
#define CS_CTL1_SELM__2_REFOCLK (0x00000002)
#define CS_CTL1_SELM__3 (0x00000003)
#define CS_CTL1_SELM__3_DCOCLK (0x00000003)
#define CS_CTL1_SELM__4 (0x00000004)
#define CS_CTL1_SELM__4_MODOSC (0x00000004)
#define CS_CTL1_SELM__5 (0x00000005)
#define CS_CTL1_SELM__6 (0x00000006)
#define CS_CTL1_SELM__7 (0x00000007)
#define CS_CTL1_SELM__M (0x00000007)
#define CS_CTL1_SELS__0 (0x00000000)
#define CS_CTL1_SELS__1 (0x00000010)
#define CS_CTL1_SELS__1_VLOCLK (0x00000010)
#define CS_CTL1_SELS__2 (0x00000020)
#define CS_CTL1_SELS__2_REFOCLK (0x00000020)
#define CS_CTL1_SELS__3 (0x00000030)
#define CS_CTL1_SELS__3_DCOCLK (0x00000030)
#define CS_CTL1_SELS__4 (0x00000040)
#define CS_CTL1_SELS__4_MODOSC (0x00000040)
#define CS_CTL1_SELS__5 (0x00000050)
#define CS_CTL1_SELS__6 (0x00000060)
#define CS_CTL1_SELS__7 (0x00000070)
#define CS_CTL1_SELS__M (0x00000070)
#define CS_CTL2 (HWREG32(0x4001040C))
#define CS_CTL2_HFXTBYPASS (0x02000000)
#define CS_CTL2_HFXTBYPASS__0 (0x00000000)
#define CS_CTL2_HFXTBYPASS__1 (0x02000000)
#define CS_CTL2_HFXTDRIVE (0x00010000)
#define CS_CTL2_HFXTFREQ__0 (0x00000000)
#define CS_CTL2_HFXTFREQ__0_1_MHZ_TO_4_MHZ (0x00000000)
#define CS_CTL2_HFXTFREQ__1 (0x00100000)
#define CS_CTL2_HFXTFREQ__1__4_MHZ_TO_8_MHZ (0x00100000)
#define CS_CTL2_HFXTFREQ__2 (0x00200000)
#define CS_CTL2_HFXTFREQ__2_8_MHZ_TO_16_MHZ (0x00200000)
#define CS_CTL2_HFXTFREQ__3 (0x00300000)
#define CS_CTL2_HFXTFREQ__4 (0x00400000)
#define CS_CTL2_HFXTFREQ__5 (0x00500000)
#define CS_CTL2_HFXTFREQ__6 (0x00600000)
#define CS_CTL2_HFXTFREQ__7 (0x00700000)
#define CS_CTL2_HFXTFREQ__M (0x00700000)
#define CS_CTL2_HFXT_EN (0x01000000)
#define CS_CTL2_HFXT_EN__0 (0x00000000)
#define CS_CTL2_HFXT_EN__1 (0x01000000)
#define CS_CTL2_LFXTAGCOFF (0x00000080)
#define CS_CTL2_LFXTAGCOFF__0 (0x00000000)
#define CS_CTL2_LFXTAGCOFF__0_AGC_ENABLED (0x00000000)
#define CS_CTL2_LFXTAGCOFF__1 (0x00000080)
#define CS_CTL2_LFXTAGCOFF__1_AGC_DISABLED (0x00000080)
#define CS_CTL2_LFXTBYPASS (0x00000200)
#define CS_CTL2_LFXTBYPASS__0 (0x00000000)
#define CS_CTL2_LFXTBYPASS__1 (0x00000200)
#define CS_CTL2_LFXTDRIVE__0 (0x00000000)
#define CS_CTL2_LFXTDRIVE__1 (0x00000001)
#define CS_CTL2_LFXTDRIVE__2 (0x00000002)
#define CS_CTL2_LFXTDRIVE__3 (0x00000003)
#define CS_CTL2_LFXTDRIVE__4 (0x00000004)
#define CS_CTL2_LFXTDRIVE__5 (0x00000005)
#define CS_CTL2_LFXTDRIVE__6 (0x00000006)
#define CS_CTL2_LFXTDRIVE__7 (0x00000007)
#define CS_CTL2_LFXTDRIVE__M (0x00000007)
#define CS_CTL2_LFXT_EN (0x00000100)
#define CS_CTL2_LFXT_EN__0 (0x00000000)
#define CS_CTL2_LFXT_EN__1 (0x00000100)
#define CS_CTL3 (HWREG32(0x40010410))
#define CS_CTL3_FCNTHF2_EN (0x00000800)
#define CS_CTL3_FCNTHF2_EN__0 (0x00000000)
#define CS_CTL3_FCNTHF2_EN__1 (0x00000800)
#define CS_CTL3_FCNTHF2__0 (0x00000000)
#define CS_CTL3_FCNTHF2__0_2048_CYCLES (0x00000000)
#define CS_CTL3_FCNTHF2__1 (0x00000100)
#define CS_CTL3_FCNTHF2__1_4096_CYCLES (0x00000100)
#define CS_CTL3_FCNTHF2__2 (0x00000200)
#define CS_CTL3_FCNTHF2__2_8192_CYCLES (0x00000200)
#define CS_CTL3_FCNTHF2__3 (0x00000300)
#define CS_CTL3_FCNTHF2__3_16384_CYCLES (0x00000300)
#define CS_CTL3_FCNTHF2__M (0x00000300)
#define CS_CTL3_FCNTHF_EN (0x00000080)
#define CS_CTL3_FCNTHF_EN__0 (0x00000000)
#define CS_CTL3_FCNTHF_EN__1 (0x00000080)
#define CS_CTL3_FCNTHF__0 (0x00000000)
#define CS_CTL3_FCNTHF__0_2048_CYCLES (0x00000000)
#define CS_CTL3_FCNTHF__1 (0x00000010)
#define CS_CTL3_FCNTHF__1_4096_CYCLES (0x00000010)
#define CS_CTL3_FCNTHF__2 (0x00000020)
#define CS_CTL3_FCNTHF__2_8192_CYCLES (0x00000020)
#define CS_CTL3_FCNTHF__3 (0x00000030)
#define CS_CTL3_FCNTHF__3_16384_CYCLES (0x00000030)
#define CS_CTL3_FCNTHF__M (0x00000030)
#define CS_CTL3_FCNTLF_EN (0x00000008)
#define CS_CTL3_FCNTLF_EN__0 (0x00000000)
#define CS_CTL3_FCNTLF_EN__1 (0x00000008)
#define CS_CTL3_FCNTLF__0 (0x00000000)
#define CS_CTL3_FCNTLF__0_4096_CYCLES (0x00000000)
#define CS_CTL3_FCNTLF__1 (0x00000001)
#define CS_CTL3_FCNTLF__1_8192_CYCLES (0x00000001)
#define CS_CTL3_FCNTLF__2 (0x00000002)
#define CS_CTL3_FCNTLF__2_16384_CYCLES (0x00000002)
#define CS_CTL3_FCNTLF__3 (0x00000003)
#define CS_CTL3_FCNTLF__3_32768_CYCLES (0x00000003)
#define CS_CTL3_FCNTLF__M (0x00000003)
#define CS_CTL3_RFCNTHF (0x00000040)
#define CS_CTL3_RFCNTHF2 (0x00000400)
#define CS_CTL3_RFCNTHF2__0 (0x00000000)
#define CS_CTL3_RFCNTHF2__1 (0x00000400)
#define CS_CTL3_RFCNTHF__0 (0x00000000)
#define CS_CTL3_RFCNTHF__1 (0x00000040)
#define CS_CTL3_RFCNTLF (0x00000004)
#define CS_CTL3_RFCNTLF__0 (0x00000000)
#define CS_CTL3_RFCNTLF__1 (0x00000004)
#define CS_CTL4 (HWREG32(0x40010414))
#define CS_CTL4_HFXT2BYPASS (0x00000200)
#define CS_CTL4_HFXT2BYPASS__0 (0x00000000)
#define CS_CTL4_HFXT2BYPASS__1 (0x00000200)
#define CS_CTL4_HFXT2DRIVE (0x00000001)
#define CS_CTL4_HFXT2FREQ__0 (0x00000000)
#define CS_CTL4_HFXT2FREQ__0_1_MHZ_TO_4_MHZ (0x00000000)
#define CS_CTL4_HFXT2FREQ__1 (0x00000010)
#define CS_CTL4_HFXT2FREQ__1__4_MHZ_TO_8_MHZ (0x00000010)
#define CS_CTL4_HFXT2FREQ__2 (0x00000020)
#define CS_CTL4_HFXT2FREQ__3 (0x00000030)
#define CS_CTL4_HFXT2FREQ__4 (0x00000040)
#define CS_CTL4_HFXT2FREQ__5 (0x00000050)
#define CS_CTL4_HFXT2FREQ__6 (0x00000060)
#define CS_CTL4_HFXT2FREQ__7 (0x00000070)
#define CS_CTL4_HFXT2FREQ__M (0x00000070)
#define CS_CTL4_HFXT2_EN (0x00000100)
#define CS_CTL4_HFXT2_EN__0 (0x00000000)
#define CS_CTL4_HFXT2_EN__1 (0x00000100)
#define CS_CTL5 (HWREG32(0x40010418))
#define CS_CTL5_CALSTART (0x00000080)
#define CS_CTL5_CALSTART__0 (0x00000000)
#define CS_CTL5_CALSTART__1 (0x00000080)
#define CS_CTL5_PERCNTSEL__0 (0x00000000)
#define CS_CTL5_PERCNTSEL__0_DCOCLK (0x00000000)
#define CS_CTL5_PERCNTSEL__1 (0x00000100)
#define CS_CTL5_PERCNTSEL__1_REFOCLK (0x00000100)
#define CS_CTL5_PERCNTSEL__M (0x00000700)
#define CS_CTL5_REFCNTPS__0 (0x00000000)
#define CS_CTL5_REFCNTPS__0__1 (0x00000000)
#define CS_CTL5_REFCNTPS__1 (0x00000008)
#define CS_CTL5_REFCNTPS__1__16 (0x00000008)
#define CS_CTL5_REFCNTPS__2 (0x00000010)
#define CS_CTL5_REFCNTPS__2__32 (0x00000010)
#define CS_CTL5_REFCNTPS__3 (0x00000018)
#define CS_CTL5_REFCNTPS__3__64 (0x00000018)
#define CS_CTL5_REFCNTPS__4 (0x00000020)
#define CS_CTL5_REFCNTPS__4__128 (0x00000020)
#define CS_CTL5_REFCNTPS__5 (0x00000028)
#define CS_CTL5_REFCNTPS__5__256 (0x00000028)
#define CS_CTL5_REFCNTPS__6 (0x00000030)
#define CS_CTL5_REFCNTPS__6__512 (0x00000030)
#define CS_CTL5_REFCNTPS__7 (0x00000038)
#define CS_CTL5_REFCNTPS__7__1024 (0x00000038)
#define CS_CTL5_REFCNTPS__M (0x00000038)
#define CS_CTL5_REFCNTSEL__0 (0x00000000)
#define CS_CTL5_REFCNTSEL__0_REFOCLK (0x00000000)
#define CS_CTL5_REFCNTSEL__1 (0x00000001)
#define CS_CTL5_REFCNTSEL__2 (0x00000002)
#define CS_CTL5_REFCNTSEL__3 (0x00000003)
#define CS_CTL5_REFCNTSEL__M (0x00000007)
#define CS_CTL6 (HWREG32(0x4001041C))
#define CS_CTL6_PERCNT__M (0x0000ffff)
#define CS_CTL7 (HWREG32(0x40010420))
#define CS_CTL7_REFCNT__M (0x0000ffff)
#define CS_DCOERCAL (HWREG32(0x40010460))
#define CS_DCOERCAL_DCO_FTRIM__M (0x07ff0000)
#define CS_DCOERCAL_DCO_TCTRIM__M (0x00000003)
#define CS_IE (HWREG32(0x40010440))
#define CS_IE_CALIE (0x00008000)
#define CS_IE_CALIE__0 (0x00000000)
#define CS_IE_CALIE__1 (0x00008000)
#define CS_IE_DCOMAXIE (0x00000020)
#define CS_IE_DCOMAXIE__0 (0x00000000)
#define CS_IE_DCOMAXIE__1 (0x00000020)
#define CS_IE_DCOMINIE (0x00000010)
#define CS_IE_DCOMINIE__0 (0x00000000)
#define CS_IE_DCOMINIE__1 (0x00000010)
#define CS_IE_DCORIE (0x00000040)
#define CS_IE_DCORIE__0 (0x00000000)
#define CS_IE_DCORIE__1 (0x00000040)
#define CS_IE_FCNTHF2IE (0x00000400)
#define CS_IE_FCNTHF2IE__0 (0x00000000)
#define CS_IE_FCNTHF2IE__1 (0x00000400)
#define CS_IE_FCNTHFIE (0x00000200)
#define CS_IE_FCNTHFIE__0 (0x00000000)
#define CS_IE_FCNTHFIE__1 (0x00000200)
#define CS_IE_FCNTLFIE (0x00000100)
#define CS_IE_FCNTLFIE__0 (0x00000000)
#define CS_IE_FCNTLFIE__1 (0x00000100)
#define CS_IE_HFXT2IE (0x00000004)
#define CS_IE_HFXT2IE__0 (0x00000000)
#define CS_IE_HFXT2IE__1 (0x00000004)
#define CS_IE_HFXTIE (0x00000002)
#define CS_IE_HFXTIE__0 (0x00000000)
#define CS_IE_HFXTIE__1 (0x00000002)
#define CS_IE_LFXTIE (0x00000001)
#define CS_IE_LFXTIE__0 (0x00000000)
#define CS_IE_LFXTIE__1 (0x00000001)
#define CS_IE_PLLLOSIE (0x00002000)
#define CS_IE_PLLLOSIE__0 (0x00000000)
#define CS_IE_PLLLOSIE__1 (0x00002000)
#define CS_IE_PLLOOLIE (0x00001000)
#define CS_IE_PLLOOLIE__0 (0x00000000)
#define CS_IE_PLLOOLIE__1 (0x00001000)
#define CS_IE_PLLOORIE (0x00004000)
#define CS_IE_PLLOORIE__0 (0x00000000)
#define CS_IE_PLLOORIE__1 (0x00004000)
#define CS_IFG (HWREG32(0x40010448))
#define CS_IFG_CALIFG (0x00008000)
#define CS_IFG_CALIFG__0 (0x00000000)
#define CS_IFG_CALIFG__1 (0x00008000)
#define CS_IFG_DCOMAXIFG (0x00000020)
#define CS_IFG_DCOMAXIFG__0 (0x00000000)
#define CS_IFG_DCOMAXIFG__1 (0x00000020)
#define CS_IFG_DCOMINIFG (0x00000010)
#define CS_IFG_DCOMINIFG__0 (0x00000000)
#define CS_IFG_DCOMINIFG__1 (0x00000010)
#define CS_IFG_DCORIFG (0x00000040)
#define CS_IFG_DCORIFG__0 (0x00000000)
#define CS_IFG_DCORIFG__1 (0x00000040)
#define CS_IFG_FCNTHF2IFG (0x00000800)
#define CS_IFG_FCNTHF2IFG__0 (0x00000000)
#define CS_IFG_FCNTHF2IFG__1 (0x00000800)
#define CS_IFG_FCNTHFIFG (0x00000200)
#define CS_IFG_FCNTHFIFG__0 (0x00000000)
#define CS_IFG_FCNTHFIFG__1 (0x00000200)
#define CS_IFG_FCNTLFIFG (0x00000100)
#define CS_IFG_FCNTLFIFG__0 (0x00000000)
#define CS_IFG_FCNTLFIFG__1 (0x00000100)
#define CS_IFG_HFXT2IFG (0x00000004)
#define CS_IFG_HFXT2IFG__0 (0x00000000)
#define CS_IFG_HFXT2IFG__1 (0x00000004)
#define CS_IFG_HFXTIFG (0x00000002)
#define CS_IFG_HFXTIFG__0 (0x00000000)
#define CS_IFG_HFXTIFG__1 (0x00000002)
#define CS_IFG_LFXTIFG (0x00000001)
#define CS_IFG_LFXTIFG__0 (0x00000000)
#define CS_IFG_LFXTIFG__1 (0x00000001)
#define CS_IFG_PLLLOSIFG (0x00002000)
#define CS_IFG_PLLLOSIFG__0 (0x00000000)
#define CS_IFG_PLLLOSIFG__1 (0x00002000)
#define CS_IFG_PLLOOLIFG (0x00001000)
#define CS_IFG_PLLOOLIFG__0 (0x00000000)
#define CS_IFG_PLLOOLIFG__1 (0x00001000)
#define CS_IFG_PLLOORIFG (0x00004000)
#define CS_IFG_PLLOORIFG__0 (0x00000000)
#define CS_IFG_PLLOORIFG__1 (0x00004000)
#define CS_SETIFG (HWREG32(0x40010458))
#define CS_SETIFG_SET_CALIFG (0x00000080)
#define CS_SETIFG_SET_CALIFG__0 (0x00000000)
#define CS_SETIFG_SET_CALIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_CALIFG__1 (0x00000080)
#define CS_SETIFG_SET_DCOMAXIFG (0x00000020)
#define CS_SETIFG_SET_DCOMAXIFG__0 (0x00000000)
#define CS_SETIFG_SET_DCOMAXIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_DCOMAXIFG__1 (0x00000020)
#define CS_SETIFG_SET_DCOMINIFG (0x00000010)
#define CS_SETIFG_SET_DCOMINIFG__0 (0x00000000)
#define CS_SETIFG_SET_DCOMINIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_DCOMINIFG__1 (0x00000010)
#define CS_SETIFG_SET_DCORIFG (0x00000040)
#define CS_SETIFG_SET_DCORIFG__0 (0x00000000)
#define CS_SETIFG_SET_DCORIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_DCORIFG__1 (0x00000040)
#define CS_SETIFG_SET_FCNTHF2IFG (0x00000400)
#define CS_SETIFG_SET_FCNTHF2IFG__0 (0x00000000)
#define CS_SETIFG_SET_FCNTHF2IFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_FCNTHF2IFG__1 (0x00000400)
#define CS_SETIFG_SET_FCNTHFIFG (0x00000200)
#define CS_SETIFG_SET_FCNTHFIFG__0 (0x00000000)
#define CS_SETIFG_SET_FCNTHFIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_FCNTHFIFG__1 (0x00000200)
#define CS_SETIFG_SET_FCNTLFIFG (0x00000100)
#define CS_SETIFG_SET_FCNTLFIFG__0 (0x00000000)
#define CS_SETIFG_SET_FCNTLFIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_FCNTLFIFG__1 (0x00000100)
#define CS_SETIFG_SET_HFXT2IFG (0x00000004)
#define CS_SETIFG_SET_HFXT2IFG__0 (0x00000000)
#define CS_SETIFG_SET_HFXT2IFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_HFXT2IFG__1 (0x00000004)
#define CS_SETIFG_SET_HFXTIFG (0x00000002)
#define CS_SETIFG_SET_HFXTIFG__0 (0x00000000)
#define CS_SETIFG_SET_HFXTIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_HFXTIFG__1 (0x00000002)
#define CS_SETIFG_SET_LFXTIFG (0x00000001)
#define CS_SETIFG_SET_LFXTIFG__0 (0x00000000)
#define CS_SETIFG_SET_LFXTIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_LFXTIFG__1 (0x00000001)
#define CS_SETIFG_SET_PLLLOSIFG (0x00002000)
#define CS_SETIFG_SET_PLLLOSIFG__0 (0x00000000)
#define CS_SETIFG_SET_PLLLOSIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_PLLLOSIFG__1 (0x00002000)
#define CS_SETIFG_SET_PLLOOLIFG (0x00001000)
#define CS_SETIFG_SET_PLLOOLIFG__0 (0x00000000)
#define CS_SETIFG_SET_PLLOOLIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_PLLOOLIFG__1 (0x00001000)
#define CS_SETIFG_SET_PLLOORIFG (0x00004000)
#define CS_SETIFG_SET_PLLOORIFG__0 (0x00000000)
#define CS_SETIFG_SET_PLLOORIFG__0_NO_EFFECT (0x00000000)
#define CS_SETIFG_SET_PLLOORIFG__1 (0x00004000)
#define CS_STAT (HWREG32(0x40010434))
#define CS_STAT_ACLK_ON (0x00010000)
#define CS_STAT_ACLK_ON__0 (0x00000000)
#define CS_STAT_ACLK_ON__0_INACTIVE (0x00000000)
#define CS_STAT_ACLK_ON__1 (0x00010000)
#define CS_STAT_ACLK_ON__1_ACTIVE (0x00010000)
#define CS_STAT_ACLK_READY (0x01000000)
#define CS_STAT_BCLK_READY (0x10000000)
#define CS_STAT_DCOBIAS_ON (0x00000002)
#define CS_STAT_DCOBIAS_ON__0 (0x00000000)
#define CS_STAT_DCOBIAS_ON__0_INACTIVE (0x00000000)
#define CS_STAT_DCOBIAS_ON__1 (0x00000002)
#define CS_STAT_DCOBIAS_ON__1_ACTIVE (0x00000002)
#define CS_STAT_DCO_ON (0x00000001)
#define CS_STAT_DCO_ON__0 (0x00000000)
#define CS_STAT_DCO_ON__0_INACTIVE (0x00000000)
#define CS_STAT_DCO_ON__1 (0x00000001)
#define CS_STAT_DCO_ON__1_ACTIVE (0x00000001)
#define CS_STAT_HFXT2_ON (0x00000008)
#define CS_STAT_HFXT2_ON__0 (0x00000000)
#define CS_STAT_HFXT2_ON__0_INACTIVE (0x00000000)
#define CS_STAT_HFXT2_ON__1 (0x00000008)
#define CS_STAT_HFXT2_ON__1_ACTIVE (0x00000008)
#define CS_STAT_HFXT_ON (0x00000004)
#define CS_STAT_HFXT_ON__0 (0x00000000)
#define CS_STAT_HFXT_ON__0_INACTIVE (0x00000000)
#define CS_STAT_HFXT_ON__1 (0x00000004)
#define CS_STAT_HFXT_ON__1_ACTIVE (0x00000004)
#define CS_STAT_HSMCLK_ON (0x00040000)
#define CS_STAT_HSMCLK_ON__0 (0x00000000)
#define CS_STAT_HSMCLK_ON__0_INACTIVE (0x00000000)
#define CS_STAT_HSMCLK_ON__1 (0x00040000)
#define CS_STAT_HSMCLK_ON__1_ACTIVE (0x00040000)
#define CS_STAT_HSMCLK_READY (0x04000000)
#define CS_STAT_LFXTCLK_ON (0x00400000)
#define CS_STAT_LFXTCLK_ON__0 (0x00000000)
#define CS_STAT_LFXTCLK_ON__0_INACTIVE (0x00000000)
#define CS_STAT_LFXTCLK_ON__1 (0x00400000)
#define CS_STAT_LFXTCLK_ON__1_ACTIVE (0x00400000)
#define CS_STAT_LFXT_ON (0x00000040)
#define CS_STAT_LFXT_ON__0 (0x00000000)
#define CS_STAT_LFXT_ON__0_INACTIVE (0x00000000)
#define CS_STAT_LFXT_ON__1 (0x00000040)
#define CS_STAT_LFXT_ON__1_ACTIVE (0x00000040)
#define CS_STAT_MCLK_ON (0x00020000)
#define CS_STAT_MCLK_ON__0 (0x00000000)
#define CS_STAT_MCLK_ON__0_INACTIVE (0x00000000)
#define CS_STAT_MCLK_ON__1 (0x00020000)
#define CS_STAT_MCLK_ON__1_ACTIVE (0x00020000)
#define CS_STAT_MCLK_READY (0x02000000)
#define CS_STAT_MODCLK_ON (0x00100000)
#define CS_STAT_MODCLK_ON__0 (0x00000000)
#define CS_STAT_MODCLK_ON__0_INACTIVE (0x00000000)
#define CS_STAT_MODCLK_ON__1 (0x00100000)
#define CS_STAT_MODCLK_ON__1_ACTIVE (0x00100000)
#define CS_STAT_MODOSC_ON (0x00000010)
#define CS_STAT_MODOSC_ON__0 (0x00000000)
#define CS_STAT_MODOSC_ON__0_INACTIVE (0x00000000)
#define CS_STAT_MODOSC_ON__1 (0x00000010)
#define CS_STAT_MODOSC_ON__1_ACTIVE (0x00000010)
#define CS_STAT_REFOCLK_ON (0x00800000)
#define CS_STAT_REFOCLK_ON__0 (0x00000000)
#define CS_STAT_REFOCLK_ON__0_INACTIVE (0x00000000)
#define CS_STAT_REFOCLK_ON__1 (0x00800000)
#define CS_STAT_REFOCLK_ON__1_ACTIVE (0x00800000)
#define CS_STAT_REFO_ON (0x00000080)
#define CS_STAT_REFO_ON__0 (0x00000000)
#define CS_STAT_REFO_ON__0_INACTIVE (0x00000000)
#define CS_STAT_REFO_ON__1 (0x00000080)
#define CS_STAT_REFO_ON__1_ACTIVE (0x00000080)
#define CS_STAT_SMCLK_ON (0x00080000)
#define CS_STAT_SMCLK_ON__0 (0x00000000)
#define CS_STAT_SMCLK_ON__0_INACTIVE (0x00000000)
#define CS_STAT_SMCLK_ON__1 (0x00080000)
#define CS_STAT_SMCLK_ON__1_ACTIVE (0x00080000)
#define CS_STAT_SMCLK_READY (0x08000000)
#define CS_STAT_VLOCLK_ON (0x00200000)
#define CS_STAT_VLOCLK_ON__0 (0x00000000)
#define CS_STAT_VLOCLK_ON__0_INACTIVE (0x00000000)
#define CS_STAT_VLOCLK_ON__1 (0x00200000)
#define CS_STAT_VLOCLK_ON__1_ACTIVE (0x00200000)
#define CS_STAT_VLO_ON (0x00000020)
#define CS_STAT_VLO_ON__0 (0x00000000)
#define CS_STAT_VLO_ON__0_INACTIVE (0x00000000)
#define CS_STAT_VLO_ON__1 (0x00000020)
#define CS_STAT_VLO_ON__1_ACTIVE (0x00000020)
#define DCORSEL__0 (0x00000000)
#define DCORSEL__1 (0x00010000)
#define DCORSEL__2 (0x00020000)
#define DCORSEL__3 (0x00030000)
#define DCORSEL__4 (0x00040000)
#define DCORSEL__5 (0x00050000)
#define DDDS_ADC14_PARAM0 (HWREG32(0x00203038))
#define DDDS_ADC14_REFTEMP0 (HWREG32(0x0020303C))
#define DDDS_ADC14_REFTEMP1 (HWREG32(0x00203040))
#define DDDS_ADC14_REFTEMP2 (HWREG32(0x00203044))
#define DDDS_ADC14_REFTEMP3 (HWREG32(0x00203048))
#define DDDS_BCREV (HWREG32(0x00203010))
#define DDDS_CSDCOCONST (HWREG32(0x00203030))
#define DDDS_CSDCOERCAL (HWREG32(0x0020302C))
#define DDDS_CSDCOIRCAL (HWREG32(0x00203028))
#define DDDS_DDDS_CHECKSUM (HWREG32(0x00203000))
#define DDDS_DDDS_ENDWORD (HWREG32(0x0020306C))
#define DDDS_DEVID (HWREG32(0x00203008))
#define DDDS_DIE_POSITION (HWREG32(0x0020301C))
#define DDDS_HWREV (HWREG32(0x0020300C))
#define DDDS_LOT_ID (HWREG32(0x00203018))
#define DDDS_MODID_ADC14 (HWREG32(0x00203034))
#define DDDS_MODID_CS (HWREG32(0x00203024))
#define DDDS_MODID_DEVINFO (HWREG32(0x00203004))
#define DDDS_MODID_DIEREC (HWREG32(0x00203014))
#define DDDS_MODID_RANDNUM (HWREG32(0x00203058))
#define DDDS_MODID_REF (HWREG32(0x0020304C))
#define DDDS_RAND0 (HWREG32(0x0020305C))
#define DDDS_RAND1 (HWREG32(0x00203060))
#define DDDS_RAND2 (HWREG32(0x00203064))
#define DDDS_RAND3 (HWREG32(0x00203068))
#define DDDS_REF_PARAM0 (HWREG32(0x00203050))
#define DDDS_REF_PARAM1 (HWREG32(0x00203054))
#define DDDS_TEST_RESULTS (HWREG32(0x00203020))
#define DIVA__0 (0x00000000)
#define DIVA__3 (0x03000000)
#define DIVA__5 (0x05000000)
#define DIVA__6 (0x06000000)
#define DIVA__7 (0x07000000)
#define DIVA__M (0x07000000)
#define DIVHS__0 (0x00000000)
#define DIVHS__3 (0x00300000)
#define DIVHS__5 (0x00500000)
#define DIVHS__6 (0x00600000)
#define DIVHS__7 (0x00700000)
#define DIVHS__M (0x00700000)
#define DIVM__0 (0x00000000)
#define DIVM__3 (0x00030000)
#define DIVM__5 (0x00050000)
#define DIVM__6 (0x00060000)
#define DIVM__7 (0x00070000)
#define DIVM__M (0x00070000)
#define DIVS__0 (0x00000000)
#define DIVS__3 (0x30000000)
#define DIVS__5 (0x50000000)
#define DIVS__6 (0x60000000)
#define DIVS__7 (0x70000000)
#define DIVS__M (0x70000000)
#define DMA_CH0_SRCCFG (HWREG32(0x4000E010))
#define DMA_CH0_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH10_SRCCFG (HWREG32(0x4000E038))
#define DMA_CH10_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH11_SRCCFG (HWREG32(0x4000E03C))
#define DMA_CH11_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH12_SRCCFG (HWREG32(0x4000E040))
#define DMA_CH12_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH13_SRCCFG (HWREG32(0x4000E044))
#define DMA_CH13_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH14_SRCCFG (HWREG32(0x4000E048))
#define DMA_CH14_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH15_SRCCFG (HWREG32(0x4000E04C))
#define DMA_CH15_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH16_SRCCFG (HWREG32(0x4000E050))
#define DMA_CH16_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH17_SRCCFG (HWREG32(0x4000E054))
#define DMA_CH17_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH18_SRCCFG (HWREG32(0x4000E058))
#define DMA_CH18_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH19_SRCCFG (HWREG32(0x4000E05C))
#define DMA_CH19_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH1_SRCCFG (HWREG32(0x4000E014))
#define DMA_CH1_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH20_SRCCFG (HWREG32(0x4000E060))
#define DMA_CH20_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH21_SRCCFG (HWREG32(0x4000E064))
#define DMA_CH21_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH22_SRCCFG (HWREG32(0x4000E068))
#define DMA_CH22_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH23_SRCCFG (HWREG32(0x4000E06C))
#define DMA_CH23_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH24_SRCCFG (HWREG32(0x4000E070))
#define DMA_CH24_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH25_SRCCFG (HWREG32(0x4000E074))
#define DMA_CH25_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH26_SRCCFG (HWREG32(0x4000E078))
#define DMA_CH26_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH27_SRCCFG (HWREG32(0x4000E07C))
#define DMA_CH27_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH28_SRCCFG (HWREG32(0x4000E080))
#define DMA_CH28_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH29_SRCCFG (HWREG32(0x4000E084))
#define DMA_CH29_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH2_SRCCFG (HWREG32(0x4000E018))
#define DMA_CH2_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH30_SRCCFG (HWREG32(0x4000E088))
#define DMA_CH30_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH31_SRCCFG (HWREG32(0x4000E08C))
#define DMA_CH31_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH3_SRCCFG (HWREG32(0x4000E01C))
#define DMA_CH3_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH4_SRCCFG (HWREG32(0x4000E020))
#define DMA_CH4_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH5_SRCCFG (HWREG32(0x4000E024))
#define DMA_CH5_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH6_SRCCFG (HWREG32(0x4000E028))
#define DMA_CH6_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH7_SRCCFG (HWREG32(0x4000E02C))
#define DMA_CH7_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH8_SRCCFG (HWREG32(0x4000E030))
#define DMA_CH8_SRCCFG_SRC__M (0x000000ff)
#define DMA_CH9_SRCCFG (HWREG32(0x4000E034))
#define DMA_CH9_SRCCFG_SRC__M (0x000000ff)
#define DMA_DEVCONFIG_NUM_DMA_CHANNELS__M (0x000000ff)
#define DMA_DEVCONFIG_NUM_SRC_PER_CHANNEL__M (0x0000ff00)
#define DMA_INT0_CLRFLG (HWREG32(0x4000E114))
#define DMA_INT0_CLRFLG_CH0 (0x00000001)
#define DMA_INT0_CLRFLG_CH1 (0x00000002)
#define DMA_INT0_CLRFLG_CH10 (0x00000400)
#define DMA_INT0_CLRFLG_CH11 (0x00000800)
#define DMA_INT0_CLRFLG_CH12 (0x00001000)
#define DMA_INT0_CLRFLG_CH13 (0x00002000)
#define DMA_INT0_CLRFLG_CH14 (0x00004000)
#define DMA_INT0_CLRFLG_CH15 (0x00008000)
#define DMA_INT0_CLRFLG_CH16 (0x00010000)
#define DMA_INT0_CLRFLG_CH17 (0x00020000)
#define DMA_INT0_CLRFLG_CH18 (0x00040000)
#define DMA_INT0_CLRFLG_CH19 (0x00080000)
#define DMA_INT0_CLRFLG_CH2 (0x00000004)
#define DMA_INT0_CLRFLG_CH20 (0x00100000)
#define DMA_INT0_CLRFLG_CH21 (0x00200000)
#define DMA_INT0_CLRFLG_CH22 (0x00400000)
#define DMA_INT0_CLRFLG_CH23 (0x00800000)
#define DMA_INT0_CLRFLG_CH24 (0x01000000)
#define DMA_INT0_CLRFLG_CH25 (0x02000000)
#define DMA_INT0_CLRFLG_CH26 (0x04000000)
#define DMA_INT0_CLRFLG_CH27 (0x08000000)
#define DMA_INT0_CLRFLG_CH28 (0x10000000)
#define DMA_INT0_CLRFLG_CH29 (0x20000000)
#define DMA_INT0_CLRFLG_CH3 (0x00000008)
#define DMA_INT0_CLRFLG_CH30 (0x40000000)
#define DMA_INT0_CLRFLG_CH31 (0x80000000)
#define DMA_INT0_CLRFLG_CH4 (0x00000010)
#define DMA_INT0_CLRFLG_CH5 (0x00000020)
#define DMA_INT0_CLRFLG_CH6 (0x00000040)
#define DMA_INT0_CLRFLG_CH7 (0x00000080)
#define DMA_INT0_CLRFLG_CH8 (0x00000100)
#define DMA_INT0_CLRFLG_CH9 (0x00000200)
#define DMA_INT0_SRCFLG (HWREG32(0x4000E110))
#define DMA_INT0_SRCFLG_CH0 (0x00000001)
#define DMA_INT0_SRCFLG_CH1 (0x00000002)
#define DMA_INT0_SRCFLG_CH10 (0x00000400)
#define DMA_INT0_SRCFLG_CH11 (0x00000800)
#define DMA_INT0_SRCFLG_CH12 (0x00001000)
#define DMA_INT0_SRCFLG_CH13 (0x00002000)
#define DMA_INT0_SRCFLG_CH14 (0x00004000)
#define DMA_INT0_SRCFLG_CH15 (0x00008000)
#define DMA_INT0_SRCFLG_CH16 (0x00010000)
#define DMA_INT0_SRCFLG_CH17 (0x00020000)
#define DMA_INT0_SRCFLG_CH18 (0x00040000)
#define DMA_INT0_SRCFLG_CH19 (0x00080000)
#define DMA_INT0_SRCFLG_CH2 (0x00000004)
#define DMA_INT0_SRCFLG_CH20 (0x00100000)
#define DMA_INT0_SRCFLG_CH21 (0x00200000)
#define DMA_INT0_SRCFLG_CH22 (0x00400000)
#define DMA_INT0_SRCFLG_CH23 (0x00800000)
#define DMA_INT0_SRCFLG_CH24 (0x01000000)
#define DMA_INT0_SRCFLG_CH25 (0x02000000)
#define DMA_INT0_SRCFLG_CH26 (0x04000000)
#define DMA_INT0_SRCFLG_CH27 (0x08000000)
#define DMA_INT0_SRCFLG_CH28 (0x10000000)
#define DMA_INT0_SRCFLG_CH29 (0x20000000)
#define DMA_INT0_SRCFLG_CH3 (0x00000008)
#define DMA_INT0_SRCFLG_CH30 (0x40000000)
#define DMA_INT0_SRCFLG_CH31 (0x80000000)
#define DMA_INT0_SRCFLG_CH4 (0x00000010)
#define DMA_INT0_SRCFLG_CH5 (0x00000020)
#define DMA_INT0_SRCFLG_CH6 (0x00000040)
#define DMA_INT0_SRCFLG_CH7 (0x00000080)
#define DMA_INT0_SRCFLG_CH8 (0x00000100)
#define DMA_INT0_SRCFLG_CH9 (0x00000200)
#define DMA_INT1_SRCCFG (HWREG32(0x4000E100))
#define DMA_INT1_SRCCFG_EN (0x00000020)
#define DMA_INT1_SRCCFG_INT_SRC__M (0x0000001f)
#define DMA_INT2_SRCCFG (HWREG32(0x4000E104))
#define DMA_INT2_SRCCFG_EN (0x00000020)
#define DMA_INT2_SRCCFG_INT_SRC__M (0x0000001f)
#define DMA_INT3_SRCCFG (HWREG32(0x4000E108))
#define DMA_INT3_SRCCFG_EN (0x00000020)
#define DMA_INT3_SRCCFG_INT_SRC__M (0x0000001f)
#define DMA_SW_CHTRIG (HWREG32(0x4000E004))
#define DMA_SW_CHTRIG_CH0 (0x00000001)
#define DMA_SW_CHTRIG_CH1 (0x00000002)
#define DMA_SW_CHTRIG_CH10 (0x00000400)
#define DMA_SW_CHTRIG_CH11 (0x00000800)
#define DMA_SW_CHTRIG_CH12 (0x00001000)
#define DMA_SW_CHTRIG_CH13 (0x00002000)
#define DMA_SW_CHTRIG_CH14 (0x00004000)
#define DMA_SW_CHTRIG_CH15 (0x00008000)
#define DMA_SW_CHTRIG_CH16 (0x00010000)
#define DMA_SW_CHTRIG_CH17 (0x00020000)
#define DMA_SW_CHTRIG_CH18 (0x00040000)
#define DMA_SW_CHTRIG_CH19 (0x00080000)
#define DMA_SW_CHTRIG_CH2 (0x00000004)
#define DMA_SW_CHTRIG_CH20 (0x00100000)
#define DMA_SW_CHTRIG_CH21 (0x00200000)
#define DMA_SW_CHTRIG_CH22 (0x00400000)
#define DMA_SW_CHTRIG_CH23 (0x00800000)
#define DMA_SW_CHTRIG_CH24 (0x01000000)
#define DMA_SW_CHTRIG_CH25 (0x02000000)
#define DMA_SW_CHTRIG_CH26 (0x04000000)
#define DMA_SW_CHTRIG_CH27 (0x08000000)
#define DMA_SW_CHTRIG_CH28 (0x10000000)
#define DMA_SW_CHTRIG_CH29 (0x20000000)
#define DMA_SW_CHTRIG_CH3 (0x00000008)
#define DMA_SW_CHTRIG_CH30 (0x40000000)
#define DMA_SW_CHTRIG_CH31 (0x80000000)
#define DMA_SW_CHTRIG_CH4 (0x00000010)
#define DMA_SW_CHTRIG_CH5 (0x00000020)
#define DMA_SW_CHTRIG_CH6 (0x00000040)
#define DMA_SW_CHTRIG_CH7 (0x00000080)
#define DMA_SW_CHTRIG_CH8 (0x00000100)
#define DMA_SW_CHTRIG_CH9 (0x00000200)
#define DWT_CPICNT_CPICNT__M (0x000000ff)
#define DWT_CTRL_CPIEVTENA__0 (0x00000000)
#define DWT_CTRL_CPIEVTENA__1 (0x00020000)
#define DWT_CTRL_CYCEVTENA__0 (0x00000000)
#define DWT_CTRL_CYCEVTENA__1 (0x00400000)
#define DWT_CTRL_CYCTAP__0 (0x00000000)
#define DWT_CTRL_CYCTAP__1 (0x00000200)
#define DWT_CTRL_EXCEVTENA__0 (0x00000000)
#define DWT_CTRL_EXCEVTENA__1 (0x00040000)
#define DWT_CTRL_EXCTRCENA__0 (0x00000000)
#define DWT_CTRL_EXCTRCENA__1 (0x00010000)
#define DWT_CTRL_FOLDEVTENA__0 (0x00000000)
#define DWT_CTRL_FOLDEVTENA__1 (0x00200000)
#define DWT_CTRL_LSUEVTENA__0 (0x00000000)
#define DWT_CTRL_LSUEVTENA__1 (0x00100000)
#define DWT_CTRL_PCSAMPLEENA__0 (0x00000000)
#define DWT_CTRL_PCSAMPLEENA__1 (0x00001000)
#define DWT_CTRL_POSTCNT__M (0x000001e0)
#define DWT_CTRL_POSTPRESET__M (0x0000001e)
#define DWT_CTRL_SLEEPEVTENA__0 (0x00000000)
#define DWT_CTRL_SLEEPEVTENA__1 (0x00080000)
#define DWT_CTRL_SYNCTAP__0 (0x00000000)
#define DWT_CTRL_SYNCTAP__1 (0x00000400)
#define DWT_CTRL_SYNCTAP__2 (0x00000800)
#define DWT_CTRL_SYNCTAP__3 (0x00000c00)
#define DWT_CTRL_SYNCTAP__M (0x00000c00)
#define DWT_EXCCNT_EXCCNT__M (0x000000ff)
#define DWT_FOLDCNT_FOLDCNT__M (0x000000ff)
#define DWT_FUNCTION0_DATAVADDR0__M (0x0000f000)
#define DWT_FUNCTION0_DATAVADDR1__M (0x000f0000)
#define DWT_FUNCTION0_DATAVSIZE__0 (0x00000000)
#define DWT_FUNCTION0_DATAVSIZE__0_BYTE (0x00000000)
#define DWT_FUNCTION0_DATAVSIZE__1 (0x00000400)
#define DWT_FUNCTION0_DATAVSIZE__1_HALFWORD (0x00000400)
#define DWT_FUNCTION0_DATAVSIZE__2 (0x00000800)
#define DWT_FUNCTION0_DATAVSIZE__2_WORD (0x00000800)
#define DWT_FUNCTION0_DATAVSIZE__3 (0x00000c00)
#define DWT_FUNCTION0_DATAVSIZE__3_UNPREDICTABLE (0x00000c00)
#define DWT_FUNCTION0_DATAVSIZE__M (0x00000c00)
#define DWT_FUNCTION0_FUNCTION__0 (0x00000000)
#define DWT_FUNCTION0_FUNCTION__0_DISABLED (0x00000000)
#define DWT_FUNCTION0_FUNCTION__1 (0x00000001)
#define DWT_FUNCTION0_FUNCTION__10 (0x0000000a)
#define DWT_FUNCTION0_FUNCTION__11 (0x0000000b)
#define DWT_FUNCTION0_FUNCTION__12 (0x0000000c)
#define DWT_FUNCTION0_FUNCTION__13 (0x0000000d)
#define DWT_FUNCTION0_FUNCTION__14 (0x0000000e)
#define DWT_FUNCTION0_FUNCTION__15 (0x0000000f)
#define DWT_FUNCTION0_FUNCTION__2 (0x00000002)
#define DWT_FUNCTION0_FUNCTION__3 (0x00000003)
#define DWT_FUNCTION0_FUNCTION__4 (0x00000004)
#define DWT_FUNCTION0_FUNCTION__5 (0x00000005)
#define DWT_FUNCTION0_FUNCTION__6 (0x00000006)
#define DWT_FUNCTION0_FUNCTION__7 (0x00000007)
#define DWT_FUNCTION0_FUNCTION__8 (0x00000008)
#define DWT_FUNCTION0_FUNCTION__9 (0x00000009)
#define DWT_FUNCTION0_FUNCTION__M (0x0000000f)
#define DWT_FUNCTION0_LNK1ENA__0 (0x00000000)
#define DWT_FUNCTION0_LNK1ENA__1 (0x00000200)
#define DWT_FUNCTION1_DATAVADDR0__M (0x0000f000)
#define DWT_FUNCTION1_DATAVADDR1__M (0x000f0000)
#define DWT_FUNCTION1_DATAVSIZE__0 (0x00000000)
#define DWT_FUNCTION1_DATAVSIZE__0_BYTE (0x00000000)
#define DWT_FUNCTION1_DATAVSIZE__1 (0x00000400)
#define DWT_FUNCTION1_DATAVSIZE__1_HALFWORD (0x00000400)
#define DWT_FUNCTION1_DATAVSIZE__2 (0x00000800)
#define DWT_FUNCTION1_DATAVSIZE__2_WORD (0x00000800)
#define DWT_FUNCTION1_DATAVSIZE__3 (0x00000c00)
#define DWT_FUNCTION1_DATAVSIZE__3_UNPREDICTABLE (0x00000c00)
#define DWT_FUNCTION1_DATAVSIZE__M (0x00000c00)
#define DWT_FUNCTION1_FUNCTION__0 (0x00000000)
#define DWT_FUNCTION1_FUNCTION__0_DISABLED (0x00000000)
#define DWT_FUNCTION1_FUNCTION__1 (0x00000001)
#define DWT_FUNCTION1_FUNCTION__10 (0x0000000a)
#define DWT_FUNCTION1_FUNCTION__11 (0x0000000b)
#define DWT_FUNCTION1_FUNCTION__12 (0x0000000c)
#define DWT_FUNCTION1_FUNCTION__13 (0x0000000d)
#define DWT_FUNCTION1_FUNCTION__14 (0x0000000e)
#define DWT_FUNCTION1_FUNCTION__15 (0x0000000f)
#define DWT_FUNCTION1_FUNCTION__2 (0x00000002)
#define DWT_FUNCTION1_FUNCTION__3 (0x00000003)
#define DWT_FUNCTION1_FUNCTION__4 (0x00000004)
#define DWT_FUNCTION1_FUNCTION__5 (0x00000005)
#define DWT_FUNCTION1_FUNCTION__6 (0x00000006)
#define DWT_FUNCTION1_FUNCTION__7 (0x00000007)
#define DWT_FUNCTION1_FUNCTION__8 (0x00000008)
#define DWT_FUNCTION1_FUNCTION__9 (0x00000009)
#define DWT_FUNCTION1_FUNCTION__M (0x0000000f)
#define DWT_FUNCTION1_LNK1ENA__0 (0x00000000)
#define DWT_FUNCTION1_LNK1ENA__1 (0x00000200)
#define DWT_FUNCTION2_DATAVADDR0__M (0x0000f000)
#define DWT_FUNCTION2_DATAVADDR1__M (0x000f0000)
#define DWT_FUNCTION2_DATAVSIZE__0 (0x00000000)
#define DWT_FUNCTION2_DATAVSIZE__0_BYTE (0x00000000)
#define DWT_FUNCTION2_DATAVSIZE__1 (0x00000400)
#define DWT_FUNCTION2_DATAVSIZE__1_HALFWORD (0x00000400)
#define DWT_FUNCTION2_DATAVSIZE__2 (0x00000800)
#define DWT_FUNCTION2_DATAVSIZE__2_WORD (0x00000800)
#define DWT_FUNCTION2_DATAVSIZE__3 (0x00000c00)
#define DWT_FUNCTION2_DATAVSIZE__3_UNPREDICTABLE (0x00000c00)
#define DWT_FUNCTION2_DATAVSIZE__M (0x00000c00)
#define DWT_FUNCTION2_FUNCTION__0 (0x00000000)
#define DWT_FUNCTION2_FUNCTION__0_DISABLED (0x00000000)
#define DWT_FUNCTION2_FUNCTION__1 (0x00000001)
#define DWT_FUNCTION2_FUNCTION__10 (0x0000000a)
#define DWT_FUNCTION2_FUNCTION__11 (0x0000000b)
#define DWT_FUNCTION2_FUNCTION__12 (0x0000000c)
#define DWT_FUNCTION2_FUNCTION__13 (0x0000000d)
#define DWT_FUNCTION2_FUNCTION__14 (0x0000000e)
#define DWT_FUNCTION2_FUNCTION__15 (0x0000000f)
#define DWT_FUNCTION2_FUNCTION__2 (0x00000002)
#define DWT_FUNCTION2_FUNCTION__3 (0x00000003)
#define DWT_FUNCTION2_FUNCTION__4 (0x00000004)
#define DWT_FUNCTION2_FUNCTION__5 (0x00000005)
#define DWT_FUNCTION2_FUNCTION__6 (0x00000006)
#define DWT_FUNCTION2_FUNCTION__7 (0x00000007)
#define DWT_FUNCTION2_FUNCTION__8 (0x00000008)
#define DWT_FUNCTION2_FUNCTION__9 (0x00000009)
#define DWT_FUNCTION2_FUNCTION__M (0x0000000f)
#define DWT_FUNCTION2_LNK1ENA__0 (0x00000000)
#define DWT_FUNCTION2_LNK1ENA__1 (0x00000200)
#define DWT_FUNCTION3_DATAVADDR0__M (0x0000f000)
#define DWT_FUNCTION3_DATAVADDR1__M (0x000f0000)
#define DWT_FUNCTION3_DATAVSIZE__0 (0x00000000)
#define DWT_FUNCTION3_DATAVSIZE__0_BYTE (0x00000000)
#define DWT_FUNCTION3_DATAVSIZE__1 (0x00000400)
#define DWT_FUNCTION3_DATAVSIZE__1_HALFWORD (0x00000400)
#define DWT_FUNCTION3_DATAVSIZE__2 (0x00000800)
#define DWT_FUNCTION3_DATAVSIZE__2_WORD (0x00000800)
#define DWT_FUNCTION3_DATAVSIZE__3 (0x00000c00)
#define DWT_FUNCTION3_DATAVSIZE__3_UNPREDICTABLE (0x00000c00)
#define DWT_FUNCTION3_DATAVSIZE__M (0x00000c00)
#define DWT_FUNCTION3_FUNCTION__0 (0x00000000)
#define DWT_FUNCTION3_FUNCTION__0_DISABLED (0x00000000)
#define DWT_FUNCTION3_FUNCTION__1 (0x00000001)
#define DWT_FUNCTION3_FUNCTION__10 (0x0000000a)
#define DWT_FUNCTION3_FUNCTION__11 (0x0000000b)
#define DWT_FUNCTION3_FUNCTION__12 (0x0000000c)
#define DWT_FUNCTION3_FUNCTION__13 (0x0000000d)
#define DWT_FUNCTION3_FUNCTION__14 (0x0000000e)
#define DWT_FUNCTION3_FUNCTION__15 (0x0000000f)
#define DWT_FUNCTION3_FUNCTION__2 (0x00000002)
#define DWT_FUNCTION3_FUNCTION__3 (0x00000003)
#define DWT_FUNCTION3_FUNCTION__4 (0x00000004)
#define DWT_FUNCTION3_FUNCTION__5 (0x00000005)
#define DWT_FUNCTION3_FUNCTION__6 (0x00000006)
#define DWT_FUNCTION3_FUNCTION__7 (0x00000007)
#define DWT_FUNCTION3_FUNCTION__8 (0x00000008)
#define DWT_FUNCTION3_FUNCTION__9 (0x00000009)
#define DWT_FUNCTION3_FUNCTION__M (0x0000000f)
#define DWT_FUNCTION3_LNK1ENA__0 (0x00000000)
#define DWT_FUNCTION3_LNK1ENA__1 (0x00000200)
#define DWT_LSUCNT_LSUCNT__M (0x000000ff)
#define DWT_MASK0_MASK__M (0x0000000f)
#define DWT_MASK1_MASK__M (0x0000000f)
#define DWT_MASK2_MASK__M (0x0000000f)
#define DWT_MASK3_MASK__M (0x0000000f)
#define DWT_SLEEPCNT_SLEEPCNT__M (0x000000ff)
#define EUSCI_A0_SPI_BRW (HWREG16(0x40001006))
#define EUSCI_A0_SPI_CTLW0 (HWREG16(0x40001000))
#define EUSCI_A0_SPI_CTLW0_UC7BIT (0x1000)
#define EUSCI_A0_SPI_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_A0_SPI_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_A0_SPI_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_A0_SPI_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_A0_SPI_CTLW0_UCCKPH (0x8000)
#define EUSCI_A0_SPI_CTLW0_UCCKPH__0 (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCCKPH__1 (0x8000)
#define EUSCI_A0_SPI_CTLW0_UCCKPL (0x4000)
#define EUSCI_A0_SPI_CTLW0_UCCKPL__0 (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCCKPL__1 (0x4000)
#define EUSCI_A0_SPI_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_A0_SPI_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_A0_SPI_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_A0_SPI_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_A0_SPI_CTLW0_UCMODE__M (0x0600)
#define EUSCI_A0_SPI_CTLW0_UCMSB (0x2000)
#define EUSCI_A0_SPI_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_A0_SPI_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_A0_SPI_CTLW0_UCMST (0x0800)
#define EUSCI_A0_SPI_CTLW0_UCMST__0 (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCMST__1 (0x0800)
#define EUSCI_A0_SPI_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_A0_SPI_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_A0_SPI_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_A0_SPI_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_A0_SPI_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_A0_SPI_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_A0_SPI_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_A0_SPI_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_A0_SPI_CTLW0_UCSTEM (0x0002)
#define EUSCI_A0_SPI_CTLW0_UCSTEM__0 (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCSTEM__1 (0x0002)
#define EUSCI_A0_SPI_CTLW0_UCSWRST (0x0001)
#define EUSCI_A0_SPI_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_A0_SPI_CTLW0_UCSYNC (0x0100)
#define EUSCI_A0_SPI_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_A0_SPI_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_A0_SPI_IE (HWREG16(0x4000101A))
#define EUSCI_A0_SPI_IE_UCRXIE (0x0001)
#define EUSCI_A0_SPI_IE_UCRXIE__0 (0x0000)
#define EUSCI_A0_SPI_IE_UCRXIE__1 (0x0001)
#define EUSCI_A0_SPI_IE_UCTXIE (0x0002)
#define EUSCI_A0_SPI_IE_UCTXIE__0 (0x0000)
#define EUSCI_A0_SPI_IE_UCTXIE__1 (0x0002)
#define EUSCI_A0_SPI_IFG (HWREG16(0x4000101C))
#define EUSCI_A0_SPI_IFG_UCRXIFG (0x0001)
#define EUSCI_A0_SPI_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_A0_SPI_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_A0_SPI_IFG_UCTXIFG (0x0002)
#define EUSCI_A0_SPI_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_A0_SPI_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_A0_SPI_IV (HWREG16(0x4000101E))
#define EUSCI_A0_SPI_RXBUF (HWREG16(0x4000100C))
#define EUSCI_A0_SPI_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_A0_SPI_STATW (HWREG16(0x4000100A))
#define EUSCI_A0_SPI_STATW_UCBUSY (0x0001)
#define EUSCI_A0_SPI_STATW_UCBUSY__0 (0x0000)
#define EUSCI_A0_SPI_STATW_UCBUSY__0_EUSCI_INACTIVE (0x0000)
#define EUSCI_A0_SPI_STATW_UCBUSY__1 (0x0001)
#define EUSCI_A0_SPI_STATW_UCFE (0x0040)
#define EUSCI_A0_SPI_STATW_UCFE__0 (0x0000)
#define EUSCI_A0_SPI_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_A0_SPI_STATW_UCFE__1 (0x0040)
#define EUSCI_A0_SPI_STATW_UCLISTEN (0x0080)
#define EUSCI_A0_SPI_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_A0_SPI_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_A0_SPI_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_A0_SPI_STATW_UCOE (0x0020)
#define EUSCI_A0_SPI_STATW_UCOE__0 (0x0000)
#define EUSCI_A0_SPI_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_A0_SPI_STATW_UCOE__1 (0x0020)
#define EUSCI_A0_SPI_TXBUF (HWREG16(0x4000100E))
#define EUSCI_A0_SPI_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_A0_UART_ABCTL (HWREG16(0x40001010))
#define EUSCI_A0_UART_ABCTL_UCABDEN (0x0001)
#define EUSCI_A0_UART_ABCTL_UCABDEN__0 (0x0000)
#define EUSCI_A0_UART_ABCTL_UCABDEN__1 (0x0001)
#define EUSCI_A0_UART_ABCTL_UCBTOE (0x0004)
#define EUSCI_A0_UART_ABCTL_UCBTOE__0 (0x0000)
#define EUSCI_A0_UART_ABCTL_UCBTOE__0_NO_ERROR (0x0000)
#define EUSCI_A0_UART_ABCTL_UCBTOE__1 (0x0004)
#define EUSCI_A0_UART_ABCTL_UCDELIM__0 (0x0000)
#define EUSCI_A0_UART_ABCTL_UCDELIM__0_1_BIT_TIME (0x0000)
#define EUSCI_A0_UART_ABCTL_UCDELIM__1 (0x0010)
#define EUSCI_A0_UART_ABCTL_UCDELIM__1_2_BIT_TIMES (0x0010)
#define EUSCI_A0_UART_ABCTL_UCDELIM__2 (0x0020)
#define EUSCI_A0_UART_ABCTL_UCDELIM__2_3_BIT_TIMES (0x0020)
#define EUSCI_A0_UART_ABCTL_UCDELIM__3 (0x0030)
#define EUSCI_A0_UART_ABCTL_UCDELIM__3_4_BIT_TIMES (0x0030)
#define EUSCI_A0_UART_ABCTL_UCDELIM__M (0x0030)
#define EUSCI_A0_UART_ABCTL_UCSTOE (0x0008)
#define EUSCI_A0_UART_ABCTL_UCSTOE__0 (0x0000)
#define EUSCI_A0_UART_ABCTL_UCSTOE__0_NO_ERROR (0x0000)
#define EUSCI_A0_UART_ABCTL_UCSTOE__1 (0x0008)
#define EUSCI_A0_UART_BRW (HWREG16(0x40001006))
#define EUSCI_A0_UART_CTLW0 (HWREG16(0x40001000))
#define EUSCI_A0_UART_CTLW0_UC7BIT (0x1000)
#define EUSCI_A0_UART_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_A0_UART_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_A0_UART_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_A0_UART_CTLW0_UCBRKIE (0x0010)
#define EUSCI_A0_UART_CTLW0_UCBRKIE__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCBRKIE__1 (0x0010)
#define EUSCI_A0_UART_CTLW0_UCDORM (0x0008)
#define EUSCI_A0_UART_CTLW0_UCDORM__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCDORM__1 (0x0008)
#define EUSCI_A0_UART_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCMODE__0_UART_MODE (0x0000)
#define EUSCI_A0_UART_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_A0_UART_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_A0_UART_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_A0_UART_CTLW0_UCMODE__M (0x0600)
#define EUSCI_A0_UART_CTLW0_UCMSB (0x2000)
#define EUSCI_A0_UART_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_A0_UART_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_A0_UART_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_A0_UART_CTLW0_UCPAR (0x4000)
#define EUSCI_A0_UART_CTLW0_UCPAR__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCPAR__0_ODD_PARITY (0x0000)
#define EUSCI_A0_UART_CTLW0_UCPAR__1 (0x4000)
#define EUSCI_A0_UART_CTLW0_UCPAR__1_EVEN_PARITY (0x4000)
#define EUSCI_A0_UART_CTLW0_UCPEN (0x8000)
#define EUSCI_A0_UART_CTLW0_UCPEN__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCPEN__0_PARITY_DISABLED (0x0000)
#define EUSCI_A0_UART_CTLW0_UCPEN__1 (0x8000)
#define EUSCI_A0_UART_CTLW0_UCRXEIE (0x0020)
#define EUSCI_A0_UART_CTLW0_UCRXEIE__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCRXEIE__1 (0x0020)
#define EUSCI_A0_UART_CTLW0_UCSPB (0x0800)
#define EUSCI_A0_UART_CTLW0_UCSPB__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCSPB__0_ONE_STOP_BIT (0x0000)
#define EUSCI_A0_UART_CTLW0_UCSPB__1 (0x0800)
#define EUSCI_A0_UART_CTLW0_UCSPB__1_TWO_STOP_BITS (0x0800)
#define EUSCI_A0_UART_CTLW0_UCSSEL__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCSSEL__0_UCLK (0x0000)
#define EUSCI_A0_UART_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_A0_UART_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_A0_UART_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_A0_UART_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_A0_UART_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_A0_UART_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_A0_UART_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_A0_UART_CTLW0_UCSWRST (0x0001)
#define EUSCI_A0_UART_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_A0_UART_CTLW0_UCSYNC (0x0100)
#define EUSCI_A0_UART_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_A0_UART_CTLW0_UCTXADDR (0x0004)
#define EUSCI_A0_UART_CTLW0_UCTXADDR__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCTXADDR__1 (0x0004)
#define EUSCI_A0_UART_CTLW0_UCTXBRK (0x0002)
#define EUSCI_A0_UART_CTLW0_UCTXBRK__0 (0x0000)
#define EUSCI_A0_UART_CTLW0_UCTXBRK__1 (0x0002)
#define EUSCI_A0_UART_CTLW1 (HWREG16(0x40001002))
#define EUSCI_A0_UART_CTLW1_UCGLIT__0 (0x0000)
#define EUSCI_A0_UART_CTLW1_UCGLIT__0__2_NS (0x0000)
#define EUSCI_A0_UART_CTLW1_UCGLIT__1 (0x0001)
#define EUSCI_A0_UART_CTLW1_UCGLIT__1__50_NS (0x0001)
#define EUSCI_A0_UART_CTLW1_UCGLIT__2 (0x0002)
#define EUSCI_A0_UART_CTLW1_UCGLIT__2__100_NS (0x0002)
#define EUSCI_A0_UART_CTLW1_UCGLIT__3 (0x0003)
#define EUSCI_A0_UART_CTLW1_UCGLIT__3__200_NS (0x0003)
#define EUSCI_A0_UART_CTLW1_UCGLIT__M (0x0003)
#define EUSCI_A0_UART_IE (HWREG16(0x4000101A))
#define EUSCI_A0_UART_IE_UCRXIE (0x0001)
#define EUSCI_A0_UART_IE_UCRXIE__0 (0x0000)
#define EUSCI_A0_UART_IE_UCRXIE__1 (0x0001)
#define EUSCI_A0_UART_IE_UCSTTIE (0x0004)
#define EUSCI_A0_UART_IE_UCSTTIE__0 (0x0000)
#define EUSCI_A0_UART_IE_UCSTTIE__1 (0x0004)
#define EUSCI_A0_UART_IE_UCTXCPTIE (0x0008)
#define EUSCI_A0_UART_IE_UCTXCPTIE__0 (0x0000)
#define EUSCI_A0_UART_IE_UCTXCPTIE__1 (0x0008)
#define EUSCI_A0_UART_IE_UCTXIE (0x0002)
#define EUSCI_A0_UART_IE_UCTXIE__0 (0x0000)
#define EUSCI_A0_UART_IE_UCTXIE__1 (0x0002)
#define EUSCI_A0_UART_IFG (HWREG16(0x4000101C))
#define EUSCI_A0_UART_IFG_UCRXIFG (0x0001)
#define EUSCI_A0_UART_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_A0_UART_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_A0_UART_IFG_UCSTTIFG (0x0004)
#define EUSCI_A0_UART_IFG_UCSTTIFG__0 (0x0000)
#define EUSCI_A0_UART_IFG_UCSTTIFG__1 (0x0004)
#define EUSCI_A0_UART_IFG_UCTXCPTIFG (0x0008)
#define EUSCI_A0_UART_IFG_UCTXCPTIFG__0 (0x0000)
#define EUSCI_A0_UART_IFG_UCTXCPTIFG__1 (0x0008)
#define EUSCI_A0_UART_IFG_UCTXIFG (0x0002)
#define EUSCI_A0_UART_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_A0_UART_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_A0_UART_IRCTL (HWREG16(0x40001012))
#define EUSCI_A0_UART_IRCTL_UCIREN (0x0001)
#define EUSCI_A0_UART_IRCTL_UCIREN__0 (0x0000)
#define EUSCI_A0_UART_IRCTL_UCIREN__1 (0x0001)
#define EUSCI_A0_UART_IRCTL_UCIRRXFE (0x0100)
#define EUSCI_A0_UART_IRCTL_UCIRRXFE__0 (0x0000)
#define EUSCI_A0_UART_IRCTL_UCIRRXFE__1 (0x0100)
#define EUSCI_A0_UART_IRCTL_UCIRRXFL__M (0xfc00)
#define EUSCI_A0_UART_IRCTL_UCIRRXPL (0x0200)
#define EUSCI_A0_UART_IRCTL_UCIRRXPL__0 (0x0000)
#define EUSCI_A0_UART_IRCTL_UCIRRXPL__1 (0x0200)
#define EUSCI_A0_UART_IRCTL_UCIRTXCLK (0x0002)
#define EUSCI_A0_UART_IRCTL_UCIRTXCLK__0 (0x0000)
#define EUSCI_A0_UART_IRCTL_UCIRTXCLK__0_BRCLK (0x0000)
#define EUSCI_A0_UART_IRCTL_UCIRTXCLK__1 (0x0002)
#define EUSCI_A0_UART_IRCTL_UCIRTXPL__M (0x00fc)
#define EUSCI_A0_UART_IV (HWREG16(0x4000101E))
#define EUSCI_A0_UART_MCTLW (HWREG16(0x40001008))
#define EUSCI_A0_UART_MCTLW_UCBRF__M (0x00f0)
#define EUSCI_A0_UART_MCTLW_UCBRS__M (0xff00)
#define EUSCI_A0_UART_MCTLW_UCOS16 (0x0001)
#define EUSCI_A0_UART_MCTLW_UCOS16__0 (0x0000)
#define EUSCI_A0_UART_MCTLW_UCOS16__0_DISABLED (0x0000)
#define EUSCI_A0_UART_MCTLW_UCOS16__1 (0x0001)
#define EUSCI_A0_UART_MCTLW_UCOS16__1_ENABLED (0x0001)
#define EUSCI_A0_UART_RXBUF (HWREG16(0x4000100C))
#define EUSCI_A0_UART_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_A0_UART_STATW (HWREG16(0x4000100A))
#define EUSCI_A0_UART_STATW_UCADDR_UCIDLE (0x0002)
#define EUSCI_A0_UART_STATW_UCADDR_UCIDLE__0 (0x0000)
#define EUSCI_A0_UART_STATW_UCADDR_UCIDLE__1 (0x0002)
#define EUSCI_A0_UART_STATW_UCBRK (0x0008)
#define EUSCI_A0_UART_STATW_UCBRK__0 (0x0000)
#define EUSCI_A0_UART_STATW_UCBRK__1 (0x0008)
#define EUSCI_A0_UART_STATW_UCBUSY (0x0001)
#define EUSCI_A0_UART_STATW_UCBUSY__0 (0x0000)
#define EUSCI_A0_UART_STATW_UCBUSY__1 (0x0001)
#define EUSCI_A0_UART_STATW_UCFE (0x0040)
#define EUSCI_A0_UART_STATW_UCFE__0 (0x0000)
#define EUSCI_A0_UART_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_A0_UART_STATW_UCFE__1 (0x0040)
#define EUSCI_A0_UART_STATW_UCLISTEN (0x0080)
#define EUSCI_A0_UART_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_A0_UART_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_A0_UART_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_A0_UART_STATW_UCOE (0x0020)
#define EUSCI_A0_UART_STATW_UCOE__0 (0x0000)
#define EUSCI_A0_UART_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_A0_UART_STATW_UCOE__1 (0x0020)
#define EUSCI_A0_UART_STATW_UCPE (0x0010)
#define EUSCI_A0_UART_STATW_UCPE__0 (0x0000)
#define EUSCI_A0_UART_STATW_UCPE__0_NO_ERROR (0x0000)
#define EUSCI_A0_UART_STATW_UCPE__1 (0x0010)
#define EUSCI_A0_UART_STATW_UCRXERR (0x0004)
#define EUSCI_A0_UART_STATW_UCRXERR__0 (0x0000)
#define EUSCI_A0_UART_STATW_UCRXERR__1 (0x0004)
#define EUSCI_A0_UART_TXBUF (HWREG16(0x4000100E))
#define EUSCI_A0_UART_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_A1_SPI_BRW (HWREG16(0x40001406))
#define EUSCI_A1_SPI_CTLW0 (HWREG16(0x40001400))
#define EUSCI_A1_SPI_CTLW0_UC7BIT (0x1000)
#define EUSCI_A1_SPI_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_A1_SPI_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_A1_SPI_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_A1_SPI_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_A1_SPI_CTLW0_UCCKPH (0x8000)
#define EUSCI_A1_SPI_CTLW0_UCCKPH__0 (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCCKPH__1 (0x8000)
#define EUSCI_A1_SPI_CTLW0_UCCKPL (0x4000)
#define EUSCI_A1_SPI_CTLW0_UCCKPL__0 (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCCKPL__1 (0x4000)
#define EUSCI_A1_SPI_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_A1_SPI_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_A1_SPI_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_A1_SPI_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_A1_SPI_CTLW0_UCMODE__M (0x0600)
#define EUSCI_A1_SPI_CTLW0_UCMSB (0x2000)
#define EUSCI_A1_SPI_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_A1_SPI_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_A1_SPI_CTLW0_UCMST (0x0800)
#define EUSCI_A1_SPI_CTLW0_UCMST__0 (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCMST__1 (0x0800)
#define EUSCI_A1_SPI_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_A1_SPI_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_A1_SPI_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_A1_SPI_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_A1_SPI_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_A1_SPI_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_A1_SPI_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_A1_SPI_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_A1_SPI_CTLW0_UCSTEM (0x0002)
#define EUSCI_A1_SPI_CTLW0_UCSTEM__0 (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCSTEM__1 (0x0002)
#define EUSCI_A1_SPI_CTLW0_UCSWRST (0x0001)
#define EUSCI_A1_SPI_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_A1_SPI_CTLW0_UCSYNC (0x0100)
#define EUSCI_A1_SPI_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_A1_SPI_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_A1_SPI_IE (HWREG16(0x4000141A))
#define EUSCI_A1_SPI_IE_UCRXIE (0x0001)
#define EUSCI_A1_SPI_IE_UCRXIE__0 (0x0000)
#define EUSCI_A1_SPI_IE_UCRXIE__1 (0x0001)
#define EUSCI_A1_SPI_IE_UCTXIE (0x0002)
#define EUSCI_A1_SPI_IE_UCTXIE__0 (0x0000)
#define EUSCI_A1_SPI_IE_UCTXIE__1 (0x0002)
#define EUSCI_A1_SPI_IFG (HWREG16(0x4000141C))
#define EUSCI_A1_SPI_IFG_UCRXIFG (0x0001)
#define EUSCI_A1_SPI_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_A1_SPI_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_A1_SPI_IFG_UCTXIFG (0x0002)
#define EUSCI_A1_SPI_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_A1_SPI_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_A1_SPI_IV (HWREG16(0x4000141E))
#define EUSCI_A1_SPI_RXBUF (HWREG16(0x4000140C))
#define EUSCI_A1_SPI_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_A1_SPI_STATW (HWREG16(0x4000140A))
#define EUSCI_A1_SPI_STATW_UCBUSY (0x0001)
#define EUSCI_A1_SPI_STATW_UCBUSY__0 (0x0000)
#define EUSCI_A1_SPI_STATW_UCBUSY__0_EUSCI_INACTIVE (0x0000)
#define EUSCI_A1_SPI_STATW_UCBUSY__1 (0x0001)
#define EUSCI_A1_SPI_STATW_UCFE (0x0040)
#define EUSCI_A1_SPI_STATW_UCFE__0 (0x0000)
#define EUSCI_A1_SPI_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_A1_SPI_STATW_UCFE__1 (0x0040)
#define EUSCI_A1_SPI_STATW_UCLISTEN (0x0080)
#define EUSCI_A1_SPI_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_A1_SPI_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_A1_SPI_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_A1_SPI_STATW_UCOE (0x0020)
#define EUSCI_A1_SPI_STATW_UCOE__0 (0x0000)
#define EUSCI_A1_SPI_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_A1_SPI_STATW_UCOE__1 (0x0020)
#define EUSCI_A1_SPI_TXBUF (HWREG16(0x4000140E))
#define EUSCI_A1_SPI_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_A1_UART_ABCTL (HWREG16(0x40001410))
#define EUSCI_A1_UART_ABCTL_UCABDEN (0x0001)
#define EUSCI_A1_UART_ABCTL_UCABDEN__0 (0x0000)
#define EUSCI_A1_UART_ABCTL_UCABDEN__1 (0x0001)
#define EUSCI_A1_UART_ABCTL_UCBTOE (0x0004)
#define EUSCI_A1_UART_ABCTL_UCBTOE__0 (0x0000)
#define EUSCI_A1_UART_ABCTL_UCBTOE__0_NO_ERROR (0x0000)
#define EUSCI_A1_UART_ABCTL_UCBTOE__1 (0x0004)
#define EUSCI_A1_UART_ABCTL_UCDELIM__0 (0x0000)
#define EUSCI_A1_UART_ABCTL_UCDELIM__0_1_BIT_TIME (0x0000)
#define EUSCI_A1_UART_ABCTL_UCDELIM__1 (0x0010)
#define EUSCI_A1_UART_ABCTL_UCDELIM__1_2_BIT_TIMES (0x0010)
#define EUSCI_A1_UART_ABCTL_UCDELIM__2 (0x0020)
#define EUSCI_A1_UART_ABCTL_UCDELIM__2_3_BIT_TIMES (0x0020)
#define EUSCI_A1_UART_ABCTL_UCDELIM__3 (0x0030)
#define EUSCI_A1_UART_ABCTL_UCDELIM__3_4_BIT_TIMES (0x0030)
#define EUSCI_A1_UART_ABCTL_UCDELIM__M (0x0030)
#define EUSCI_A1_UART_ABCTL_UCSTOE (0x0008)
#define EUSCI_A1_UART_ABCTL_UCSTOE__0 (0x0000)
#define EUSCI_A1_UART_ABCTL_UCSTOE__0_NO_ERROR (0x0000)
#define EUSCI_A1_UART_ABCTL_UCSTOE__1 (0x0008)
#define EUSCI_A1_UART_BRW (HWREG16(0x40001406))
#define EUSCI_A1_UART_CTLW0 (HWREG16(0x40001400))
#define EUSCI_A1_UART_CTLW0_UC7BIT (0x1000)
#define EUSCI_A1_UART_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_A1_UART_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_A1_UART_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_A1_UART_CTLW0_UCBRKIE (0x0010)
#define EUSCI_A1_UART_CTLW0_UCBRKIE__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCBRKIE__1 (0x0010)
#define EUSCI_A1_UART_CTLW0_UCDORM (0x0008)
#define EUSCI_A1_UART_CTLW0_UCDORM__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCDORM__1 (0x0008)
#define EUSCI_A1_UART_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCMODE__0_UART_MODE (0x0000)
#define EUSCI_A1_UART_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_A1_UART_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_A1_UART_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_A1_UART_CTLW0_UCMODE__M (0x0600)
#define EUSCI_A1_UART_CTLW0_UCMSB (0x2000)
#define EUSCI_A1_UART_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_A1_UART_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_A1_UART_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_A1_UART_CTLW0_UCPAR (0x4000)
#define EUSCI_A1_UART_CTLW0_UCPAR__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCPAR__0_ODD_PARITY (0x0000)
#define EUSCI_A1_UART_CTLW0_UCPAR__1 (0x4000)
#define EUSCI_A1_UART_CTLW0_UCPAR__1_EVEN_PARITY (0x4000)
#define EUSCI_A1_UART_CTLW0_UCPEN (0x8000)
#define EUSCI_A1_UART_CTLW0_UCPEN__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCPEN__0_PARITY_DISABLED (0x0000)
#define EUSCI_A1_UART_CTLW0_UCPEN__1 (0x8000)
#define EUSCI_A1_UART_CTLW0_UCRXEIE (0x0020)
#define EUSCI_A1_UART_CTLW0_UCRXEIE__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCRXEIE__1 (0x0020)
#define EUSCI_A1_UART_CTLW0_UCSPB (0x0800)
#define EUSCI_A1_UART_CTLW0_UCSPB__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCSPB__0_ONE_STOP_BIT (0x0000)
#define EUSCI_A1_UART_CTLW0_UCSPB__1 (0x0800)
#define EUSCI_A1_UART_CTLW0_UCSPB__1_TWO_STOP_BITS (0x0800)
#define EUSCI_A1_UART_CTLW0_UCSSEL__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCSSEL__0_UCLK (0x0000)
#define EUSCI_A1_UART_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_A1_UART_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_A1_UART_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_A1_UART_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_A1_UART_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_A1_UART_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_A1_UART_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_A1_UART_CTLW0_UCSWRST (0x0001)
#define EUSCI_A1_UART_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_A1_UART_CTLW0_UCSYNC (0x0100)
#define EUSCI_A1_UART_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_A1_UART_CTLW0_UCTXADDR (0x0004)
#define EUSCI_A1_UART_CTLW0_UCTXADDR__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCTXADDR__1 (0x0004)
#define EUSCI_A1_UART_CTLW0_UCTXBRK (0x0002)
#define EUSCI_A1_UART_CTLW0_UCTXBRK__0 (0x0000)
#define EUSCI_A1_UART_CTLW0_UCTXBRK__1 (0x0002)
#define EUSCI_A1_UART_CTLW1 (HWREG16(0x40001402))
#define EUSCI_A1_UART_CTLW1_UCGLIT__0 (0x0000)
#define EUSCI_A1_UART_CTLW1_UCGLIT__0__2_NS (0x0000)
#define EUSCI_A1_UART_CTLW1_UCGLIT__1 (0x0001)
#define EUSCI_A1_UART_CTLW1_UCGLIT__1__50_NS (0x0001)
#define EUSCI_A1_UART_CTLW1_UCGLIT__2 (0x0002)
#define EUSCI_A1_UART_CTLW1_UCGLIT__2__100_NS (0x0002)
#define EUSCI_A1_UART_CTLW1_UCGLIT__3 (0x0003)
#define EUSCI_A1_UART_CTLW1_UCGLIT__3__200_NS (0x0003)
#define EUSCI_A1_UART_CTLW1_UCGLIT__M (0x0003)
#define EUSCI_A1_UART_IE (HWREG16(0x4000141A))
#define EUSCI_A1_UART_IE_UCRXIE (0x0001)
#define EUSCI_A1_UART_IE_UCRXIE__0 (0x0000)
#define EUSCI_A1_UART_IE_UCRXIE__1 (0x0001)
#define EUSCI_A1_UART_IE_UCSTTIE (0x0004)
#define EUSCI_A1_UART_IE_UCSTTIE__0 (0x0000)
#define EUSCI_A1_UART_IE_UCSTTIE__1 (0x0004)
#define EUSCI_A1_UART_IE_UCTXCPTIE (0x0008)
#define EUSCI_A1_UART_IE_UCTXCPTIE__0 (0x0000)
#define EUSCI_A1_UART_IE_UCTXCPTIE__1 (0x0008)
#define EUSCI_A1_UART_IE_UCTXIE (0x0002)
#define EUSCI_A1_UART_IE_UCTXIE__0 (0x0000)
#define EUSCI_A1_UART_IE_UCTXIE__1 (0x0002)
#define EUSCI_A1_UART_IFG (HWREG16(0x4000141C))
#define EUSCI_A1_UART_IFG_UCRXIFG (0x0001)
#define EUSCI_A1_UART_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_A1_UART_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_A1_UART_IFG_UCSTTIFG (0x0004)
#define EUSCI_A1_UART_IFG_UCSTTIFG__0 (0x0000)
#define EUSCI_A1_UART_IFG_UCSTTIFG__1 (0x0004)
#define EUSCI_A1_UART_IFG_UCTXCPTIFG (0x0008)
#define EUSCI_A1_UART_IFG_UCTXCPTIFG__0 (0x0000)
#define EUSCI_A1_UART_IFG_UCTXCPTIFG__1 (0x0008)
#define EUSCI_A1_UART_IFG_UCTXIFG (0x0002)
#define EUSCI_A1_UART_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_A1_UART_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_A1_UART_IRCTL (HWREG16(0x40001412))
#define EUSCI_A1_UART_IRCTL_UCIREN (0x0001)
#define EUSCI_A1_UART_IRCTL_UCIREN__0 (0x0000)
#define EUSCI_A1_UART_IRCTL_UCIREN__1 (0x0001)
#define EUSCI_A1_UART_IRCTL_UCIRRXFE (0x0100)
#define EUSCI_A1_UART_IRCTL_UCIRRXFE__0 (0x0000)
#define EUSCI_A1_UART_IRCTL_UCIRRXFE__1 (0x0100)
#define EUSCI_A1_UART_IRCTL_UCIRRXFL__M (0xfc00)
#define EUSCI_A1_UART_IRCTL_UCIRRXPL (0x0200)
#define EUSCI_A1_UART_IRCTL_UCIRRXPL__0 (0x0000)
#define EUSCI_A1_UART_IRCTL_UCIRRXPL__1 (0x0200)
#define EUSCI_A1_UART_IRCTL_UCIRTXCLK (0x0002)
#define EUSCI_A1_UART_IRCTL_UCIRTXCLK__0 (0x0000)
#define EUSCI_A1_UART_IRCTL_UCIRTXCLK__0_BRCLK (0x0000)
#define EUSCI_A1_UART_IRCTL_UCIRTXCLK__1 (0x0002)
#define EUSCI_A1_UART_IRCTL_UCIRTXPL__M (0x00fc)
#define EUSCI_A1_UART_IV (HWREG16(0x4000141E))
#define EUSCI_A1_UART_MCTLW (HWREG16(0x40001408))
#define EUSCI_A1_UART_MCTLW_UCBRF__M (0x00f0)
#define EUSCI_A1_UART_MCTLW_UCBRS__M (0xff00)
#define EUSCI_A1_UART_MCTLW_UCOS16 (0x0001)
#define EUSCI_A1_UART_MCTLW_UCOS16__0 (0x0000)
#define EUSCI_A1_UART_MCTLW_UCOS16__0_DISABLED (0x0000)
#define EUSCI_A1_UART_MCTLW_UCOS16__1 (0x0001)
#define EUSCI_A1_UART_MCTLW_UCOS16__1_ENABLED (0x0001)
#define EUSCI_A1_UART_RXBUF (HWREG16(0x4000140C))
#define EUSCI_A1_UART_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_A1_UART_STATW (HWREG16(0x4000140A))
#define EUSCI_A1_UART_STATW_UCADDR_UCIDLE (0x0002)
#define EUSCI_A1_UART_STATW_UCADDR_UCIDLE__0 (0x0000)
#define EUSCI_A1_UART_STATW_UCADDR_UCIDLE__1 (0x0002)
#define EUSCI_A1_UART_STATW_UCBRK (0x0008)
#define EUSCI_A1_UART_STATW_UCBRK__0 (0x0000)
#define EUSCI_A1_UART_STATW_UCBRK__1 (0x0008)
#define EUSCI_A1_UART_STATW_UCBUSY (0x0001)
#define EUSCI_A1_UART_STATW_UCBUSY__0 (0x0000)
#define EUSCI_A1_UART_STATW_UCBUSY__1 (0x0001)
#define EUSCI_A1_UART_STATW_UCFE (0x0040)
#define EUSCI_A1_UART_STATW_UCFE__0 (0x0000)
#define EUSCI_A1_UART_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_A1_UART_STATW_UCFE__1 (0x0040)
#define EUSCI_A1_UART_STATW_UCLISTEN (0x0080)
#define EUSCI_A1_UART_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_A1_UART_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_A1_UART_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_A1_UART_STATW_UCOE (0x0020)
#define EUSCI_A1_UART_STATW_UCOE__0 (0x0000)
#define EUSCI_A1_UART_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_A1_UART_STATW_UCOE__1 (0x0020)
#define EUSCI_A1_UART_STATW_UCPE (0x0010)
#define EUSCI_A1_UART_STATW_UCPE__0 (0x0000)
#define EUSCI_A1_UART_STATW_UCPE__0_NO_ERROR (0x0000)
#define EUSCI_A1_UART_STATW_UCPE__1 (0x0010)
#define EUSCI_A1_UART_STATW_UCRXERR (0x0004)
#define EUSCI_A1_UART_STATW_UCRXERR__0 (0x0000)
#define EUSCI_A1_UART_STATW_UCRXERR__1 (0x0004)
#define EUSCI_A1_UART_TXBUF (HWREG16(0x4000140E))
#define EUSCI_A1_UART_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_A2_SPI_BRW (HWREG16(0x40001806))
#define EUSCI_A2_SPI_CTLW0 (HWREG16(0x40001800))
#define EUSCI_A2_SPI_CTLW0_UC7BIT (0x1000)
#define EUSCI_A2_SPI_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_A2_SPI_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_A2_SPI_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_A2_SPI_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_A2_SPI_CTLW0_UCCKPH (0x8000)
#define EUSCI_A2_SPI_CTLW0_UCCKPH__0 (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCCKPH__1 (0x8000)
#define EUSCI_A2_SPI_CTLW0_UCCKPL (0x4000)
#define EUSCI_A2_SPI_CTLW0_UCCKPL__0 (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCCKPL__1 (0x4000)
#define EUSCI_A2_SPI_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_A2_SPI_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_A2_SPI_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_A2_SPI_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_A2_SPI_CTLW0_UCMODE__M (0x0600)
#define EUSCI_A2_SPI_CTLW0_UCMSB (0x2000)
#define EUSCI_A2_SPI_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_A2_SPI_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_A2_SPI_CTLW0_UCMST (0x0800)
#define EUSCI_A2_SPI_CTLW0_UCMST__0 (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCMST__1 (0x0800)
#define EUSCI_A2_SPI_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_A2_SPI_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_A2_SPI_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_A2_SPI_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_A2_SPI_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_A2_SPI_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_A2_SPI_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_A2_SPI_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_A2_SPI_CTLW0_UCSTEM (0x0002)
#define EUSCI_A2_SPI_CTLW0_UCSTEM__0 (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCSTEM__1 (0x0002)
#define EUSCI_A2_SPI_CTLW0_UCSWRST (0x0001)
#define EUSCI_A2_SPI_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_A2_SPI_CTLW0_UCSYNC (0x0100)
#define EUSCI_A2_SPI_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_A2_SPI_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_A2_SPI_IE (HWREG16(0x4000181A))
#define EUSCI_A2_SPI_IE_UCRXIE (0x0001)
#define EUSCI_A2_SPI_IE_UCRXIE__0 (0x0000)
#define EUSCI_A2_SPI_IE_UCRXIE__1 (0x0001)
#define EUSCI_A2_SPI_IE_UCTXIE (0x0002)
#define EUSCI_A2_SPI_IE_UCTXIE__0 (0x0000)
#define EUSCI_A2_SPI_IE_UCTXIE__1 (0x0002)
#define EUSCI_A2_SPI_IFG (HWREG16(0x4000181C))
#define EUSCI_A2_SPI_IFG_UCRXIFG (0x0001)
#define EUSCI_A2_SPI_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_A2_SPI_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_A2_SPI_IFG_UCTXIFG (0x0002)
#define EUSCI_A2_SPI_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_A2_SPI_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_A2_SPI_IV (HWREG16(0x4000181E))
#define EUSCI_A2_SPI_RXBUF (HWREG16(0x4000180C))
#define EUSCI_A2_SPI_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_A2_SPI_STATW (HWREG16(0x4000180A))
#define EUSCI_A2_SPI_STATW_UCBUSY (0x0001)
#define EUSCI_A2_SPI_STATW_UCBUSY__0 (0x0000)
#define EUSCI_A2_SPI_STATW_UCBUSY__0_EUSCI_INACTIVE (0x0000)
#define EUSCI_A2_SPI_STATW_UCBUSY__1 (0x0001)
#define EUSCI_A2_SPI_STATW_UCFE (0x0040)
#define EUSCI_A2_SPI_STATW_UCFE__0 (0x0000)
#define EUSCI_A2_SPI_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_A2_SPI_STATW_UCFE__1 (0x0040)
#define EUSCI_A2_SPI_STATW_UCLISTEN (0x0080)
#define EUSCI_A2_SPI_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_A2_SPI_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_A2_SPI_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_A2_SPI_STATW_UCOE (0x0020)
#define EUSCI_A2_SPI_STATW_UCOE__0 (0x0000)
#define EUSCI_A2_SPI_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_A2_SPI_STATW_UCOE__1 (0x0020)
#define EUSCI_A2_SPI_TXBUF (HWREG16(0x4000180E))
#define EUSCI_A2_SPI_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_A2_UART_ABCTL (HWREG16(0x40001810))
#define EUSCI_A2_UART_ABCTL_UCABDEN (0x0001)
#define EUSCI_A2_UART_ABCTL_UCABDEN__0 (0x0000)
#define EUSCI_A2_UART_ABCTL_UCABDEN__1 (0x0001)
#define EUSCI_A2_UART_ABCTL_UCBTOE (0x0004)
#define EUSCI_A2_UART_ABCTL_UCBTOE__0 (0x0000)
#define EUSCI_A2_UART_ABCTL_UCBTOE__0_NO_ERROR (0x0000)
#define EUSCI_A2_UART_ABCTL_UCBTOE__1 (0x0004)
#define EUSCI_A2_UART_ABCTL_UCDELIM__0 (0x0000)
#define EUSCI_A2_UART_ABCTL_UCDELIM__0_1_BIT_TIME (0x0000)
#define EUSCI_A2_UART_ABCTL_UCDELIM__1 (0x0010)
#define EUSCI_A2_UART_ABCTL_UCDELIM__1_2_BIT_TIMES (0x0010)
#define EUSCI_A2_UART_ABCTL_UCDELIM__2 (0x0020)
#define EUSCI_A2_UART_ABCTL_UCDELIM__2_3_BIT_TIMES (0x0020)
#define EUSCI_A2_UART_ABCTL_UCDELIM__3 (0x0030)
#define EUSCI_A2_UART_ABCTL_UCDELIM__3_4_BIT_TIMES (0x0030)
#define EUSCI_A2_UART_ABCTL_UCDELIM__M (0x0030)
#define EUSCI_A2_UART_ABCTL_UCSTOE (0x0008)
#define EUSCI_A2_UART_ABCTL_UCSTOE__0 (0x0000)
#define EUSCI_A2_UART_ABCTL_UCSTOE__0_NO_ERROR (0x0000)
#define EUSCI_A2_UART_ABCTL_UCSTOE__1 (0x0008)
#define EUSCI_A2_UART_BRW (HWREG16(0x40001806))
#define EUSCI_A2_UART_CTLW0 (HWREG16(0x40001800))
#define EUSCI_A2_UART_CTLW0_UC7BIT (0x1000)
#define EUSCI_A2_UART_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_A2_UART_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_A2_UART_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_A2_UART_CTLW0_UCBRKIE (0x0010)
#define EUSCI_A2_UART_CTLW0_UCBRKIE__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCBRKIE__1 (0x0010)
#define EUSCI_A2_UART_CTLW0_UCDORM (0x0008)
#define EUSCI_A2_UART_CTLW0_UCDORM__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCDORM__1 (0x0008)
#define EUSCI_A2_UART_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCMODE__0_UART_MODE (0x0000)
#define EUSCI_A2_UART_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_A2_UART_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_A2_UART_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_A2_UART_CTLW0_UCMODE__M (0x0600)
#define EUSCI_A2_UART_CTLW0_UCMSB (0x2000)
#define EUSCI_A2_UART_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_A2_UART_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_A2_UART_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_A2_UART_CTLW0_UCPAR (0x4000)
#define EUSCI_A2_UART_CTLW0_UCPAR__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCPAR__0_ODD_PARITY (0x0000)
#define EUSCI_A2_UART_CTLW0_UCPAR__1 (0x4000)
#define EUSCI_A2_UART_CTLW0_UCPAR__1_EVEN_PARITY (0x4000)
#define EUSCI_A2_UART_CTLW0_UCPEN (0x8000)
#define EUSCI_A2_UART_CTLW0_UCPEN__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCPEN__0_PARITY_DISABLED (0x0000)
#define EUSCI_A2_UART_CTLW0_UCPEN__1 (0x8000)
#define EUSCI_A2_UART_CTLW0_UCRXEIE (0x0020)
#define EUSCI_A2_UART_CTLW0_UCRXEIE__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCRXEIE__1 (0x0020)
#define EUSCI_A2_UART_CTLW0_UCSPB (0x0800)
#define EUSCI_A2_UART_CTLW0_UCSPB__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCSPB__0_ONE_STOP_BIT (0x0000)
#define EUSCI_A2_UART_CTLW0_UCSPB__1 (0x0800)
#define EUSCI_A2_UART_CTLW0_UCSPB__1_TWO_STOP_BITS (0x0800)
#define EUSCI_A2_UART_CTLW0_UCSSEL__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCSSEL__0_UCLK (0x0000)
#define EUSCI_A2_UART_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_A2_UART_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_A2_UART_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_A2_UART_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_A2_UART_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_A2_UART_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_A2_UART_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_A2_UART_CTLW0_UCSWRST (0x0001)
#define EUSCI_A2_UART_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_A2_UART_CTLW0_UCSYNC (0x0100)
#define EUSCI_A2_UART_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_A2_UART_CTLW0_UCTXADDR (0x0004)
#define EUSCI_A2_UART_CTLW0_UCTXADDR__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCTXADDR__1 (0x0004)
#define EUSCI_A2_UART_CTLW0_UCTXBRK (0x0002)
#define EUSCI_A2_UART_CTLW0_UCTXBRK__0 (0x0000)
#define EUSCI_A2_UART_CTLW0_UCTXBRK__1 (0x0002)
#define EUSCI_A2_UART_CTLW1 (HWREG16(0x40001802))
#define EUSCI_A2_UART_CTLW1_UCGLIT__0 (0x0000)
#define EUSCI_A2_UART_CTLW1_UCGLIT__0__2_NS (0x0000)
#define EUSCI_A2_UART_CTLW1_UCGLIT__1 (0x0001)
#define EUSCI_A2_UART_CTLW1_UCGLIT__1__50_NS (0x0001)
#define EUSCI_A2_UART_CTLW1_UCGLIT__2 (0x0002)
#define EUSCI_A2_UART_CTLW1_UCGLIT__2__100_NS (0x0002)
#define EUSCI_A2_UART_CTLW1_UCGLIT__3 (0x0003)
#define EUSCI_A2_UART_CTLW1_UCGLIT__3__200_NS (0x0003)
#define EUSCI_A2_UART_CTLW1_UCGLIT__M (0x0003)
#define EUSCI_A2_UART_IE (HWREG16(0x4000181A))
#define EUSCI_A2_UART_IE_UCRXIE (0x0001)
#define EUSCI_A2_UART_IE_UCRXIE__0 (0x0000)
#define EUSCI_A2_UART_IE_UCRXIE__1 (0x0001)
#define EUSCI_A2_UART_IE_UCSTTIE (0x0004)
#define EUSCI_A2_UART_IE_UCSTTIE__0 (0x0000)
#define EUSCI_A2_UART_IE_UCSTTIE__1 (0x0004)
#define EUSCI_A2_UART_IE_UCTXCPTIE (0x0008)
#define EUSCI_A2_UART_IE_UCTXCPTIE__0 (0x0000)
#define EUSCI_A2_UART_IE_UCTXCPTIE__1 (0x0008)
#define EUSCI_A2_UART_IE_UCTXIE (0x0002)
#define EUSCI_A2_UART_IE_UCTXIE__0 (0x0000)
#define EUSCI_A2_UART_IE_UCTXIE__1 (0x0002)
#define EUSCI_A2_UART_IFG (HWREG16(0x4000181C))
#define EUSCI_A2_UART_IFG_UCRXIFG (0x0001)
#define EUSCI_A2_UART_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_A2_UART_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_A2_UART_IFG_UCSTTIFG (0x0004)
#define EUSCI_A2_UART_IFG_UCSTTIFG__0 (0x0000)
#define EUSCI_A2_UART_IFG_UCSTTIFG__1 (0x0004)
#define EUSCI_A2_UART_IFG_UCTXCPTIFG (0x0008)
#define EUSCI_A2_UART_IFG_UCTXCPTIFG__0 (0x0000)
#define EUSCI_A2_UART_IFG_UCTXCPTIFG__1 (0x0008)
#define EUSCI_A2_UART_IFG_UCTXIFG (0x0002)
#define EUSCI_A2_UART_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_A2_UART_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_A2_UART_IRCTL (HWREG16(0x40001812))
#define EUSCI_A2_UART_IRCTL_UCIREN (0x0001)
#define EUSCI_A2_UART_IRCTL_UCIREN__0 (0x0000)
#define EUSCI_A2_UART_IRCTL_UCIREN__1 (0x0001)
#define EUSCI_A2_UART_IRCTL_UCIRRXFE (0x0100)
#define EUSCI_A2_UART_IRCTL_UCIRRXFE__0 (0x0000)
#define EUSCI_A2_UART_IRCTL_UCIRRXFE__1 (0x0100)
#define EUSCI_A2_UART_IRCTL_UCIRRXFL__M (0xfc00)
#define EUSCI_A2_UART_IRCTL_UCIRRXPL (0x0200)
#define EUSCI_A2_UART_IRCTL_UCIRRXPL__0 (0x0000)
#define EUSCI_A2_UART_IRCTL_UCIRRXPL__1 (0x0200)
#define EUSCI_A2_UART_IRCTL_UCIRTXCLK (0x0002)
#define EUSCI_A2_UART_IRCTL_UCIRTXCLK__0 (0x0000)
#define EUSCI_A2_UART_IRCTL_UCIRTXCLK__0_BRCLK (0x0000)
#define EUSCI_A2_UART_IRCTL_UCIRTXCLK__1 (0x0002)
#define EUSCI_A2_UART_IRCTL_UCIRTXPL__M (0x00fc)
#define EUSCI_A2_UART_IV (HWREG16(0x4000181E))
#define EUSCI_A2_UART_MCTLW (HWREG16(0x40001808))
#define EUSCI_A2_UART_MCTLW_UCBRF__M (0x00f0)
#define EUSCI_A2_UART_MCTLW_UCBRS__M (0xff00)
#define EUSCI_A2_UART_MCTLW_UCOS16 (0x0001)
#define EUSCI_A2_UART_MCTLW_UCOS16__0 (0x0000)
#define EUSCI_A2_UART_MCTLW_UCOS16__0_DISABLED (0x0000)
#define EUSCI_A2_UART_MCTLW_UCOS16__1 (0x0001)
#define EUSCI_A2_UART_MCTLW_UCOS16__1_ENABLED (0x0001)
#define EUSCI_A2_UART_RXBUF (HWREG16(0x4000180C))
#define EUSCI_A2_UART_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_A2_UART_STATW (HWREG16(0x4000180A))
#define EUSCI_A2_UART_STATW_UCADDR_UCIDLE (0x0002)
#define EUSCI_A2_UART_STATW_UCADDR_UCIDLE__0 (0x0000)
#define EUSCI_A2_UART_STATW_UCADDR_UCIDLE__1 (0x0002)
#define EUSCI_A2_UART_STATW_UCBRK (0x0008)
#define EUSCI_A2_UART_STATW_UCBRK__0 (0x0000)
#define EUSCI_A2_UART_STATW_UCBRK__1 (0x0008)
#define EUSCI_A2_UART_STATW_UCBUSY (0x0001)
#define EUSCI_A2_UART_STATW_UCBUSY__0 (0x0000)
#define EUSCI_A2_UART_STATW_UCBUSY__1 (0x0001)
#define EUSCI_A2_UART_STATW_UCFE (0x0040)
#define EUSCI_A2_UART_STATW_UCFE__0 (0x0000)
#define EUSCI_A2_UART_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_A2_UART_STATW_UCFE__1 (0x0040)
#define EUSCI_A2_UART_STATW_UCLISTEN (0x0080)
#define EUSCI_A2_UART_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_A2_UART_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_A2_UART_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_A2_UART_STATW_UCOE (0x0020)
#define EUSCI_A2_UART_STATW_UCOE__0 (0x0000)
#define EUSCI_A2_UART_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_A2_UART_STATW_UCOE__1 (0x0020)
#define EUSCI_A2_UART_STATW_UCPE (0x0010)
#define EUSCI_A2_UART_STATW_UCPE__0 (0x0000)
#define EUSCI_A2_UART_STATW_UCPE__0_NO_ERROR (0x0000)
#define EUSCI_A2_UART_STATW_UCPE__1 (0x0010)
#define EUSCI_A2_UART_STATW_UCRXERR (0x0004)
#define EUSCI_A2_UART_STATW_UCRXERR__0 (0x0000)
#define EUSCI_A2_UART_STATW_UCRXERR__1 (0x0004)
#define EUSCI_A2_UART_TXBUF (HWREG16(0x4000180E))
#define EUSCI_A2_UART_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_A3_SPI_BRW (HWREG16(0x40001C06))
#define EUSCI_A3_SPI_CTLW0 (HWREG16(0x40001C00))
#define EUSCI_A3_SPI_CTLW0_UC7BIT (0x1000)
#define EUSCI_A3_SPI_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_A3_SPI_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_A3_SPI_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_A3_SPI_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_A3_SPI_CTLW0_UCCKPH (0x8000)
#define EUSCI_A3_SPI_CTLW0_UCCKPH__0 (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCCKPH__1 (0x8000)
#define EUSCI_A3_SPI_CTLW0_UCCKPL (0x4000)
#define EUSCI_A3_SPI_CTLW0_UCCKPL__0 (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCCKPL__1 (0x4000)
#define EUSCI_A3_SPI_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_A3_SPI_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_A3_SPI_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_A3_SPI_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_A3_SPI_CTLW0_UCMODE__M (0x0600)
#define EUSCI_A3_SPI_CTLW0_UCMSB (0x2000)
#define EUSCI_A3_SPI_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_A3_SPI_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_A3_SPI_CTLW0_UCMST (0x0800)
#define EUSCI_A3_SPI_CTLW0_UCMST__0 (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCMST__1 (0x0800)
#define EUSCI_A3_SPI_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_A3_SPI_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_A3_SPI_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_A3_SPI_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_A3_SPI_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_A3_SPI_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_A3_SPI_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_A3_SPI_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_A3_SPI_CTLW0_UCSTEM (0x0002)
#define EUSCI_A3_SPI_CTLW0_UCSTEM__0 (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCSTEM__1 (0x0002)
#define EUSCI_A3_SPI_CTLW0_UCSWRST (0x0001)
#define EUSCI_A3_SPI_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_A3_SPI_CTLW0_UCSYNC (0x0100)
#define EUSCI_A3_SPI_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_A3_SPI_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_A3_SPI_IE (HWREG16(0x40001C1A))
#define EUSCI_A3_SPI_IE_UCRXIE (0x0001)
#define EUSCI_A3_SPI_IE_UCRXIE__0 (0x0000)
#define EUSCI_A3_SPI_IE_UCRXIE__1 (0x0001)
#define EUSCI_A3_SPI_IE_UCTXIE (0x0002)
#define EUSCI_A3_SPI_IE_UCTXIE__0 (0x0000)
#define EUSCI_A3_SPI_IE_UCTXIE__1 (0x0002)
#define EUSCI_A3_SPI_IFG (HWREG16(0x40001C1C))
#define EUSCI_A3_SPI_IFG_UCRXIFG (0x0001)
#define EUSCI_A3_SPI_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_A3_SPI_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_A3_SPI_IFG_UCTXIFG (0x0002)
#define EUSCI_A3_SPI_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_A3_SPI_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_A3_SPI_IV (HWREG16(0x40001C1E))
#define EUSCI_A3_SPI_RXBUF (HWREG16(0x40001C0C))
#define EUSCI_A3_SPI_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_A3_SPI_STATW (HWREG16(0x40001C0A))
#define EUSCI_A3_SPI_STATW_UCBUSY (0x0001)
#define EUSCI_A3_SPI_STATW_UCBUSY__0 (0x0000)
#define EUSCI_A3_SPI_STATW_UCBUSY__0_EUSCI_INACTIVE (0x0000)
#define EUSCI_A3_SPI_STATW_UCBUSY__1 (0x0001)
#define EUSCI_A3_SPI_STATW_UCFE (0x0040)
#define EUSCI_A3_SPI_STATW_UCFE__0 (0x0000)
#define EUSCI_A3_SPI_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_A3_SPI_STATW_UCFE__1 (0x0040)
#define EUSCI_A3_SPI_STATW_UCLISTEN (0x0080)
#define EUSCI_A3_SPI_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_A3_SPI_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_A3_SPI_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_A3_SPI_STATW_UCOE (0x0020)
#define EUSCI_A3_SPI_STATW_UCOE__0 (0x0000)
#define EUSCI_A3_SPI_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_A3_SPI_STATW_UCOE__1 (0x0020)
#define EUSCI_A3_SPI_TXBUF (HWREG16(0x40001C0E))
#define EUSCI_A3_SPI_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_A3_UART_ABCTL (HWREG16(0x40001C10))
#define EUSCI_A3_UART_ABCTL_UCABDEN (0x0001)
#define EUSCI_A3_UART_ABCTL_UCABDEN__0 (0x0000)
#define EUSCI_A3_UART_ABCTL_UCABDEN__1 (0x0001)
#define EUSCI_A3_UART_ABCTL_UCBTOE (0x0004)
#define EUSCI_A3_UART_ABCTL_UCBTOE__0 (0x0000)
#define EUSCI_A3_UART_ABCTL_UCBTOE__0_NO_ERROR (0x0000)
#define EUSCI_A3_UART_ABCTL_UCBTOE__1 (0x0004)
#define EUSCI_A3_UART_ABCTL_UCDELIM__0 (0x0000)
#define EUSCI_A3_UART_ABCTL_UCDELIM__0_1_BIT_TIME (0x0000)
#define EUSCI_A3_UART_ABCTL_UCDELIM__1 (0x0010)
#define EUSCI_A3_UART_ABCTL_UCDELIM__1_2_BIT_TIMES (0x0010)
#define EUSCI_A3_UART_ABCTL_UCDELIM__2 (0x0020)
#define EUSCI_A3_UART_ABCTL_UCDELIM__2_3_BIT_TIMES (0x0020)
#define EUSCI_A3_UART_ABCTL_UCDELIM__3 (0x0030)
#define EUSCI_A3_UART_ABCTL_UCDELIM__3_4_BIT_TIMES (0x0030)
#define EUSCI_A3_UART_ABCTL_UCDELIM__M (0x0030)
#define EUSCI_A3_UART_ABCTL_UCSTOE (0x0008)
#define EUSCI_A3_UART_ABCTL_UCSTOE__0 (0x0000)
#define EUSCI_A3_UART_ABCTL_UCSTOE__0_NO_ERROR (0x0000)
#define EUSCI_A3_UART_ABCTL_UCSTOE__1 (0x0008)
#define EUSCI_A3_UART_BRW (HWREG16(0x40001C06))
#define EUSCI_A3_UART_CTLW0 (HWREG16(0x40001C00))
#define EUSCI_A3_UART_CTLW0_UC7BIT (0x1000)
#define EUSCI_A3_UART_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_A3_UART_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_A3_UART_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_A3_UART_CTLW0_UCBRKIE (0x0010)
#define EUSCI_A3_UART_CTLW0_UCBRKIE__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCBRKIE__1 (0x0010)
#define EUSCI_A3_UART_CTLW0_UCDORM (0x0008)
#define EUSCI_A3_UART_CTLW0_UCDORM__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCDORM__1 (0x0008)
#define EUSCI_A3_UART_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCMODE__0_UART_MODE (0x0000)
#define EUSCI_A3_UART_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_A3_UART_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_A3_UART_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_A3_UART_CTLW0_UCMODE__M (0x0600)
#define EUSCI_A3_UART_CTLW0_UCMSB (0x2000)
#define EUSCI_A3_UART_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_A3_UART_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_A3_UART_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_A3_UART_CTLW0_UCPAR (0x4000)
#define EUSCI_A3_UART_CTLW0_UCPAR__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCPAR__0_ODD_PARITY (0x0000)
#define EUSCI_A3_UART_CTLW0_UCPAR__1 (0x4000)
#define EUSCI_A3_UART_CTLW0_UCPAR__1_EVEN_PARITY (0x4000)
#define EUSCI_A3_UART_CTLW0_UCPEN (0x8000)
#define EUSCI_A3_UART_CTLW0_UCPEN__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCPEN__0_PARITY_DISABLED (0x0000)
#define EUSCI_A3_UART_CTLW0_UCPEN__1 (0x8000)
#define EUSCI_A3_UART_CTLW0_UCRXEIE (0x0020)
#define EUSCI_A3_UART_CTLW0_UCRXEIE__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCRXEIE__1 (0x0020)
#define EUSCI_A3_UART_CTLW0_UCSPB (0x0800)
#define EUSCI_A3_UART_CTLW0_UCSPB__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCSPB__0_ONE_STOP_BIT (0x0000)
#define EUSCI_A3_UART_CTLW0_UCSPB__1 (0x0800)
#define EUSCI_A3_UART_CTLW0_UCSPB__1_TWO_STOP_BITS (0x0800)
#define EUSCI_A3_UART_CTLW0_UCSSEL__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCSSEL__0_UCLK (0x0000)
#define EUSCI_A3_UART_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_A3_UART_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_A3_UART_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_A3_UART_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_A3_UART_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_A3_UART_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_A3_UART_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_A3_UART_CTLW0_UCSWRST (0x0001)
#define EUSCI_A3_UART_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_A3_UART_CTLW0_UCSYNC (0x0100)
#define EUSCI_A3_UART_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_A3_UART_CTLW0_UCTXADDR (0x0004)
#define EUSCI_A3_UART_CTLW0_UCTXADDR__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCTXADDR__1 (0x0004)
#define EUSCI_A3_UART_CTLW0_UCTXBRK (0x0002)
#define EUSCI_A3_UART_CTLW0_UCTXBRK__0 (0x0000)
#define EUSCI_A3_UART_CTLW0_UCTXBRK__1 (0x0002)
#define EUSCI_A3_UART_CTLW1 (HWREG16(0x40001C02))
#define EUSCI_A3_UART_CTLW1_UCGLIT__0 (0x0000)
#define EUSCI_A3_UART_CTLW1_UCGLIT__0__2_NS (0x0000)
#define EUSCI_A3_UART_CTLW1_UCGLIT__1 (0x0001)
#define EUSCI_A3_UART_CTLW1_UCGLIT__1__50_NS (0x0001)
#define EUSCI_A3_UART_CTLW1_UCGLIT__2 (0x0002)
#define EUSCI_A3_UART_CTLW1_UCGLIT__2__100_NS (0x0002)
#define EUSCI_A3_UART_CTLW1_UCGLIT__3 (0x0003)
#define EUSCI_A3_UART_CTLW1_UCGLIT__3__200_NS (0x0003)
#define EUSCI_A3_UART_CTLW1_UCGLIT__M (0x0003)
#define EUSCI_A3_UART_IE (HWREG16(0x40001C1A))
#define EUSCI_A3_UART_IE_UCRXIE (0x0001)
#define EUSCI_A3_UART_IE_UCRXIE__0 (0x0000)
#define EUSCI_A3_UART_IE_UCRXIE__1 (0x0001)
#define EUSCI_A3_UART_IE_UCSTTIE (0x0004)
#define EUSCI_A3_UART_IE_UCSTTIE__0 (0x0000)
#define EUSCI_A3_UART_IE_UCSTTIE__1 (0x0004)
#define EUSCI_A3_UART_IE_UCTXCPTIE (0x0008)
#define EUSCI_A3_UART_IE_UCTXCPTIE__0 (0x0000)
#define EUSCI_A3_UART_IE_UCTXCPTIE__1 (0x0008)
#define EUSCI_A3_UART_IE_UCTXIE (0x0002)
#define EUSCI_A3_UART_IE_UCTXIE__0 (0x0000)
#define EUSCI_A3_UART_IE_UCTXIE__1 (0x0002)
#define EUSCI_A3_UART_IFG (HWREG16(0x40001C1C))
#define EUSCI_A3_UART_IFG_UCRXIFG (0x0001)
#define EUSCI_A3_UART_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_A3_UART_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_A3_UART_IFG_UCSTTIFG (0x0004)
#define EUSCI_A3_UART_IFG_UCSTTIFG__0 (0x0000)
#define EUSCI_A3_UART_IFG_UCSTTIFG__1 (0x0004)
#define EUSCI_A3_UART_IFG_UCTXCPTIFG (0x0008)
#define EUSCI_A3_UART_IFG_UCTXCPTIFG__0 (0x0000)
#define EUSCI_A3_UART_IFG_UCTXCPTIFG__1 (0x0008)
#define EUSCI_A3_UART_IFG_UCTXIFG (0x0002)
#define EUSCI_A3_UART_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_A3_UART_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_A3_UART_IRCTL (HWREG16(0x40001C12))
#define EUSCI_A3_UART_IRCTL_UCIREN (0x0001)
#define EUSCI_A3_UART_IRCTL_UCIREN__0 (0x0000)
#define EUSCI_A3_UART_IRCTL_UCIREN__1 (0x0001)
#define EUSCI_A3_UART_IRCTL_UCIRRXFE (0x0100)
#define EUSCI_A3_UART_IRCTL_UCIRRXFE__0 (0x0000)
#define EUSCI_A3_UART_IRCTL_UCIRRXFE__1 (0x0100)
#define EUSCI_A3_UART_IRCTL_UCIRRXFL__M (0xfc00)
#define EUSCI_A3_UART_IRCTL_UCIRRXPL (0x0200)
#define EUSCI_A3_UART_IRCTL_UCIRRXPL__0 (0x0000)
#define EUSCI_A3_UART_IRCTL_UCIRRXPL__1 (0x0200)
#define EUSCI_A3_UART_IRCTL_UCIRTXCLK (0x0002)
#define EUSCI_A3_UART_IRCTL_UCIRTXCLK__0 (0x0000)
#define EUSCI_A3_UART_IRCTL_UCIRTXCLK__0_BRCLK (0x0000)
#define EUSCI_A3_UART_IRCTL_UCIRTXCLK__1 (0x0002)
#define EUSCI_A3_UART_IRCTL_UCIRTXPL__M (0x00fc)
#define EUSCI_A3_UART_IV (HWREG16(0x40001C1E))
#define EUSCI_A3_UART_MCTLW (HWREG16(0x40001C08))
#define EUSCI_A3_UART_MCTLW_UCBRF__M (0x00f0)
#define EUSCI_A3_UART_MCTLW_UCBRS__M (0xff00)
#define EUSCI_A3_UART_MCTLW_UCOS16 (0x0001)
#define EUSCI_A3_UART_MCTLW_UCOS16__0 (0x0000)
#define EUSCI_A3_UART_MCTLW_UCOS16__0_DISABLED (0x0000)
#define EUSCI_A3_UART_MCTLW_UCOS16__1 (0x0001)
#define EUSCI_A3_UART_MCTLW_UCOS16__1_ENABLED (0x0001)
#define EUSCI_A3_UART_RXBUF (HWREG16(0x40001C0C))
#define EUSCI_A3_UART_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_A3_UART_STATW (HWREG16(0x40001C0A))
#define EUSCI_A3_UART_STATW_UCADDR_UCIDLE (0x0002)
#define EUSCI_A3_UART_STATW_UCADDR_UCIDLE__0 (0x0000)
#define EUSCI_A3_UART_STATW_UCADDR_UCIDLE__1 (0x0002)
#define EUSCI_A3_UART_STATW_UCBRK (0x0008)
#define EUSCI_A3_UART_STATW_UCBRK__0 (0x0000)
#define EUSCI_A3_UART_STATW_UCBRK__1 (0x0008)
#define EUSCI_A3_UART_STATW_UCBUSY (0x0001)
#define EUSCI_A3_UART_STATW_UCBUSY__0 (0x0000)
#define EUSCI_A3_UART_STATW_UCBUSY__1 (0x0001)
#define EUSCI_A3_UART_STATW_UCFE (0x0040)
#define EUSCI_A3_UART_STATW_UCFE__0 (0x0000)
#define EUSCI_A3_UART_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_A3_UART_STATW_UCFE__1 (0x0040)
#define EUSCI_A3_UART_STATW_UCLISTEN (0x0080)
#define EUSCI_A3_UART_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_A3_UART_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_A3_UART_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_A3_UART_STATW_UCOE (0x0020)
#define EUSCI_A3_UART_STATW_UCOE__0 (0x0000)
#define EUSCI_A3_UART_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_A3_UART_STATW_UCOE__1 (0x0020)
#define EUSCI_A3_UART_STATW_UCPE (0x0010)
#define EUSCI_A3_UART_STATW_UCPE__0 (0x0000)
#define EUSCI_A3_UART_STATW_UCPE__0_NO_ERROR (0x0000)
#define EUSCI_A3_UART_STATW_UCPE__1 (0x0010)
#define EUSCI_A3_UART_STATW_UCRXERR (0x0004)
#define EUSCI_A3_UART_STATW_UCRXERR__0 (0x0000)
#define EUSCI_A3_UART_STATW_UCRXERR__1 (0x0004)
#define EUSCI_A3_UART_TXBUF (HWREG16(0x40001C0E))
#define EUSCI_A3_UART_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_B0_I2C_ADDMASK (HWREG16(0x4000201E))
#define EUSCI_B0_I2C_ADDMASK_ADDMASK__M (0x03ff)
#define EUSCI_B0_I2C_ADDRX (HWREG16(0x4000201C))
#define EUSCI_B0_I2C_ADDRX_ADDRX__M (0x03ff)
#define EUSCI_B0_I2C_BRW (HWREG16(0x40002006))
#define EUSCI_B0_I2C_CTLW0 (HWREG16(0x40002000))
#define EUSCI_B0_I2C_CTLW0_UCA10 (0x8000)
#define EUSCI_B0_I2C_CTLW0_UCA10__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCA10__1 (0x8000)
#define EUSCI_B0_I2C_CTLW0_UCMM (0x2000)
#define EUSCI_B0_I2C_CTLW0_UCMM__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCMM__1 (0x2000)
#define EUSCI_B0_I2C_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_B0_I2C_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_B0_I2C_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_B0_I2C_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_B0_I2C_CTLW0_UCMODE__M (0x0600)
#define EUSCI_B0_I2C_CTLW0_UCMST (0x0800)
#define EUSCI_B0_I2C_CTLW0_UCMST__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCMST__1 (0x0800)
#define EUSCI_B0_I2C_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_B0_I2C_CTLW0_UCSLA10 (0x4000)
#define EUSCI_B0_I2C_CTLW0_UCSLA10__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCSLA10__1 (0x4000)
#define EUSCI_B0_I2C_CTLW0_UCSSEL__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCSSEL__0_UCLKI (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_B0_I2C_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_B0_I2C_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_B0_I2C_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_B0_I2C_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_B0_I2C_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_B0_I2C_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_B0_I2C_CTLW0_UCSWRST (0x0001)
#define EUSCI_B0_I2C_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_B0_I2C_CTLW0_UCSYNC (0x0100)
#define EUSCI_B0_I2C_CTLW0_UCTR (0x0010)
#define EUSCI_B0_I2C_CTLW0_UCTR__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCTR__0_RECEIVER (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCTR__1 (0x0010)
#define EUSCI_B0_I2C_CTLW0_UCTR__1_TRANSMITTER (0x0010)
#define EUSCI_B0_I2C_CTLW0_UCTXACK (0x0020)
#define EUSCI_B0_I2C_CTLW0_UCTXACK__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCTXACK__1 (0x0020)
#define EUSCI_B0_I2C_CTLW0_UCTXNACK (0x0008)
#define EUSCI_B0_I2C_CTLW0_UCTXNACK__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCTXNACK__1 (0x0008)
#define EUSCI_B0_I2C_CTLW0_UCTXNACK__1_GENERATE_NACK (0x0008)
#define EUSCI_B0_I2C_CTLW0_UCTXSTP (0x0004)
#define EUSCI_B0_I2C_CTLW0_UCTXSTP__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCTXSTP__1 (0x0004)
#define EUSCI_B0_I2C_CTLW0_UCTXSTP__1_GENERATE_STOP (0x0004)
#define EUSCI_B0_I2C_CTLW0_UCTXSTT (0x0002)
#define EUSCI_B0_I2C_CTLW0_UCTXSTT__0 (0x0000)
#define EUSCI_B0_I2C_CTLW0_UCTXSTT__1 (0x0002)
#define EUSCI_B0_I2C_CTLW1 (HWREG16(0x40002002))
#define EUSCI_B0_I2C_CTLW1_UCASTP__0 (0x0000)
#define EUSCI_B0_I2C_CTLW1_UCASTP__1 (0x0004)
#define EUSCI_B0_I2C_CTLW1_UCASTP__2 (0x0008)
#define EUSCI_B0_I2C_CTLW1_UCASTP__M (0x000c)
#define EUSCI_B0_I2C_CTLW1_UCCLTO__0 (0x0000)
#define EUSCI_B0_I2C_CTLW1_UCCLTO__1 (0x0040)
#define EUSCI_B0_I2C_CTLW1_UCCLTO__2 (0x0080)
#define EUSCI_B0_I2C_CTLW1_UCCLTO__3 (0x00c0)
#define EUSCI_B0_I2C_CTLW1_UCCLTO__M (0x00c0)
#define EUSCI_B0_I2C_CTLW1_UCETXINT (0x0100)
#define EUSCI_B0_I2C_CTLW1_UCETXINT__0 (0x0000)
#define EUSCI_B0_I2C_CTLW1_UCETXINT__1 (0x0100)
#define EUSCI_B0_I2C_CTLW1_UCGLIT__0 (0x0000)
#define EUSCI_B0_I2C_CTLW1_UCGLIT__0_50_NS (0x0000)
#define EUSCI_B0_I2C_CTLW1_UCGLIT__1 (0x0001)
#define EUSCI_B0_I2C_CTLW1_UCGLIT__1_25_NS (0x0001)
#define EUSCI_B0_I2C_CTLW1_UCGLIT__2 (0x0002)
#define EUSCI_B0_I2C_CTLW1_UCGLIT__2_12_5_NS (0x0002)
#define EUSCI_B0_I2C_CTLW1_UCGLIT__3 (0x0003)
#define EUSCI_B0_I2C_CTLW1_UCGLIT__3_6_25_NS (0x0003)
#define EUSCI_B0_I2C_CTLW1_UCGLIT__M (0x0003)
#define EUSCI_B0_I2C_CTLW1_UCSTPNACK (0x0020)
#define EUSCI_B0_I2C_CTLW1_UCSTPNACK__0 (0x0000)
#define EUSCI_B0_I2C_CTLW1_UCSTPNACK__1 (0x0020)
#define EUSCI_B0_I2C_CTLW1_UCSWACK (0x0010)
#define EUSCI_B0_I2C_CTLW1_UCSWACK__0 (0x0000)
#define EUSCI_B0_I2C_CTLW1_UCSWACK__1 (0x0010)
#define EUSCI_B0_I2C_I2COA0 (HWREG16(0x40002014))
#define EUSCI_B0_I2C_I2COA0_I2COA__M (0x03ff)
#define EUSCI_B0_I2C_I2COA0_UCGCEN (0x8000)
#define EUSCI_B0_I2C_I2COA0_UCGCEN__0 (0x0000)
#define EUSCI_B0_I2C_I2COA0_UCGCEN__1 (0x8000)
#define EUSCI_B0_I2C_I2COA0_UCOAEN (0x0400)
#define EUSCI_B0_I2C_I2COA0_UCOAEN__0 (0x0000)
#define EUSCI_B0_I2C_I2COA0_UCOAEN__1 (0x0400)
#define EUSCI_B0_I2C_I2COA1 (HWREG16(0x40002016))
#define EUSCI_B0_I2C_I2COA1_I2COA1__M (0x03ff)
#define EUSCI_B0_I2C_I2COA1_UCOAEN (0x0400)
#define EUSCI_B0_I2C_I2COA1_UCOAEN__0 (0x0000)
#define EUSCI_B0_I2C_I2COA1_UCOAEN__1 (0x0400)
#define EUSCI_B0_I2C_I2COA2 (HWREG16(0x40002018))
#define EUSCI_B0_I2C_I2COA2_I2COA2__M (0x03ff)
#define EUSCI_B0_I2C_I2COA2_UCOAEN (0x0400)
#define EUSCI_B0_I2C_I2COA2_UCOAEN__0 (0x0000)
#define EUSCI_B0_I2C_I2COA2_UCOAEN__1 (0x0400)
#define EUSCI_B0_I2C_I2COA3 (HWREG16(0x4000201A))
#define EUSCI_B0_I2C_I2COA3_I2COA3__M (0x03ff)
#define EUSCI_B0_I2C_I2COA3_UCOAEN (0x0400)
#define EUSCI_B0_I2C_I2COA3_UCOAEN__0 (0x0000)
#define EUSCI_B0_I2C_I2COA3_UCOAEN__1 (0x0400)
#define EUSCI_B0_I2C_I2CSA (HWREG16(0x40002020))
#define EUSCI_B0_I2C_I2CSA_I2CSA__M (0x03ff)
#define EUSCI_B0_I2C_IE (HWREG16(0x4000202A))
#define EUSCI_B0_I2C_IE_UCALIE (0x0010)
#define EUSCI_B0_I2C_IE_UCALIE__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCALIE__1 (0x0010)
#define EUSCI_B0_I2C_IE_UCBCNTIE (0x0040)
#define EUSCI_B0_I2C_IE_UCBCNTIE__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCBCNTIE__1 (0x0040)
#define EUSCI_B0_I2C_IE_UCBIT9IE (0x4000)
#define EUSCI_B0_I2C_IE_UCBIT9IE__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCBIT9IE__1 (0x4000)
#define EUSCI_B0_I2C_IE_UCCLTOIE (0x0080)
#define EUSCI_B0_I2C_IE_UCCLTOIE__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCCLTOIE__1 (0x0080)
#define EUSCI_B0_I2C_IE_UCNACKIE (0x0020)
#define EUSCI_B0_I2C_IE_UCNACKIE__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCNACKIE__1 (0x0020)
#define EUSCI_B0_I2C_IE_UCRXIE0 (0x0001)
#define EUSCI_B0_I2C_IE_UCRXIE0__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCRXIE0__1 (0x0001)
#define EUSCI_B0_I2C_IE_UCRXIE1 (0x0100)
#define EUSCI_B0_I2C_IE_UCRXIE1__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCRXIE1__1 (0x0100)
#define EUSCI_B0_I2C_IE_UCRXIE2 (0x0400)
#define EUSCI_B0_I2C_IE_UCRXIE2__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCRXIE2__1 (0x0400)
#define EUSCI_B0_I2C_IE_UCRXIE3 (0x1000)
#define EUSCI_B0_I2C_IE_UCRXIE3__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCRXIE3__1 (0x1000)
#define EUSCI_B0_I2C_IE_UCSTPIE (0x0008)
#define EUSCI_B0_I2C_IE_UCSTPIE__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCSTPIE__1 (0x0008)
#define EUSCI_B0_I2C_IE_UCSTTIE (0x0004)
#define EUSCI_B0_I2C_IE_UCSTTIE__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCSTTIE__1 (0x0004)
#define EUSCI_B0_I2C_IE_UCTXIE0 (0x0002)
#define EUSCI_B0_I2C_IE_UCTXIE0__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCTXIE0__1 (0x0002)
#define EUSCI_B0_I2C_IE_UCTXIE1 (0x0200)
#define EUSCI_B0_I2C_IE_UCTXIE1__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCTXIE1__1 (0x0200)
#define EUSCI_B0_I2C_IE_UCTXIE2 (0x0800)
#define EUSCI_B0_I2C_IE_UCTXIE2__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCTXIE2__1 (0x0800)
#define EUSCI_B0_I2C_IE_UCTXIE3 (0x2000)
#define EUSCI_B0_I2C_IE_UCTXIE3__0 (0x0000)
#define EUSCI_B0_I2C_IE_UCTXIE3__1 (0x2000)
#define EUSCI_B0_I2C_IFG (HWREG16(0x4000202C))
#define EUSCI_B0_I2C_IFG_UCALIFG (0x0010)
#define EUSCI_B0_I2C_IFG_UCALIFG__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCALIFG__1 (0x0010)
#define EUSCI_B0_I2C_IFG_UCBCNTIFG (0x0040)
#define EUSCI_B0_I2C_IFG_UCBCNTIFG__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCBCNTIFG__1 (0x0040)
#define EUSCI_B0_I2C_IFG_UCBIT9IFG (0x4000)
#define EUSCI_B0_I2C_IFG_UCBIT9IFG__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCBIT9IFG__1 (0x4000)
#define EUSCI_B0_I2C_IFG_UCCLTOIFG (0x0080)
#define EUSCI_B0_I2C_IFG_UCCLTOIFG__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCCLTOIFG__1 (0x0080)
#define EUSCI_B0_I2C_IFG_UCNACKIFG (0x0020)
#define EUSCI_B0_I2C_IFG_UCNACKIFG__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCNACKIFG__1 (0x0020)
#define EUSCI_B0_I2C_IFG_UCRXIFG0 (0x0001)
#define EUSCI_B0_I2C_IFG_UCRXIFG0__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCRXIFG0__1 (0x0001)
#define EUSCI_B0_I2C_IFG_UCRXIFG1 (0x0100)
#define EUSCI_B0_I2C_IFG_UCRXIFG1__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCRXIFG1__1 (0x0100)
#define EUSCI_B0_I2C_IFG_UCRXIFG2 (0x0400)
#define EUSCI_B0_I2C_IFG_UCRXIFG2__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCRXIFG2__1 (0x0400)
#define EUSCI_B0_I2C_IFG_UCRXIFG3 (0x1000)
#define EUSCI_B0_I2C_IFG_UCRXIFG3__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCRXIFG3__1 (0x1000)
#define EUSCI_B0_I2C_IFG_UCSTPIFG (0x0008)
#define EUSCI_B0_I2C_IFG_UCSTPIFG__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCSTPIFG__1 (0x0008)
#define EUSCI_B0_I2C_IFG_UCSTTIFG (0x0004)
#define EUSCI_B0_I2C_IFG_UCSTTIFG__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCSTTIFG__1 (0x0004)
#define EUSCI_B0_I2C_IFG_UCTXIFG0 (0x0002)
#define EUSCI_B0_I2C_IFG_UCTXIFG0__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCTXIFG0__1 (0x0002)
#define EUSCI_B0_I2C_IFG_UCTXIFG1 (0x0200)
#define EUSCI_B0_I2C_IFG_UCTXIFG1__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCTXIFG1__1 (0x0200)
#define EUSCI_B0_I2C_IFG_UCTXIFG2 (0x0800)
#define EUSCI_B0_I2C_IFG_UCTXIFG2__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCTXIFG2__1 (0x0800)
#define EUSCI_B0_I2C_IFG_UCTXIFG3 (0x2000)
#define EUSCI_B0_I2C_IFG_UCTXIFG3__0 (0x0000)
#define EUSCI_B0_I2C_IFG_UCTXIFG3__1 (0x2000)
#define EUSCI_B0_I2C_IV (HWREG16(0x4000202E))
#define EUSCI_B0_I2C_RXBUF (HWREG16(0x4000200C))
#define EUSCI_B0_I2C_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_B0_I2C_STATW (HWREG16(0x40002008))
#define EUSCI_B0_I2C_STATW_UCBBUSY (0x0010)
#define EUSCI_B0_I2C_STATW_UCBBUSY__0 (0x0000)
#define EUSCI_B0_I2C_STATW_UCBBUSY__0_BUS_INACTIVE (0x0000)
#define EUSCI_B0_I2C_STATW_UCBBUSY__1 (0x0010)
#define EUSCI_B0_I2C_STATW_UCBBUSY__1_BUS_BUSY (0x0010)
#define EUSCI_B0_I2C_STATW_UCBCNT__M (0xff00)
#define EUSCI_B0_I2C_STATW_UCGC (0x0020)
#define EUSCI_B0_I2C_STATW_UCGC__0 (0x0000)
#define EUSCI_B0_I2C_STATW_UCGC__1 (0x0020)
#define EUSCI_B0_I2C_STATW_UCSCLLOW (0x0040)
#define EUSCI_B0_I2C_STATW_UCSCLLOW__0 (0x0000)
#define EUSCI_B0_I2C_STATW_UCSCLLOW__1 (0x0040)
#define EUSCI_B0_I2C_STATW_UCSCLLOW__1_SCL_IS_HELD_LOW (0x0040)
#define EUSCI_B0_I2C_TBCNT (HWREG16(0x4000200A))
#define EUSCI_B0_I2C_TBCNT_UCTBCNT__M (0x00ff)
#define EUSCI_B0_I2C_TXBUF (HWREG16(0x4000200E))
#define EUSCI_B0_I2C_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_B0_SPI_BRW (HWREG16(0x40002006))
#define EUSCI_B0_SPI_CTLW0 (HWREG16(0x40002000))
#define EUSCI_B0_SPI_CTLW0_UC7BIT (0x1000)
#define EUSCI_B0_SPI_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_B0_SPI_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_B0_SPI_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_B0_SPI_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_B0_SPI_CTLW0_UCCKPH (0x8000)
#define EUSCI_B0_SPI_CTLW0_UCCKPH__0 (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCCKPH__1 (0x8000)
#define EUSCI_B0_SPI_CTLW0_UCCKPL (0x4000)
#define EUSCI_B0_SPI_CTLW0_UCCKPL__0 (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCCKPL__1 (0x4000)
#define EUSCI_B0_SPI_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_B0_SPI_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_B0_SPI_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_B0_SPI_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_B0_SPI_CTLW0_UCMODE__M (0x0600)
#define EUSCI_B0_SPI_CTLW0_UCMSB (0x2000)
#define EUSCI_B0_SPI_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_B0_SPI_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_B0_SPI_CTLW0_UCMST (0x0800)
#define EUSCI_B0_SPI_CTLW0_UCMST__0 (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCMST__1 (0x0800)
#define EUSCI_B0_SPI_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_B0_SPI_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_B0_SPI_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_B0_SPI_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_B0_SPI_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_B0_SPI_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_B0_SPI_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_B0_SPI_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_B0_SPI_CTLW0_UCSTEM (0x0002)
#define EUSCI_B0_SPI_CTLW0_UCSTEM__0 (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCSTEM__1 (0x0002)
#define EUSCI_B0_SPI_CTLW0_UCSWRST (0x0001)
#define EUSCI_B0_SPI_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_B0_SPI_CTLW0_UCSYNC (0x0100)
#define EUSCI_B0_SPI_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_B0_SPI_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_B0_SPI_IE (HWREG16(0x4000202A))
#define EUSCI_B0_SPI_IE_UCRXIE (0x0001)
#define EUSCI_B0_SPI_IE_UCRXIE__0 (0x0000)
#define EUSCI_B0_SPI_IE_UCRXIE__1 (0x0001)
#define EUSCI_B0_SPI_IE_UCTXIE (0x0002)
#define EUSCI_B0_SPI_IE_UCTXIE__0 (0x0000)
#define EUSCI_B0_SPI_IE_UCTXIE__1 (0x0002)
#define EUSCI_B0_SPI_IFG (HWREG16(0x4000202C))
#define EUSCI_B0_SPI_IFG_UCRXIFG (0x0001)
#define EUSCI_B0_SPI_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_B0_SPI_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_B0_SPI_IFG_UCTXIFG (0x0002)
#define EUSCI_B0_SPI_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_B0_SPI_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_B0_SPI_IV (HWREG16(0x4000202E))
#define EUSCI_B0_SPI_RXBUF (HWREG16(0x4000200C))
#define EUSCI_B0_SPI_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_B0_SPI_STATW (HWREG16(0x40002008))
#define EUSCI_B0_SPI_STATW_UCBUSY (0x0001)
#define EUSCI_B0_SPI_STATW_UCBUSY__0 (0x0000)
#define EUSCI_B0_SPI_STATW_UCBUSY__0_EUSCI_INACTIVE (0x0000)
#define EUSCI_B0_SPI_STATW_UCBUSY__1 (0x0001)
#define EUSCI_B0_SPI_STATW_UCFE (0x0040)
#define EUSCI_B0_SPI_STATW_UCFE__0 (0x0000)
#define EUSCI_B0_SPI_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_B0_SPI_STATW_UCFE__1 (0x0040)
#define EUSCI_B0_SPI_STATW_UCLISTEN (0x0080)
#define EUSCI_B0_SPI_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_B0_SPI_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_B0_SPI_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_B0_SPI_STATW_UCOE (0x0020)
#define EUSCI_B0_SPI_STATW_UCOE__0 (0x0000)
#define EUSCI_B0_SPI_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_B0_SPI_STATW_UCOE__1 (0x0020)
#define EUSCI_B0_SPI_TXBUF (HWREG16(0x4000200E))
#define EUSCI_B0_SPI_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_B1_I2C_ADDMASK (HWREG16(0x4000241E))
#define EUSCI_B1_I2C_ADDMASK_ADDMASK__M (0x03ff)
#define EUSCI_B1_I2C_ADDRX (HWREG16(0x4000241C))
#define EUSCI_B1_I2C_ADDRX_ADDRX__M (0x03ff)
#define EUSCI_B1_I2C_BRW (HWREG16(0x40002406))
#define EUSCI_B1_I2C_CTLW0 (HWREG16(0x40002400))
#define EUSCI_B1_I2C_CTLW0_UCA10 (0x8000)
#define EUSCI_B1_I2C_CTLW0_UCA10__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCA10__1 (0x8000)
#define EUSCI_B1_I2C_CTLW0_UCMM (0x2000)
#define EUSCI_B1_I2C_CTLW0_UCMM__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCMM__1 (0x2000)
#define EUSCI_B1_I2C_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_B1_I2C_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_B1_I2C_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_B1_I2C_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_B1_I2C_CTLW0_UCMODE__M (0x0600)
#define EUSCI_B1_I2C_CTLW0_UCMST (0x0800)
#define EUSCI_B1_I2C_CTLW0_UCMST__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCMST__1 (0x0800)
#define EUSCI_B1_I2C_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_B1_I2C_CTLW0_UCSLA10 (0x4000)
#define EUSCI_B1_I2C_CTLW0_UCSLA10__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCSLA10__1 (0x4000)
#define EUSCI_B1_I2C_CTLW0_UCSSEL__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCSSEL__0_UCLKI (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_B1_I2C_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_B1_I2C_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_B1_I2C_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_B1_I2C_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_B1_I2C_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_B1_I2C_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_B1_I2C_CTLW0_UCSWRST (0x0001)
#define EUSCI_B1_I2C_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_B1_I2C_CTLW0_UCSYNC (0x0100)
#define EUSCI_B1_I2C_CTLW0_UCTR (0x0010)
#define EUSCI_B1_I2C_CTLW0_UCTR__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCTR__0_RECEIVER (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCTR__1 (0x0010)
#define EUSCI_B1_I2C_CTLW0_UCTR__1_TRANSMITTER (0x0010)
#define EUSCI_B1_I2C_CTLW0_UCTXACK (0x0020)
#define EUSCI_B1_I2C_CTLW0_UCTXACK__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCTXACK__1 (0x0020)
#define EUSCI_B1_I2C_CTLW0_UCTXNACK (0x0008)
#define EUSCI_B1_I2C_CTLW0_UCTXNACK__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCTXNACK__1 (0x0008)
#define EUSCI_B1_I2C_CTLW0_UCTXNACK__1_GENERATE_NACK (0x0008)
#define EUSCI_B1_I2C_CTLW0_UCTXSTP (0x0004)
#define EUSCI_B1_I2C_CTLW0_UCTXSTP__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCTXSTP__1 (0x0004)
#define EUSCI_B1_I2C_CTLW0_UCTXSTP__1_GENERATE_STOP (0x0004)
#define EUSCI_B1_I2C_CTLW0_UCTXSTT (0x0002)
#define EUSCI_B1_I2C_CTLW0_UCTXSTT__0 (0x0000)
#define EUSCI_B1_I2C_CTLW0_UCTXSTT__1 (0x0002)
#define EUSCI_B1_I2C_CTLW1 (HWREG16(0x40002402))
#define EUSCI_B1_I2C_CTLW1_UCASTP__0 (0x0000)
#define EUSCI_B1_I2C_CTLW1_UCASTP__1 (0x0004)
#define EUSCI_B1_I2C_CTLW1_UCASTP__2 (0x0008)
#define EUSCI_B1_I2C_CTLW1_UCASTP__M (0x000c)
#define EUSCI_B1_I2C_CTLW1_UCCLTO__0 (0x0000)
#define EUSCI_B1_I2C_CTLW1_UCCLTO__1 (0x0040)
#define EUSCI_B1_I2C_CTLW1_UCCLTO__2 (0x0080)
#define EUSCI_B1_I2C_CTLW1_UCCLTO__3 (0x00c0)
#define EUSCI_B1_I2C_CTLW1_UCCLTO__M (0x00c0)
#define EUSCI_B1_I2C_CTLW1_UCETXINT (0x0100)
#define EUSCI_B1_I2C_CTLW1_UCETXINT__0 (0x0000)
#define EUSCI_B1_I2C_CTLW1_UCETXINT__1 (0x0100)
#define EUSCI_B1_I2C_CTLW1_UCGLIT__0 (0x0000)
#define EUSCI_B1_I2C_CTLW1_UCGLIT__0_50_NS (0x0000)
#define EUSCI_B1_I2C_CTLW1_UCGLIT__1 (0x0001)
#define EUSCI_B1_I2C_CTLW1_UCGLIT__1_25_NS (0x0001)
#define EUSCI_B1_I2C_CTLW1_UCGLIT__2 (0x0002)
#define EUSCI_B1_I2C_CTLW1_UCGLIT__2_12_5_NS (0x0002)
#define EUSCI_B1_I2C_CTLW1_UCGLIT__3 (0x0003)
#define EUSCI_B1_I2C_CTLW1_UCGLIT__3_6_25_NS (0x0003)
#define EUSCI_B1_I2C_CTLW1_UCGLIT__M (0x0003)
#define EUSCI_B1_I2C_CTLW1_UCSTPNACK (0x0020)
#define EUSCI_B1_I2C_CTLW1_UCSTPNACK__0 (0x0000)
#define EUSCI_B1_I2C_CTLW1_UCSTPNACK__1 (0x0020)
#define EUSCI_B1_I2C_CTLW1_UCSWACK (0x0010)
#define EUSCI_B1_I2C_CTLW1_UCSWACK__0 (0x0000)
#define EUSCI_B1_I2C_CTLW1_UCSWACK__1 (0x0010)
#define EUSCI_B1_I2C_I2COA0 (HWREG16(0x40002414))
#define EUSCI_B1_I2C_I2COA0_I2COA__M (0x03ff)
#define EUSCI_B1_I2C_I2COA0_UCGCEN (0x8000)
#define EUSCI_B1_I2C_I2COA0_UCGCEN__0 (0x0000)
#define EUSCI_B1_I2C_I2COA0_UCGCEN__1 (0x8000)
#define EUSCI_B1_I2C_I2COA0_UCOAEN (0x0400)
#define EUSCI_B1_I2C_I2COA0_UCOAEN__0 (0x0000)
#define EUSCI_B1_I2C_I2COA0_UCOAEN__1 (0x0400)
#define EUSCI_B1_I2C_I2COA1 (HWREG16(0x40002416))
#define EUSCI_B1_I2C_I2COA1_I2COA1__M (0x03ff)
#define EUSCI_B1_I2C_I2COA1_UCOAEN (0x0400)
#define EUSCI_B1_I2C_I2COA1_UCOAEN__0 (0x0000)
#define EUSCI_B1_I2C_I2COA1_UCOAEN__1 (0x0400)
#define EUSCI_B1_I2C_I2COA2 (HWREG16(0x40002418))
#define EUSCI_B1_I2C_I2COA2_I2COA2__M (0x03ff)
#define EUSCI_B1_I2C_I2COA2_UCOAEN (0x0400)
#define EUSCI_B1_I2C_I2COA2_UCOAEN__0 (0x0000)
#define EUSCI_B1_I2C_I2COA2_UCOAEN__1 (0x0400)
#define EUSCI_B1_I2C_I2COA3 (HWREG16(0x4000241A))
#define EUSCI_B1_I2C_I2COA3_I2COA3__M (0x03ff)
#define EUSCI_B1_I2C_I2COA3_UCOAEN (0x0400)
#define EUSCI_B1_I2C_I2COA3_UCOAEN__0 (0x0000)
#define EUSCI_B1_I2C_I2COA3_UCOAEN__1 (0x0400)
#define EUSCI_B1_I2C_I2CSA (HWREG16(0x40002420))
#define EUSCI_B1_I2C_I2CSA_I2CSA__M (0x03ff)
#define EUSCI_B1_I2C_IE (HWREG16(0x4000242A))
#define EUSCI_B1_I2C_IE_UCALIE (0x0010)
#define EUSCI_B1_I2C_IE_UCALIE__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCALIE__1 (0x0010)
#define EUSCI_B1_I2C_IE_UCBCNTIE (0x0040)
#define EUSCI_B1_I2C_IE_UCBCNTIE__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCBCNTIE__1 (0x0040)
#define EUSCI_B1_I2C_IE_UCBIT9IE (0x4000)
#define EUSCI_B1_I2C_IE_UCBIT9IE__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCBIT9IE__1 (0x4000)
#define EUSCI_B1_I2C_IE_UCCLTOIE (0x0080)
#define EUSCI_B1_I2C_IE_UCCLTOIE__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCCLTOIE__1 (0x0080)
#define EUSCI_B1_I2C_IE_UCNACKIE (0x0020)
#define EUSCI_B1_I2C_IE_UCNACKIE__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCNACKIE__1 (0x0020)
#define EUSCI_B1_I2C_IE_UCRXIE0 (0x0001)
#define EUSCI_B1_I2C_IE_UCRXIE0__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCRXIE0__1 (0x0001)
#define EUSCI_B1_I2C_IE_UCRXIE1 (0x0100)
#define EUSCI_B1_I2C_IE_UCRXIE1__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCRXIE1__1 (0x0100)
#define EUSCI_B1_I2C_IE_UCRXIE2 (0x0400)
#define EUSCI_B1_I2C_IE_UCRXIE2__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCRXIE2__1 (0x0400)
#define EUSCI_B1_I2C_IE_UCRXIE3 (0x1000)
#define EUSCI_B1_I2C_IE_UCRXIE3__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCRXIE3__1 (0x1000)
#define EUSCI_B1_I2C_IE_UCSTPIE (0x0008)
#define EUSCI_B1_I2C_IE_UCSTPIE__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCSTPIE__1 (0x0008)
#define EUSCI_B1_I2C_IE_UCSTTIE (0x0004)
#define EUSCI_B1_I2C_IE_UCSTTIE__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCSTTIE__1 (0x0004)
#define EUSCI_B1_I2C_IE_UCTXIE0 (0x0002)
#define EUSCI_B1_I2C_IE_UCTXIE0__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCTXIE0__1 (0x0002)
#define EUSCI_B1_I2C_IE_UCTXIE1 (0x0200)
#define EUSCI_B1_I2C_IE_UCTXIE1__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCTXIE1__1 (0x0200)
#define EUSCI_B1_I2C_IE_UCTXIE2 (0x0800)
#define EUSCI_B1_I2C_IE_UCTXIE2__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCTXIE2__1 (0x0800)
#define EUSCI_B1_I2C_IE_UCTXIE3 (0x2000)
#define EUSCI_B1_I2C_IE_UCTXIE3__0 (0x0000)
#define EUSCI_B1_I2C_IE_UCTXIE3__1 (0x2000)
#define EUSCI_B1_I2C_IFG (HWREG16(0x4000242C))
#define EUSCI_B1_I2C_IFG_UCALIFG (0x0010)
#define EUSCI_B1_I2C_IFG_UCALIFG__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCALIFG__1 (0x0010)
#define EUSCI_B1_I2C_IFG_UCBCNTIFG (0x0040)
#define EUSCI_B1_I2C_IFG_UCBCNTIFG__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCBCNTIFG__1 (0x0040)
#define EUSCI_B1_I2C_IFG_UCBIT9IFG (0x4000)
#define EUSCI_B1_I2C_IFG_UCBIT9IFG__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCBIT9IFG__1 (0x4000)
#define EUSCI_B1_I2C_IFG_UCCLTOIFG (0x0080)
#define EUSCI_B1_I2C_IFG_UCCLTOIFG__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCCLTOIFG__1 (0x0080)
#define EUSCI_B1_I2C_IFG_UCNACKIFG (0x0020)
#define EUSCI_B1_I2C_IFG_UCNACKIFG__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCNACKIFG__1 (0x0020)
#define EUSCI_B1_I2C_IFG_UCRXIFG0 (0x0001)
#define EUSCI_B1_I2C_IFG_UCRXIFG0__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCRXIFG0__1 (0x0001)
#define EUSCI_B1_I2C_IFG_UCRXIFG1 (0x0100)
#define EUSCI_B1_I2C_IFG_UCRXIFG1__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCRXIFG1__1 (0x0100)
#define EUSCI_B1_I2C_IFG_UCRXIFG2 (0x0400)
#define EUSCI_B1_I2C_IFG_UCRXIFG2__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCRXIFG2__1 (0x0400)
#define EUSCI_B1_I2C_IFG_UCRXIFG3 (0x1000)
#define EUSCI_B1_I2C_IFG_UCRXIFG3__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCRXIFG3__1 (0x1000)
#define EUSCI_B1_I2C_IFG_UCSTPIFG (0x0008)
#define EUSCI_B1_I2C_IFG_UCSTPIFG__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCSTPIFG__1 (0x0008)
#define EUSCI_B1_I2C_IFG_UCSTTIFG (0x0004)
#define EUSCI_B1_I2C_IFG_UCSTTIFG__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCSTTIFG__1 (0x0004)
#define EUSCI_B1_I2C_IFG_UCTXIFG0 (0x0002)
#define EUSCI_B1_I2C_IFG_UCTXIFG0__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCTXIFG0__1 (0x0002)
#define EUSCI_B1_I2C_IFG_UCTXIFG1 (0x0200)
#define EUSCI_B1_I2C_IFG_UCTXIFG1__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCTXIFG1__1 (0x0200)
#define EUSCI_B1_I2C_IFG_UCTXIFG2 (0x0800)
#define EUSCI_B1_I2C_IFG_UCTXIFG2__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCTXIFG2__1 (0x0800)
#define EUSCI_B1_I2C_IFG_UCTXIFG3 (0x2000)
#define EUSCI_B1_I2C_IFG_UCTXIFG3__0 (0x0000)
#define EUSCI_B1_I2C_IFG_UCTXIFG3__1 (0x2000)
#define EUSCI_B1_I2C_IV (HWREG16(0x4000242E))
#define EUSCI_B1_I2C_RXBUF (HWREG16(0x4000240C))
#define EUSCI_B1_I2C_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_B1_I2C_STATW (HWREG16(0x40002408))
#define EUSCI_B1_I2C_STATW_UCBBUSY (0x0010)
#define EUSCI_B1_I2C_STATW_UCBBUSY__0 (0x0000)
#define EUSCI_B1_I2C_STATW_UCBBUSY__0_BUS_INACTIVE (0x0000)
#define EUSCI_B1_I2C_STATW_UCBBUSY__1 (0x0010)
#define EUSCI_B1_I2C_STATW_UCBBUSY__1_BUS_BUSY (0x0010)
#define EUSCI_B1_I2C_STATW_UCBCNT__M (0xff00)
#define EUSCI_B1_I2C_STATW_UCGC (0x0020)
#define EUSCI_B1_I2C_STATW_UCGC__0 (0x0000)
#define EUSCI_B1_I2C_STATW_UCGC__1 (0x0020)
#define EUSCI_B1_I2C_STATW_UCSCLLOW (0x0040)
#define EUSCI_B1_I2C_STATW_UCSCLLOW__0 (0x0000)
#define EUSCI_B1_I2C_STATW_UCSCLLOW__1 (0x0040)
#define EUSCI_B1_I2C_STATW_UCSCLLOW__1_SCL_IS_HELD_LOW (0x0040)
#define EUSCI_B1_I2C_TBCNT (HWREG16(0x4000240A))
#define EUSCI_B1_I2C_TBCNT_UCTBCNT__M (0x00ff)
#define EUSCI_B1_I2C_TXBUF (HWREG16(0x4000240E))
#define EUSCI_B1_I2C_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_B1_SPI_BRW (HWREG16(0x40002406))
#define EUSCI_B1_SPI_CTLW0 (HWREG16(0x40002400))
#define EUSCI_B1_SPI_CTLW0_UC7BIT (0x1000)
#define EUSCI_B1_SPI_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_B1_SPI_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_B1_SPI_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_B1_SPI_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_B1_SPI_CTLW0_UCCKPH (0x8000)
#define EUSCI_B1_SPI_CTLW0_UCCKPH__0 (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCCKPH__1 (0x8000)
#define EUSCI_B1_SPI_CTLW0_UCCKPL (0x4000)
#define EUSCI_B1_SPI_CTLW0_UCCKPL__0 (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCCKPL__1 (0x4000)
#define EUSCI_B1_SPI_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_B1_SPI_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_B1_SPI_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_B1_SPI_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_B1_SPI_CTLW0_UCMODE__M (0x0600)
#define EUSCI_B1_SPI_CTLW0_UCMSB (0x2000)
#define EUSCI_B1_SPI_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_B1_SPI_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_B1_SPI_CTLW0_UCMST (0x0800)
#define EUSCI_B1_SPI_CTLW0_UCMST__0 (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCMST__1 (0x0800)
#define EUSCI_B1_SPI_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_B1_SPI_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_B1_SPI_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_B1_SPI_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_B1_SPI_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_B1_SPI_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_B1_SPI_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_B1_SPI_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_B1_SPI_CTLW0_UCSTEM (0x0002)
#define EUSCI_B1_SPI_CTLW0_UCSTEM__0 (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCSTEM__1 (0x0002)
#define EUSCI_B1_SPI_CTLW0_UCSWRST (0x0001)
#define EUSCI_B1_SPI_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_B1_SPI_CTLW0_UCSYNC (0x0100)
#define EUSCI_B1_SPI_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_B1_SPI_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_B1_SPI_IE (HWREG16(0x4000242A))
#define EUSCI_B1_SPI_IE_UCRXIE (0x0001)
#define EUSCI_B1_SPI_IE_UCRXIE__0 (0x0000)
#define EUSCI_B1_SPI_IE_UCRXIE__1 (0x0001)
#define EUSCI_B1_SPI_IE_UCTXIE (0x0002)
#define EUSCI_B1_SPI_IE_UCTXIE__0 (0x0000)
#define EUSCI_B1_SPI_IE_UCTXIE__1 (0x0002)
#define EUSCI_B1_SPI_IFG (HWREG16(0x4000242C))
#define EUSCI_B1_SPI_IFG_UCRXIFG (0x0001)
#define EUSCI_B1_SPI_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_B1_SPI_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_B1_SPI_IFG_UCTXIFG (0x0002)
#define EUSCI_B1_SPI_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_B1_SPI_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_B1_SPI_IV (HWREG16(0x4000242E))
#define EUSCI_B1_SPI_RXBUF (HWREG16(0x4000240C))
#define EUSCI_B1_SPI_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_B1_SPI_STATW (HWREG16(0x40002408))
#define EUSCI_B1_SPI_STATW_UCBUSY (0x0001)
#define EUSCI_B1_SPI_STATW_UCBUSY__0 (0x0000)
#define EUSCI_B1_SPI_STATW_UCBUSY__0_EUSCI_INACTIVE (0x0000)
#define EUSCI_B1_SPI_STATW_UCBUSY__1 (0x0001)
#define EUSCI_B1_SPI_STATW_UCFE (0x0040)
#define EUSCI_B1_SPI_STATW_UCFE__0 (0x0000)
#define EUSCI_B1_SPI_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_B1_SPI_STATW_UCFE__1 (0x0040)
#define EUSCI_B1_SPI_STATW_UCLISTEN (0x0080)
#define EUSCI_B1_SPI_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_B1_SPI_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_B1_SPI_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_B1_SPI_STATW_UCOE (0x0020)
#define EUSCI_B1_SPI_STATW_UCOE__0 (0x0000)
#define EUSCI_B1_SPI_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_B1_SPI_STATW_UCOE__1 (0x0020)
#define EUSCI_B1_SPI_TXBUF (HWREG16(0x4000240E))
#define EUSCI_B1_SPI_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_B2_I2C_ADDMASK (HWREG16(0x4000281E))
#define EUSCI_B2_I2C_ADDMASK_ADDMASK__M (0x03ff)
#define EUSCI_B2_I2C_ADDRX (HWREG16(0x4000281C))
#define EUSCI_B2_I2C_ADDRX_ADDRX__M (0x03ff)
#define EUSCI_B2_I2C_BRW (HWREG16(0x40002806))
#define EUSCI_B2_I2C_CTLW0 (HWREG16(0x40002800))
#define EUSCI_B2_I2C_CTLW0_UCA10 (0x8000)
#define EUSCI_B2_I2C_CTLW0_UCA10__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCA10__1 (0x8000)
#define EUSCI_B2_I2C_CTLW0_UCMM (0x2000)
#define EUSCI_B2_I2C_CTLW0_UCMM__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCMM__1 (0x2000)
#define EUSCI_B2_I2C_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_B2_I2C_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_B2_I2C_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_B2_I2C_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_B2_I2C_CTLW0_UCMODE__M (0x0600)
#define EUSCI_B2_I2C_CTLW0_UCMST (0x0800)
#define EUSCI_B2_I2C_CTLW0_UCMST__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCMST__1 (0x0800)
#define EUSCI_B2_I2C_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_B2_I2C_CTLW0_UCSLA10 (0x4000)
#define EUSCI_B2_I2C_CTLW0_UCSLA10__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCSLA10__1 (0x4000)
#define EUSCI_B2_I2C_CTLW0_UCSSEL__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCSSEL__0_UCLKI (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_B2_I2C_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_B2_I2C_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_B2_I2C_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_B2_I2C_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_B2_I2C_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_B2_I2C_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_B2_I2C_CTLW0_UCSWRST (0x0001)
#define EUSCI_B2_I2C_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_B2_I2C_CTLW0_UCSYNC (0x0100)
#define EUSCI_B2_I2C_CTLW0_UCTR (0x0010)
#define EUSCI_B2_I2C_CTLW0_UCTR__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCTR__0_RECEIVER (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCTR__1 (0x0010)
#define EUSCI_B2_I2C_CTLW0_UCTR__1_TRANSMITTER (0x0010)
#define EUSCI_B2_I2C_CTLW0_UCTXACK (0x0020)
#define EUSCI_B2_I2C_CTLW0_UCTXACK__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCTXACK__1 (0x0020)
#define EUSCI_B2_I2C_CTLW0_UCTXNACK (0x0008)
#define EUSCI_B2_I2C_CTLW0_UCTXNACK__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCTXNACK__1 (0x0008)
#define EUSCI_B2_I2C_CTLW0_UCTXNACK__1_GENERATE_NACK (0x0008)
#define EUSCI_B2_I2C_CTLW0_UCTXSTP (0x0004)
#define EUSCI_B2_I2C_CTLW0_UCTXSTP__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCTXSTP__1 (0x0004)
#define EUSCI_B2_I2C_CTLW0_UCTXSTP__1_GENERATE_STOP (0x0004)
#define EUSCI_B2_I2C_CTLW0_UCTXSTT (0x0002)
#define EUSCI_B2_I2C_CTLW0_UCTXSTT__0 (0x0000)
#define EUSCI_B2_I2C_CTLW0_UCTXSTT__1 (0x0002)
#define EUSCI_B2_I2C_CTLW1 (HWREG16(0x40002802))
#define EUSCI_B2_I2C_CTLW1_UCASTP__0 (0x0000)
#define EUSCI_B2_I2C_CTLW1_UCASTP__1 (0x0004)
#define EUSCI_B2_I2C_CTLW1_UCASTP__2 (0x0008)
#define EUSCI_B2_I2C_CTLW1_UCASTP__M (0x000c)
#define EUSCI_B2_I2C_CTLW1_UCCLTO__0 (0x0000)
#define EUSCI_B2_I2C_CTLW1_UCCLTO__1 (0x0040)
#define EUSCI_B2_I2C_CTLW1_UCCLTO__2 (0x0080)
#define EUSCI_B2_I2C_CTLW1_UCCLTO__3 (0x00c0)
#define EUSCI_B2_I2C_CTLW1_UCCLTO__M (0x00c0)
#define EUSCI_B2_I2C_CTLW1_UCETXINT (0x0100)
#define EUSCI_B2_I2C_CTLW1_UCETXINT__0 (0x0000)
#define EUSCI_B2_I2C_CTLW1_UCETXINT__1 (0x0100)
#define EUSCI_B2_I2C_CTLW1_UCGLIT__0 (0x0000)
#define EUSCI_B2_I2C_CTLW1_UCGLIT__0_50_NS (0x0000)
#define EUSCI_B2_I2C_CTLW1_UCGLIT__1 (0x0001)
#define EUSCI_B2_I2C_CTLW1_UCGLIT__1_25_NS (0x0001)
#define EUSCI_B2_I2C_CTLW1_UCGLIT__2 (0x0002)
#define EUSCI_B2_I2C_CTLW1_UCGLIT__2_12_5_NS (0x0002)
#define EUSCI_B2_I2C_CTLW1_UCGLIT__3 (0x0003)
#define EUSCI_B2_I2C_CTLW1_UCGLIT__3_6_25_NS (0x0003)
#define EUSCI_B2_I2C_CTLW1_UCGLIT__M (0x0003)
#define EUSCI_B2_I2C_CTLW1_UCSTPNACK (0x0020)
#define EUSCI_B2_I2C_CTLW1_UCSTPNACK__0 (0x0000)
#define EUSCI_B2_I2C_CTLW1_UCSTPNACK__1 (0x0020)
#define EUSCI_B2_I2C_CTLW1_UCSWACK (0x0010)
#define EUSCI_B2_I2C_CTLW1_UCSWACK__0 (0x0000)
#define EUSCI_B2_I2C_CTLW1_UCSWACK__1 (0x0010)
#define EUSCI_B2_I2C_I2COA0 (HWREG16(0x40002814))
#define EUSCI_B2_I2C_I2COA0_I2COA__M (0x03ff)
#define EUSCI_B2_I2C_I2COA0_UCGCEN (0x8000)
#define EUSCI_B2_I2C_I2COA0_UCGCEN__0 (0x0000)
#define EUSCI_B2_I2C_I2COA0_UCGCEN__1 (0x8000)
#define EUSCI_B2_I2C_I2COA0_UCOAEN (0x0400)
#define EUSCI_B2_I2C_I2COA0_UCOAEN__0 (0x0000)
#define EUSCI_B2_I2C_I2COA0_UCOAEN__1 (0x0400)
#define EUSCI_B2_I2C_I2COA1 (HWREG16(0x40002816))
#define EUSCI_B2_I2C_I2COA1_I2COA1__M (0x03ff)
#define EUSCI_B2_I2C_I2COA1_UCOAEN (0x0400)
#define EUSCI_B2_I2C_I2COA1_UCOAEN__0 (0x0000)
#define EUSCI_B2_I2C_I2COA1_UCOAEN__1 (0x0400)
#define EUSCI_B2_I2C_I2COA2 (HWREG16(0x40002818))
#define EUSCI_B2_I2C_I2COA2_I2COA2__M (0x03ff)
#define EUSCI_B2_I2C_I2COA2_UCOAEN (0x0400)
#define EUSCI_B2_I2C_I2COA2_UCOAEN__0 (0x0000)
#define EUSCI_B2_I2C_I2COA2_UCOAEN__1 (0x0400)
#define EUSCI_B2_I2C_I2COA3 (HWREG16(0x4000281A))
#define EUSCI_B2_I2C_I2COA3_I2COA3__M (0x03ff)
#define EUSCI_B2_I2C_I2COA3_UCOAEN (0x0400)
#define EUSCI_B2_I2C_I2COA3_UCOAEN__0 (0x0000)
#define EUSCI_B2_I2C_I2COA3_UCOAEN__1 (0x0400)
#define EUSCI_B2_I2C_I2CSA (HWREG16(0x40002820))
#define EUSCI_B2_I2C_I2CSA_I2CSA__M (0x03ff)
#define EUSCI_B2_I2C_IE (HWREG16(0x4000282A))
#define EUSCI_B2_I2C_IE_UCALIE (0x0010)
#define EUSCI_B2_I2C_IE_UCALIE__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCALIE__1 (0x0010)
#define EUSCI_B2_I2C_IE_UCBCNTIE (0x0040)
#define EUSCI_B2_I2C_IE_UCBCNTIE__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCBCNTIE__1 (0x0040)
#define EUSCI_B2_I2C_IE_UCBIT9IE (0x4000)
#define EUSCI_B2_I2C_IE_UCBIT9IE__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCBIT9IE__1 (0x4000)
#define EUSCI_B2_I2C_IE_UCCLTOIE (0x0080)
#define EUSCI_B2_I2C_IE_UCCLTOIE__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCCLTOIE__1 (0x0080)
#define EUSCI_B2_I2C_IE_UCNACKIE (0x0020)
#define EUSCI_B2_I2C_IE_UCNACKIE__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCNACKIE__1 (0x0020)
#define EUSCI_B2_I2C_IE_UCRXIE0 (0x0001)
#define EUSCI_B2_I2C_IE_UCRXIE0__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCRXIE0__1 (0x0001)
#define EUSCI_B2_I2C_IE_UCRXIE1 (0x0100)
#define EUSCI_B2_I2C_IE_UCRXIE1__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCRXIE1__1 (0x0100)
#define EUSCI_B2_I2C_IE_UCRXIE2 (0x0400)
#define EUSCI_B2_I2C_IE_UCRXIE2__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCRXIE2__1 (0x0400)
#define EUSCI_B2_I2C_IE_UCRXIE3 (0x1000)
#define EUSCI_B2_I2C_IE_UCRXIE3__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCRXIE3__1 (0x1000)
#define EUSCI_B2_I2C_IE_UCSTPIE (0x0008)
#define EUSCI_B2_I2C_IE_UCSTPIE__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCSTPIE__1 (0x0008)
#define EUSCI_B2_I2C_IE_UCSTTIE (0x0004)
#define EUSCI_B2_I2C_IE_UCSTTIE__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCSTTIE__1 (0x0004)
#define EUSCI_B2_I2C_IE_UCTXIE0 (0x0002)
#define EUSCI_B2_I2C_IE_UCTXIE0__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCTXIE0__1 (0x0002)
#define EUSCI_B2_I2C_IE_UCTXIE1 (0x0200)
#define EUSCI_B2_I2C_IE_UCTXIE1__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCTXIE1__1 (0x0200)
#define EUSCI_B2_I2C_IE_UCTXIE2 (0x0800)
#define EUSCI_B2_I2C_IE_UCTXIE2__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCTXIE2__1 (0x0800)
#define EUSCI_B2_I2C_IE_UCTXIE3 (0x2000)
#define EUSCI_B2_I2C_IE_UCTXIE3__0 (0x0000)
#define EUSCI_B2_I2C_IE_UCTXIE3__1 (0x2000)
#define EUSCI_B2_I2C_IFG (HWREG16(0x4000282C))
#define EUSCI_B2_I2C_IFG_UCALIFG (0x0010)
#define EUSCI_B2_I2C_IFG_UCALIFG__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCALIFG__1 (0x0010)
#define EUSCI_B2_I2C_IFG_UCBCNTIFG (0x0040)
#define EUSCI_B2_I2C_IFG_UCBCNTIFG__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCBCNTIFG__1 (0x0040)
#define EUSCI_B2_I2C_IFG_UCBIT9IFG (0x4000)
#define EUSCI_B2_I2C_IFG_UCBIT9IFG__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCBIT9IFG__1 (0x4000)
#define EUSCI_B2_I2C_IFG_UCCLTOIFG (0x0080)
#define EUSCI_B2_I2C_IFG_UCCLTOIFG__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCCLTOIFG__1 (0x0080)
#define EUSCI_B2_I2C_IFG_UCNACKIFG (0x0020)
#define EUSCI_B2_I2C_IFG_UCNACKIFG__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCNACKIFG__1 (0x0020)
#define EUSCI_B2_I2C_IFG_UCRXIFG0 (0x0001)
#define EUSCI_B2_I2C_IFG_UCRXIFG0__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCRXIFG0__1 (0x0001)
#define EUSCI_B2_I2C_IFG_UCRXIFG1 (0x0100)
#define EUSCI_B2_I2C_IFG_UCRXIFG1__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCRXIFG1__1 (0x0100)
#define EUSCI_B2_I2C_IFG_UCRXIFG2 (0x0400)
#define EUSCI_B2_I2C_IFG_UCRXIFG2__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCRXIFG2__1 (0x0400)
#define EUSCI_B2_I2C_IFG_UCRXIFG3 (0x1000)
#define EUSCI_B2_I2C_IFG_UCRXIFG3__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCRXIFG3__1 (0x1000)
#define EUSCI_B2_I2C_IFG_UCSTPIFG (0x0008)
#define EUSCI_B2_I2C_IFG_UCSTPIFG__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCSTPIFG__1 (0x0008)
#define EUSCI_B2_I2C_IFG_UCSTTIFG (0x0004)
#define EUSCI_B2_I2C_IFG_UCSTTIFG__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCSTTIFG__1 (0x0004)
#define EUSCI_B2_I2C_IFG_UCTXIFG0 (0x0002)
#define EUSCI_B2_I2C_IFG_UCTXIFG0__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCTXIFG0__1 (0x0002)
#define EUSCI_B2_I2C_IFG_UCTXIFG1 (0x0200)
#define EUSCI_B2_I2C_IFG_UCTXIFG1__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCTXIFG1__1 (0x0200)
#define EUSCI_B2_I2C_IFG_UCTXIFG2 (0x0800)
#define EUSCI_B2_I2C_IFG_UCTXIFG2__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCTXIFG2__1 (0x0800)
#define EUSCI_B2_I2C_IFG_UCTXIFG3 (0x2000)
#define EUSCI_B2_I2C_IFG_UCTXIFG3__0 (0x0000)
#define EUSCI_B2_I2C_IFG_UCTXIFG3__1 (0x2000)
#define EUSCI_B2_I2C_IV (HWREG16(0x4000282E))
#define EUSCI_B2_I2C_RXBUF (HWREG16(0x4000280C))
#define EUSCI_B2_I2C_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_B2_I2C_STATW (HWREG16(0x40002808))
#define EUSCI_B2_I2C_STATW_UCBBUSY (0x0010)
#define EUSCI_B2_I2C_STATW_UCBBUSY__0 (0x0000)
#define EUSCI_B2_I2C_STATW_UCBBUSY__0_BUS_INACTIVE (0x0000)
#define EUSCI_B2_I2C_STATW_UCBBUSY__1 (0x0010)
#define EUSCI_B2_I2C_STATW_UCBBUSY__1_BUS_BUSY (0x0010)
#define EUSCI_B2_I2C_STATW_UCBCNT__M (0xff00)
#define EUSCI_B2_I2C_STATW_UCGC (0x0020)
#define EUSCI_B2_I2C_STATW_UCGC__0 (0x0000)
#define EUSCI_B2_I2C_STATW_UCGC__1 (0x0020)
#define EUSCI_B2_I2C_STATW_UCSCLLOW (0x0040)
#define EUSCI_B2_I2C_STATW_UCSCLLOW__0 (0x0000)
#define EUSCI_B2_I2C_STATW_UCSCLLOW__1 (0x0040)
#define EUSCI_B2_I2C_STATW_UCSCLLOW__1_SCL_IS_HELD_LOW (0x0040)
#define EUSCI_B2_I2C_TBCNT (HWREG16(0x4000280A))
#define EUSCI_B2_I2C_TBCNT_UCTBCNT__M (0x00ff)
#define EUSCI_B2_I2C_TXBUF (HWREG16(0x4000280E))
#define EUSCI_B2_I2C_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_B2_SPI_BRW (HWREG16(0x40002806))
#define EUSCI_B2_SPI_CTLW0 (HWREG16(0x40002800))
#define EUSCI_B2_SPI_CTLW0_UC7BIT (0x1000)
#define EUSCI_B2_SPI_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_B2_SPI_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_B2_SPI_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_B2_SPI_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_B2_SPI_CTLW0_UCCKPH (0x8000)
#define EUSCI_B2_SPI_CTLW0_UCCKPH__0 (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCCKPH__1 (0x8000)
#define EUSCI_B2_SPI_CTLW0_UCCKPL (0x4000)
#define EUSCI_B2_SPI_CTLW0_UCCKPL__0 (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCCKPL__1 (0x4000)
#define EUSCI_B2_SPI_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_B2_SPI_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_B2_SPI_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_B2_SPI_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_B2_SPI_CTLW0_UCMODE__M (0x0600)
#define EUSCI_B2_SPI_CTLW0_UCMSB (0x2000)
#define EUSCI_B2_SPI_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_B2_SPI_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_B2_SPI_CTLW0_UCMST (0x0800)
#define EUSCI_B2_SPI_CTLW0_UCMST__0 (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCMST__1 (0x0800)
#define EUSCI_B2_SPI_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_B2_SPI_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_B2_SPI_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_B2_SPI_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_B2_SPI_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_B2_SPI_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_B2_SPI_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_B2_SPI_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_B2_SPI_CTLW0_UCSTEM (0x0002)
#define EUSCI_B2_SPI_CTLW0_UCSTEM__0 (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCSTEM__1 (0x0002)
#define EUSCI_B2_SPI_CTLW0_UCSWRST (0x0001)
#define EUSCI_B2_SPI_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_B2_SPI_CTLW0_UCSYNC (0x0100)
#define EUSCI_B2_SPI_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_B2_SPI_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_B2_SPI_IE (HWREG16(0x4000282A))
#define EUSCI_B2_SPI_IE_UCRXIE (0x0001)
#define EUSCI_B2_SPI_IE_UCRXIE__0 (0x0000)
#define EUSCI_B2_SPI_IE_UCRXIE__1 (0x0001)
#define EUSCI_B2_SPI_IE_UCTXIE (0x0002)
#define EUSCI_B2_SPI_IE_UCTXIE__0 (0x0000)
#define EUSCI_B2_SPI_IE_UCTXIE__1 (0x0002)
#define EUSCI_B2_SPI_IFG (HWREG16(0x4000282C))
#define EUSCI_B2_SPI_IFG_UCRXIFG (0x0001)
#define EUSCI_B2_SPI_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_B2_SPI_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_B2_SPI_IFG_UCTXIFG (0x0002)
#define EUSCI_B2_SPI_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_B2_SPI_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_B2_SPI_IV (HWREG16(0x4000282E))
#define EUSCI_B2_SPI_RXBUF (HWREG16(0x4000280C))
#define EUSCI_B2_SPI_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_B2_SPI_STATW (HWREG16(0x40002808))
#define EUSCI_B2_SPI_STATW_UCBUSY (0x0001)
#define EUSCI_B2_SPI_STATW_UCBUSY__0 (0x0000)
#define EUSCI_B2_SPI_STATW_UCBUSY__0_EUSCI_INACTIVE (0x0000)
#define EUSCI_B2_SPI_STATW_UCBUSY__1 (0x0001)
#define EUSCI_B2_SPI_STATW_UCFE (0x0040)
#define EUSCI_B2_SPI_STATW_UCFE__0 (0x0000)
#define EUSCI_B2_SPI_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_B2_SPI_STATW_UCFE__1 (0x0040)
#define EUSCI_B2_SPI_STATW_UCLISTEN (0x0080)
#define EUSCI_B2_SPI_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_B2_SPI_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_B2_SPI_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_B2_SPI_STATW_UCOE (0x0020)
#define EUSCI_B2_SPI_STATW_UCOE__0 (0x0000)
#define EUSCI_B2_SPI_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_B2_SPI_STATW_UCOE__1 (0x0020)
#define EUSCI_B2_SPI_TXBUF (HWREG16(0x4000280E))
#define EUSCI_B2_SPI_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_B3_I2C_ADDMASK (HWREG16(0x40002C1E))
#define EUSCI_B3_I2C_ADDMASK_ADDMASK__M (0x03ff)
#define EUSCI_B3_I2C_ADDRX (HWREG16(0x40002C1C))
#define EUSCI_B3_I2C_ADDRX_ADDRX__M (0x03ff)
#define EUSCI_B3_I2C_BRW (HWREG16(0x40002C06))
#define EUSCI_B3_I2C_CTLW0 (HWREG16(0x40002C00))
#define EUSCI_B3_I2C_CTLW0_UCA10 (0x8000)
#define EUSCI_B3_I2C_CTLW0_UCA10__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCA10__1 (0x8000)
#define EUSCI_B3_I2C_CTLW0_UCMM (0x2000)
#define EUSCI_B3_I2C_CTLW0_UCMM__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCMM__1 (0x2000)
#define EUSCI_B3_I2C_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_B3_I2C_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_B3_I2C_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_B3_I2C_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_B3_I2C_CTLW0_UCMODE__M (0x0600)
#define EUSCI_B3_I2C_CTLW0_UCMST (0x0800)
#define EUSCI_B3_I2C_CTLW0_UCMST__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCMST__1 (0x0800)
#define EUSCI_B3_I2C_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_B3_I2C_CTLW0_UCSLA10 (0x4000)
#define EUSCI_B3_I2C_CTLW0_UCSLA10__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCSLA10__1 (0x4000)
#define EUSCI_B3_I2C_CTLW0_UCSSEL__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCSSEL__0_UCLKI (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_B3_I2C_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_B3_I2C_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_B3_I2C_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_B3_I2C_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_B3_I2C_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_B3_I2C_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_B3_I2C_CTLW0_UCSWRST (0x0001)
#define EUSCI_B3_I2C_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_B3_I2C_CTLW0_UCSYNC (0x0100)
#define EUSCI_B3_I2C_CTLW0_UCTR (0x0010)
#define EUSCI_B3_I2C_CTLW0_UCTR__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCTR__0_RECEIVER (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCTR__1 (0x0010)
#define EUSCI_B3_I2C_CTLW0_UCTR__1_TRANSMITTER (0x0010)
#define EUSCI_B3_I2C_CTLW0_UCTXACK (0x0020)
#define EUSCI_B3_I2C_CTLW0_UCTXACK__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCTXACK__1 (0x0020)
#define EUSCI_B3_I2C_CTLW0_UCTXNACK (0x0008)
#define EUSCI_B3_I2C_CTLW0_UCTXNACK__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCTXNACK__1 (0x0008)
#define EUSCI_B3_I2C_CTLW0_UCTXNACK__1_GENERATE_NACK (0x0008)
#define EUSCI_B3_I2C_CTLW0_UCTXSTP (0x0004)
#define EUSCI_B3_I2C_CTLW0_UCTXSTP__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCTXSTP__1 (0x0004)
#define EUSCI_B3_I2C_CTLW0_UCTXSTP__1_GENERATE_STOP (0x0004)
#define EUSCI_B3_I2C_CTLW0_UCTXSTT (0x0002)
#define EUSCI_B3_I2C_CTLW0_UCTXSTT__0 (0x0000)
#define EUSCI_B3_I2C_CTLW0_UCTXSTT__1 (0x0002)
#define EUSCI_B3_I2C_CTLW1 (HWREG16(0x40002C02))
#define EUSCI_B3_I2C_CTLW1_UCASTP__0 (0x0000)
#define EUSCI_B3_I2C_CTLW1_UCASTP__1 (0x0004)
#define EUSCI_B3_I2C_CTLW1_UCASTP__2 (0x0008)
#define EUSCI_B3_I2C_CTLW1_UCASTP__M (0x000c)
#define EUSCI_B3_I2C_CTLW1_UCCLTO__0 (0x0000)
#define EUSCI_B3_I2C_CTLW1_UCCLTO__1 (0x0040)
#define EUSCI_B3_I2C_CTLW1_UCCLTO__2 (0x0080)
#define EUSCI_B3_I2C_CTLW1_UCCLTO__3 (0x00c0)
#define EUSCI_B3_I2C_CTLW1_UCCLTO__M (0x00c0)
#define EUSCI_B3_I2C_CTLW1_UCETXINT (0x0100)
#define EUSCI_B3_I2C_CTLW1_UCETXINT__0 (0x0000)
#define EUSCI_B3_I2C_CTLW1_UCETXINT__1 (0x0100)
#define EUSCI_B3_I2C_CTLW1_UCGLIT__0 (0x0000)
#define EUSCI_B3_I2C_CTLW1_UCGLIT__0_50_NS (0x0000)
#define EUSCI_B3_I2C_CTLW1_UCGLIT__1 (0x0001)
#define EUSCI_B3_I2C_CTLW1_UCGLIT__1_25_NS (0x0001)
#define EUSCI_B3_I2C_CTLW1_UCGLIT__2 (0x0002)
#define EUSCI_B3_I2C_CTLW1_UCGLIT__2_12_5_NS (0x0002)
#define EUSCI_B3_I2C_CTLW1_UCGLIT__3 (0x0003)
#define EUSCI_B3_I2C_CTLW1_UCGLIT__3_6_25_NS (0x0003)
#define EUSCI_B3_I2C_CTLW1_UCGLIT__M (0x0003)
#define EUSCI_B3_I2C_CTLW1_UCSTPNACK (0x0020)
#define EUSCI_B3_I2C_CTLW1_UCSTPNACK__0 (0x0000)
#define EUSCI_B3_I2C_CTLW1_UCSTPNACK__1 (0x0020)
#define EUSCI_B3_I2C_CTLW1_UCSWACK (0x0010)
#define EUSCI_B3_I2C_CTLW1_UCSWACK__0 (0x0000)
#define EUSCI_B3_I2C_CTLW1_UCSWACK__1 (0x0010)
#define EUSCI_B3_I2C_I2COA0 (HWREG16(0x40002C14))
#define EUSCI_B3_I2C_I2COA0_I2COA__M (0x03ff)
#define EUSCI_B3_I2C_I2COA0_UCGCEN (0x8000)
#define EUSCI_B3_I2C_I2COA0_UCGCEN__0 (0x0000)
#define EUSCI_B3_I2C_I2COA0_UCGCEN__1 (0x8000)
#define EUSCI_B3_I2C_I2COA0_UCOAEN (0x0400)
#define EUSCI_B3_I2C_I2COA0_UCOAEN__0 (0x0000)
#define EUSCI_B3_I2C_I2COA0_UCOAEN__1 (0x0400)
#define EUSCI_B3_I2C_I2COA1 (HWREG16(0x40002C16))
#define EUSCI_B3_I2C_I2COA1_I2COA1__M (0x03ff)
#define EUSCI_B3_I2C_I2COA1_UCOAEN (0x0400)
#define EUSCI_B3_I2C_I2COA1_UCOAEN__0 (0x0000)
#define EUSCI_B3_I2C_I2COA1_UCOAEN__1 (0x0400)
#define EUSCI_B3_I2C_I2COA2 (HWREG16(0x40002C18))
#define EUSCI_B3_I2C_I2COA2_I2COA2__M (0x03ff)
#define EUSCI_B3_I2C_I2COA2_UCOAEN (0x0400)
#define EUSCI_B3_I2C_I2COA2_UCOAEN__0 (0x0000)
#define EUSCI_B3_I2C_I2COA2_UCOAEN__1 (0x0400)
#define EUSCI_B3_I2C_I2COA3 (HWREG16(0x40002C1A))
#define EUSCI_B3_I2C_I2COA3_I2COA3__M (0x03ff)
#define EUSCI_B3_I2C_I2COA3_UCOAEN (0x0400)
#define EUSCI_B3_I2C_I2COA3_UCOAEN__0 (0x0000)
#define EUSCI_B3_I2C_I2COA3_UCOAEN__1 (0x0400)
#define EUSCI_B3_I2C_I2CSA (HWREG16(0x40002C20))
#define EUSCI_B3_I2C_I2CSA_I2CSA__M (0x03ff)
#define EUSCI_B3_I2C_IE (HWREG16(0x40002C2A))
#define EUSCI_B3_I2C_IE_UCALIE (0x0010)
#define EUSCI_B3_I2C_IE_UCALIE__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCALIE__1 (0x0010)
#define EUSCI_B3_I2C_IE_UCBCNTIE (0x0040)
#define EUSCI_B3_I2C_IE_UCBCNTIE__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCBCNTIE__1 (0x0040)
#define EUSCI_B3_I2C_IE_UCBIT9IE (0x4000)
#define EUSCI_B3_I2C_IE_UCBIT9IE__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCBIT9IE__1 (0x4000)
#define EUSCI_B3_I2C_IE_UCCLTOIE (0x0080)
#define EUSCI_B3_I2C_IE_UCCLTOIE__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCCLTOIE__1 (0x0080)
#define EUSCI_B3_I2C_IE_UCNACKIE (0x0020)
#define EUSCI_B3_I2C_IE_UCNACKIE__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCNACKIE__1 (0x0020)
#define EUSCI_B3_I2C_IE_UCRXIE0 (0x0001)
#define EUSCI_B3_I2C_IE_UCRXIE0__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCRXIE0__1 (0x0001)
#define EUSCI_B3_I2C_IE_UCRXIE1 (0x0100)
#define EUSCI_B3_I2C_IE_UCRXIE1__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCRXIE1__1 (0x0100)
#define EUSCI_B3_I2C_IE_UCRXIE2 (0x0400)
#define EUSCI_B3_I2C_IE_UCRXIE2__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCRXIE2__1 (0x0400)
#define EUSCI_B3_I2C_IE_UCRXIE3 (0x1000)
#define EUSCI_B3_I2C_IE_UCRXIE3__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCRXIE3__1 (0x1000)
#define EUSCI_B3_I2C_IE_UCSTPIE (0x0008)
#define EUSCI_B3_I2C_IE_UCSTPIE__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCSTPIE__1 (0x0008)
#define EUSCI_B3_I2C_IE_UCSTTIE (0x0004)
#define EUSCI_B3_I2C_IE_UCSTTIE__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCSTTIE__1 (0x0004)
#define EUSCI_B3_I2C_IE_UCTXIE0 (0x0002)
#define EUSCI_B3_I2C_IE_UCTXIE0__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCTXIE0__1 (0x0002)
#define EUSCI_B3_I2C_IE_UCTXIE1 (0x0200)
#define EUSCI_B3_I2C_IE_UCTXIE1__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCTXIE1__1 (0x0200)
#define EUSCI_B3_I2C_IE_UCTXIE2 (0x0800)
#define EUSCI_B3_I2C_IE_UCTXIE2__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCTXIE2__1 (0x0800)
#define EUSCI_B3_I2C_IE_UCTXIE3 (0x2000)
#define EUSCI_B3_I2C_IE_UCTXIE3__0 (0x0000)
#define EUSCI_B3_I2C_IE_UCTXIE3__1 (0x2000)
#define EUSCI_B3_I2C_IFG (HWREG16(0x40002C2C))
#define EUSCI_B3_I2C_IFG_UCALIFG (0x0010)
#define EUSCI_B3_I2C_IFG_UCALIFG__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCALIFG__1 (0x0010)
#define EUSCI_B3_I2C_IFG_UCBCNTIFG (0x0040)
#define EUSCI_B3_I2C_IFG_UCBCNTIFG__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCBCNTIFG__1 (0x0040)
#define EUSCI_B3_I2C_IFG_UCBIT9IFG (0x4000)
#define EUSCI_B3_I2C_IFG_UCBIT9IFG__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCBIT9IFG__1 (0x4000)
#define EUSCI_B3_I2C_IFG_UCCLTOIFG (0x0080)
#define EUSCI_B3_I2C_IFG_UCCLTOIFG__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCCLTOIFG__1 (0x0080)
#define EUSCI_B3_I2C_IFG_UCNACKIFG (0x0020)
#define EUSCI_B3_I2C_IFG_UCNACKIFG__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCNACKIFG__1 (0x0020)
#define EUSCI_B3_I2C_IFG_UCRXIFG0 (0x0001)
#define EUSCI_B3_I2C_IFG_UCRXIFG0__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCRXIFG0__1 (0x0001)
#define EUSCI_B3_I2C_IFG_UCRXIFG1 (0x0100)
#define EUSCI_B3_I2C_IFG_UCRXIFG1__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCRXIFG1__1 (0x0100)
#define EUSCI_B3_I2C_IFG_UCRXIFG2 (0x0400)
#define EUSCI_B3_I2C_IFG_UCRXIFG2__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCRXIFG2__1 (0x0400)
#define EUSCI_B3_I2C_IFG_UCRXIFG3 (0x1000)
#define EUSCI_B3_I2C_IFG_UCRXIFG3__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCRXIFG3__1 (0x1000)
#define EUSCI_B3_I2C_IFG_UCSTPIFG (0x0008)
#define EUSCI_B3_I2C_IFG_UCSTPIFG__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCSTPIFG__1 (0x0008)
#define EUSCI_B3_I2C_IFG_UCSTTIFG (0x0004)
#define EUSCI_B3_I2C_IFG_UCSTTIFG__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCSTTIFG__1 (0x0004)
#define EUSCI_B3_I2C_IFG_UCTXIFG0 (0x0002)
#define EUSCI_B3_I2C_IFG_UCTXIFG0__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCTXIFG0__1 (0x0002)
#define EUSCI_B3_I2C_IFG_UCTXIFG1 (0x0200)
#define EUSCI_B3_I2C_IFG_UCTXIFG1__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCTXIFG1__1 (0x0200)
#define EUSCI_B3_I2C_IFG_UCTXIFG2 (0x0800)
#define EUSCI_B3_I2C_IFG_UCTXIFG2__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCTXIFG2__1 (0x0800)
#define EUSCI_B3_I2C_IFG_UCTXIFG3 (0x2000)
#define EUSCI_B3_I2C_IFG_UCTXIFG3__0 (0x0000)
#define EUSCI_B3_I2C_IFG_UCTXIFG3__1 (0x2000)
#define EUSCI_B3_I2C_IV (HWREG16(0x40002C2E))
#define EUSCI_B3_I2C_RXBUF (HWREG16(0x40002C0C))
#define EUSCI_B3_I2C_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_B3_I2C_STATW (HWREG16(0x40002C08))
#define EUSCI_B3_I2C_STATW_UCBBUSY (0x0010)
#define EUSCI_B3_I2C_STATW_UCBBUSY__0 (0x0000)
#define EUSCI_B3_I2C_STATW_UCBBUSY__0_BUS_INACTIVE (0x0000)
#define EUSCI_B3_I2C_STATW_UCBBUSY__1 (0x0010)
#define EUSCI_B3_I2C_STATW_UCBBUSY__1_BUS_BUSY (0x0010)
#define EUSCI_B3_I2C_STATW_UCBCNT__M (0xff00)
#define EUSCI_B3_I2C_STATW_UCGC (0x0020)
#define EUSCI_B3_I2C_STATW_UCGC__0 (0x0000)
#define EUSCI_B3_I2C_STATW_UCGC__1 (0x0020)
#define EUSCI_B3_I2C_STATW_UCSCLLOW (0x0040)
#define EUSCI_B3_I2C_STATW_UCSCLLOW__0 (0x0000)
#define EUSCI_B3_I2C_STATW_UCSCLLOW__1 (0x0040)
#define EUSCI_B3_I2C_STATW_UCSCLLOW__1_SCL_IS_HELD_LOW (0x0040)
#define EUSCI_B3_I2C_TBCNT (HWREG16(0x40002C0A))
#define EUSCI_B3_I2C_TBCNT_UCTBCNT__M (0x00ff)
#define EUSCI_B3_I2C_TXBUF (HWREG16(0x40002C0E))
#define EUSCI_B3_I2C_TXBUF_UCTXBUF__M (0x00ff)
#define EUSCI_B3_SPI_BRW (HWREG16(0x40002C06))
#define EUSCI_B3_SPI_CTLW0 (HWREG16(0x40002C00))
#define EUSCI_B3_SPI_CTLW0_UC7BIT (0x1000)
#define EUSCI_B3_SPI_CTLW0_UC7BIT__0 (0x0000)
#define EUSCI_B3_SPI_CTLW0_UC7BIT__0_8_BIT_DATA (0x0000)
#define EUSCI_B3_SPI_CTLW0_UC7BIT__1 (0x1000)
#define EUSCI_B3_SPI_CTLW0_UC7BIT__1_7_BIT_DATA (0x1000)
#define EUSCI_B3_SPI_CTLW0_UCCKPH (0x8000)
#define EUSCI_B3_SPI_CTLW0_UCCKPH__0 (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCCKPH__1 (0x8000)
#define EUSCI_B3_SPI_CTLW0_UCCKPL (0x4000)
#define EUSCI_B3_SPI_CTLW0_UCCKPL__0 (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCCKPL__1 (0x4000)
#define EUSCI_B3_SPI_CTLW0_UCMODE__0 (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCMODE__0_3_PIN_SPI (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCMODE__1 (0x0200)
#define EUSCI_B3_SPI_CTLW0_UCMODE__2 (0x0400)
#define EUSCI_B3_SPI_CTLW0_UCMODE__3 (0x0600)
#define EUSCI_B3_SPI_CTLW0_UCMODE__3_I2C_MODE (0x0600)
#define EUSCI_B3_SPI_CTLW0_UCMODE__M (0x0600)
#define EUSCI_B3_SPI_CTLW0_UCMSB (0x2000)
#define EUSCI_B3_SPI_CTLW0_UCMSB__0 (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCMSB__0_LSB_FIRST (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCMSB__1 (0x2000)
#define EUSCI_B3_SPI_CTLW0_UCMSB__1_MSB_FIRST (0x2000)
#define EUSCI_B3_SPI_CTLW0_UCMST (0x0800)
#define EUSCI_B3_SPI_CTLW0_UCMST__0 (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCMST__0_SLAVE_MODE (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCMST__1 (0x0800)
#define EUSCI_B3_SPI_CTLW0_UCMST__1_MASTER_MODE (0x0800)
#define EUSCI_B3_SPI_CTLW0_UCSSEL__1 (0x0040)
#define EUSCI_B3_SPI_CTLW0_UCSSEL__1_ACLK (0x0040)
#define EUSCI_B3_SPI_CTLW0_UCSSEL__2 (0x0080)
#define EUSCI_B3_SPI_CTLW0_UCSSEL__2_SMCLK (0x0080)
#define EUSCI_B3_SPI_CTLW0_UCSSEL__3 (0x00c0)
#define EUSCI_B3_SPI_CTLW0_UCSSEL__3_SMCLK (0x00c0)
#define EUSCI_B3_SPI_CTLW0_UCSSEL__M (0x00c0)
#define EUSCI_B3_SPI_CTLW0_UCSTEM (0x0002)
#define EUSCI_B3_SPI_CTLW0_UCSTEM__0 (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCSTEM__1 (0x0002)
#define EUSCI_B3_SPI_CTLW0_UCSWRST (0x0001)
#define EUSCI_B3_SPI_CTLW0_UCSWRST__0 (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCSWRST__1 (0x0001)
#define EUSCI_B3_SPI_CTLW0_UCSYNC (0x0100)
#define EUSCI_B3_SPI_CTLW0_UCSYNC__0 (0x0000)
#define EUSCI_B3_SPI_CTLW0_UCSYNC__1 (0x0100)
#define EUSCI_B3_SPI_IE (HWREG16(0x40002C2A))
#define EUSCI_B3_SPI_IE_UCRXIE (0x0001)
#define EUSCI_B3_SPI_IE_UCRXIE__0 (0x0000)
#define EUSCI_B3_SPI_IE_UCRXIE__1 (0x0001)
#define EUSCI_B3_SPI_IE_UCTXIE (0x0002)
#define EUSCI_B3_SPI_IE_UCTXIE__0 (0x0000)
#define EUSCI_B3_SPI_IE_UCTXIE__1 (0x0002)
#define EUSCI_B3_SPI_IFG (HWREG16(0x40002C2C))
#define EUSCI_B3_SPI_IFG_UCRXIFG (0x0001)
#define EUSCI_B3_SPI_IFG_UCRXIFG__0 (0x0000)
#define EUSCI_B3_SPI_IFG_UCRXIFG__1 (0x0001)
#define EUSCI_B3_SPI_IFG_UCTXIFG (0x0002)
#define EUSCI_B3_SPI_IFG_UCTXIFG__0 (0x0000)
#define EUSCI_B3_SPI_IFG_UCTXIFG__1 (0x0002)
#define EUSCI_B3_SPI_IV (HWREG16(0x40002C2E))
#define EUSCI_B3_SPI_RXBUF (HWREG16(0x40002C0C))
#define EUSCI_B3_SPI_RXBUF_UCRXBUF__M (0x00ff)
#define EUSCI_B3_SPI_STATW (HWREG16(0x40002C08))
#define EUSCI_B3_SPI_STATW_UCBUSY (0x0001)
#define EUSCI_B3_SPI_STATW_UCBUSY__0 (0x0000)
#define EUSCI_B3_SPI_STATW_UCBUSY__0_EUSCI_INACTIVE (0x0000)
#define EUSCI_B3_SPI_STATW_UCBUSY__1 (0x0001)
#define EUSCI_B3_SPI_STATW_UCFE (0x0040)
#define EUSCI_B3_SPI_STATW_UCFE__0 (0x0000)
#define EUSCI_B3_SPI_STATW_UCFE__0_NO_ERROR (0x0000)
#define EUSCI_B3_SPI_STATW_UCFE__1 (0x0040)
#define EUSCI_B3_SPI_STATW_UCLISTEN (0x0080)
#define EUSCI_B3_SPI_STATW_UCLISTEN__0 (0x0000)
#define EUSCI_B3_SPI_STATW_UCLISTEN__0_DISABLED (0x0000)
#define EUSCI_B3_SPI_STATW_UCLISTEN__1 (0x0080)
#define EUSCI_B3_SPI_STATW_UCOE (0x0020)
#define EUSCI_B3_SPI_STATW_UCOE__0 (0x0000)
#define EUSCI_B3_SPI_STATW_UCOE__0_NO_ERROR (0x0000)
#define EUSCI_B3_SPI_STATW_UCOE__1 (0x0020)
#define EUSCI_B3_SPI_TXBUF (HWREG16(0x40002C0E))
#define EUSCI_B3_SPI_TXBUF_UCTXBUF__M (0x00ff)
#define FCNTHF2__0 (0x00000000)
#define FCNTHF2__1 (0x00000100)
#define FCNTHF2__2 (0x00000200)
#define FCNTHF2__3 (0x00000300)
#define FCNTHF__0 (0x00000000)
#define FCNTHF__1 (0x00000010)
#define FCNTHF__2 (0x00000020)
#define FCNTHF__3 (0x00000030)
#define FCNTLF__0 (0x00000000)
#define FCNTLF__1 (0x00000001)
#define FCNTLF__2 (0x00000002)
#define FCNTLF__3 (0x00000003)
#define FLCTL_BMRK_CTLSTAT_CMP_SEL__0 (0x00000000)
#define FLCTL_BMRK_CTLSTAT_CMP_SEL__1 (0x00000008)
#define FLCTL_ERASE_CTLSTAT_MODE__0 (0x00000000)
#define FLCTL_ERASE_CTLSTAT_MODE__1 (0x00000002)
#define FLCTL_ERASE_CTLSTAT_STATUS__0 (0x00000000)
#define FLCTL_ERASE_CTLSTAT_STATUS__1 (0x00010000)
#define FLCTL_ERASE_CTLSTAT_STATUS__2 (0x00020000)
#define FLCTL_ERASE_CTLSTAT_STATUS__3 (0x00030000)
#define FLCTL_ERASE_CTLSTAT_STATUS__M (0x00030000)
#define FLCTL_ERASE_CTLSTAT_TYPE__0 (0x00000000)
#define FLCTL_ERASE_CTLSTAT_TYPE__0_USER (0x00000000)
#define FLCTL_ERASE_CTLSTAT_TYPE__1 (0x00000004)
#define FLCTL_ERASE_CTLSTAT_TYPE__1_INFO (0x00000004)
#define FLCTL_ERASE_CTLSTAT_TYPE__3 (0x0000000c)
#define FLCTL_ERASE_CTLSTAT_TYPE__3_ENGR (0x0000000c)
#define FLCTL_ERASE_CTLSTAT_TYPE__M (0x0000000c)
#define FLCTL_ERASE_SECTADDR_SECT_ADDRESS__M (0x003fffff)
#define FLCTL_ERASE_TIMCTL_ACTIVE__M (0x0fffff00)
#define FLCTL_ERASE_TIMCTL_HOLD__M (0xf0000000)
#define FLCTL_ERASE_TIMCTL_SETUP__M (0x000000ff)
#define FLCTL_ERSVER_TIMCTL_SETUP__M (0x000000ff)
#define FLCTL_LKGVER_TIMCTL_SETUP__M (0x000000ff)
#define FLCTL_MASSERASE_TIMCTL_BOOST_ACTIVE__M (0x000000ff)
#define FLCTL_MASSERASE_TIMCTL_BOOST_HOLD__M (0x0000ff00)
#define FLCTL_PRGBRST_CTLSTAT_AUTO_PRE__0 (0x00000000)
#define FLCTL_PRGBRST_CTLSTAT_AUTO_PRE__1 (0x00000040)
#define FLCTL_PRGBRST_CTLSTAT_AUTO_PST__0 (0x00000000)
#define FLCTL_PRGBRST_CTLSTAT_AUTO_PST__1 (0x00000080)
#define FLCTL_PRGBRST_CTLSTAT_BURST_STATUS__0 (0x00000000)
#define FLCTL_PRGBRST_CTLSTAT_BURST_STATUS__1 (0x00010000)
#define FLCTL_PRGBRST_CTLSTAT_BURST_STATUS__2 (0x00020000)
#define FLCTL_PRGBRST_CTLSTAT_BURST_STATUS__3 (0x00030000)
#define FLCTL_PRGBRST_CTLSTAT_BURST_STATUS__4 (0x00040000)
#define FLCTL_PRGBRST_CTLSTAT_BURST_STATUS__5 (0x00050000)
#define FLCTL_PRGBRST_CTLSTAT_BURST_STATUS__7 (0x00070000)
#define FLCTL_PRGBRST_CTLSTAT_BURST_STATUS__M (0x00070000)
#define FLCTL_PRGBRST_CTLSTAT_LEN__0 (0x00000000)
#define FLCTL_PRGBRST_CTLSTAT_LEN__1 (0x00000008)
#define FLCTL_PRGBRST_CTLSTAT_LEN__2 (0x00000010)
#define FLCTL_PRGBRST_CTLSTAT_LEN__3 (0x00000018)
#define FLCTL_PRGBRST_CTLSTAT_LEN__4 (0x00000020)
#define FLCTL_PRGBRST_CTLSTAT_LEN__5 (0x00000028)
#define FLCTL_PRGBRST_CTLSTAT_LEN__6 (0x00000030)
#define FLCTL_PRGBRST_CTLSTAT_LEN__7 (0x00000038)
#define FLCTL_PRGBRST_CTLSTAT_LEN__M (0x00000038)
#define FLCTL_PRGBRST_CTLSTAT_TYPE__0 (0x00000000)
#define FLCTL_PRGBRST_CTLSTAT_TYPE__0_USER (0x00000000)
#define FLCTL_PRGBRST_CTLSTAT_TYPE__1 (0x00000002)
#define FLCTL_PRGBRST_CTLSTAT_TYPE__1_INFO (0x00000002)
#define FLCTL_PRGBRST_CTLSTAT_TYPE__3 (0x00000006)
#define FLCTL_PRGBRST_CTLSTAT_TYPE__3_ENGR (0x00000006)
#define FLCTL_PRGBRST_CTLSTAT_TYPE__M (0x00000006)
#define FLCTL_PRGBRST_STARTADDR_START_ADDRESS__M (0x003fffff)
#define FLCTL_PRGVER_TIMCTL_ACTIVE__M (0x00000f00)
#define FLCTL_PRGVER_TIMCTL_HOLD__M (0x0000f000)
#define FLCTL_PRGVER_TIMCTL_SETUP__M (0x000000ff)
#define FLCTL_PRG_CTLSTAT_BNK_ACT__0 (0x00000000)
#define FLCTL_PRG_CTLSTAT_BNK_ACT__1 (0x00040000)
#define FLCTL_PRG_CTLSTAT_ENABLE__0 (0x00000000)
#define FLCTL_PRG_CTLSTAT_ENABLE__1 (0x00000001)
#define FLCTL_PRG_CTLSTAT_MODE__0 (0x00000000)
#define FLCTL_PRG_CTLSTAT_MODE__1 (0x00000002)
#define FLCTL_PRG_CTLSTAT_STATUS__0 (0x00000000)
#define FLCTL_PRG_CTLSTAT_STATUS__1 (0x00010000)
#define FLCTL_PRG_CTLSTAT_STATUS__2 (0x00020000)
#define FLCTL_PRG_CTLSTAT_STATUS__M (0x00030000)
#define FLCTL_PRG_CTLSTAT_VER_PRE__0 (0x00000000)
#define FLCTL_PRG_CTLSTAT_VER_PRE__1 (0x00000004)
#define FLCTL_PRG_CTLSTAT_VER_PST__0 (0x00000000)
#define FLCTL_PRG_CTLSTAT_VER_PST__1 (0x00000008)
#define FLCTL_PROGRAM_TIMCTL_ACTIVE__M (0x0fffff00)
#define FLCTL_PROGRAM_TIMCTL_HOLD__M (0xf0000000)
#define FLCTL_PROGRAM_TIMCTL_SETUP__M (0x000000ff)
#define FLCTL_PWRSTAT_IREFSTAT__0 (0x00000000)
#define FLCTL_PWRSTAT_IREFSTAT__0_IREF_NOT_STABLE (0x00000000)
#define FLCTL_PWRSTAT_IREFSTAT__1 (0x00000020)
#define FLCTL_PWRSTAT_IREFSTAT__1_IREF_STABLE (0x00000020)
#define FLCTL_PWRSTAT_LDOSTAT__0 (0x00000000)
#define FLCTL_PWRSTAT_LDOSTAT__0_FLDO_NOT_GOOD (0x00000000)
#define FLCTL_PWRSTAT_LDOSTAT__1 (0x00000008)
#define FLCTL_PWRSTAT_LDOSTAT__1_FLDO_GOOD (0x00000008)
#define FLCTL_PWRSTAT_PSTAT__0 (0x00000000)
#define FLCTL_PWRSTAT_PSTAT__1 (0x00000001)
#define FLCTL_PWRSTAT_PSTAT__2 (0x00000002)
#define FLCTL_PWRSTAT_PSTAT__3 (0x00000003)
#define FLCTL_PWRSTAT_PSTAT__4 (0x00000004)
#define FLCTL_PWRSTAT_PSTAT__4_FLASH_IP_ACTIVE (0x00000004)
#define FLCTL_PWRSTAT_PSTAT__5 (0x00000005)
#define FLCTL_PWRSTAT_PSTAT__6 (0x00000006)
#define FLCTL_PWRSTAT_PSTAT__7 (0x00000007)
#define FLCTL_PWRSTAT_PSTAT__M (0x00000007)
#define FLCTL_PWRSTAT_RD_2T__0 (0x00000000)
#define FLCTL_PWRSTAT_RD_2T__1 (0x00000080)
#define FLCTL_PWRSTAT_TRIMSTAT__0 (0x00000000)
#define FLCTL_PWRSTAT_TRIMSTAT__1 (0x00000040)
#define FLCTL_PWRSTAT_VREFSTAT__0 (0x00000000)
#define FLCTL_PWRSTAT_VREFSTAT__1 (0x00000010)
#define FLCTL_RDBRST_CTLSTAT_BRST_STAT__0 (0x00000000)
#define FLCTL_RDBRST_CTLSTAT_BRST_STAT__0_IDLE (0x00000000)
#define FLCTL_RDBRST_CTLSTAT_BRST_STAT__1 (0x00010000)
#define FLCTL_RDBRST_CTLSTAT_BRST_STAT__2 (0x00020000)
#define FLCTL_RDBRST_CTLSTAT_BRST_STAT__3 (0x00030000)
#define FLCTL_RDBRST_CTLSTAT_BRST_STAT__M (0x00030000)
#define FLCTL_RDBRST_CTLSTAT_DATA_CMP__0 (0x00000000)
#define FLCTL_RDBRST_CTLSTAT_DATA_CMP__1 (0x00000010)
#define FLCTL_RDBRST_CTLSTAT_MEM_TYPE__0 (0x00000000)
#define FLCTL_RDBRST_CTLSTAT_MEM_TYPE__0_USER (0x00000000)
#define FLCTL_RDBRST_CTLSTAT_MEM_TYPE__1 (0x00000002)
#define FLCTL_RDBRST_CTLSTAT_MEM_TYPE__1_INFO (0x00000002)
#define FLCTL_RDBRST_CTLSTAT_MEM_TYPE__3 (0x00000006)
#define FLCTL_RDBRST_CTLSTAT_MEM_TYPE__3_ENGR (0x00000006)
#define FLCTL_RDBRST_CTLSTAT_MEM_TYPE__M (0x00000006)
#define FLCTL_RDBRST_FAILADDR_FAIL_ADDRESS__M (0x001fffff)
#define FLCTL_RDBRST_FAILCNT_FAIL_COUNT__M (0x0001ffff)
#define FLCTL_RDBRST_LEN_BURST_LENGTH__M (0x001fffff)
#define FLCTL_RDBRST_STARTADDR_START_ADDRESS__M (0x001fffff)
#define FLCTL_RDCTL_BNK0_INFO_PARD__0 (0x00000000)
#define FLCTL_RDCTL_BNK0_INFO_PARD__1 (0x00000200)
#define FLCTL_RDCTL_BNK0_INFO_PARI__0 (0x00000000)
#define FLCTL_RDCTL_BNK0_INFO_PARI__1 (0x00000100)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__0 (0x00000000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__1 (0x00010000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__1_READ_MARGIN_0 (0x00010000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__2 (0x00020000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__2_READ_MARGIN_1 (0x00020000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__3 (0x00030000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__3_PROGRAM_VERIFY (0x00030000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__4 (0x00040000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__4_ERASE_VERIFY (0x00040000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__5 (0x00050000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__5_LEAKAGE_VERIFY (0x00050000)
#define FLCTL_RDCTL_BNK0_RD_MODE_STATUS__M (0x000f0000)
#define FLCTL_RDCTL_BNK0_RD_MODE__0 (0x00000000)
#define FLCTL_RDCTL_BNK0_RD_MODE__1 (0x00000001)
#define FLCTL_RDCTL_BNK0_RD_MODE__1_READ_MARGIN_0 (0x00000001)
#define FLCTL_RDCTL_BNK0_RD_MODE__2 (0x00000002)
#define FLCTL_RDCTL_BNK0_RD_MODE__2_READ_MARGIN_1 (0x00000002)
#define FLCTL_RDCTL_BNK0_RD_MODE__3 (0x00000003)
#define FLCTL_RDCTL_BNK0_RD_MODE__3_PROGRAM_VERIFY (0x00000003)
#define FLCTL_RDCTL_BNK0_RD_MODE__4 (0x00000004)
#define FLCTL_RDCTL_BNK0_RD_MODE__4_ERASE_VERIFY (0x00000004)
#define FLCTL_RDCTL_BNK0_RD_MODE__5 (0x00000005)
#define FLCTL_RDCTL_BNK0_RD_MODE__5_LEAKAGE_VERIFY (0x00000005)
#define FLCTL_RDCTL_BNK0_RD_MODE__M (0x0000000f)
#define FLCTL_RDCTL_BNK0_USR_PARD__0 (0x00000000)
#define FLCTL_RDCTL_BNK0_USR_PARD__1 (0x00000800)
#define FLCTL_RDCTL_BNK0_USR_PARI__0 (0x00000000)
#define FLCTL_RDCTL_BNK0_USR_PARI__1 (0x00000400)
#define FLCTL_RDCTL_BNK0_WAIT__M (0x0000f000)
#define FLCTL_RDCTL_BNK1_INFO_PARD__0 (0x00000000)
#define FLCTL_RDCTL_BNK1_INFO_PARD__1 (0x00000200)
#define FLCTL_RDCTL_BNK1_INFO_PARI__0 (0x00000000)
#define FLCTL_RDCTL_BNK1_INFO_PARI__1 (0x00000100)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__0 (0x00000000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__1 (0x00010000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__1_READ_MARGIN_0 (0x00010000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__2 (0x00020000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__2_READ_MARGIN_1 (0x00020000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__3 (0x00030000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__3_PROGRAM_VERIFY (0x00030000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__4 (0x00040000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__4_ERASE_VERIFY (0x00040000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__5 (0x00050000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__5_LEAKAGE_VERIFY (0x00050000)
#define FLCTL_RDCTL_BNK1_RD_MODE_STATUS__M (0x000f0000)
#define FLCTL_RDCTL_BNK1_RD_MODE__0 (0x00000000)
#define FLCTL_RDCTL_BNK1_RD_MODE__1 (0x00000001)
#define FLCTL_RDCTL_BNK1_RD_MODE__1_READ_MARGIN_0 (0x00000001)
#define FLCTL_RDCTL_BNK1_RD_MODE__2 (0x00000002)
#define FLCTL_RDCTL_BNK1_RD_MODE__2_READ_MARGIN_1 (0x00000002)
#define FLCTL_RDCTL_BNK1_RD_MODE__3 (0x00000003)
#define FLCTL_RDCTL_BNK1_RD_MODE__3_PROGRAM_VERIFY (0x00000003)
#define FLCTL_RDCTL_BNK1_RD_MODE__4 (0x00000004)
#define FLCTL_RDCTL_BNK1_RD_MODE__4_ERASE_VERIFY (0x00000004)
#define FLCTL_RDCTL_BNK1_RD_MODE__5 (0x00000005)
#define FLCTL_RDCTL_BNK1_RD_MODE__5_LEAKAGE_VERIFY (0x00000005)
#define FLCTL_RDCTL_BNK1_RD_MODE__M (0x0000000f)
#define FLCTL_RDCTL_BNK1_USR_PARD__0 (0x00000000)
#define FLCTL_RDCTL_BNK1_USR_PARD__1 (0x00000800)
#define FLCTL_RDCTL_BNK1_USR_PARI__0 (0x00000000)
#define FLCTL_RDCTL_BNK1_USR_PARI__1 (0x00000400)
#define FLCTL_RDCTL_BNK1_WAIT__M (0x0000f000)
#define FLCTL_READMARGIN_TIMCTL_SETUP__M (0x000000ff)
#define FLCTL_READ_TIMCTL_IREF_BOOST1__M (0x0000f000)
#define FLCTL_READ_TIMCTL_SETUP_LONG__M (0x00ff0000)
#define FLCTL_READ_TIMCTL_SETUP__M (0x000000ff)
#define FPB_FP_COMP0_COMP__M (0x1ffffffc)
#define FPB_FP_COMP0_ENABLE__0 (0x00000000)
#define FPB_FP_COMP0_ENABLE__1 (0x00000001)
#define FPB_FP_COMP0_REPLACE__0 (0x00000000)
#define FPB_FP_COMP0_REPLACE__1 (0x40000000)
#define FPB_FP_COMP0_REPLACE__2 (0x80000000)
#define FPB_FP_COMP0_REPLACE__3 (0xc0000000)
#define FPB_FP_COMP0_REPLACE__M (0xc0000000)
#define FPB_FP_COMP1_COMP__M (0x1ffffffc)
#define FPB_FP_COMP1_ENABLE__0 (0x00000000)
#define FPB_FP_COMP1_ENABLE__1 (0x00000001)
#define FPB_FP_COMP1_REPLACE__0 (0x00000000)
#define FPB_FP_COMP1_REPLACE__1 (0x40000000)
#define FPB_FP_COMP1_REPLACE__2 (0x80000000)
#define FPB_FP_COMP1_REPLACE__3 (0xc0000000)
#define FPB_FP_COMP1_REPLACE__M (0xc0000000)
#define FPB_FP_COMP2_COMP__M (0x1ffffffc)
#define FPB_FP_COMP2_ENABLE__0 (0x00000000)
#define FPB_FP_COMP2_ENABLE__1 (0x00000001)
#define FPB_FP_COMP2_REPLACE__0 (0x00000000)
#define FPB_FP_COMP2_REPLACE__1 (0x40000000)
#define FPB_FP_COMP2_REPLACE__2 (0x80000000)
#define FPB_FP_COMP2_REPLACE__3 (0xc0000000)
#define FPB_FP_COMP2_REPLACE__M (0xc0000000)
#define FPB_FP_COMP3_COMP__M (0x1ffffffc)
#define FPB_FP_COMP3_ENABLE__0 (0x00000000)
#define FPB_FP_COMP3_ENABLE__1 (0x00000001)
#define FPB_FP_COMP3_REPLACE__0 (0x00000000)
#define FPB_FP_COMP3_REPLACE__1 (0x40000000)
#define FPB_FP_COMP3_REPLACE__2 (0x80000000)
#define FPB_FP_COMP3_REPLACE__3 (0xc0000000)
#define FPB_FP_COMP3_REPLACE__M (0xc0000000)
#define FPB_FP_COMP4_COMP__M (0x1ffffffc)
#define FPB_FP_COMP4_ENABLE__0 (0x00000000)
#define FPB_FP_COMP4_ENABLE__1 (0x00000001)
#define FPB_FP_COMP4_REPLACE__0 (0x00000000)
#define FPB_FP_COMP4_REPLACE__1 (0x40000000)
#define FPB_FP_COMP4_REPLACE__2 (0x80000000)
#define FPB_FP_COMP4_REPLACE__3 (0xc0000000)
#define FPB_FP_COMP4_REPLACE__M (0xc0000000)
#define FPB_FP_COMP5_COMP__M (0x1ffffffc)
#define FPB_FP_COMP5_ENABLE__0 (0x00000000)
#define FPB_FP_COMP5_ENABLE__1 (0x00000001)
#define FPB_FP_COMP5_REPLACE__0 (0x00000000)
#define FPB_FP_COMP5_REPLACE__1 (0x40000000)
#define FPB_FP_COMP5_REPLACE__2 (0x80000000)
#define FPB_FP_COMP5_REPLACE__3 (0xc0000000)
#define FPB_FP_COMP5_REPLACE__M (0xc0000000)
#define FPB_FP_COMP6_COMP__M (0x1ffffffc)
#define FPB_FP_COMP6_ENABLE__0 (0x00000000)
#define FPB_FP_COMP6_ENABLE__1 (0x00000001)
#define FPB_FP_COMP6_REPLACE__0 (0x00000000)
#define FPB_FP_COMP6_REPLACE__1 (0x40000000)
#define FPB_FP_COMP6_REPLACE__2 (0x80000000)
#define FPB_FP_COMP6_REPLACE__3 (0xc0000000)
#define FPB_FP_COMP6_REPLACE__M (0xc0000000)
#define FPB_FP_COMP7_COMP__M (0x1ffffffc)
#define FPB_FP_COMP7_ENABLE__0 (0x00000000)
#define FPB_FP_COMP7_ENABLE__1 (0x00000001)
#define FPB_FP_COMP7_REPLACE__0 (0x00000000)
#define FPB_FP_COMP7_REPLACE__1 (0x40000000)
#define FPB_FP_COMP7_REPLACE__2 (0x80000000)
#define FPB_FP_COMP7_REPLACE__3 (0xc0000000)
#define FPB_FP_COMP7_REPLACE__M (0xc0000000)
#define FPB_FP_CTRL_ENABLE__0 (0x00000000)
#define FPB_FP_CTRL_ENABLE__1 (0x00000001)
#define FPB_FP_CTRL_NUM_CODE1__0 (0x00000000)
#define FPB_FP_CTRL_NUM_CODE1__0_NO_CODE_SLOTS (0x00000000)
#define FPB_FP_CTRL_NUM_CODE1__2 (0x00000020)
#define FPB_FP_CTRL_NUM_CODE1__2_TWO_CODE_SLOTS (0x00000020)
#define FPB_FP_CTRL_NUM_CODE1__6 (0x00000060)
#define FPB_FP_CTRL_NUM_CODE1__6_SIX_CODE_SLOTS (0x00000060)
#define FPB_FP_CTRL_NUM_CODE1__M (0x000000f0)
#define FPB_FP_CTRL_NUM_CODE2__M (0x00003000)
#define FPB_FP_CTRL_NUM_LIT__0 (0x00000000)
#define FPB_FP_CTRL_NUM_LIT__2 (0x00000200)
#define FPB_FP_CTRL_NUM_LIT__M (0x00000f00)
#define FPB_FP_REMAP_REMAP__M (0x1fffffe0)
#define FPU_CPACR_CP10__M (0x00300000)
#define FPU_CPACR_CP11__M (0x00c00000)
#define FPU_FPCAR_ADDRESS__M (0x7ffffffc)
#define FPU_FPDSCR_RMODE__M (0x00c00000)
#define FPU_MVFR0_A_SIMD_REGISTERS__M (0x0000000f)
#define FPU_MVFR0_DIVIDE__M (0x000f0000)
#define FPU_MVFR0_DOUBLE_PRECISION__M (0x00000f00)
#define FPU_MVFR0_FP_ECEPTION_TRAPPING__M (0x0000f000)
#define FPU_MVFR0_FP_ROUNDING_MODES__M (0xf0000000)
#define FPU_MVFR0_SHORT_VECTORS__M (0x0f000000)
#define FPU_MVFR0_SINGLE_PRECISION__M (0x000000f0)
#define FPU_MVFR0_SQUARE_ROOT__M (0x00f00000)
#define FPU_MVFR1_D_NAN_MODE__M (0x000000f0)
#define FPU_MVFR1_FP_FUSED_MAC__M (0xf0000000)
#define FPU_MVFR1_FP_HPFP__M (0x0f000000)
#define FPU_MVFR1_FTZ_MODE__M (0x0000000f)
#define HFXT2DRIVE (0x00000001)
#define HFXT2FREQ__0 (0x00000000)
#define HFXT2FREQ__1 (0x00000010)
#define HFXT2FREQ__2 (0x00000020)
#define HFXT2FREQ__3 (0x00000030)
#define HFXT2FREQ__4 (0x00000040)
#define HFXT2FREQ__5 (0x00000050)
#define HFXT2FREQ__6 (0x00000060)
#define HFXT2FREQ__7 (0x00000070)
#define HFXTFREQ__0 (0x00000000)
#define HFXTFREQ__1 (0x00100000)
#define HFXTFREQ__2 (0x00200000)
#define HFXTFREQ__3 (0x00300000)
#define HFXTFREQ__4 (0x00400000)
#define HFXTFREQ__5 (0x00500000)
#define HFXTFREQ__6 (0x00600000)
#define HFXTFREQ__7 (0x00700000)
#define ID0 (0x0040)
#define ID1 (0x0080)
#define ITM_ITM_IMCR (HWREG32(0xE0000F00))
#define ITM_ITM_IMCR_INTEGRATION (0x00000001)
#define ITM_ITM_IMCR_INTEGRATION__0 (0x00000000)
#define ITM_ITM_IMCR_INTEGRATION__0_ATVALIDM_NORMAL (0x00000000)
#define ITM_ITM_IMCR_INTEGRATION__1 (0x00000001)
#define ITM_ITM_IWR (HWREG32(0xE0000EF8))
#define ITM_ITM_IWR_ATVALIDM (0x00000001)
#define ITM_ITM_IWR_ATVALIDM__0 (0x00000000)
#define ITM_ITM_IWR_ATVALIDM__0_ATVALIDM_CLEAR (0x00000000)
#define ITM_ITM_IWR_ATVALIDM__1 (0x00000001)
#define ITM_ITM_IWR_ATVALIDM__1_ATVALIDM_SET (0x00000001)
#define ITM_ITM_LAR (HWREG32(0xE0000FB0))
#define ITM_ITM_LSR (HWREG32(0xE0000FB4))
#define ITM_ITM_LSR_ACCESS (0x00000002)
#define ITM_ITM_LSR_BYTEACC (0x00000004)
#define ITM_ITM_LSR_PRESENT (0x00000001)
#define ITM_ITM_STIM0 (HWREG32(0xE0000000))
#define ITM_ITM_STIM1 (HWREG32(0xE0000004))
#define ITM_ITM_STIM10 (HWREG32(0xE0000028))
#define ITM_ITM_STIM11 (HWREG32(0xE000002C))
#define ITM_ITM_STIM12 (HWREG32(0xE0000030))
#define ITM_ITM_STIM13 (HWREG32(0xE0000034))
#define ITM_ITM_STIM14 (HWREG32(0xE0000038))
#define ITM_ITM_STIM15 (HWREG32(0xE000003C))
#define ITM_ITM_STIM16 (HWREG32(0xE0000040))
#define ITM_ITM_STIM17 (HWREG32(0xE0000044))
#define ITM_ITM_STIM18 (HWREG32(0xE0000048))
#define ITM_ITM_STIM19 (HWREG32(0xE000004C))
#define ITM_ITM_STIM2 (HWREG32(0xE0000008))
#define ITM_ITM_STIM20 (HWREG32(0xE0000050))
#define ITM_ITM_STIM21 (HWREG32(0xE0000054))
#define ITM_ITM_STIM22 (HWREG32(0xE0000058))
#define ITM_ITM_STIM23 (HWREG32(0xE000005C))
#define ITM_ITM_STIM24 (HWREG32(0xE0000060))
#define ITM_ITM_STIM25 (HWREG32(0xE0000064))
#define ITM_ITM_STIM26 (HWREG32(0xE0000068))
#define ITM_ITM_STIM27 (HWREG32(0xE000006C))
#define ITM_ITM_STIM28 (HWREG32(0xE0000070))
#define ITM_ITM_STIM29 (HWREG32(0xE0000074))
#define ITM_ITM_STIM3 (HWREG32(0xE000000C))
#define ITM_ITM_STIM30 (HWREG32(0xE0000078))
#define ITM_ITM_STIM31 (HWREG32(0xE000007C))
#define ITM_ITM_STIM4 (HWREG32(0xE0000010))
#define ITM_ITM_STIM5 (HWREG32(0xE0000014))
#define ITM_ITM_STIM6 (HWREG32(0xE0000018))
#define ITM_ITM_STIM7 (HWREG32(0xE000001C))
#define ITM_ITM_STIM8 (HWREG32(0xE0000020))
#define ITM_ITM_STIM9 (HWREG32(0xE0000024))
#define ITM_ITM_TCR (HWREG32(0xE0000E80))
#define ITM_ITM_TCR_ATBID__M (0x007f0000)
#define ITM_ITM_TCR_BUSY (0x00800000)
#define ITM_ITM_TCR_DWTENA (0x00000008)
#define ITM_ITM_TCR_ITMENA (0x00000001)
#define ITM_ITM_TCR_SWOENA (0x00000010)
#define ITM_ITM_TCR_SYNCENA (0x00000004)
#define ITM_ITM_TCR_TSENA (0x00000002)
#define ITM_ITM_TCR_TSPRESCALE__0 (0x00000000)
#define ITM_ITM_TCR_TSPRESCALE__0_NO_PRESCALING (0x00000000)
#define ITM_ITM_TCR_TSPRESCALE__1 (0x00000100)
#define ITM_ITM_TCR_TSPRESCALE__1_DIVIDE_BY_4 (0x00000100)
#define ITM_ITM_TCR_TSPRESCALE__2 (0x00000200)
#define ITM_ITM_TCR_TSPRESCALE__2_DIVIDE_BY_16 (0x00000200)
#define ITM_ITM_TCR_TSPRESCALE__3 (0x00000300)
#define ITM_ITM_TCR_TSPRESCALE__3_DIVIDE_BY_64 (0x00000300)
#define ITM_ITM_TCR_TSPRESCALE__M (0x00000300)
#define ITM_ITM_TER (HWREG32(0xE0000E00))
#define ITM_ITM_TPR (HWREG32(0xE0000E40))
#define ITM_ITM_TPR_PRIVMASK__M (0x0000000f)
#define LFXTDRIVE__0 (0x00000000)
#define LFXTDRIVE__1 (0x00000001)
#define LFXTDRIVE__2 (0x00000002)
#define LFXTDRIVE__3 (0x00000003)
#define LFXTDRIVE__4 (0x00000004)
#define LFXTDRIVE__5 (0x00000005)
#define LFXTDRIVE__6 (0x00000006)
#define LFXTDRIVE__7 (0x00000007)
#define MC0 (0x0010)
#define MC1 (0x0020)
#define MC__CONTINOUS (2*0x10u)
#define MPU_CTRL_ENABLE__0 (0x00000000)
#define MPU_CTRL_ENABLE__0_DISABLE_MPU (0x00000000)
#define MPU_CTRL_ENABLE__1 (0x00000001)
#define MPU_CTRL_ENABLE__1_ENABLE_MPU (0x00000001)
#define MPU_RASR_AP__0 (0x00000000)
#define MPU_RASR_AP__1 (0x01000000)
#define MPU_RASR_AP__2 (0x02000000)
#define MPU_RASR_AP__3 (0x03000000)
#define MPU_RASR_AP__5 (0x05000000)
#define MPU_RASR_AP__6 (0x06000000)
#define MPU_RASR_AP__7 (0x07000000)
#define MPU_RASR_AP__M (0x07000000)
#define MPU_RASR_B__0 (0x00000000)
#define MPU_RASR_B__0_NOT_BUFFERABLE (0x00000000)
#define MPU_RASR_B__1 (0x00010000)
#define MPU_RASR_B__1_BUFFERABLE (0x00010000)
#define MPU_RASR_C__0 (0x00000000)
#define MPU_RASR_C__0_NOT_CACHEABLE (0x00000000)
#define MPU_RASR_C__1 (0x00020000)
#define MPU_RASR_C__1_CACHEABLE (0x00020000)
#define MPU_RASR_SIZE__0 (0x00000000)
#define MPU_RASR_SIZE__0_4KB (0x00000000)
#define MPU_RASR_SIZE__1 (0x00000002)
#define MPU_RASR_SIZE__10 (0x00000014)
#define MPU_RASR_SIZE__10_2KB (0x00000014)
#define MPU_RASR_SIZE__12 (0x00000018)
#define MPU_RASR_SIZE__12_8KB (0x00000018)
#define MPU_RASR_SIZE__13 (0x0000001a)
#define MPU_RASR_SIZE__13_16KB (0x0000001a)
#define MPU_RASR_SIZE__14 (0x0000001c)
#define MPU_RASR_SIZE__14_32KB (0x0000001c)
#define MPU_RASR_SIZE__15 (0x0000001e)
#define MPU_RASR_SIZE__15_64KB (0x0000001e)
#define MPU_RASR_SIZE__16 (0x00000020)
#define MPU_RASR_SIZE__16_128KB (0x00000020)
#define MPU_RASR_SIZE__17 (0x00000022)
#define MPU_RASR_SIZE__17_256KB (0x00000022)
#define MPU_RASR_SIZE__18 (0x00000024)
#define MPU_RASR_SIZE__18_512KB (0x00000024)
#define MPU_RASR_SIZE__19 (0x00000026)
#define MPU_RASR_SIZE__19_1MB (0x00000026)
#define MPU_RASR_SIZE__1_256MB (0x00000002)
#define MPU_RASR_SIZE__20 (0x00000028)
#define MPU_RASR_SIZE__20_2MB (0x00000028)
#define MPU_RASR_SIZE__21 (0x0000002a)
#define MPU_RASR_SIZE__21_4MB (0x0000002a)
#define MPU_RASR_SIZE__22 (0x0000002c)
#define MPU_RASR_SIZE__22_8MB (0x0000002c)
#define MPU_RASR_SIZE__23 (0x0000002e)
#define MPU_RASR_SIZE__23_16MB (0x0000002e)
#define MPU_RASR_SIZE__24 (0x00000030)
#define MPU_RASR_SIZE__24_32MB (0x00000030)
#define MPU_RASR_SIZE__25 (0x00000032)
#define MPU_RASR_SIZE__25_64MB (0x00000032)
#define MPU_RASR_SIZE__26 (0x00000034)
#define MPU_RASR_SIZE__26_128MB (0x00000034)
#define MPU_RASR_SIZE__28 (0x00000038)
#define MPU_RASR_SIZE__28_512MB (0x00000038)
#define MPU_RASR_SIZE__29 (0x0000003a)
#define MPU_RASR_SIZE__29_1GB (0x0000003a)
#define MPU_RASR_SIZE__30 (0x0000003c)
#define MPU_RASR_SIZE__30_2GB (0x0000003c)
#define MPU_RASR_SIZE__31 (0x0000003e)
#define MPU_RASR_SIZE__31_4GB (0x0000003e)
#define MPU_RASR_SIZE__4_32B (0x00000008)
#define MPU_RASR_SIZE__5 (0x0000000a)
#define MPU_RASR_SIZE__5_64B (0x0000000a)
#define MPU_RASR_SIZE__6 (0x0000000c)
#define MPU_RASR_SIZE__6_128B (0x0000000c)
#define MPU_RASR_SIZE__7 (0x0000000e)
#define MPU_RASR_SIZE__7_256B (0x0000000e)
#define MPU_RASR_SIZE__8 (0x00000010)
#define MPU_RASR_SIZE__8_512B (0x00000010)
#define MPU_RASR_SIZE__9 (0x00000012)
#define MPU_RASR_SIZE__9_1KB (0x00000012)
#define MPU_RASR_SIZE__M (0x0000003e)
#define MPU_RASR_SRD__M (0x0000ff00)
#define MPU_RASR_S__0 (0x00000000)
#define MPU_RASR_S__0_NOT_SHAREABLE (0x00000000)
#define MPU_RASR_S__1 (0x00040000)
#define MPU_RASR_S__1_SHAREABLE (0x00040000)
#define MPU_RASR_TEX__M (0x00380000)
#define MPU_RASR_XN__0 (0x00000000)
#define MPU_RASR_XN__1 (0x10000000)
#define MPU_RBAR_ADDR__M (0xffffffe0)
#define MPU_RBAR_REGION__M (0x0000000f)
#define MPU_RBAR_VALID__0 (0x00000000)
#define MPU_RBAR_VALID__1 (0x00000010)
#define MPU_RNR_REGION__M (0x000000ff)
#define MPU_TYPE_DREGION__M (0x0000ff00)
#define MPU_TYPE_IREGION__M (0x00ff0000)
#define OFS_ADC14CLRIFGR0 (0x0000014C)
#define OFS_ADC14CLRIFGR1 (0x00000150)
#define OFS_ADC14CTL0 (0x00000000)
#define OFS_ADC14CTL1 (0x00000004)
#define OFS_ADC14DBG0 (0x00000340)
#define OFS_ADC14DSCR0 (0x00000380)
#define OFS_ADC14HI0 (0x0000000C)
#define OFS_ADC14HI1 (0x00000014)
#define OFS_ADC14IER0 (0x0000013C)
#define OFS_ADC14IER1 (0x00000140)
#define OFS_ADC14IFGR0 (0x00000144)
#define OFS_ADC14IFGR1 (0x00000148)
#define OFS_ADC14IV (0x00000154)
#define OFS_ADC14LO0 (0x00000008)
#define OFS_ADC14LO1 (0x00000010)
#define OFS_ADC14MCTL0 (0x00000018)
#define OFS_ADC14MCTL1 (0x0000001C)
#define OFS_ADC14MCTL10 (0x00000040)
#define OFS_ADC14MCTL11 (0x00000044)
#define OFS_ADC14MCTL12 (0x00000048)
#define OFS_ADC14MCTL13 (0x0000004C)
#define OFS_ADC14MCTL14 (0x00000050)
#define OFS_ADC14MCTL15 (0x00000054)
#define OFS_ADC14MCTL16 (0x00000058)
#define OFS_ADC14MCTL17 (0x0000005C)
#define OFS_ADC14MCTL18 (0x00000060)
#define OFS_ADC14MCTL19 (0x00000064)
#define OFS_ADC14MCTL2 (0x00000020)
#define OFS_ADC14MCTL20 (0x00000068)
#define OFS_ADC14MCTL21 (0x0000006C)
#define OFS_ADC14MCTL22 (0x00000070)
#define OFS_ADC14MCTL23 (0x00000074)
#define OFS_ADC14MCTL24 (0x00000078)
#define OFS_ADC14MCTL25 (0x0000007C)
#define OFS_ADC14MCTL26 (0x00000080)
#define OFS_ADC14MCTL27 (0x00000084)
#define OFS_ADC14MCTL28 (0x00000088)
#define OFS_ADC14MCTL29 (0x0000008C)
#define OFS_ADC14MCTL3 (0x00000024)
#define OFS_ADC14MCTL30 (0x00000090)
#define OFS_ADC14MCTL31 (0x00000094)
#define OFS_ADC14MCTL4 (0x00000028)
#define OFS_ADC14MCTL5 (0x0000002C)
#define OFS_ADC14MCTL6 (0x00000030)
#define OFS_ADC14MCTL7 (0x00000034)
#define OFS_ADC14MCTL8 (0x00000038)
#define OFS_ADC14MCTL9 (0x0000003C)
#define OFS_ADC14MEM0 (0x00000098)
#define OFS_ADC14MEM1 (0x0000009C)
#define OFS_ADC14MEM10 (0x000000C0)
#define OFS_ADC14MEM11 (0x000000C4)
#define OFS_ADC14MEM12 (0x000000C8)
#define OFS_ADC14MEM13 (0x000000CC)
#define OFS_ADC14MEM14 (0x000000D0)
#define OFS_ADC14MEM15 (0x000000D4)
#define OFS_ADC14MEM16 (0x000000D8)
#define OFS_ADC14MEM17 (0x000000DC)
#define OFS_ADC14MEM18 (0x000000E0)
#define OFS_ADC14MEM19 (0x000000E4)
#define OFS_ADC14MEM2 (0x000000A0)
#define OFS_ADC14MEM20 (0x000000E8)
#define OFS_ADC14MEM21 (0x000000EC)
#define OFS_ADC14MEM22 (0x000000F0)
#define OFS_ADC14MEM23 (0x000000F4)
#define OFS_ADC14MEM24 (0x000000F8)
#define OFS_ADC14MEM25 (0x000000FC)
#define OFS_ADC14MEM26 (0x00000100)
#define OFS_ADC14MEM27 (0x00000104)
#define OFS_ADC14MEM28 (0x00000108)
#define OFS_ADC14MEM29 (0x0000010C)
#define OFS_ADC14MEM3 (0x000000A4)
#define OFS_ADC14MEM30 (0x00000110)
#define OFS_ADC14MEM31 (0x00000114)
#define OFS_ADC14MEM4 (0x000000A8)
#define OFS_ADC14MEM5 (0x000000AC)
#define OFS_ADC14MEM6 (0x000000B0)
#define OFS_ADC14MEM7 (0x000000B4)
#define OFS_ADC14MEM8 (0x000000B8)
#define OFS_ADC14MEM9 (0x000000BC)
#define OFS_ADC14TEST0 (0x00000300)
#define OFS_ADC14TEST1 (0x00000304)
#define OFS_ADC14TEST2 (0x00000308)
#define OFS_ADC14TEST3 (0x0000030C)
#define OFS_ADC14TEST4 (0x00000310)
#define OFS_ADC14TEST5 (0x00000314)
#define OFS_ADC14TEST6 (0x00000318)
#define OFS_ADC14TEST7 (0x0000031C)
#define OFS_ADC14_CLRIFGR0 (0x0000014C)
#define OFS_ADC14_CLRIFGR1 (0x00000150)
#define OFS_ADC14_CTL0 (0x00000000)
#define OFS_ADC14_CTL1 (0x00000004)
#define OFS_ADC14_HI0 (0x0000000C)
#define OFS_ADC14_HI1 (0x00000014)
#define OFS_ADC14_IER0 (0x0000013C)
#define OFS_ADC14_IER1 (0x00000140)
#define OFS_ADC14_IFGR0 (0x00000144)
#define OFS_ADC14_IFGR1 (0x00000148)
#define OFS_ADC14_IV (0x00000154)
#define OFS_ADC14_LO0 (0x00000008)
#define OFS_ADC14_LO1 (0x00000010)
#define OFS_ADC14_MCTL0 (0x00000018)
#define OFS_ADC14_MCTL1 (0x0000001C)
#define OFS_ADC14_MCTL10 (0x00000040)
#define OFS_ADC14_MCTL11 (0x00000044)
#define OFS_ADC14_MCTL12 (0x00000048)
#define OFS_ADC14_MCTL13 (0x0000004C)
#define OFS_ADC14_MCTL14 (0x00000050)
#define OFS_ADC14_MCTL15 (0x00000054)
#define OFS_ADC14_MCTL16 (0x00000058)
#define OFS_ADC14_MCTL17 (0x0000005C)
#define OFS_ADC14_MCTL18 (0x00000060)
#define OFS_ADC14_MCTL19 (0x00000064)
#define OFS_ADC14_MCTL2 (0x00000020)
#define OFS_ADC14_MCTL20 (0x00000068)
#define OFS_ADC14_MCTL21 (0x0000006C)
#define OFS_ADC14_MCTL22 (0x00000070)
#define OFS_ADC14_MCTL23 (0x00000074)
#define OFS_ADC14_MCTL24 (0x00000078)
#define OFS_ADC14_MCTL25 (0x0000007C)
#define OFS_ADC14_MCTL26 (0x00000080)
#define OFS_ADC14_MCTL27 (0x00000084)
#define OFS_ADC14_MCTL28 (0x00000088)
#define OFS_ADC14_MCTL29 (0x0000008C)
#define OFS_ADC14_MCTL3 (0x00000024)
#define OFS_ADC14_MCTL30 (0x00000090)
#define OFS_ADC14_MCTL31 (0x00000094)
#define OFS_ADC14_MCTL4 (0x00000028)
#define OFS_ADC14_MCTL5 (0x0000002C)
#define OFS_ADC14_MCTL6 (0x00000030)
#define OFS_ADC14_MCTL7 (0x00000034)
#define OFS_ADC14_MCTL8 (0x00000038)
#define OFS_ADC14_MCTL9 (0x0000003C)
#define OFS_ADC14_MEM0 (0x00000098)
#define OFS_ADC14_MEM1 (0x0000009C)
#define OFS_ADC14_MEM10 (0x000000C0)
#define OFS_ADC14_MEM11 (0x000000C4)
#define OFS_ADC14_MEM12 (0x000000C8)
#define OFS_ADC14_MEM13 (0x000000CC)
#define OFS_ADC14_MEM14 (0x000000D0)
#define OFS_ADC14_MEM15 (0x000000D4)
#define OFS_ADC14_MEM16 (0x000000D8)
#define OFS_ADC14_MEM17 (0x000000DC)
#define OFS_ADC14_MEM18 (0x000000E0)
#define OFS_ADC14_MEM19 (0x000000E4)
#define OFS_ADC14_MEM2 (0x000000A0)
#define OFS_ADC14_MEM20 (0x000000E8)
#define OFS_ADC14_MEM21 (0x000000EC)
#define OFS_ADC14_MEM22 (0x000000F0)
#define OFS_ADC14_MEM23 (0x000000F4)
#define OFS_ADC14_MEM24 (0x000000F8)
#define OFS_ADC14_MEM25 (0x000000FC)
#define OFS_ADC14_MEM26 (0x00000100)
#define OFS_ADC14_MEM27 (0x00000104)
#define OFS_ADC14_MEM28 (0x00000108)
#define OFS_ADC14_MEM29 (0x0000010C)
#define OFS_ADC14_MEM3 (0x000000A4)
#define OFS_ADC14_MEM30 (0x00000110)
#define OFS_ADC14_MEM31 (0x00000114)
#define OFS_ADC14_MEM4 (0x000000A8)
#define OFS_ADC14_MEM5 (0x000000AC)
#define OFS_ADC14_MEM6 (0x000000B0)
#define OFS_ADC14_MEM7 (0x000000B4)
#define OFS_ADC14_MEM8 (0x000000B8)
#define OFS_ADC14_MEM9 (0x000000BC)
#define OFS_AES256_ACTL0 (0x00000000)
#define OFS_AES256_ACTL1 (0x00000002)
#define OFS_AES256_ADIN (0x00000008)
#define OFS_AES256_ADOUT (0x0000000A)
#define OFS_AES256_AKEY (0x00000006)
#define OFS_AES256_ASTAT (0x00000004)
#define OFS_AES256_AXDIN (0x0000000C)
#define OFS_AES256_AXIN (0x0000000E)
#define OFS_AESACTL0 (OFS_AES256_ACTL0)
#define OFS_AESACTL0_H (OFS_AESACTL0+1)
#define OFS_AESACTL0_L (OFS_AESACTL0)
#define OFS_AESACTL1 (OFS_AES256_ACTL1)
#define OFS_AESACTL1_H (OFS_AESACTL1+1)
#define OFS_AESACTL1_L (OFS_AESACTL1)
#define OFS_AESADIN (OFS_AES256_ADIN)
#define OFS_AESADIN_H (OFS_AESADIN+1)
#define OFS_AESADIN_L (OFS_AESADIN)
#define OFS_AESADOUT (OFS_AES256_ADOUT)
#define OFS_AESADOUT_H (OFS_AESADOUT+1)
#define OFS_AESADOUT_L (OFS_AESADOUT)
#define OFS_AESAKEY (OFS_AES256_AKEY)
#define OFS_AESAKEY_H (OFS_AESAKEY+1)
#define OFS_AESAKEY_L (OFS_AESAKEY)
#define OFS_AESASTAT (OFS_AES256_ASTAT)
#define OFS_AESASTAT_H (OFS_AESASTAT+1)
#define OFS_AESASTAT_L (OFS_AESASTAT)
#define OFS_AESAXDIN (OFS_AES256_AXDIN)
#define OFS_AESAXDIN_H (OFS_AESAXDIN+1)
#define OFS_AESAXDIN_L (OFS_AESAXDIN)
#define OFS_AESAXIN (OFS_AES256_AXIN)
#define OFS_AESAXIN_H (OFS_AESAXIN+1)
#define OFS_AESAXIN_L (OFS_AESAXIN)
#define OFS_BCD2BIN (0x001E)
#define OFS_BIN2BCD (0x001C)
#define OFS_CAPSIOxCTL (OFS_CAPTIO0_CTL)
#define OFS_CAPSIOxCTL_H (OFS_CAPSIOxCTL+1)
#define OFS_CAPSIOxCTL_L (OFS_CAPSIOxCTL)
#define OFS_CAPTIO0_CTL (0x0000000E)
#define OFS_CAPTIO1_CTL (0x0000000E)
#define OFS_CE0CTL0 (OFS_COMP_E0CTL0)
#define OFS_CE0CTL0_H (OFS_CE0CTL0+1)
#define OFS_CE0CTL0_L (OFS_CE0CTL0)
#define OFS_CE0CTL1 (OFS_COMP_E0CTL1)
#define OFS_CE0CTL1_H (OFS_CE0CTL1+1)
#define OFS_CE0CTL1_L (OFS_CE0CTL1)
#define OFS_CE0CTL2 (OFS_COMP_E0CTL2)
#define OFS_CE0CTL2_H (OFS_CE0CTL2+1)
#define OFS_CE0CTL2_L (OFS_CE0CTL2)
#define OFS_CE0CTL3 (OFS_COMP_E0CTL3)
#define OFS_CE0CTL3_H (OFS_CE0CTL3+1)
#define OFS_CE0CTL3_L (OFS_CE0CTL3)
#define OFS_CE0INT (OFS_COMP_E0INT)
#define OFS_CE0INT_H (OFS_CE0INT+1)
#define OFS_CE0INT_L (OFS_CE0INT)
#define OFS_CE0IV (OFS_COMP_E0IV)
#define OFS_CE0IV_H (OFS_CE0IV+1)
#define OFS_CE0IV_L (OFS_CE0IV)
#define OFS_CECTL0 (OFS_COMP_E0_CTL0)
#define OFS_CECTL0_H (OFS_CECTL0+1)
#define OFS_CECTL0_L (OFS_CECTL0)
#define OFS_CECTL1 (OFS_COMP_E0_CTL1)
#define OFS_CECTL1_H (OFS_CECTL1+1)
#define OFS_CECTL1_L (OFS_CECTL1)
#define OFS_CECTL2 (OFS_COMP_E0_CTL2)
#define OFS_CECTL2_H (OFS_CECTL2+1)
#define OFS_CECTL2_L (OFS_CECTL2)
#define OFS_CECTL3 (OFS_COMP_E0_CTL3)
#define OFS_CECTL3_H (OFS_CECTL3+1)
#define OFS_CECTL3_L (OFS_CECTL3)
#define OFS_CEINT (OFS_COMP_E0_INT)
#define OFS_CEINT_H (OFS_CEINT+1)
#define OFS_CEINT_L (OFS_CEINT)
#define OFS_CEIV (OFS_COMP_E0_IV)
#define OFS_CEIV_H (OFS_CEIV+1)
#define OFS_CEIV_L (OFS_CEIV)
#define OFS_COMP_E0_CTL0 (0x00000000)
#define OFS_COMP_E0_CTL1 (0x00000002)
#define OFS_COMP_E0_CTL2 (0x00000004)
#define OFS_COMP_E0_CTL3 (0x00000006)
#define OFS_COMP_E0_INT (0x0000000C)
#define OFS_COMP_E0_IV (0x0000000E)
#define OFS_COMP_E1CTL0 (0x00000000)
#define OFS_COMP_E1CTL1 (0x00000002)
#define OFS_COMP_E1CTL2 (0x00000004)
#define OFS_COMP_E1CTL3 (0x00000006)
#define OFS_COMP_E1INT (0x0000000C)
#define OFS_COMP_E1IV (0x0000000E)
#define OFS_COMP_E1_CTL0 (0x00000000)
#define OFS_COMP_E1_CTL1 (0x00000002)
#define OFS_COMP_E1_CTL2 (0x00000004)
#define OFS_COMP_E1_CTL3 (0x00000006)
#define OFS_COMP_E1_INT (0x0000000C)
#define OFS_COMP_E1_IV (0x0000000E)
#define OFS_CRC16DI (0x00000010)
#define OFS_CRC16DIRB (0x00000014)
#define OFS_CRC16INIRES (0x00000018)
#define OFS_CRC16RESR (0x0000001E)
#define OFS_CRC32DI (0x00000000)
#define OFS_CRC32DIRB (0x00000004)
#define OFS_CRC32INIRES_HI (0x0000000A)
#define OFS_CRC32INIRES_LO (0x00000008)
#define OFS_CRC32RESR_HI (0x0000000E)
#define OFS_CRC32RESR_LO (0x0000000C)
#define OFS_CRCDI (0x0000)
#define OFS_CRCDIRB (0x0002)
#define OFS_CRCDIRB_H (OFS_CRCDIRB+1)
#define OFS_CRCDIRB_L (OFS_CRCDIRB)
#define OFS_CRCDI_H (OFS_CRCDI+1)
#define OFS_CRCDI_L (OFS_CRCDI)
#define OFS_CRCINIRES (0x0004)
#define OFS_CRCINIRES_H (OFS_CRCINIRES+1)
#define OFS_CRCINIRES_L (OFS_CRCINIRES)
#define OFS_CRCRESR (0x0006)
#define OFS_CRCRESR_H (OFS_CRCRESR+1)
#define OFS_CRCRESR_L (OFS_CRCRESR)
#define OFS_CS_ACC (0x00000000)
#define OFS_CS_CLKEN (0x00000030)
#define OFS_CS_CLRIFG (0x00000050)
#define OFS_CS_CTL0 (0x00000004)
#define OFS_CS_CTL1 (0x00000008)
#define OFS_CS_CTL2 (0x0000000C)
#define OFS_CS_CTL3 (0x00000010)
#define OFS_CS_CTL4 (0x00000014)
#define OFS_CS_CTL5 (0x00000018)
#define OFS_CS_CTL6 (0x0000001C)
#define OFS_CS_CTL7 (0x00000020)
#define OFS_CS_DCOERCAL (0x00000060)
#define OFS_CS_IE (0x00000040)
#define OFS_CS_IFG (0x00000048)
#define OFS_CS_SETIFG (0x00000058)
#define OFS_CS_STAT (0x00000034)
#define OFS_DDDS_ADC14_PARAM0 (0x00000038)
#define OFS_DDDS_ADC14_REFTEMP0 (0x0000003C)
#define OFS_DDDS_ADC14_REFTEMP1 (0x00000040)
#define OFS_DDDS_ADC14_REFTEMP2 (0x00000044)
#define OFS_DDDS_ADC14_REFTEMP3 (0x00000048)
#define OFS_DDDS_BCREV (0x00000010)
#define OFS_DDDS_CSDCOCONST (0x00000030)
#define OFS_DDDS_CSDCOERCAL (0x0000002C)
#define OFS_DDDS_CSDCOIRCAL (0x00000028)
#define OFS_DDDS_DDDS_CHECKSUM (0x00000000)
#define OFS_DDDS_DDDS_ENDWORD (0x0000006C)
#define OFS_DDDS_DEVID (0x00000008)
#define OFS_DDDS_DIE_POSITION (0x0000001C)
#define OFS_DDDS_HWREV (0x0000000C)
#define OFS_DDDS_LOT_ID (0x00000018)
#define OFS_DDDS_MODID_ADC14 (0x00000034)
#define OFS_DDDS_MODID_CS (0x00000024)
#define OFS_DDDS_MODID_DEVINFO (0x00000004)
#define OFS_DDDS_MODID_DIEREC (0x00000014)
#define OFS_DDDS_MODID_RANDNUM (0x00000058)
#define OFS_DDDS_MODID_REF (0x0000004C)
#define OFS_DDDS_RAND0 (0x0000005C)
#define OFS_DDDS_RAND1 (0x00000060)
#define OFS_DDDS_RAND2 (0x00000064)
#define OFS_DDDS_RAND3 (0x00000068)
#define OFS_DDDS_REF_PARAM0 (0x00000050)
#define OFS_DDDS_REF_PARAM1 (0x00000054)
#define OFS_DDDS_TEST_RESULTS (0x00000020)
#define OFS_DMA_CH0_SRCCFG (0x00000010)
#define OFS_DMA_CH10_SRCCFG (0x00000038)
#define OFS_DMA_CH11_SRCCFG (0x0000003C)
#define OFS_DMA_CH12_SRCCFG (0x00000040)
#define OFS_DMA_CH13_SRCCFG (0x00000044)
#define OFS_DMA_CH14_SRCCFG (0x00000048)
#define OFS_DMA_CH15_SRCCFG (0x0000004C)
#define OFS_DMA_CH16_SRCCFG (0x00000050)
#define OFS_DMA_CH17_SRCCFG (0x00000054)
#define OFS_DMA_CH18_SRCCFG (0x00000058)
#define OFS_DMA_CH19_SRCCFG (0x0000005C)
#define OFS_DMA_CH1_SRCCFG (0x00000014)
#define OFS_DMA_CH20_SRCCFG (0x00000060)
#define OFS_DMA_CH21_SRCCFG (0x00000064)
#define OFS_DMA_CH22_SRCCFG (0x00000068)
#define OFS_DMA_CH23_SRCCFG (0x0000006C)
#define OFS_DMA_CH24_SRCCFG (0x00000070)
#define OFS_DMA_CH25_SRCCFG (0x00000074)
#define OFS_DMA_CH26_SRCCFG (0x00000078)
#define OFS_DMA_CH27_SRCCFG (0x0000007C)
#define OFS_DMA_CH28_SRCCFG (0x00000080)
#define OFS_DMA_CH29_SRCCFG (0x00000084)
#define OFS_DMA_CH2_SRCCFG (0x00000018)
#define OFS_DMA_CH30_SRCCFG (0x00000088)
#define OFS_DMA_CH31_SRCCFG (0x0000008C)
#define OFS_DMA_CH3_SRCCFG (0x0000001C)
#define OFS_DMA_CH4_SRCCFG (0x00000020)
#define OFS_DMA_CH5_SRCCFG (0x00000024)
#define OFS_DMA_CH6_SRCCFG (0x00000028)
#define OFS_DMA_CH7_SRCCFG (0x0000002C)
#define OFS_DMA_CH8_SRCCFG (0x00000030)
#define OFS_DMA_CH9_SRCCFG (0x00000034)
#define OFS_DMA_DEVCONFIG (0x00000000)
#define OFS_DMA_INT0_CLRFLG (0x00000114)
#define OFS_DMA_INT0_SRCFLG (0x00000110)
#define OFS_DMA_INT1_SRCCFG (0x00000100)
#define OFS_DMA_INT2_SRCCFG (0x00000104)
#define OFS_DMA_INT3_SRCCFG (0x00000108)
#define OFS_DMA_SW_CHTRIG (0x00000004)
#define OFS_DWT_CID0 (0x00000FF0)
#define OFS_DWT_CID1 (0x00000FF4)
#define OFS_DWT_CID2 (0x00000FF8)
#define OFS_DWT_CID3 (0x00000FFC)
#define OFS_DWT_COMP0 (0x00000020)
#define OFS_DWT_COMP1 (0x00000030)
#define OFS_DWT_COMP2 (0x00000040)
#define OFS_DWT_COMP3 (0x00000050)
#define OFS_DWT_CPICNT (0x00000008)
#define OFS_DWT_CTRL (0x00000000)
#define OFS_DWT_CYCCNT (0x00000004)
#define OFS_DWT_EXCCNT (0x0000000C)
#define OFS_DWT_FOLDCNT (0x00000018)
#define OFS_DWT_FUNCTION0 (0x00000028)
#define OFS_DWT_FUNCTION1 (0x00000038)
#define OFS_DWT_FUNCTION2 (0x00000048)
#define OFS_DWT_FUNCTION3 (0x00000058)
#define OFS_DWT_LSUCNT (0x00000014)
#define OFS_DWT_MASK0 (0x00000024)
#define OFS_DWT_MASK1 (0x00000034)
#define OFS_DWT_MASK2 (0x00000044)
#define OFS_DWT_MASK3 (0x00000054)
#define OFS_DWT_PCSR (0x0000001C)
#define OFS_DWT_PID0 (0x00000FE0)
#define OFS_DWT_PID1 (0x00000FE4)
#define OFS_DWT_PID2 (0x00000FE8)
#define OFS_DWT_PID3 (0x00000FEC)
#define OFS_DWT_PID4 (0x00000FD0)
#define OFS_DWT_PID5 (0x00000FD4)
#define OFS_DWT_PID6 (0x00000FD8)
#define OFS_DWT_PID7 (0x00000FDC)
#define OFS_DWT_SLEEPCNT (0x00000010)
#define OFS_EUSCI_A0_SPI_BRW (0x00000006)
#define OFS_EUSCI_A0_SPI_CTLW0 (0x00000000)
#define OFS_EUSCI_A0_SPI_IE (0x0000001A)
#define OFS_EUSCI_A0_SPI_IFG (0x0000001C)
#define OFS_EUSCI_A0_SPI_IV (0x0000001E)
#define OFS_EUSCI_A0_SPI_RXBUF (0x0000000C)
#define OFS_EUSCI_A0_SPI_STATW (0x0000000A)
#define OFS_EUSCI_A0_SPI_TXBUF (0x0000000E)
#define OFS_EUSCI_A0_UART_ABCTL (0x00000010)
#define OFS_EUSCI_A0_UART_BRW (0x00000006)
#define OFS_EUSCI_A0_UART_CTLW0 (0x00000000)
#define OFS_EUSCI_A0_UART_CTLW1 (0x00000002)
#define OFS_EUSCI_A0_UART_IE (0x0000001A)
#define OFS_EUSCI_A0_UART_IFG (0x0000001C)
#define OFS_EUSCI_A0_UART_IRCTL (0x00000012)
#define OFS_EUSCI_A0_UART_IV (0x0000001E)
#define OFS_EUSCI_A0_UART_MCTLW (0x00000008)
#define OFS_EUSCI_A0_UART_RXBUF (0x0000000C)
#define OFS_EUSCI_A0_UART_STATW (0x0000000A)
#define OFS_EUSCI_A0_UART_TXBUF (0x0000000E)
#define OFS_EUSCI_A1_SPI_BRW (0x00000006)
#define OFS_EUSCI_A1_SPI_CTLW0 (0x00000000)
#define OFS_EUSCI_A1_SPI_IE (0x0000001A)
#define OFS_EUSCI_A1_SPI_IFG (0x0000001C)
#define OFS_EUSCI_A1_SPI_IV (0x0000001E)
#define OFS_EUSCI_A1_SPI_RXBUF (0x0000000C)
#define OFS_EUSCI_A1_SPI_STATW (0x0000000A)
#define OFS_EUSCI_A1_SPI_TXBUF (0x0000000E)
#define OFS_EUSCI_A1_UART_ABCTL (0x00000010)
#define OFS_EUSCI_A1_UART_BRW (0x00000006)
#define OFS_EUSCI_A1_UART_CTLW0 (0x00000000)
#define OFS_EUSCI_A1_UART_CTLW1 (0x00000002)
#define OFS_EUSCI_A1_UART_IE (0x0000001A)
#define OFS_EUSCI_A1_UART_IFG (0x0000001C)
#define OFS_EUSCI_A1_UART_IRCTL (0x00000012)
#define OFS_EUSCI_A1_UART_IV (0x0000001E)
#define OFS_EUSCI_A1_UART_MCTLW (0x00000008)
#define OFS_EUSCI_A1_UART_RXBUF (0x0000000C)
#define OFS_EUSCI_A1_UART_STATW (0x0000000A)
#define OFS_EUSCI_A1_UART_TXBUF (0x0000000E)
#define OFS_EUSCI_A2_SPI_BRW (0x00000006)
#define OFS_EUSCI_A2_SPI_CTLW0 (0x00000000)
#define OFS_EUSCI_A2_SPI_IE (0x0000001A)
#define OFS_EUSCI_A2_SPI_IFG (0x0000001C)
#define OFS_EUSCI_A2_SPI_IV (0x0000001E)
#define OFS_EUSCI_A2_SPI_RXBUF (0x0000000C)
#define OFS_EUSCI_A2_SPI_STATW (0x0000000A)
#define OFS_EUSCI_A2_SPI_TXBUF (0x0000000E)
#define OFS_EUSCI_A2_UART_ABCTL (0x00000010)
#define OFS_EUSCI_A2_UART_BRW (0x00000006)
#define OFS_EUSCI_A2_UART_CTLW0 (0x00000000)
#define OFS_EUSCI_A2_UART_CTLW1 (0x00000002)
#define OFS_EUSCI_A2_UART_IE (0x0000001A)
#define OFS_EUSCI_A2_UART_IFG (0x0000001C)
#define OFS_EUSCI_A2_UART_IRCTL (0x00000012)
#define OFS_EUSCI_A2_UART_IV (0x0000001E)
#define OFS_EUSCI_A2_UART_MCTLW (0x00000008)
#define OFS_EUSCI_A2_UART_RXBUF (0x0000000C)
#define OFS_EUSCI_A2_UART_STATW (0x0000000A)
#define OFS_EUSCI_A2_UART_TXBUF (0x0000000E)
#define OFS_EUSCI_A3_SPI_BRW (0x00000006)
#define OFS_EUSCI_A3_SPI_CTLW0 (0x00000000)
#define OFS_EUSCI_A3_SPI_IE (0x0000001A)
#define OFS_EUSCI_A3_SPI_IFG (0x0000001C)
#define OFS_EUSCI_A3_SPI_IV (0x0000001E)
#define OFS_EUSCI_A3_SPI_RXBUF (0x0000000C)
#define OFS_EUSCI_A3_SPI_STATW (0x0000000A)
#define OFS_EUSCI_A3_SPI_TXBUF (0x0000000E)
#define OFS_EUSCI_A3_UART_ABCTL (0x00000010)
#define OFS_EUSCI_A3_UART_BRW (0x00000006)
#define OFS_EUSCI_A3_UART_CTLW0 (0x00000000)
#define OFS_EUSCI_A3_UART_CTLW1 (0x00000002)
#define OFS_EUSCI_A3_UART_IE (0x0000001A)
#define OFS_EUSCI_A3_UART_IFG (0x0000001C)
#define OFS_EUSCI_A3_UART_IRCTL (0x00000012)
#define OFS_EUSCI_A3_UART_IV (0x0000001E)
#define OFS_EUSCI_A3_UART_MCTLW (0x00000008)
#define OFS_EUSCI_A3_UART_RXBUF (0x0000000C)
#define OFS_EUSCI_A3_UART_STATW (0x0000000A)
#define OFS_EUSCI_A3_UART_TXBUF (0x0000000E)
#define OFS_EUSCI_B0_I2C_ADDMASK (0x0000001E)
#define OFS_EUSCI_B0_I2C_ADDRX (0x0000001C)
#define OFS_EUSCI_B0_I2C_BRW (0x00000006)
#define OFS_EUSCI_B0_I2C_CTLW0 (0x00000000)
#define OFS_EUSCI_B0_I2C_CTLW1 (0x00000002)
#define OFS_EUSCI_B0_I2C_I2COA0 (0x00000014)
#define OFS_EUSCI_B0_I2C_I2COA1 (0x00000016)
#define OFS_EUSCI_B0_I2C_I2COA2 (0x00000018)
#define OFS_EUSCI_B0_I2C_I2COA3 (0x0000001A)
#define OFS_EUSCI_B0_I2C_I2CSA (0x00000020)
#define OFS_EUSCI_B0_I2C_IE (0x0000002A)
#define OFS_EUSCI_B0_I2C_IFG (0x0000002C)
#define OFS_EUSCI_B0_I2C_IV (0x0000002E)
#define OFS_EUSCI_B0_I2C_RXBUF (0x0000000C)
#define OFS_EUSCI_B0_I2C_STATW (0x00000008)
#define OFS_EUSCI_B0_I2C_TBCNT (0x0000000A)
#define OFS_EUSCI_B0_I2C_TXBUF (0x0000000E)
#define OFS_EUSCI_B0_SPI_BRW (0x00000006)
#define OFS_EUSCI_B0_SPI_CTLW0 (0x00000000)
#define OFS_EUSCI_B0_SPI_IE (0x0000002A)
#define OFS_EUSCI_B0_SPI_IFG (0x0000002C)
#define OFS_EUSCI_B0_SPI_IV (0x0000002E)
#define OFS_EUSCI_B0_SPI_RXBUF (0x0000000C)
#define OFS_EUSCI_B0_SPI_STATW (0x00000008)
#define OFS_EUSCI_B0_SPI_TXBUF (0x0000000E)
#define OFS_EUSCI_B1_I2C_ADDMASK (0x0000001E)
#define OFS_EUSCI_B1_I2C_ADDRX (0x0000001C)
#define OFS_EUSCI_B1_I2C_BRW (0x00000006)
#define OFS_EUSCI_B1_I2C_CTLW0 (0x00000000)
#define OFS_EUSCI_B1_I2C_CTLW1 (0x00000002)
#define OFS_EUSCI_B1_I2C_I2COA0 (0x00000014)
#define OFS_EUSCI_B1_I2C_I2COA1 (0x00000016)
#define OFS_EUSCI_B1_I2C_I2COA2 (0x00000018)
#define OFS_EUSCI_B1_I2C_I2COA3 (0x0000001A)
#define OFS_EUSCI_B1_I2C_I2CSA (0x00000020)
#define OFS_EUSCI_B1_I2C_IE (0x0000002A)
#define OFS_EUSCI_B1_I2C_IFG (0x0000002C)
#define OFS_EUSCI_B1_I2C_IV (0x0000002E)
#define OFS_EUSCI_B1_I2C_RXBUF (0x0000000C)
#define OFS_EUSCI_B1_I2C_STATW (0x00000008)
#define OFS_EUSCI_B1_I2C_TBCNT (0x0000000A)
#define OFS_EUSCI_B1_I2C_TXBUF (0x0000000E)
#define OFS_EUSCI_B1_SPI_BRW (0x00000006)
#define OFS_EUSCI_B1_SPI_CTLW0 (0x00000000)
#define OFS_EUSCI_B1_SPI_IE (0x0000002A)
#define OFS_EUSCI_B1_SPI_IFG (0x0000002C)
#define OFS_EUSCI_B1_SPI_IV (0x0000002E)
#define OFS_EUSCI_B1_SPI_RXBUF (0x0000000C)
#define OFS_EUSCI_B1_SPI_STATW (0x00000008)
#define OFS_EUSCI_B1_SPI_TXBUF (0x0000000E)
#define OFS_EUSCI_B2_I2C_ADDMASK (0x0000001E)
#define OFS_EUSCI_B2_I2C_ADDRX (0x0000001C)
#define OFS_EUSCI_B2_I2C_BRW (0x00000006)
#define OFS_EUSCI_B2_I2C_CTLW0 (0x00000000)
#define OFS_EUSCI_B2_I2C_CTLW1 (0x00000002)
#define OFS_EUSCI_B2_I2C_I2COA0 (0x00000014)
#define OFS_EUSCI_B2_I2C_I2COA1 (0x00000016)
#define OFS_EUSCI_B2_I2C_I2COA2 (0x00000018)
#define OFS_EUSCI_B2_I2C_I2COA3 (0x0000001A)
#define OFS_EUSCI_B2_I2C_I2CSA (0x00000020)
#define OFS_EUSCI_B2_I2C_IE (0x0000002A)
#define OFS_EUSCI_B2_I2C_IFG (0x0000002C)
#define OFS_EUSCI_B2_I2C_IV (0x0000002E)
#define OFS_EUSCI_B2_I2C_RXBUF (0x0000000C)
#define OFS_EUSCI_B2_I2C_STATW (0x00000008)
#define OFS_EUSCI_B2_I2C_TBCNT (0x0000000A)
#define OFS_EUSCI_B2_I2C_TXBUF (0x0000000E)
#define OFS_EUSCI_B2_SPI_BRW (0x00000006)
#define OFS_EUSCI_B2_SPI_CTLW0 (0x00000000)
#define OFS_EUSCI_B2_SPI_IE (0x0000002A)
#define OFS_EUSCI_B2_SPI_IFG (0x0000002C)
#define OFS_EUSCI_B2_SPI_IV (0x0000002E)
#define OFS_EUSCI_B2_SPI_RXBUF (0x0000000C)
#define OFS_EUSCI_B2_SPI_STATW (0x00000008)
#define OFS_EUSCI_B2_SPI_TXBUF (0x0000000E)
#define OFS_EUSCI_B3_I2C_ADDMASK (0x0000001E)
#define OFS_EUSCI_B3_I2C_ADDRX (0x0000001C)
#define OFS_EUSCI_B3_I2C_BRW (0x00000006)
#define OFS_EUSCI_B3_I2C_CTLW0 (0x00000000)
#define OFS_EUSCI_B3_I2C_CTLW1 (0x00000002)
#define OFS_EUSCI_B3_I2C_I2COA0 (0x00000014)
#define OFS_EUSCI_B3_I2C_I2COA1 (0x00000016)
#define OFS_EUSCI_B3_I2C_I2COA2 (0x00000018)
#define OFS_EUSCI_B3_I2C_I2COA3 (0x0000001A)
#define OFS_EUSCI_B3_I2C_I2CSA (0x00000020)
#define OFS_EUSCI_B3_I2C_IE (0x0000002A)
#define OFS_EUSCI_B3_I2C_IFG (0x0000002C)
#define OFS_EUSCI_B3_I2C_IV (0x0000002E)
#define OFS_EUSCI_B3_I2C_RXBUF (0x0000000C)
#define OFS_EUSCI_B3_I2C_STATW (0x00000008)
#define OFS_EUSCI_B3_I2C_TBCNT (0x0000000A)
#define OFS_EUSCI_B3_I2C_TXBUF (0x0000000E)
#define OFS_EUSCI_B3_SPI_BRW (0x00000006)
#define OFS_EUSCI_B3_SPI_CTLW0 (0x00000000)
#define OFS_EUSCI_B3_SPI_IE (0x0000002A)
#define OFS_EUSCI_B3_SPI_IFG (0x0000002C)
#define OFS_EUSCI_B3_SPI_IV (0x0000002E)
#define OFS_EUSCI_B3_SPI_RXBUF (0x0000000C)
#define OFS_EUSCI_B3_SPI_STATW (0x00000008)
#define OFS_EUSCI_B3_SPI_TXBUF (0x0000000E)
#define OFS_FLCTL_BMRK_CMP (0x000000DC)
#define OFS_FLCTL_BMRK_CTLSTAT (0x000000D0)
#define OFS_FLCTL_BMRK_DREAD (0x000000D8)
#define OFS_FLCTL_BMRK_IFETCH (0x000000D4)
#define OFS_FLCTL_ERASE_CTLSTAT (0x000000A0)
#define OFS_FLCTL_ERASE_SECTADDR (0x000000A4)
#define OFS_FLCTL_ERASE_TIMCTL (0x00000118)
#define OFS_FLCTL_ERSVER_TIMCTL (0x0000010C)
#define OFS_FLCTL_INFOWEPROT_BNK0 (0x000000B0)
#define OFS_FLCTL_INFOWEPROT_BNK1 (0x000000C0)
#define OFS_FLCTL_INTCLR (0x000000F8)
#define OFS_FLCTL_INTEN (0x000000F4)
#define OFS_FLCTL_INTFLAG (0x000000F0)
#define OFS_FLCTL_INTSET (0x000000FC)
#define OFS_FLCTL_LKGVER_TIMCTL (0x00000110)
#define OFS_FLCTL_MASSERASE_TIMCTL (0x0000011C)
#define OFS_FLCTL_PRGBRST_CTLSTAT (0x00000054)
#define OFS_FLCTL_PRGBRST_DATA0_0 (0x00000060)
#define OFS_FLCTL_PRGBRST_DATA0_1 (0x00000064)
#define OFS_FLCTL_PRGBRST_DATA0_2 (0x00000068)
#define OFS_FLCTL_PRGBRST_DATA0_3 (0x0000006C)
#define OFS_FLCTL_PRGBRST_DATA1_0 (0x00000070)
#define OFS_FLCTL_PRGBRST_DATA1_1 (0x00000074)
#define OFS_FLCTL_PRGBRST_DATA1_2 (0x00000078)
#define OFS_FLCTL_PRGBRST_DATA1_3 (0x0000007C)
#define OFS_FLCTL_PRGBRST_DATA2_0 (0x00000080)
#define OFS_FLCTL_PRGBRST_DATA2_1 (0x00000084)
#define OFS_FLCTL_PRGBRST_DATA2_2 (0x00000088)
#define OFS_FLCTL_PRGBRST_DATA2_3 (0x0000008C)
#define OFS_FLCTL_PRGBRST_DATA3_0 (0x00000090)
#define OFS_FLCTL_PRGBRST_DATA3_1 (0x00000094)
#define OFS_FLCTL_PRGBRST_DATA3_2 (0x00000098)
#define OFS_FLCTL_PRGBRST_DATA3_3 (0x0000009C)
#define OFS_FLCTL_PRGBRST_STARTADDR (0x00000058)
#define OFS_FLCTL_PRGVER_TIMCTL (0x00000108)
#define OFS_FLCTL_PRG_CTLSTAT (0x00000050)
#define OFS_FLCTL_PROGRAM_TIMCTL (0x00000114)
#define OFS_FLCTL_PWRSTAT (0x00000000)
#define OFS_FLCTL_RDBRST_CTLSTAT (0x00000020)
#define OFS_FLCTL_RDBRST_FAILADDR (0x0000003C)
#define OFS_FLCTL_RDBRST_FAILCNT (0x00000040)
#define OFS_FLCTL_RDBRST_LEN (0x00000028)
#define OFS_FLCTL_RDBRST_STARTADDR (0x00000024)
#define OFS_FLCTL_RDCTL_BNK0 (0x00000010)
#define OFS_FLCTL_RDCTL_BNK1 (0x00000014)
#define OFS_FLCTL_READMARGIN_TIMCTL (0x00000104)
#define OFS_FLCTL_READ_TIMCTL (0x00000100)
#define OFS_FLCTL_USRWEPROT_BNK0 (0x000000B4)
#define OFS_FLCTL_USRWEPROT_BNK1 (0x000000C4)
#define OFS_FPB_CID0 (0x00000FF0)
#define OFS_FPB_CID1 (0x00000FF4)
#define OFS_FPB_CID2 (0x00000FF8)
#define OFS_FPB_CID3 (0x00000FFC)
#define OFS_FPB_FP_COMP0 (0x00000008)
#define OFS_FPB_FP_COMP1 (0x0000000C)
#define OFS_FPB_FP_COMP2 (0x00000010)
#define OFS_FPB_FP_COMP3 (0x00000014)
#define OFS_FPB_FP_COMP4 (0x00000018)
#define OFS_FPB_FP_COMP5 (0x0000001C)
#define OFS_FPB_FP_COMP6 (0x00000020)
#define OFS_FPB_FP_COMP7 (0x00000024)
#define OFS_FPB_FP_CTRL (0x00000000)
#define OFS_FPB_FP_REMAP (0x00000004)
#define OFS_FPB_PID0 (0x00000FE0)
#define OFS_FPB_PID1 (0x00000FE4)
#define OFS_FPB_PID2 (0x00000FE8)
#define OFS_FPB_PID3 (0x00000FEC)
#define OFS_FPB_PID4 (0x00000FD0)
#define OFS_FPB_PID5 (0x00000FD4)
#define OFS_FPB_PID6 (0x00000FD8)
#define OFS_FPB_PID7 (0x00000FDC)
#define OFS_FPU_CPACR (0x00000D88)
#define OFS_FPU_FPCAR (0x00000F38)
#define OFS_FPU_FPCCR (0x00000F34)
#define OFS_FPU_FPDSCR (0x00000F3C)
#define OFS_FPU_MVFR0 (0x00000F40)
#define OFS_FPU_MVFR1 (0x00000F44)
#define OFS_ITM_CID0 (0x00000FF0)
#define OFS_ITM_CID1 (0x00000FF4)
#define OFS_ITM_CID2 (0x00000FF8)
#define OFS_ITM_CID3 (0x00000FFC)
#define OFS_ITM_ITM_IMCR (0x00000F00)
#define OFS_ITM_ITM_IWR (0x00000EF8)
#define OFS_ITM_ITM_LAR (0x00000FB0)
#define OFS_ITM_ITM_LSR (0x00000FB4)
#define OFS_ITM_ITM_STIM0 (0x00000000)
#define OFS_ITM_ITM_STIM1 (0x00000004)
#define OFS_ITM_ITM_STIM10 (0x00000028)
#define OFS_ITM_ITM_STIM11 (0x0000002C)
#define OFS_ITM_ITM_STIM12 (0x00000030)
#define OFS_ITM_ITM_STIM13 (0x00000034)
#define OFS_ITM_ITM_STIM14 (0x00000038)
#define OFS_ITM_ITM_STIM15 (0x0000003C)
#define OFS_ITM_ITM_STIM16 (0x00000040)
#define OFS_ITM_ITM_STIM17 (0x00000044)
#define OFS_ITM_ITM_STIM18 (0x00000048)
#define OFS_ITM_ITM_STIM19 (0x0000004C)
#define OFS_ITM_ITM_STIM2 (0x00000008)
#define OFS_ITM_ITM_STIM20 (0x00000050)
#define OFS_ITM_ITM_STIM21 (0x00000054)
#define OFS_ITM_ITM_STIM22 (0x00000058)
#define OFS_ITM_ITM_STIM23 (0x0000005C)
#define OFS_ITM_ITM_STIM24 (0x00000060)
#define OFS_ITM_ITM_STIM25 (0x00000064)
#define OFS_ITM_ITM_STIM26 (0x00000068)
#define OFS_ITM_ITM_STIM27 (0x0000006C)
#define OFS_ITM_ITM_STIM28 (0x00000070)
#define OFS_ITM_ITM_STIM29 (0x00000074)
#define OFS_ITM_ITM_STIM3 (0x0000000C)
#define OFS_ITM_ITM_STIM30 (0x00000078)
#define OFS_ITM_ITM_STIM31 (0x0000007C)
#define OFS_ITM_ITM_STIM4 (0x00000010)
#define OFS_ITM_ITM_STIM5 (0x00000014)
#define OFS_ITM_ITM_STIM6 (0x00000018)
#define OFS_ITM_ITM_STIM7 (0x0000001C)
#define OFS_ITM_ITM_STIM8 (0x00000020)
#define OFS_ITM_ITM_STIM9 (0x00000024)
#define OFS_ITM_ITM_TCR (0x00000E80)
#define OFS_ITM_ITM_TER (0x00000E00)
#define OFS_ITM_ITM_TPR (0x00000E40)
#define OFS_ITM_PID0 (0x00000FE0)
#define OFS_ITM_PID1 (0x00000FE4)
#define OFS_ITM_PID2 (0x00000FE8)
#define OFS_ITM_PID3 (0x00000FEC)
#define OFS_ITM_PID4 (0x00000FD0)
#define OFS_ITM_PID5 (0x00000FD4)
#define OFS_ITM_PID6 (0x00000FD8)
#define OFS_ITM_PID7 (0x00000FDC)
#define OFS_MPU_CTRL (0x00000D94)
#define OFS_MPU_RASR (0x00000DA0)
#define OFS_MPU_RASR_A1 (0x00000DA8)
#define OFS_MPU_RASR_A2 (0x00000DB0)
#define OFS_MPU_RASR_A3 (0x00000DB8)
#define OFS_MPU_RBAR (0x00000D9C)
#define OFS_MPU_RBAR_A1 (0x00000DA4)
#define OFS_MPU_RBAR_A2 (0x00000DAC)
#define OFS_MPU_RBAR_A3 (0x00000DB4)
#define OFS_MPU_RNR (0x00000D98)
#define OFS_MPU_TYPE (0x00000D90)
#define OFS_P10DIR (OFS_P10_DIR)
#define OFS_P10IE (OFS_P10_IE)
#define OFS_P10IES (OFS_P10_IES)
#define OFS_P10IFG (OFS_P10_IFG)
#define OFS_P10IN (OFS_P10_IN)
#define OFS_P10IV (OFS_P10_IV)
#define OFS_P10OUT (OFS_P10_OUT)
#define OFS_P10REN (OFS_P10_REN)
#define OFS_P10SEL0 (OFS_P10_SEL0)
#define OFS_P10SEL1 (OFS_P10_SEL1)
#define OFS_P10_DIR (0x00000004)
#define OFS_P10_DS (0x00000008)
#define OFS_P10_IE (0x0000001A)
#define OFS_P10_IES (0x00000018)
#define OFS_P10_IFG (0x0000001C)
#define OFS_P10_IN (0x00000000)
#define OFS_P10_IV (0x0000001D)
#define OFS_P10_OUT (0x00000002)
#define OFS_P10_REN (0x00000006)
#define OFS_P10_SEL0 (0x0000000A)
#define OFS_P10_SEL1 (0x0000000C)
#define OFS_P10_SELC (0x00000016)
#define OFS_P1DIR (OFS_P1_DIR)
#define OFS_P1IE (OFS_P1_IE)
#define OFS_P1IES (OFS_P1_IES)
#define OFS_P1IFG (OFS_P1_IFG)
#define OFS_P1IN (OFS_P1_IN)
#define OFS_P1IV (OFS_P1_IV)
#define OFS_P1OUT (OFS_P1_OUT)
#define OFS_P1REN (OFS_P1_REN)
#define OFS_P1SEL0 (OFS_P1_SEL0)
#define OFS_P1SEL1 (OFS_P1_SEL1)
#define OFS_P1_DIR (0x00000004)
#define OFS_P1_DS (0x00000008)
#define OFS_P1_IE (0x0000001A)
#define OFS_P1_IES (0x00000018)
#define OFS_P1_IFG (0x0000001C)
#define OFS_P1_IN (0x00000000)
#define OFS_P1_IV (0x0000000E)
#define OFS_P1_OUT (0x00000002)
#define OFS_P1_REN (0x00000006)
#define OFS_P1_SEL0 (0x0000000A)
#define OFS_P1_SEL1 (0x0000000C)
#define OFS_P1_SELC (0x00000016)
#define OFS_P2DIR (OFS_P2_DIR)
#define OFS_P2IE (OFS_P2_IE)
#define OFS_P2IES (OFS_P2_IES)
#define OFS_P2IFG (OFS_P2_IFG)
#define OFS_P2IN (OFS_P2_IN)
#define OFS_P2IV (OFS_P2_IV)
#define OFS_P2OUT (OFS_P2_OUT)
#define OFS_P2REN (OFS_P2_REN)
#define OFS_P2SEL0 (OFS_P2_SEL0)
#define OFS_P2SEL1 (OFS_P2_SEL1)
#define OFS_P2_DIR (0x00000004)
#define OFS_P2_DS (0x00000008)
#define OFS_P2_IE (0x0000001A)
#define OFS_P2_IES (0x00000018)
#define OFS_P2_IFG (0x0000001C)
#define OFS_P2_IN (0x00000000)
#define OFS_P2_IV (0x0000001D)
#define OFS_P2_OUT (0x00000002)
#define OFS_P2_REN (0x00000006)
#define OFS_P2_SEL0 (0x0000000A)
#define OFS_P2_SEL1 (0x0000000C)
#define OFS_P2_SELC (0x00000016)
#define OFS_P3DIR (OFS_P3_DIR)
#define OFS_P3IE (OFS_P3_IE)
#define OFS_P3IES (OFS_P3_IES)
#define OFS_P3IFG (OFS_P3_IFG)
#define OFS_P3IN (OFS_P3_IN)
#define OFS_P3IV (OFS_P3_IV)
#define OFS_P3OUT (OFS_P3_OUT)
#define OFS_P3REN (OFS_P3_REN)
#define OFS_P3SEL0 (OFS_P3_SEL0)
#define OFS_P3SEL1 (OFS_P3_SEL1)
#define OFS_P3_DIR (0x00000004)
#define OFS_P3_DS (0x00000008)
#define OFS_P3_IE (0x0000001A)
#define OFS_P3_IES (0x00000018)
#define OFS_P3_IFG (0x0000001C)
#define OFS_P3_IN (0x00000000)
#define OFS_P3_IV (0x0000000E)
#define OFS_P3_OUT (0x00000002)
#define OFS_P3_REN (0x00000006)
#define OFS_P3_SEL0 (0x0000000A)
#define OFS_P3_SEL1 (0x0000000C)
#define OFS_P3_SELC (0x00000016)
#define OFS_P4DIR (OFS_P4_DIR)
#define OFS_P4IE (OFS_P4_IE)
#define OFS_P4IES (OFS_P4_IES)
#define OFS_P4IFG (OFS_P4_IFG)
#define OFS_P4IN (OFS_P4_IN)
#define OFS_P4IV (OFS_P4_IV)
#define OFS_P4OUT (OFS_P4_OUT)
#define OFS_P4REN (OFS_P4_REN)
#define OFS_P4SEL0 (OFS_P4_SEL0)
#define OFS_P4SEL1 (OFS_P4_SEL1)
#define OFS_P4_DIR (0x00000004)
#define OFS_P4_DS (0x00000008)
#define OFS_P4_IE (0x0000001A)
#define OFS_P4_IES (0x00000018)
#define OFS_P4_IFG (0x0000001C)
#define OFS_P4_IN (0x00000000)
#define OFS_P4_IV (0x0000001D)
#define OFS_P4_OUT (0x00000002)
#define OFS_P4_REN (0x00000006)
#define OFS_P4_SEL0 (0x0000000A)
#define OFS_P4_SEL1 (0x0000000C)
#define OFS_P4_SELC (0x00000016)
#define OFS_P5DIR (OFS_P5_DIR)
#define OFS_P5IE (OFS_P5_IE)
#define OFS_P5IES (OFS_P5_IES)
#define OFS_P5IFG (OFS_P5_IFG)
#define OFS_P5IN (OFS_P5_IN)
#define OFS_P5IV (OFS_P5_IV)
#define OFS_P5OUT (OFS_P5_OUT)
#define OFS_P5REN (OFS_P5_REN)
#define OFS_P5SEL0 (OFS_P5_SEL0)
#define OFS_P5SEL1 (OFS_P5_SEL1)
#define OFS_P5_DIR (0x00000004)
#define OFS_P5_DS (0x00000008)
#define OFS_P5_IE (0x0000001A)
#define OFS_P5_IES (0x00000018)
#define OFS_P5_IFG (0x0000001C)
#define OFS_P5_IN (0x00000000)
#define OFS_P5_IV (0x0000000E)
#define OFS_P5_OUT (0x00000002)
#define OFS_P5_REN (0x00000006)
#define OFS_P5_SEL0 (0x0000000A)
#define OFS_P5_SEL1 (0x0000000C)
#define OFS_P5_SELC (0x00000016)
#define OFS_P6DIR (OFS_P6_DIR)
#define OFS_P6IE (OFS_P6_IE)
#define OFS_P6IES (OFS_P6_IES)
#define OFS_P6IFG (OFS_P6_IFG)
#define OFS_P6IN (OFS_P6_IN)
#define OFS_P6IV (OFS_P6_IV)
#define OFS_P6OUT (OFS_P6_OUT)
#define OFS_P6REN (OFS_P6_REN)
#define OFS_P6SEL0 (OFS_P6_SEL0)
#define OFS_P6SEL1 (OFS_P6_SEL1)
#define OFS_P6_DIR (0x00000004)
#define OFS_P6_DS (0x00000008)
#define OFS_P6_IE (0x0000001A)
#define OFS_P6_IES (0x00000018)
#define OFS_P6_IFG (0x0000001C)
#define OFS_P6_IN (0x00000000)
#define OFS_P6_IV (0x0000001D)
#define OFS_P6_OUT (0x00000002)
#define OFS_P6_REN (0x00000006)
#define OFS_P6_SEL0 (0x0000000A)
#define OFS_P6_SEL1 (0x0000000C)
#define OFS_P6_SELC (0x00000016)
#define OFS_P7DIR (OFS_P7_DIR)
#define OFS_P7IE (OFS_P7_IE)
#define OFS_P7IES (OFS_P7_IES)
#define OFS_P7IFG (OFS_P7_IFG)
#define OFS_P7IN (OFS_P7_IN)
#define OFS_P7IV (OFS_P7_IV)
#define OFS_P7OUT (OFS_P7_OUT)
#define OFS_P7REN (OFS_P7_REN)
#define OFS_P7SEL0 (OFS_P7_SEL0)
#define OFS_P7SEL1 (OFS_P7_SEL1)
#define OFS_P7_DIR (0x00000004)
#define OFS_P7_DS (0x00000008)
#define OFS_P7_IE (0x0000001A)
#define OFS_P7_IES (0x00000018)
#define OFS_P7_IFG (0x0000001C)
#define OFS_P7_IN (0x00000000)
#define OFS_P7_IV (0x0000000E)
#define OFS_P7_OUT (0x00000002)
#define OFS_P7_REN (0x00000006)
#define OFS_P7_SEL0 (0x0000000A)
#define OFS_P7_SEL1 (0x0000000C)
#define OFS_P7_SELC (0x00000016)
#define OFS_P8DIR (OFS_P8_DIR)
#define OFS_P8IE (OFS_P8_IE)
#define OFS_P8IES (OFS_P8_IES)
#define OFS_P8IFG (OFS_P8_IFG)
#define OFS_P8IN (OFS_P8_IN)
#define OFS_P8IV (OFS_P8_IV)
#define OFS_P8OUT (OFS_P8_OUT)
#define OFS_P8REN (OFS_P8_REN)
#define OFS_P8SEL0 (OFS_P8_SEL0)
#define OFS_P8SEL1 (OFS_P8_SEL1)
#define OFS_P8_DIR (0x00000004)
#define OFS_P8_DS (0x00000008)
#define OFS_P8_IE (0x0000001A)
#define OFS_P8_IES (0x00000018)
#define OFS_P8_IFG (0x0000001C)
#define OFS_P8_IN (0x00000000)
#define OFS_P8_IV (0x0000001D)
#define OFS_P8_OUT (0x00000002)
#define OFS_P8_REN (0x00000006)
#define OFS_P8_SEL0 (0x0000000A)
#define OFS_P8_SEL1 (0x0000000C)
#define OFS_P8_SELC (0x00000016)
#define OFS_P9DIR (OFS_P9_DIR)
#define OFS_P9IE (OFS_P9_IE)
#define OFS_P9IES (OFS_P9_IES)
#define OFS_P9IFG (OFS_P9_IFG)
#define OFS_P9IN (OFS_P9_IN)
#define OFS_P9IV (OFS_P9_IV)
#define OFS_P9OUT (OFS_P9_OUT)
#define OFS_P9REN (OFS_P9_REN)
#define OFS_P9SEL0 (OFS_P9_SEL0)
#define OFS_P9SEL1 (OFS_P9_SEL1)
#define OFS_P9_DIR (0x00000004)
#define OFS_P9_DS (0x00000008)
#define OFS_P9_IE (0x0000001A)
#define OFS_P9_IES (0x00000018)
#define OFS_P9_IFG (0x0000001C)
#define OFS_P9_IN (0x00000000)
#define OFS_P9_IV (0x0000000E)
#define OFS_P9_OUT (0x00000002)
#define OFS_P9_REN (0x00000006)
#define OFS_P9_SEL0 (0x0000000A)
#define OFS_P9_SEL1 (0x0000000C)
#define OFS_P9_SELC (0x00000016)
#define OFS_PADIR (OFS_PA_DIR)
#define OFS_PADIR_H (OFS_PADIR+1)
#define OFS_PADIR_L (OFS_PADIR)
#define OFS_PAIE (OFS_PA_IE)
#define OFS_PAIES (OFS_PA_IES)
#define OFS_PAIES_H (OFS_PAIES+1)
#define OFS_PAIES_L (OFS_PAIES)
#define OFS_PAIE_H (OFS_PAIE+1)
#define OFS_PAIE_L (OFS_PAIE)
#define OFS_PAIFG (OFS_PA_IFG)
#define OFS_PAIFG_H (OFS_PAIFG+1)
#define OFS_PAIFG_L (OFS_PAIFG)
#define OFS_PAIN (OFS_PA_IN)
#define OFS_PAIN_H (OFS_PAIN+1)
#define OFS_PAIN_L (OFS_PAIN)
#define OFS_PAOUT (OFS_PA_OUT)
#define OFS_PAOUT_H (OFS_PAOUT+1)
#define OFS_PAOUT_L (OFS_PAOUT)
#define OFS_PAREN (OFS_PA_REN)
#define OFS_PAREN_H (OFS_PAREN+1)
#define OFS_PAREN_L (OFS_PAREN)
#define OFS_PASEL0 (OFS_PA_SEL0)
#define OFS_PASEL0_H (OFS_PASEL0+1)
#define OFS_PASEL0_L (OFS_PASEL0)
#define OFS_PASEL1 (OFS_PA_SEL1)
#define OFS_PASEL1_H (OFS_PASEL1+1)
#define OFS_PASEL1_L (OFS_PASEL1)
#define OFS_PA_DIR (0x00000004)
#define OFS_PA_DS (0x00000008)
#define OFS_PA_IE (0x0000001A)
#define OFS_PA_IES (0x00000018)
#define OFS_PA_IFG (0x0000001C)
#define OFS_PA_IN (0x00000000)
#define OFS_PA_OUT (0x00000002)
#define OFS_PA_REN (0x00000006)
#define OFS_PA_SEL0 (0x0000000A)
#define OFS_PA_SEL1 (0x0000000C)
#define OFS_PA_SELC (0x00000016)
#define OFS_PBDIR (OFS_PB_DIR)
#define OFS_PBDIR_H (OFS_PBDIR+1)
#define OFS_PBDIR_L (OFS_PBDIR)
#define OFS_PBIE (OFS_PB_IE)
#define OFS_PBIES (OFS_PB_IES)
#define OFS_PBIES_H (OFS_PBIES+1)
#define OFS_PBIES_L (OFS_PBIES)
#define OFS_PBIE_H (OFS_PBIE+1)
#define OFS_PBIE_L (OFS_PBIE)
#define OFS_PBIFG (OFS_PB_IFG)
#define OFS_PBIFG_H (OFS_PBIFG+1)
#define OFS_PBIFG_L (OFS_PBIFG)
#define OFS_PBIN (OFS_PB_IN)
#define OFS_PBIN_H (OFS_PBIN+1)
#define OFS_PBIN_L (OFS_PBIN)
#define OFS_PBOUT (OFS_PB_OUT)
#define OFS_PBOUT_H (OFS_PBOUT+1)
#define OFS_PBOUT_L (OFS_PBOUT)
#define OFS_PBREN (OFS_PB_REN)
#define OFS_PBREN_H (OFS_PBREN+1)
#define OFS_PBREN_L (OFS_PBREN)
#define OFS_PBSEL0 (OFS_PB_SEL0)
#define OFS_PBSEL0_H (OFS_PBSEL0+1)
#define OFS_PBSEL0_L (OFS_PBSEL0)
#define OFS_PBSEL1 (OFS_PB_SEL1)
#define OFS_PBSEL1_H (OFS_PBSEL1+1)
#define OFS_PBSEL1_L (OFS_PBSEL1)
#define OFS_PB_DIR (0x00000004)
#define OFS_PB_DS (0x00000008)
#define OFS_PB_IE (0x0000001A)
#define OFS_PB_IES (0x00000018)
#define OFS_PB_IFG (0x0000001C)
#define OFS_PB_IN (0x00000000)
#define OFS_PB_OUT (0x00000002)
#define OFS_PB_REN (0x00000006)
#define OFS_PB_SEL0 (0x0000000A)
#define OFS_PB_SEL1 (0x0000000C)
#define OFS_PB_SELC (0x00000016)
#define OFS_PCDIR (OFS_PC_DIR)
#define OFS_PCDIR_H (OFS_PCDIR+1)
#define OFS_PCDIR_L (OFS_PCDIR)
#define OFS_PCIE (OFS_PC_IE)
#define OFS_PCIES (OFS_PC_IES)
#define OFS_PCIES_H (OFS_PCIES+1)
#define OFS_PCIES_L (OFS_PCIES)
#define OFS_PCIE_H (OFS_PCIE+1)
#define OFS_PCIE_L (OFS_PCIE)
#define OFS_PCIFG (OFS_PC_IFG)
#define OFS_PCIFG_H (OFS_PCIFG+1)
#define OFS_PCIFG_L (OFS_PCIFG)
#define OFS_PCIN (OFS_PC_IN)
#define OFS_PCIN_H (OFS_PCIN+1)
#define OFS_PCIN_L (OFS_PCIN)
#define OFS_PCM_CTL (0x00000004)
#define OFS_PCM_INTCLR (0x00000010)
#define OFS_PCM_INTEN (0x00000008)
#define OFS_PCM_INTFLAG (0x0000000C)
#define OFS_PCM_PMR (0x00000000)
#define OFS_PCOUT (OFS_PC_OUT)
#define OFS_PCOUT_H (OFS_PCOUT+1)
#define OFS_PCOUT_L (OFS_PCOUT)
#define OFS_PCREN (OFS_PC_REN)
#define OFS_PCREN_H (OFS_PCREN+1)
#define OFS_PCREN_L (OFS_PCREN)
#define OFS_PCSEL0 (OFS_PC_SEL0)
#define OFS_PCSEL0_H (OFS_PCSEL0+1)
#define OFS_PCSEL0_L (OFS_PCSEL0)
#define OFS_PCSEL1 (OFS_PC_SEL1)
#define OFS_PCSEL1_H (OFS_PCSEL1+1)
#define OFS_PCSEL1_L (OFS_PCSEL1)
#define OFS_PC_DIR (0x00000004)
#define OFS_PC_DS (0x00000008)
#define OFS_PC_IE (0x0000001A)
#define OFS_PC_IES (0x00000018)
#define OFS_PC_IFG (0x0000001C)
#define OFS_PC_IN (0x00000000)
#define OFS_PC_OUT (0x00000002)
#define OFS_PC_REN (0x00000006)
#define OFS_PC_SEL0 (0x0000000A)
#define OFS_PC_SEL1 (0x0000000C)
#define OFS_PC_SELC (0x00000016)
#define OFS_PDDIR (OFS_PD_DIR)
#define OFS_PDDIR_H (OFS_PDDIR+1)
#define OFS_PDDIR_L (OFS_PDDIR)
#define OFS_PDIN (OFS_PD_IN)
#define OFS_PDIN_H (OFS_PDIN+1)
#define OFS_PDIN_L (OFS_PDIN)
#define OFS_PDOUT (OFS_PD_OUT)
#define OFS_PDOUT_H (OFS_PDOUT+1)
#define OFS_PDOUT_L (OFS_PDOUT)
#define OFS_PDREN (OFS_PD_REN)
#define OFS_PDREN_H (OFS_PDREN+1)
#define OFS_PDREN_L (OFS_PDREN)
#define OFS_PDSEL0 (OFS_PD_SEL0)
#define OFS_PDSEL0_H (OFS_PDSEL0+1)
#define OFS_PDSEL0_L (OFS_PDSEL0)
#define OFS_PDSEL1 (OFS_PD_SEL1)
#define OFS_PDSEL1_H (OFS_PDSEL1+1)
#define OFS_PDSEL1_L (OFS_PDSEL1)
#define OFS_PD_DIR (0x00000004)
#define OFS_PD_DS (0x00000008)
#define OFS_PD_IE (0x0000001A)
#define OFS_PD_IES (0x00000018)
#define OFS_PD_IFG (0x0000001C)
#define OFS_PD_IN (0x00000000)
#define OFS_PD_OUT (0x00000002)
#define OFS_PD_REN (0x00000006)
#define OFS_PD_SEL0 (0x0000000A)
#define OFS_PD_SEL1 (0x0000000C)
#define OFS_PD_SELC (0x00000016)
#define OFS_PEDIR (OFS_PE_DIR)
#define OFS_PEDIR_H (OFS_PEDIR+1)
#define OFS_PEDIR_L (OFS_PEDIR)
#define OFS_PEIN (OFS_PE_IN)
#define OFS_PEIN_H (OFS_PEIN+1)
#define OFS_PEIN_L (OFS_PEIN)
#define OFS_PEOUT (OFS_PE_OUT)
#define OFS_PEOUT_H (OFS_PEOUT+1)
#define OFS_PEOUT_L (OFS_PEOUT)
#define OFS_PEREN (OFS_PE_REN)
#define OFS_PEREN_H (OFS_PEREN+1)
#define OFS_PEREN_L (OFS_PEREN)
#define OFS_PESEL0 (OFS_PE_SEL0)
#define OFS_PESEL0_H (OFS_PESEL0+1)
#define OFS_PESEL0_L (OFS_PESEL0)
#define OFS_PESEL1 (OFS_PE_SEL1)
#define OFS_PESEL1_H (OFS_PESEL1+1)
#define OFS_PESEL1_L (OFS_PESEL1)
#define OFS_PE_DIR (0x00000004)
#define OFS_PE_DS (0x00000008)
#define OFS_PE_IE (0x0000001A)
#define OFS_PE_IES (0x00000018)
#define OFS_PE_IFG (0x0000001C)
#define OFS_PE_IN (0x00000000)
#define OFS_PE_OUT (0x00000002)
#define OFS_PE_REN (0x00000006)
#define OFS_PE_SEL0 (0x0000000A)
#define OFS_PE_SEL1 (0x0000000C)
#define OFS_PE_SELC (0x00000016)
#define OFS_PJDIR (OFS_PJ_DIR)
#define OFS_PJDIR_H (OFS_PJDIR+1)
#define OFS_PJDIR_L (OFS_PJDIR)
#define OFS_PJIN (OFS_PJ_IN)
#define OFS_PJIN_H (OFS_PJIN+1)
#define OFS_PJIN_L (OFS_PJIN)
#define OFS_PJOUT (OFS_PJ_OUT)
#define OFS_PJOUT_H (OFS_PJOUT+1)
#define OFS_PJOUT_L (OFS_PJOUT)
#define OFS_PJREN (OFS_PJ_REN)
#define OFS_PJREN_H (OFS_PJREN+1)
#define OFS_PJREN_L (OFS_PJREN)
#define OFS_PJSEL0 (OFS_PJ_SEL0)
#define OFS_PJSEL0_H (OFS_PJSEL0+1)
#define OFS_PJSEL0_L (OFS_PJSEL0)
#define OFS_PJSEL1 (OFS_PJ_SEL1)
#define OFS_PJSEL1_H (OFS_PJSEL1+1)
#define OFS_PJSEL1_L (OFS_PJSEL1)
#define OFS_PJ_DIR (0x00000004)
#define OFS_PJ_DS (0x00000008)
#define OFS_PJ_IN (0x00000000)
#define OFS_PJ_OUT (0x00000002)
#define OFS_PJ_REN (0x00000006)
#define OFS_PJ_SEL0 (0x0000000A)
#define OFS_PJ_SEL1 (0x0000000C)
#define OFS_PJ_SELC (0x00000016)
#define OFS_PMAPCTL (0x0002)
#define OFS_PMAPKEYID (0x0000)
#define OFS_PMAP_CTL (0x00000002)
#define OFS_PMAP_KEYID (0x00000000)
#define OFS_PMAP_P1MAP0 (0x00000008)
#define OFS_PMAP_P1MAP1 (0x00000009)
#define OFS_PMAP_P1MAP2 (0x0000000A)
#define OFS_PMAP_P1MAP3 (0x0000000B)
#define OFS_PMAP_P1MAP4 (0x0000000C)
#define OFS_PMAP_P1MAP5 (0x0000000D)
#define OFS_PMAP_P1MAP6 (0x0000000E)
#define OFS_PMAP_P1MAP7 (0x0000000F)
#define OFS_PMAP_P2MAP0 (0x00000010)
#define OFS_PMAP_P2MAP1 (0x00000011)
#define OFS_PMAP_P2MAP2 (0x00000012)
#define OFS_PMAP_P2MAP3 (0x00000013)
#define OFS_PMAP_P2MAP4 (0x00000014)
#define OFS_PMAP_P2MAP5 (0x00000015)
#define OFS_PMAP_P2MAP6 (0x00000016)
#define OFS_PMAP_P2MAP7 (0x00000017)
#define OFS_PMAP_P3MAP0 (0x00000018)
#define OFS_PMAP_P3MAP1 (0x00000019)
#define OFS_PMAP_P3MAP2 (0x0000001A)
#define OFS_PMAP_P3MAP3 (0x0000001B)
#define OFS_PMAP_P3MAP4 (0x0000001C)
#define OFS_PMAP_P3MAP5 (0x0000001D)
#define OFS_PMAP_P3MAP6 (0x0000001E)
#define OFS_PMAP_P3MAP7 (0x0000001F)
#define OFS_PMAP_P4MAP0 (0x00000020)
#define OFS_PMAP_P4MAP1 (0x00000021)
#define OFS_PMAP_P4MAP2 (0x00000022)
#define OFS_PMAP_P4MAP3 (0x00000023)
#define OFS_PMAP_P4MAP4 (0x00000024)
#define OFS_PMAP_P4MAP5 (0x00000025)
#define OFS_PMAP_P4MAP6 (0x00000026)
#define OFS_PMAP_P4MAP7 (0x00000027)
#define OFS_PMAP_P5MAP0 (0x00000028)
#define OFS_PMAP_P5MAP1 (0x00000029)
#define OFS_PMAP_P5MAP2 (0x0000002A)
#define OFS_PMAP_P5MAP3 (0x0000002B)
#define OFS_PMAP_P5MAP4 (0x0000002C)
#define OFS_PMAP_P5MAP5 (0x0000002D)
#define OFS_PMAP_P5MAP6 (0x0000002E)
#define OFS_PMAP_P5MAP7 (0x0000002F)
#define OFS_PMAP_P6MAP0 (0x00000030)
#define OFS_PMAP_P6MAP1 (0x00000031)
#define OFS_PMAP_P6MAP2 (0x00000032)
#define OFS_PMAP_P6MAP3 (0x00000033)
#define OFS_PMAP_P6MAP4 (0x00000034)
#define OFS_PMAP_P6MAP5 (0x00000035)
#define OFS_PMAP_P6MAP6 (0x00000036)
#define OFS_PMAP_P6MAP7 (0x00000037)
#define OFS_PMAP_P7MAP0 (0x00000038)
#define OFS_PMAP_P7MAP1 (0x00000039)
#define OFS_PMAP_P7MAP2 (0x0000003A)
#define OFS_PMAP_P7MAP3 (0x0000003B)
#define OFS_PMAP_P7MAP4 (0x0000003C)
#define OFS_PMAP_P7MAP5 (0x0000003D)
#define OFS_PMAP_P7MAP6 (0x0000003E)
#define OFS_PMAP_P7MAP7 (0x0000003F)
#define OFS_PSS_CLRIFG (0x0000003C)
#define OFS_PSS_DCDCCNFG1 (0x00000320)
#define OFS_PSS_DCDCCNFG2 (0x00000324)
#define OFS_PSS_DCDCCNFG3 (0x00000328)
#define OFS_PSS_DFTATBBF (0x00000728)
#define OFS_PSS_DFTATBUBF (0x0000072C)
#define OFS_PSS_DFTCNFG (0x00000710)
#define OFS_PSS_DFTCTRL1 (0x00000720)
#define OFS_PSS_DFTCTRL2 (0x00000724)
#define OFS_PSS_DOCMCTL (0x00000008)
#define OFS_PSS_DOCMOUTR (0x0000000C)
#define OFS_PSS_FLSHCNFG0 (0x0000030C)
#define OFS_PSS_FLSHCNFG1 (0x00000310)
#define OFS_PSS_IE (0x00000034)
#define OFS_PSS_IFG (0x00000038)
#define OFS_PSS_KEY (0x00000000)
#define OFS_PSS_MISCCNFG (0x00000314)
#define OFS_PSS_OPTEOP (0x0000033C)
#define OFS_PSS_OSDLCNFG (0x0000031C)
#define OFS_PSS_REFTRIM1 (0x00000300)
#define OFS_PSS_REFTRIM2 (0x00000304)
#define OFS_PSS_RSTFLG (0x00000330)
#define OFS_PSS_SHCTR (0x0000032C)
#define OFS_PSS_SVSCNFG (0x00000308)
#define OFS_PSS_SVSMCTL (0x00000004)
#define OFS_PSS_SVSMHTH01 (0x00000700)
#define OFS_PSS_SVSMHTH23 (0x00000704)
#define OFS_PSS_SVSMHTH45 (0x00000708)
#define OFS_PSS_SVSMHTH67 (0x0000070C)
#define OFS_PSS_VCOREPROG (0x00000318)
#define OFS_REFCTL0 (OFS_REF_A_CTL0)
#define OFS_REFCTL0_H (OFS_REFCTL0+1)
#define OFS_REFCTL0_L (OFS_REFCTL0)
#define OFS_REF_A_CTL0 (0x00000000)
#define OFS_RSTCTL_HRDRESETCLR (0x00000008)
#define OFS_RSTCTL_HRDRESETSET (0x0000000C)
#define OFS_RSTCTL_HRDRESETSTAT (0x00000004)
#define OFS_RSTCTL_PCMRSTCLR (0x0000010C)
#define OFS_RSTCTL_PCMRSTSTAT (0x00000108)
#define OFS_RSTCTL_PINRSTCLR (0x00000114)
#define OFS_RSTCTL_PINRSTSTAT (0x00000110)
#define OFS_RSTCTL_PSSRSTCLR (0x00000104)
#define OFS_RSTCTL_PSSRSTSTAT (0x00000100)
#define OFS_RSTCTL_RBTRSTCLR (0x0000011C)
#define OFS_RSTCTL_RBTRSTSTAT (0x00000118)
#define OFS_RSTCTL_RESETREQ (0x00000000)
#define OFS_RSTCTL_SFTRESETCLR (0x00000014)
#define OFS_RSTCTL_SFTRESETSET (0x00000018)
#define OFS_RSTCTL_SFTRESETSTAT (0x00000010)
#define OFS_RTCADOWDAY (0x001A)
#define OFS_RTCADOWDAY_L                                   OFS_RTCADOWDAY
#define OFS_RTCADOWDAY_H                                   OFS_RTCADOWDAY+1
#define OFS_RTCAMINHR (0x0018)
#define OFS_RTCAMINHR_L                                    OFS_RTCAMINHR
#define OFS_RTCAMINHR_H                                    OFS_RTCAMINHR+1
#define OFS_RTCCAP0CTL (0x0022)
#define OFS_RTCCAP1CTL (0x0023)
#define OFS_RTCCTL0 (0x0000)
#define OFS_RTCCTL0_L                                      OFS_RTCCTL0
#define OFS_RTCCTL0_H                                      OFS_RTCCTL0+1
#define OFS_RTCCTL13 (0x0002)
#define OFS_RTCCTL13_L                                     OFS_RTCCTL13
#define OFS_RTCCTL13_H                                     OFS_RTCCTL13+1
#define OFS_RTCDATE (0x0014)
#define OFS_RTCDATE_L                                      OFS_RTCDATE
#define OFS_RTCDATE_H                                      OFS_RTCDATE+1
#define OFS_RTCDAYBAK0 (0x0033)
#define OFS_RTCDAYBAK1 (0x003B)
#define OFS_RTCHOURBAK0 (0x0032)
#define OFS_RTCHOURBAK1 (0x003A)
#define OFS_RTCIV (0x000E)
#define OFS_RTCMINBAK0 (0x0031)
#define OFS_RTCMINBAK1 (0x0039)
#define OFS_RTCMONBAK0 (0x0034)
#define OFS_RTCMONBAK1 (0x003C)
#define OFS_RTCOCAL (0x0004)
#define OFS_RTCPS (0x000C)
#define OFS_RTCPS_L                                        OFS_RTCPS
#define OFS_RTCPS_H                                        OFS_RTCPS+1
#define OFS_RTCPS0CTL (0x0008)
#define OFS_RTCPS0CTL_L                                    OFS_RTCPS0CTL
#define OFS_RTCPS0CTL_H                                    OFS_RTCPS0CTL+1
#define OFS_RTCPS1CTL (0x000A)
#define OFS_RTCPS1CTL_L                                    OFS_RTCPS1CTL
#define OFS_RTCPS1CTL_H                                    OFS_RTCPS1CTL+1
#define OFS_RTCSECBAK0 (0x0030)
#define OFS_RTCSECBAK1 (0x0038)
#define OFS_RTCTCCTL0 (0x0020)
#define OFS_RTCTCCTL1 (0x0021)
#define OFS_RTCTCMP (0x0006)
#define OFS_RTCTCMP_L                                      OFS_RTCTCMP
#define OFS_RTCTCMP_H                                      OFS_RTCTCMP+1
#define OFS_RTCTIM0 (0x0010)
#define OFS_RTCTIM0_L                                      OFS_RTCTIM0
#define OFS_RTCTIM0_H                                      OFS_RTCTIM0+1
#define OFS_RTCTIM1 (0x0012)
#define OFS_RTCTIM1_L                                      OFS_RTCTIM1
#define OFS_RTCTIM1_H                                      OFS_RTCTIM1+1
#define OFS_RTCYEAR (0x0016)
#define OFS_RTCYEARBAK0 (0x0036)
#define OFS_RTCYEARBAK1 (0x003E)
#define OFS_RTC_C_ADAY (0x0000001B)
#define OFS_RTC_C_ADOW (0x0000001A)
#define OFS_RTC_C_AHOUR (0x00000019)
#define OFS_RTC_C_AMIN (0x00000018)
#define OFS_RTC_C_BCD2BIN (0x0000001E)
#define OFS_RTC_C_BIN2BCD (0x0000001C)
#define OFS_RTC_C_CTL0 (0x00000000)
#define OFS_RTC_C_CTL1 (0x00000002)
#define OFS_RTC_C_CTL3 (0x00000003)
#define OFS_RTC_C_DAY (0x00000014)
#define OFS_RTC_C_DOW (0x00000013)
#define OFS_RTC_C_HOUR (0x00000012)
#define OFS_RTC_C_IV (0x0000000E)
#define OFS_RTC_C_MIN (0x00000011)
#define OFS_RTC_C_MON (0x00000015)
#define OFS_RTC_C_OCAL (0x00000004)
#define OFS_RTC_C_PS0 (0x0000000C)
#define OFS_RTC_C_PS0CTL (0x00000008)
#define OFS_RTC_C_PS1 (0x0000000D)
#define OFS_RTC_C_PS1CTL (0x0000000A)
#define OFS_RTC_C_SEC (0x00000010)
#define OFS_RTC_C_TCMP (0x00000006)
#define OFS_RTC_C_YEAR (0x00000016)
#define OFS_SCS_ACTLR (0x00000008)
#define OFS_SCS_AFSR (0x00000D3C)
#define OFS_SCS_AIRCR (0x00000D0C)
#define OFS_SCS_BFAR (0x00000D38)
#define OFS_SCS_CCR (0x00000D14)
#define OFS_SCS_CFSR (0x00000D28)
#define OFS_SCS_CID0 (0x00000FF0)
#define OFS_SCS_CID1 (0x00000FF4)
#define OFS_SCS_CID2 (0x00000FF8)
#define OFS_SCS_CID3 (0x00000FFC)
#define OFS_SCS_CPUID (0x00000D00)
#define OFS_SCS_DCRDR (0x00000DF8)
#define OFS_SCS_DCRSR (0x00000DF4)
#define OFS_SCS_DEMCR (0x00000DFC)
#define OFS_SCS_DFSR (0x00000D30)
#define OFS_SCS_DHCSR (0x00000DF0)
#define OFS_SCS_HFSR (0x00000D2C)
#define OFS_SCS_ICSR (0x00000D04)
#define OFS_SCS_ICTR (0x00000004)
#define OFS_SCS_ID_AFR0 (0x00000D4C)
#define OFS_SCS_ID_DFR0 (0x00000D48)
#define OFS_SCS_ID_ISAR1 (0x00000D64)
#define OFS_SCS_ID_ISAR2 (0x00000D68)
#define OFS_SCS_ID_ISAR3 (0x00000D6C)
#define OFS_SCS_ID_ISAR4 (0x00000D70)
#define OFS_SCS_ID_MMFR0 (0x00000D50)
#define OFS_SCS_ID_MMFR1 (0x00000D54)
#define OFS_SCS_ID_MMFR2 (0x00000D58)
#define OFS_SCS_ID_MMFR3 (0x00000D5C)
#define OFS_SCS_ID_PFR0 (0x00000D40)
#define OFS_SCS_ID_PFR1 (0x00000D44)
#define OFS_SCS_ISAR0 (0x00000D60)
#define OFS_SCS_MMFAR (0x00000D34)
#define OFS_SCS_NVIC_IABR0 (0x00000300)
#define OFS_SCS_NVIC_IABR1 (0x00000304)
#define OFS_SCS_NVIC_ICER0 (0x00000180)
#define OFS_SCS_NVIC_ICER1 (0x00000184)
#define OFS_SCS_NVIC_ICPR0 (0x00000280)
#define OFS_SCS_NVIC_ICPR1 (0x00000284)
#define OFS_SCS_NVIC_IPR0 (0x00000400)
#define OFS_SCS_NVIC_IPR1 (0x00000404)
#define OFS_SCS_NVIC_IPR10 (0x00000428)
#define OFS_SCS_NVIC_IPR11 (0x0000042C)
#define OFS_SCS_NVIC_IPR12 (0x00000430)
#define OFS_SCS_NVIC_IPR13 (0x00000434)
#define OFS_SCS_NVIC_IPR14 (0x00000438)
#define OFS_SCS_NVIC_IPR15 (0x0000043C)
#define OFS_SCS_NVIC_IPR2 (0x00000408)
#define OFS_SCS_NVIC_IPR3 (0x0000040C)
#define OFS_SCS_NVIC_IPR4 (0x00000410)
#define OFS_SCS_NVIC_IPR5 (0x00000414)
#define OFS_SCS_NVIC_IPR6 (0x00000418)
#define OFS_SCS_NVIC_IPR7 (0x0000041C)
#define OFS_SCS_NVIC_IPR8 (0x00000420)
#define OFS_SCS_NVIC_IPR9 (0x00000424)
#define OFS_SCS_NVIC_ISER0 (0x00000100)
#define OFS_SCS_NVIC_ISER1 (0x00000104)
#define OFS_SCS_NVIC_ISPR0 (0x00000200)
#define OFS_SCS_NVIC_ISPR1 (0x00000204)
#define OFS_SCS_PID0 (0x00000FE0)
#define OFS_SCS_PID1 (0x00000FE4)
#define OFS_SCS_PID2 (0x00000FE8)
#define OFS_SCS_PID3 (0x00000FEC)
#define OFS_SCS_PID4 (0x00000FD0)
#define OFS_SCS_PID5 (0x00000FD4)
#define OFS_SCS_PID6 (0x00000FD8)
#define OFS_SCS_PID7 (0x00000FDC)
#define OFS_SCS_SCR (0x00000D10)
#define OFS_SCS_SHCSR (0x00000D24)
#define OFS_SCS_SHPR1 (0x00000D18)
#define OFS_SCS_SHPR2 (0x00000D1C)
#define OFS_SCS_SHPR3 (0x00000D20)
#define OFS_SCS_STCR (0x0000001C)
#define OFS_SCS_STCSR (0x00000010)
#define OFS_SCS_STCVR (0x00000018)
#define OFS_SCS_STIR (0x00000F00)
#define OFS_SCS_STRVR (0x00000014)
#define OFS_SCS_VTOR (0x00000D08)
#define OFS_SYSCTL_DIOGLTFLTCTL (0x00000030)
#define OFS_SYSCTL_FLUSER_SIZE (0x00000020)
#define OFS_SYSCTL_NMI_CTLSTAT (0x00000004)
#define OFS_SYSCTL_PERI_HALTCTL (0x0000000C)
#define OFS_SYSCTL_REBOOT_CTL (0x00000000)
#define OFS_SYSCTL_SECDATA_UNLOCK (0x00000040)
#define OFS_SYSCTL_SRAM_BANKEN (0x00000014)
#define OFS_SYSCTL_SRAM_BANKRET (0x00000018)
#define OFS_SYSCTL_SRAM_SIZE (0x00000010)
#define OFS_SYSCTL_WDT_RSTCTL (0x00000008)
#define OFS_T32BGLOAD1 (0x00000018)
#define OFS_T32BGLOAD2 (0x00000038)
#define OFS_T32CONTROL1 (0x00000008)
#define OFS_T32CONTROL2 (0x00000028)
#define OFS_T32INTCLR1 (0x0000000C)
#define OFS_T32INTCLR2 (0x0000002C)
#define OFS_T32LOAD1 (0x00000000)
#define OFS_T32LOAD2 (0x00000020)
#define OFS_T32MIS1 (0x00000014)
#define OFS_T32MIS2 (0x00000034)
#define OFS_T32RIS1 (0x00000010)
#define OFS_T32RIS2 (0x00000030)
#define OFS_T32VALUE1 (0x00000004)
#define OFS_T32VALUE2 (0x00000024)
#define OFS_T32_BGLOAD1 (0x00000018)
#define OFS_T32_BGLOAD2 (0x00000038)
#define OFS_T32_CONTROL1 (0x00000008)
#define OFS_T32_CONTROL2 (0x00000028)
#define OFS_T32_INTCLR1 (0x0000000C)
#define OFS_T32_INTCLR2 (0x0000002C)
#define OFS_T32_LOAD1 (0x00000000)
#define OFS_T32_LOAD2 (0x00000020)
#define OFS_T32_MIS1 (0x00000014)
#define OFS_T32_MIS2 (0x00000034)
#define OFS_T32_RIS1 (0x00000010)
#define OFS_T32_RIS2 (0x00000030)
#define OFS_T32_VALUE1 (0x00000004)
#define OFS_T32_VALUE2 (0x00000024)
#define OFS_TA0_CCR0 (0x00000012)
#define OFS_TA0_CCR1 (0x00000014)
#define OFS_TA0_CCR2 (0x00000016)
#define OFS_TA0_CCR3 (0x00000018)
#define OFS_TA0_CCR4 (0x0000001A)
#define OFS_TA0_CCR5 (0x0000001C)
#define OFS_TA0_CCR6 (0x0000001E)
#define OFS_TA0_CCTL0 (0x00000002)
#define OFS_TA0_CCTL1 (0x00000004)
#define OFS_TA0_CCTL2 (0x00000006)
#define OFS_TA0_CCTL3 (0x00000008)
#define OFS_TA0_CCTL4 (0x0000000A)
#define OFS_TA0_CCTL5 (0x0000000C)
#define OFS_TA0_CCTL6 (0x0000000E)
#define OFS_TA0_CTL (0x00000000)
#define OFS_TA0_EX0 (0x00000020)
#define OFS_TA0_IV (0x0000002E)
#define OFS_TA0_R (0x00000010)
#define OFS_TA1_CCR0 (0x00000012)
#define OFS_TA1_CCR1 (0x00000014)
#define OFS_TA1_CCR2 (0x00000016)
#define OFS_TA1_CCR3 (0x00000018)
#define OFS_TA1_CCR4 (0x0000001A)
#define OFS_TA1_CCR5 (0x0000001C)
#define OFS_TA1_CCR6 (0x0000001E)
#define OFS_TA1_CCTL0 (0x00000002)
#define OFS_TA1_CCTL1 (0x00000004)
#define OFS_TA1_CCTL2 (0x00000006)
#define OFS_TA1_CCTL3 (0x00000008)
#define OFS_TA1_CCTL4 (0x0000000A)
#define OFS_TA1_CCTL5 (0x0000000C)
#define OFS_TA1_CCTL6 (0x0000000E)
#define OFS_TA1_CTL (0x00000000)
#define OFS_TA1_EX0 (0x00000020)
#define OFS_TA1_IV (0x0000002E)
#define OFS_TA1_R (0x00000010)
#define OFS_TA2_CCR0 (0x00000012)
#define OFS_TA2_CCR1 (0x00000014)
#define OFS_TA2_CCR2 (0x00000016)
#define OFS_TA2_CCR3 (0x00000018)
#define OFS_TA2_CCR4 (0x0000001A)
#define OFS_TA2_CCR5 (0x0000001C)
#define OFS_TA2_CCR6 (0x0000001E)
#define OFS_TA2_CCTL0 (0x00000002)
#define OFS_TA2_CCTL1 (0x00000004)
#define OFS_TA2_CCTL2 (0x00000006)
#define OFS_TA2_CCTL3 (0x00000008)
#define OFS_TA2_CCTL4 (0x0000000A)
#define OFS_TA2_CCTL5 (0x0000000C)
#define OFS_TA2_CCTL6 (0x0000000E)
#define OFS_TA2_CTL (0x00000000)
#define OFS_TA2_EX0 (0x00000020)
#define OFS_TA2_IV (0x0000002E)
#define OFS_TA2_R (0x00000010)
#define OFS_TA3_CCR0 (0x00000012)
#define OFS_TA3_CCR1 (0x00000014)
#define OFS_TA3_CCR2 (0x00000016)
#define OFS_TA3_CCR3 (0x00000018)
#define OFS_TA3_CCR4 (0x0000001A)
#define OFS_TA3_CCR5 (0x0000001C)
#define OFS_TA3_CCR6 (0x0000001E)
#define OFS_TA3_CCTL0 (0x00000002)
#define OFS_TA3_CCTL1 (0x00000004)
#define OFS_TA3_CCTL2 (0x00000006)
#define OFS_TA3_CCTL3 (0x00000008)
#define OFS_TA3_CCTL4 (0x0000000A)
#define OFS_TA3_CCTL5 (0x0000000C)
#define OFS_TA3_CCTL6 (0x0000000E)
#define OFS_TA3_CTL (0x00000000)
#define OFS_TA3_EX0 (0x00000020)
#define OFS_TA3_IV (0x0000002E)
#define OFS_TA3_R (0x00000010)
#define OFS_TAxCCR0 (OFS_TA0_CCR0)
#define OFS_TAxCCR1 (OFS_TA0_CCR1)
#define OFS_TAxCCR2 (OFS_TA0_CCR2)
#define OFS_TAxCCR3 (OFS_TA0_CCR3)
#define OFS_TAxCCR4 (OFS_TA0_CCR4)
#define OFS_TAxCCR5 (OFS_TA0_CCR5)
#define OFS_TAxCCR6 (OFS_TA0_CCR6)
#define OFS_TAxCCTL0 (OFS_TA0_CCTL0)
#define OFS_TAxCCTL1 (OFS_TA0_CCTL1)
#define OFS_TAxCCTL2 (OFS_TA0_CCTL2)
#define OFS_TAxCCTL3 (OFS_TA0_CCTL3)
#define OFS_TAxCCTL4 (OFS_TA0_CCTL4)
#define OFS_TAxCCTL5 (OFS_TA0_CCTL5)
#define OFS_TAxCCTL6 (OFS_TA0_CCTL6)
#define OFS_TAxCTL (OFS_TA0_CTL)
#define OFS_TAxEX0 (OFS_TA0_EX0)
#define OFS_TAxIV (OFS_TA0_IV)
#define OFS_TAxR (OFS_TA0_R)
#define OFS_UCAxABCTL (0x0010)
#define OFS_UCAxBR0 (0x0006)
#define OFS_UCAxBR0__SPI (0x0006)
#define OFS_UCAxBR1 (0x0007)
#define OFS_UCAxBR1__SPI (0x0007)
#define OFS_UCAxBRW (0x0006)
#define OFS_UCAxBRW__SPI (0x0006)
#define OFS_UCAxCTL0 (0x0001)
#define OFS_UCAxCTL0__SPI (0x0001)
#define OFS_UCAxCTL1 (0x0000)
#define OFS_UCAxCTL1__SPI (0x0000)
#define OFS_UCAxCTLW0 (0x0000)
#define OFS_UCAxCTLW0__SPI (0x0000)
#define OFS_UCAxCTLW1 (0x0002)
#define OFS_UCAxIE (0x001A)
#define OFS_UCAxIE__SPI (0x001A)
#define OFS_UCAxIE__UART (0x001A)
#define OFS_UCAxIFG (0x001C)
#define OFS_UCAxIFG__SPI (0x001C)
#define OFS_UCAxIFG__UART (0x001C)
#define OFS_UCAxIRCTL (0x0012)
#define OFS_UCAxIRRCTL (0x0013)
#define OFS_UCAxIRTCTL (0x0012)
#define OFS_UCAxIV (0x001E)
#define OFS_UCAxIV__SPI (0x001E)
#define OFS_UCAxMCTLW (0x0008)
#define OFS_UCAxRXBUF (0x000C)
#define OFS_UCAxRXBUF__SPI (0x000C)
#define OFS_UCAxSTATW (0x000A)
#define OFS_UCAxSTATW__SPI (0x000A)
#define OFS_UCAxTXBUF (0x000E)
#define OFS_UCAxTXBUF__SPI (0x000E)
#define OFS_UCBxADDMASK (0x001E)
#define OFS_UCBxADDRX (0x001C)
#define OFS_UCBxBCNT__I2C (0x0009)
#define OFS_UCBxBR0 (0x0006)
#define OFS_UCBxBR0__SPI (0x0006)
#define OFS_UCBxBR1 (0x0007)
#define OFS_UCBxBR1__SPI (0x0007)
#define OFS_UCBxBRW (0x0006)
#define OFS_UCBxBRW__SPI (0x0006)
#define OFS_UCBxCTL0 (0x0001)
#define OFS_UCBxCTL0__SPI (0x0001)
#define OFS_UCBxCTL1 (0x0000)
#define OFS_UCBxCTL1__SPI (0x0000)
#define OFS_UCBxCTLW0 (0x0000)
#define OFS_UCBxCTLW0__SPI (0x0000)
#define OFS_UCBxCTLW1 (0x0002)
#define OFS_UCBxI2COA0 (0x0014)
#define OFS_UCBxI2COA1 (0x0016)
#define OFS_UCBxI2COA2 (0x0018)
#define OFS_UCBxI2COA3 (0x001A)
#define OFS_UCBxI2CSA (0x0020)
#define OFS_UCBxIE (0x002A)
#define OFS_UCBxIE__I2C (0x002A)
#define OFS_UCBxIE__SPI (0x002A)
#define OFS_UCBxIFG (0x002C)
#define OFS_UCBxIFG__I2C (0x002C)
#define OFS_UCBxIFG__SPI (0x002C)
#define OFS_UCBxIV (0x002E)
#define OFS_UCBxIV__SPI (0x002E)
#define OFS_UCBxRXBUF (0x000C)
#define OFS_UCBxRXBUF__SPI (0x000C)
#define OFS_UCBxSTATW (0x0008)
#define OFS_UCBxSTATW__I2C (0x0008)
#define OFS_UCBxSTATW__SPI (0x0008)
#define OFS_UCBxSTAT__I2C (0x0008)
#define OFS_UCBxTBCNT (0x000A)
#define OFS_UCBxTXBUF (0x000E)
#define OFS_UCBxTXBUF__SPI (0x000E)
#define OFS_UDMA_ALTBASE (0x0000000C)
#define OFS_UDMA_ALTCLR (0x00000034)
#define OFS_UDMA_ALTSET (0x00000030)
#define OFS_UDMA_CFG (0x00000004)
#define OFS_UDMA_CTLBASE (0x00000008)
#define OFS_UDMA_ENACLR (0x0000002C)
#define OFS_UDMA_ENASET (0x00000028)
#define OFS_UDMA_ERRCLR (0x0000004C)
#define OFS_UDMA_PCELL_ID_0 (0x00000FF0)
#define OFS_UDMA_PCELL_ID_1 (0x00000FF4)
#define OFS_UDMA_PCELL_ID_2 (0x00000FF8)
#define OFS_UDMA_PCELL_ID_3 (0x00000FFC)
#define OFS_UDMA_PERIPH_ID_0 (0x00000FE0)
#define OFS_UDMA_PERIPH_ID_1 (0x00000FE4)
#define OFS_UDMA_PERIPH_ID_2 (0x00000FE8)
#define OFS_UDMA_PERIPH_ID_3 (0x00000FEC)
#define OFS_UDMA_PERIPH_ID_4 (0x00000FD0)
#define OFS_UDMA_PRIOCLR (0x0000003C)
#define OFS_UDMA_PRIOSET (0x00000038)
#define OFS_UDMA_REQMASKCLR (0x00000024)
#define OFS_UDMA_REQMASKSET (0x00000020)
#define OFS_UDMA_STAT (0x00000000)
#define OFS_UDMA_SWREQ (0x00000014)
#define OFS_UDMA_USEBURSTCLR (0x0000001C)
#define OFS_UDMA_USEBURSTSET (0x00000018)
#define OFS_UDMA_WAITSTAT (0x00000010)
#define OFS_WDTCTL (OFS_WDT_A_CTL)
#define OFS_WDTCTL_H (OFS_WDTCTL+1)
#define OFS_WDTCTL_L (OFS_WDTCTL)
#define OFS_WDT_A_CTL (0x0000000C)
#define OUTMOD0 (0x0020)
#define OUTMOD1 (0x0040)
#define OUTMOD2 (0x0080)
#define P10IV_NONE (0x0000)
#define P10IV_P10IFG0 (0x0002)
#define P10IV_P10IFG1 (0x0004)
#define P10IV_P10IFG2 (0x0006)
#define P10IV_P10IFG3 (0x0008)
#define P10IV_P10IFG4 (0x000A)
#define P10IV_P10IFG5 (0x000C)
#define P10IV_P10IFG6 (0x000E)
#define P10IV_P10IFG7 (0x0010)
#define P10_DIR (HWREG8(0x40004C85))
#define P10_DS (HWREG8(0x40004C89))
#define P10_IE (HWREG8(0x40004C9B))
#define P10_IES (HWREG8(0x40004C99))
#define P10_IFG (HWREG8(0x40004C9D))
#define P10_IN (HWREG8(0x40004C81))
#define P10_IV (HWREG8(0x40004C9E))
#define P10_OUT (HWREG8(0x40004C83))
#define P10_REN (HWREG8(0x40004C87))
#define P10_SEL0 (HWREG8(0x40004C8B))
#define P10_SEL1 (HWREG8(0x40004C8D))
#define P10_SELC (HWREG8(0x40004C97))
#define P1IV_NONE (0x0000)
#define P1IV_P1IFG0 (0x0002)
#define P1IV_P1IFG1 (0x0004)
#define P1IV_P1IFG2 (0x0006)
#define P1IV_P1IFG3 (0x0008)
#define P1IV_P1IFG4 (0x000A)
#define P1IV_P1IFG5 (0x000C)
#define P1IV_P1IFG6 (0x000E)
#define P1IV_P1IFG7 (0x0010)
#define P1MAP0 (PMAP_P1MAP0)
#define P1MAP1 (PMAP_P1MAP1)
#define P1MAP2 (PMAP_P1MAP2)
#define P1MAP3 (PMAP_P1MAP3)
#define P1MAP4 (PMAP_P1MAP4)
#define P1MAP5 (PMAP_P1MAP5)
#define P1MAP6 (PMAP_P1MAP6)
#define P1MAP7 (PMAP_P1MAP7)
#define P1_DIR (HWREG8(0x40004C04))
#define P1_DS (HWREG8(0x40004C08))
#define P1_IE (HWREG8(0x40004C1A))
#define P1_IES (HWREG8(0x40004C18))
#define P1_IFG (HWREG8(0x40004C1C))
#define P1_IN (HWREG8(0x40004C00))
#define P1_IV (HWREG8(0x40004C0E))
#define P1_OUT (HWREG8(0x40004C02))
#define P1_REN (HWREG8(0x40004C06))
#define P1_SEL0 (HWREG8(0x40004C0A))
#define P1_SEL1 (HWREG8(0x40004C0C))
#define P1_SELC (HWREG8(0x40004C16))
#define P2IV_NONE (0x0000)
#define P2IV_P2IFG0 (0x0002)
#define P2IV_P2IFG1 (0x0004)
#define P2IV_P2IFG2 (0x0006)
#define P2IV_P2IFG3 (0x0008)
#define P2IV_P2IFG4 (0x000A)
#define P2IV_P2IFG5 (0x000C)
#define P2IV_P2IFG6 (0x000E)
#define P2IV_P2IFG7 (0x0010)
#define P2MAP0 (PMAP_P2MAP0)
#define P2MAP1 (PMAP_P2MAP1)
#define P2MAP2 (PMAP_P2MAP2)
#define P2MAP3 (PMAP_P2MAP3)
#define P2MAP4 (PMAP_P2MAP4)
#define P2MAP5 (PMAP_P2MAP5)
#define P2MAP6 (PMAP_P2MAP6)
#define P2MAP7 (PMAP_P2MAP7)
#define P2_DIR (HWREG8(0x40004C05))
#define P2_DS (HWREG8(0x40004C09))
#define P2_IE (HWREG8(0x40004C1B))
#define P2_IES (HWREG8(0x40004C19))
#define P2_IFG (HWREG8(0x40004C1D))
#define P2_IN (HWREG8(0x40004C01))
#define P2_IV (HWREG8(0x40004C1E))
#define P2_OUT (HWREG8(0x40004C03))
#define P2_REN (HWREG8(0x40004C07))
#define P2_SEL0 (HWREG8(0x40004C0B))
#define P2_SEL1 (HWREG8(0x40004C0D))
#define P2_SELC (HWREG8(0x40004C17))
#define P3IV_NONE (0x0000)
#define P3IV_P3IFG0 (0x0002)
#define P3IV_P3IFG1 (0x0004)
#define P3IV_P3IFG2 (0x0006)
#define P3IV_P3IFG3 (0x0008)
#define P3IV_P3IFG4 (0x000A)
#define P3IV_P3IFG5 (0x000C)
#define P3IV_P3IFG6 (0x000E)
#define P3IV_P3IFG7 (0x0010)
#define P3MAP0 (PMAP_P3MAP0)
#define P3MAP1 (PMAP_P3MAP1)
#define P3MAP2 (PMAP_P3MAP2)
#define P3MAP3 (PMAP_P3MAP3)
#define P3MAP4 (PMAP_P3MAP4)
#define P3MAP5 (PMAP_P3MAP5)
#define P3MAP6 (PMAP_P3MAP6)
#define P3MAP7 (PMAP_P3MAP7)
#define P3_DIR (HWREG8(0x40004C24))
#define P3_DS (HWREG8(0x40004C28))
#define P3_IE (HWREG8(0x40004C3A))
#define P3_IES (HWREG8(0x40004C38))
#define P3_IFG (HWREG8(0x40004C3C))
#define P3_IN (HWREG8(0x40004C20))
#define P3_IV (HWREG8(0x40004C2E))
#define P3_OUT (HWREG8(0x40004C22))
#define P3_REN (HWREG8(0x40004C26))
#define P3_SEL0 (HWREG8(0x40004C2A))
#define P3_SEL1 (HWREG8(0x40004C2C))
#define P3_SELC (HWREG8(0x40004C36))
#define P4IV_NONE (0x0000)
#define P4IV_P4IFG0 (0x0002)
#define P4IV_P4IFG1 (0x0004)
#define P4IV_P4IFG2 (0x0006)
#define P4IV_P4IFG3 (0x0008)
#define P4IV_P4IFG4 (0x000A)
#define P4IV_P4IFG5 (0x000C)
#define P4IV_P4IFG6 (0x000E)
#define P4IV_P4IFG7 (0x0010)
#define P4MAP0 (PMAP_P4MAP0)
#define P4MAP1 (PMAP_P4MAP1)
#define P4MAP2 (PMAP_P4MAP2)
#define P4MAP3 (PMAP_P4MAP3)
#define P4MAP4 (PMAP_P4MAP4)
#define P4MAP5 (PMAP_P4MAP5)
#define P4MAP6 (PMAP_P4MAP6)
#define P4MAP7 (PMAP_P4MAP7)
#define P4_DIR (HWREG8(0x40004C25))
#define P4_DS (HWREG8(0x40004C29))
#define P4_IE (HWREG8(0x40004C3B))
#define P4_IES (HWREG8(0x40004C39))
#define P4_IFG (HWREG8(0x40004C3D))
#define P4_IN (HWREG8(0x40004C21))
#define P4_IV (HWREG8(0x40004C3E))
#define P4_OUT (HWREG8(0x40004C23))
#define P4_REN (HWREG8(0x40004C27))
#define P4_SEL0 (HWREG8(0x40004C2B))
#define P4_SEL1 (HWREG8(0x40004C2D))
#define P4_SELC (HWREG8(0x40004C37))
#define P5IV_NONE (0x0000)
#define P5IV_P5IFG0 (0x0002)
#define P5IV_P5IFG1 (0x0004)
#define P5IV_P5IFG2 (0x0006)
#define P5IV_P5IFG3 (0x0008)
#define P5IV_P5IFG4 (0x000A)
#define P5IV_P5IFG5 (0x000C)
#define P5IV_P5IFG6 (0x000E)
#define P5IV_P5IFG7 (0x0010)
#define P5MAP0 (PMAP_P5MAP0)
#define P5MAP1 (PMAP_P5MAP1)
#define P5MAP2 (PMAP_P5MAP2)
#define P5MAP3 (PMAP_P5MAP3)
#define P5MAP4 (PMAP_P5MAP4)
#define P5MAP5 (PMAP_P5MAP5)
#define P5MAP6 (PMAP_P5MAP6)
#define P5MAP7 (PMAP_P5MAP7)
#define P5_DIR (HWREG8(0x40004C44))
#define P5_DS (HWREG8(0x40004C48))
#define P5_IE (HWREG8(0x40004C5A))
#define P5_IES (HWREG8(0x40004C58))
#define P5_IFG (HWREG8(0x40004C5C))
#define P5_IN (HWREG8(0x40004C40))
#define P5_IV (HWREG8(0x40004C4E))
#define P5_OUT (HWREG8(0x40004C42))
#define P5_REN (HWREG8(0x40004C46))
#define P5_SEL0 (HWREG8(0x40004C4A))
#define P5_SEL1 (HWREG8(0x40004C4C))
#define P5_SELC (HWREG8(0x40004C56))
#define P6IV_NONE (0x0000)
#define P6IV_P6IFG0 (0x0002)
#define P6IV_P6IFG1 (0x0004)
#define P6IV_P6IFG2 (0x0006)
#define P6IV_P6IFG3 (0x0008)
#define P6IV_P6IFG4 (0x000A)
#define P6IV_P6IFG5 (0x000C)
#define P6IV_P6IFG6 (0x000E)
#define P6IV_P6IFG7 (0x0010)
#define P6_DIR (HWREG8(0x40004C45))
#define P6_DS (HWREG8(0x40004C49))
#define P6_IE (HWREG8(0x40004C5B))
#define P6_IES (HWREG8(0x40004C59))
#define P6_IFG (HWREG8(0x40004C5D))
#define P6_IN (HWREG8(0x40004C41))
#define P6_IV (HWREG8(0x40004C5E))
#define P6_OUT (HWREG8(0x40004C43))
#define P6_REN (HWREG8(0x40004C47))
#define P6_SEL0 (HWREG8(0x40004C4B))
#define P6_SEL1 (HWREG8(0x40004C4D))
#define P6_SELC (HWREG8(0x40004C57))
#define P7IV_NONE (0x0000)
#define P7IV_P7IFG0 (0x0002)
#define P7IV_P7IFG1 (0x0004)
#define P7IV_P7IFG2 (0x0006)
#define P7IV_P7IFG3 (0x0008)
#define P7IV_P7IFG4 (0x000A)
#define P7IV_P7IFG5 (0x000C)
#define P7IV_P7IFG6 (0x000E)
#define P7IV_P7IFG7 (0x0010)
#define P7_DIR (HWREG8(0x40004C64))
#define P7_DS (HWREG8(0x40004C68))
#define P7_IE (HWREG8(0x40004C7A))
#define P7_IES (HWREG8(0x40004C78))
#define P7_IFG (HWREG8(0x40004C7C))
#define P7_IN (HWREG8(0x40004C60))
#define P7_IV (HWREG8(0x40004C6E))
#define P7_OUT (HWREG8(0x40004C62))
#define P7_REN (HWREG8(0x40004C66))
#define P7_SEL0 (HWREG8(0x40004C6A))
#define P7_SEL1 (HWREG8(0x40004C6C))
#define P7_SELC (HWREG8(0x40004C76))
#define P8IV_NONE (0x0000)
#define P8IV_P8IFG0 (0x0002)
#define P8IV_P8IFG1 (0x0004)
#define P8IV_P8IFG2 (0x0006)
#define P8IV_P8IFG3 (0x0008)
#define P8IV_P8IFG4 (0x000A)
#define P8IV_P8IFG5 (0x000C)
#define P8IV_P8IFG6 (0x000E)
#define P8IV_P8IFG7 (0x0010)
#define P8_DIR (HWREG8(0x40004C65))
#define P8_DS (HWREG8(0x40004C69))
#define P8_IE (HWREG8(0x40004C7B))
#define P8_IES (HWREG8(0x40004C79))
#define P8_IFG (HWREG8(0x40004C7D))
#define P8_IN (HWREG8(0x40004C61))
#define P8_IV (HWREG8(0x40004C7E))
#define P8_OUT (HWREG8(0x40004C63))
#define P8_REN (HWREG8(0x40004C67))
#define P8_SEL0 (HWREG8(0x40004C6B))
#define P8_SEL1 (HWREG8(0x40004C6D))
#define P8_SELC (HWREG8(0x40004C77))
#define P9IV_NONE (0x0000)
#define P9IV_P9IFG0 (0x0002)
#define P9IV_P9IFG1 (0x0004)
#define P9IV_P9IFG2 (0x0006)
#define P9IV_P9IFG3 (0x0008)
#define P9IV_P9IFG4 (0x000A)
#define P9IV_P9IFG5 (0x000C)
#define P9IV_P9IFG6 (0x000E)
#define P9IV_P9IFG7 (0x0010)
#define P9_DIR (HWREG8(0x40004C84))
#define P9_DS (HWREG8(0x40004C88))
#define P9_IE (HWREG8(0x40004C9A))
#define P9_IES (HWREG8(0x40004C98))
#define P9_IFG (HWREG8(0x40004C9C))
#define P9_IN (HWREG8(0x40004C80))
#define P9_IV (HWREG8(0x40004C8E))
#define P9_OUT (HWREG8(0x40004C82))
#define P9_REN (HWREG8(0x40004C86))
#define P9_SEL0 (HWREG8(0x40004C8A))
#define P9_SEL1 (HWREG8(0x40004C8C))
#define P9_SELC (HWREG8(0x40004C96))
#define PADIR_H (HWREG8_H(PADIR))
#define PADIR_L (HWREG8_L(PADIR))
#define PAIES_H (HWREG8_H(PAIES))
#define PAIES_L (HWREG8_L(PAIES))
#define PAIE_H (HWREG8_H(PAIE))
#define PAIE_L (HWREG8_L(PAIE))
#define PAIFG_H (HWREG8_H(PAIFG))
#define PAIFG_L (HWREG8_L(PAIFG))
#define PAIN_H (HWREG8_H(PAIN))
#define PAIN_L (HWREG8_L(PAIN))
#define PAOUT_H (HWREG8_H(PAOUT))
#define PAOUT_L (HWREG8_L(PAOUT))
#define PAREN_H (HWREG8_H(PAREN))
#define PAREN_L (HWREG8_L(PAREN))
#define PASEL0_H (HWREG8_H(PASEL0))
#define PASEL0_L (HWREG8_L(PASEL0))
#define PASEL1_H (HWREG8_H(PASEL1))
#define PASEL1_L (HWREG8_L(PASEL1))
#define PA_DIR (HWREG16(0x40004C04))
#define PA_DS (HWREG16(0x40004C08))
#define PA_IE (HWREG16(0x40004C1A))
#define PA_IES (HWREG16(0x40004C18))
#define PA_IFG (HWREG16(0x40004C1C))
#define PA_IN (HWREG16(0x40004C00))
#define PA_OUT (HWREG16(0x40004C02))
#define PA_REN (HWREG16(0x40004C06))
#define PA_SEL0 (HWREG16(0x40004C0A))
#define PA_SEL1 (HWREG16(0x40004C0C))
#define PA_SELC (HWREG16(0x40004C16))
#define PBDIR_H (HWREG8_H(PBDIR))
#define PBDIR_L (HWREG8_L(PBDIR))
#define PBIES_H (HWREG8_H(PBIES))
#define PBIES_L (HWREG8_L(PBIES))
#define PBIE_H (HWREG8_H(PBIE))
#define PBIE_L (HWREG8_L(PBIE))
#define PBIFG_H (HWREG8_H(PBIFG))
#define PBIFG_L (HWREG8_L(PBIFG))
#define PBIN_H (HWREG8_H(PBIN))
#define PBIN_L (HWREG8_L(PBIN))
#define PBOUT_H (HWREG8_H(PBOUT))
#define PBOUT_L (HWREG8_L(PBOUT))
#define PBREN_H (HWREG8_H(PBREN))
#define PBREN_L (HWREG8_L(PBREN))
#define PBSEL0_H (HWREG8_H(PBSEL0))
#define PBSEL0_L (HWREG8_L(PBSEL0))
#define PBSEL1_H (HWREG8_H(PBSEL1))
#define PBSEL1_L (HWREG8_L(PBSEL1))
#define PB_DIR (HWREG16(0x40004C24))
#define PB_DS (HWREG16(0x40004C28))
#define PB_IE (HWREG16(0x40004C3A))
#define PB_IES (HWREG16(0x40004C38))
#define PB_IFG (HWREG16(0x40004C3C))
#define PB_IN (HWREG16(0x40004C20))
#define PB_OUT (HWREG16(0x40004C22))
#define PB_REN (HWREG16(0x40004C26))
#define PB_SEL0 (HWREG16(0x40004C2A))
#define PB_SEL1 (HWREG16(0x40004C2C))
#define PB_SELC (HWREG16(0x40004C36))
#define PCDIR_H (HWREG8_H(PCDIR))
#define PCDIR_L (HWREG8_L(PCDIR))
#define PCIES_H (HWREG8_H(PCIES))
#define PCIES_L (HWREG8_L(PCIES))
#define PCIE_H (HWREG8_H(PCIE))
#define PCIE_L (HWREG8_L(PCIE))
#define PCIFG_H (HWREG8_H(PCIFG))
#define PCIFG_L (HWREG8_L(PCIFG))
#define PCIN_H (HWREG8_H(PCIN))
#define PCIN_L (HWREG8_L(PCIN))
#define PCM_CTL (HWREG32(0x40010004))
#define PCM_CTL_FORCE_DSL_SD_ENTRY (0x00000004)
#define PCM_CTL_KEY_VAL (0x695A0000)
#define PCM_CTL_KEY__M (0xffff0000)
#define PCM_CTL_LOCKRTC (0x00000002)
#define PCM_CTL_LOCKRTC__0 (0x00000000)
#define PCM_CTL_LOCKRTC__1 (0x00000002)
#define PCM_CTL_LOCKSD (0x00000001)
#define PCM_CTL_LOCKSD__0 (0x00000000)
#define PCM_CTL_LOCKSD__1 (0x00000001)
#define PCM_CTL_PMR_BUSY (0x00000100)
#define PCM_INTCLR (HWREG32(0x40010010))
#define PCM_INTCLR_CLR_AM_INVALID_TR (0x00000004)
#define PCM_INTCLR_CLR_AM_INVALID_TR__0 (0x00000000)
#define PCM_INTCLR_CLR_AM_INVALID_TR__0_NO_EFFECT (0x00000000)
#define PCM_INTCLR_CLR_AM_INVALID_TR__1 (0x00000004)
#define PCM_INTCLR_CLR_AM_INVALID_TR__1_CLEAR_FLAG (0x00000004)
#define PCM_INTCLR_CLR_DCDC_ERROR (0x00000040)
#define PCM_INTCLR_CLR_DCDC_ERROR__0 (0x00000000)
#define PCM_INTCLR_CLR_DCDC_ERROR__0_NO_EFFECT (0x00000000)
#define PCM_INTCLR_CLR_DCDC_ERROR__1 (0x00000040)
#define PCM_INTCLR_CLR_DCDC_ERROR__1_CLEAR_FLAG (0x00000040)
#define PCM_INTCLR_CLR_SM_INVALID_CLK (0x00000002)
#define PCM_INTCLR_CLR_SM_INVALID_CLK__0 (0x00000000)
#define PCM_INTCLR_CLR_SM_INVALID_CLK__0_NO_EFFECT (0x00000000)
#define PCM_INTCLR_CLR_SM_INVALID_CLK__1 (0x00000002)
#define PCM_INTCLR_CLR_SM_INVALID_CLK__1_CLEAR_FLAG (0x00000002)
#define PCM_INTCLR_CLR_SM_INVALID_TR (0x00000001)
#define PCM_INTCLR_CLR_SM_INVALID_TR__0 (0x00000000)
#define PCM_INTCLR_CLR_SM_INVALID_TR__0_NO_EFFECT (0x00000000)
#define PCM_INTCLR_CLR_SM_INVALID_TR__1 (0x00000001)
#define PCM_INTCLR_CLR_SM_INVALID_TR__1_CLEAR_FLAG (0x00000001)
#define PCM_INTEN (HWREG32(0x40010008))
#define PCM_INTEN_EN_AM_INVALID_TR (0x00000004)
#define PCM_INTEN_EN_AM_INVALID_TR__0 (0x00000000)
#define PCM_INTEN_EN_AM_INVALID_TR__0_DISABLED (0x00000000)
#define PCM_INTEN_EN_AM_INVALID_TR__1 (0x00000004)
#define PCM_INTEN_EN_AM_INVALID_TR__1_ENABLED (0x00000004)
#define PCM_INTEN_EN_DCDC_ERROR (0x00000040)
#define PCM_INTEN_EN_DCDC_ERROR__0 (0x00000000)
#define PCM_INTEN_EN_DCDC_ERROR__0_DISABLED (0x00000000)
#define PCM_INTEN_EN_DCDC_ERROR__1 (0x00000040)
#define PCM_INTEN_EN_DCDC_ERROR__1_ENABLED (0x00000040)
#define PCM_INTEN_EN_SM_INVALID_CLK (0x00000002)
#define PCM_INTEN_EN_SM_INVALID_CLK__0 (0x00000000)
#define PCM_INTEN_EN_SM_INVALID_CLK__0_DISABLED (0x00000000)
#define PCM_INTEN_EN_SM_INVALID_CLK__1 (0x00000002)
#define PCM_INTEN_EN_SM_INVALID_CLK__1_ENABLED (0x00000002)
#define PCM_INTEN_EN_SM_INVALID_TR (0x00000001)
#define PCM_INTEN_EN_SM_INVALID_TR__0 (0x00000000)
#define PCM_INTEN_EN_SM_INVALID_TR__0_DISABLED (0x00000000)
#define PCM_INTEN_EN_SM_INVALID_TR__1 (0x00000001)
#define PCM_INTEN_EN_SM_INVALID_TR__1_ENABLED (0x00000001)
#define PCM_INTFLAG (HWREG32(0x4001000C))
#define PCM_INTFLAG_AM_INVALID_TR (0x00000004)
#define PCM_INTFLAG_DCDC_ERROR (0x00000040)
#define PCM_INTFLAG_SM_INVALID_CLK (0x00000002)
#define PCM_INTFLAG_SM_INVALID_TR (0x00000001)
#define PCM_PMR (HWREG32(0x40010000))
#define PCM_PMR_AMR__0 (0x00000000)
#define PCM_PMR_AMR__0_AM0_LDO (0x00000000)
#define PCM_PMR_AMR__1 (0x00000001)
#define PCM_PMR_AMR__1_AM1_LDO (0x00000001)
#define PCM_PMR_AMR__4 (0x00000004)
#define PCM_PMR_AMR__4_AM0_DCDC (0x00000004)
#define PCM_PMR_AMR__5 (0x00000005)
#define PCM_PMR_AMR__5_AM1_DCDC (0x00000005)
#define PCM_PMR_AMR__8 (0x00000008)
#define PCM_PMR_AMR__8_AM0_LPR (0x00000008)
#define PCM_PMR_AMR__9 (0x00000009)
#define PCM_PMR_AMR__9_AM1_LPR (0x00000009)
#define PCM_PMR_AMR__M (0x0000000f)
#define PCM_PMR_CPM__0 (0x00000000)
#define PCM_PMR_CPM__0_AM0_LDO (0x00000000)
#define PCM_PMR_CPM__1 (0x00000100)
#define PCM_PMR_CPM__16 (0x00001000)
#define PCM_PMR_CPM__16_SL0_LDO (0x00001000)
#define PCM_PMR_CPM__17 (0x00001100)
#define PCM_PMR_CPM__17_SL1_LDO (0x00001100)
#define PCM_PMR_CPM__1_AM1_LDO (0x00000100)
#define PCM_PMR_CPM__20 (0x00001400)
#define PCM_PMR_CPM__20_SL0_DCDC (0x00001400)
#define PCM_PMR_CPM__21 (0x00001500)
#define PCM_PMR_CPM__21_SL1_DCDC (0x00001500)
#define PCM_PMR_CPM__24 (0x00001800)
#define PCM_PMR_CPM__24_SL0_LPR (0x00001800)
#define PCM_PMR_CPM__25 (0x00001900)
#define PCM_PMR_CPM__25_SL1_LPR (0x00001900)
#define PCM_PMR_CPM__32 (0x00002000)
#define PCM_PMR_CPM__32_DSL (0x00002000)
#define PCM_PMR_CPM__4 (0x00000400)
#define PCM_PMR_CPM__4_AM0_DCDC (0x00000400)
#define PCM_PMR_CPM__5 (0x00000500)
#define PCM_PMR_CPM__5_AM1_DCDC (0x00000500)
#define PCM_PMR_CPM__63 (0x00003f00)
#define PCM_PMR_CPM__63_AM_DEFAULT (0x00003f00)
#define PCM_PMR_CPM__8 (0x00000800)
#define PCM_PMR_CPM__8_AM0_LPR (0x00000800)
#define PCM_PMR_CPM__9 (0x00000900)
#define PCM_PMR_CPM__9_AM1_LPR (0x00000900)
#define PCM_PMR_CPM__M (0x00003f00)
#define PCM_PMR_KEY_VAL (0x695A0000)
#define PCM_PMR_KEY__M (0xffff0000)
#define PCM_PMR_SDR__0 (0x00000000)
#define PCM_PMR_SDR__10 (0x000000a0)
#define PCM_PMR_SDR__12 (0x000000c0)
#define PCM_PMR_SDR__M (0x000000f0)
#define PCOUT_H (HWREG8_H(PCOUT))
#define PCOUT_L (HWREG8_L(PCOUT))
#define PCREN_H (HWREG8_H(PCREN))
#define PCREN_L (HWREG8_L(PCREN))
#define PCSEL0_H (HWREG8_H(PCSEL0))
#define PCSEL0_L (HWREG8_L(PCSEL0))
#define PCSEL1_H (HWREG8_H(PCSEL1))
#define PCSEL1_L (HWREG8_L(PCSEL1))
#define PC_DIR (HWREG16(0x40004C44))
#define PC_DS (HWREG16(0x40004C48))
#define PC_IE (HWREG16(0x40004C5A))
#define PC_IES (HWREG16(0x40004C58))
#define PC_IFG (HWREG16(0x40004C5C))
#define PC_IN (HWREG16(0x40004C40))
#define PC_OUT (HWREG16(0x40004C42))
#define PC_REN (HWREG16(0x40004C46))
#define PC_SEL0 (HWREG16(0x40004C4A))
#define PC_SEL1 (HWREG16(0x40004C4C))
#define PC_SELC (HWREG16(0x40004C56))
#define PDDIR_H (HWREG8_H(PDDIR))
#define PDDIR_L (HWREG8_L(PDDIR))
#define PDIN_H (HWREG8_H(PDIN))
#define PDIN_L (HWREG8_L(PDIN))
#define PDOUT_H (HWREG8_H(PDOUT))
#define PDOUT_L (HWREG8_L(PDOUT))
#define PDREN_H (HWREG8_H(PDREN))
#define PDREN_L (HWREG8_L(PDREN))
#define PDSEL0_H (HWREG8_H(PDSEL0))
#define PDSEL0_L (HWREG8_L(PDSEL0))
#define PDSEL1_H (HWREG8_H(PDSEL1))
#define PDSEL1_L (HWREG8_L(PDSEL1))
#define PD_DIR (HWREG16(0x40004C64))
#define PD_DS (HWREG16(0x40004C68))
#define PD_IE (HWREG16(0x40004C7A))
#define PD_IES (HWREG16(0x40004C78))
#define PD_IFG (HWREG16(0x40004C7C))
#define PD_IN (HWREG16(0x40004C60))
#define PD_OUT (HWREG16(0x40004C62))
#define PD_REN (HWREG16(0x40004C66))
#define PD_SEL0 (HWREG16(0x40004C6A))
#define PD_SEL1 (HWREG16(0x40004C6C))
#define PD_SELC (HWREG16(0x40004C76))
#define PEDIR_H (HWREG8_H(PEDIR))
#define PEDIR_L (HWREG8_L(PEDIR))
#define PEIN_H (HWREG8_H(PEIN))
#define PEIN_L (HWREG8_L(PEIN))
#define PEOUT_H (HWREG8_H(PEOUT))
#define PEOUT_L (HWREG8_L(PEOUT))
#define PERCNTSEL__0 (0x00000000)
#define PERCNTSEL__1 (0x00000100)
#define PEREN_H (HWREG8_H(PEREN))
#define PEREN_L (HWREG8_L(PEREN))
#define PESEL0_H (HWREG8_H(PESEL0))
#define PESEL0_L (HWREG8_L(PESEL0))
#define PESEL1_H (HWREG8_H(PESEL1))
#define PESEL1_L (HWREG8_L(PESEL1))
#define PE_DIR (HWREG16(0x40004C84))
#define PE_DS (HWREG16(0x40004C88))
#define PE_IE (HWREG16(0x40004C9A))
#define PE_IES (HWREG16(0x40004C98))
#define PE_IFG (HWREG16(0x40004C9C))
#define PE_IN (HWREG16(0x40004C80))
#define PE_OUT (HWREG16(0x40004C82))
#define PE_REN (HWREG16(0x40004C86))
#define PE_SEL0 (HWREG16(0x40004C8A))
#define PE_SEL1 (HWREG16(0x40004C8C))
#define PE_SELC (HWREG16(0x40004C96))
#define PJDIR_H (HWREG8_H(PJDIR))
#define PJDIR_L (HWREG8_L(PJDIR))
#define PJIN_H (HWREG8_H(PJIN))
#define PJIN_L (HWREG8_L(PJIN))
#define PJOUT_H (HWREG8_H(PJOUT))
#define PJOUT_L (HWREG8_L(PJOUT))
#define PJREN_H (HWREG8_H(PJREN))
#define PJREN_L (HWREG8_L(PJREN))
#define PJSEL0_H (HWREG8_H(PJSEL0))
#define PJSEL0_L (HWREG8_L(PJSEL0))
#define PJSEL1_H (HWREG8_H(PJSEL1))
#define PJSEL1_L (HWREG8_L(PJSEL1))
#define PJ_DIR (HWREG16(0x40004D24))
#define PJ_DS (HWREG8(0x40004D28))
#define PJ_IN (HWREG16(0x40004D20))
#define PJ_OUT (HWREG16(0x40004D22))
#define PJ_REN (HWREG16(0x40004D26))
#define PJ_SEL0 (HWREG16(0x40004D2A))
#define PJ_SEL1 (HWREG16(0x40004D2C))
#define PJ_SELC (HWREG16(0x40004D36))
#define PMAPCTL_H (HWREG8_H(PMAPCTL))
#define PMAPCTL_L (HWREG8_L(PMAPCTL))
#define PMAPKEY (0x2D52)
#define PMAPKEYID_H (HWREG8_H(PMAPKEYID))
#define PMAPKEYID_L (HWREG8_L(PMAPKEYID))
#define PMAPLOCKED_L (0x0001)
#define PMAPPW (0x2D52)
#define PMAPPWD (PMAPKEYID)
#define PMAPRECFG_L (0x0002)
#define PMAP_CTL (HWREG16(0x40005002))
#define PMAP_CTL_LOCKED (0x0001)
#define PMAP_CTL_LOCKED__0 (0x0000)
#define PMAP_CTL_LOCKED__1 (0x0001)
#define PMAP_CTL_RECFG (0x0002)
#define PMAP_CTL_RECFG__0 (0x0000)
#define PMAP_CTL_RECFG__1 (0x0002)
#define PMAP_KEYID (HWREG16(0x40005000))
#define PMAP_P1MAP0 (HWREG8(0x40005008))
#define PMAP_P1MAP1 (HWREG8(0x40005009))
#define PMAP_P1MAP2 (HWREG8(0x4000500A))
#define PMAP_P1MAP3 (HWREG8(0x4000500B))
#define PMAP_P1MAP4 (HWREG8(0x4000500C))
#define PMAP_P1MAP5 (HWREG8(0x4000500D))
#define PMAP_P1MAP6 (HWREG8(0x4000500E))
#define PMAP_P1MAP7 (HWREG8(0x4000500F))
#define PMAP_P2MAP0 (HWREG8(0x40005010))
#define PMAP_P2MAP1 (HWREG8(0x40005011))
#define PMAP_P2MAP2 (HWREG8(0x40005012))
#define PMAP_P2MAP3 (HWREG8(0x40005013))
#define PMAP_P2MAP4 (HWREG8(0x40005014))
#define PMAP_P2MAP5 (HWREG8(0x40005015))
#define PMAP_P2MAP6 (HWREG8(0x40005016))
#define PMAP_P2MAP7 (HWREG8(0x40005017))
#define PMAP_P3MAP0 (HWREG8(0x40005018))
#define PMAP_P3MAP1 (HWREG8(0x40005019))
#define PMAP_P3MAP2 (HWREG8(0x4000501A))
#define PMAP_P3MAP3 (HWREG8(0x4000501B))
#define PMAP_P3MAP4 (HWREG8(0x4000501C))
#define PMAP_P3MAP5 (HWREG8(0x4000501D))
#define PMAP_P3MAP6 (HWREG8(0x4000501E))
#define PMAP_P3MAP7 (HWREG8(0x4000501F))
#define PMAP_P4MAP0 (HWREG8(0x40005020))
#define PMAP_P4MAP1 (HWREG8(0x40005021))
#define PMAP_P4MAP2 (HWREG8(0x40005022))
#define PMAP_P4MAP3 (HWREG8(0x40005023))
#define PMAP_P4MAP4 (HWREG8(0x40005024))
#define PMAP_P4MAP5 (HWREG8(0x40005025))
#define PMAP_P4MAP6 (HWREG8(0x40005026))
#define PMAP_P4MAP7 (HWREG8(0x40005027))
#define PMAP_P5MAP0 (HWREG8(0x40005028))
#define PMAP_P5MAP1 (HWREG8(0x40005029))
#define PMAP_P5MAP2 (HWREG8(0x4000502A))
#define PMAP_P5MAP3 (HWREG8(0x4000502B))
#define PMAP_P5MAP4 (HWREG8(0x4000502C))
#define PMAP_P5MAP5 (HWREG8(0x4000502D))
#define PMAP_P5MAP6 (HWREG8(0x4000502E))
#define PMAP_P5MAP7 (HWREG8(0x4000502F))
#define PMAP_P6MAP0 (HWREG8(0x40005030))
#define PMAP_P6MAP1 (HWREG8(0x40005031))
#define PMAP_P6MAP2 (HWREG8(0x40005032))
#define PMAP_P6MAP3 (HWREG8(0x40005033))
#define PMAP_P6MAP4 (HWREG8(0x40005034))
#define PMAP_P6MAP5 (HWREG8(0x40005035))
#define PMAP_P6MAP6 (HWREG8(0x40005036))
#define PMAP_P6MAP7 (HWREG8(0x40005037))
#define PMAP_P7MAP0 (HWREG8(0x40005038))
#define PMAP_P7MAP1 (HWREG8(0x40005039))
#define PMAP_P7MAP2 (HWREG8(0x4000503A))
#define PMAP_P7MAP3 (HWREG8(0x4000503B))
#define PMAP_P7MAP4 (HWREG8(0x4000503C))
#define PMAP_P7MAP5 (HWREG8(0x4000503D))
#define PMAP_P7MAP6 (HWREG8(0x4000503E))
#define PMAP_P7MAP7 (HWREG8(0x4000503F))
#define PSS_CLRIFG (HWREG32(0x4001083C))
#define PSS_CLRIFG_CLRSVSLVLRIFG (0x00000001)
#define PSS_CLRIFG_CLRSVSLVLRIFG__0 (0x00000000)
#define PSS_CLRIFG_CLRSVSLVLRIFG__0_NO_EFFECT (0x00000000)
#define PSS_CLRIFG_CLRSVSLVLRIFG__1 (0x00000001)
#define PSS_CLRIFG_CLRSVSMHIFG (0x00000002)
#define PSS_CLRIFG_CLRSVSMHIFG__0 (0x00000000)
#define PSS_CLRIFG_CLRSVSMHIFG__0_NO_EFFECT (0x00000000)
#define PSS_CLRIFG_CLRSVSMHIFG__1 (0x00000002)
#define PSS_DCDCCNFG1 (HWREG32(0x40010B20))
#define PSS_DCDCCNFG2 (HWREG32(0x40010B24))
#define PSS_DCDCCNFG3 (HWREG32(0x40010B28))
#define PSS_DFTATBBF (HWREG32(0x40010F28))
#define PSS_DFTATBBF_ATBBFDCDC (0x00000002)
#define PSS_DFTATBBF_ATBBFFLSH (0x00000004)
#define PSS_DFTATBBF_ATBBFGEN (0x00000001)
#define PSS_DFTATBBF_BG0P6SNSBF (0x00800000)
#define PSS_DFTATBBF_BG1P2SNSBF (0x00400000)
#define PSS_DFTATBBF_BGINTSNSBF (0x00008000)
#define PSS_DFTATBBF_BUFCALBF (0x00000008)
#define PSS_DFTATBBF_LDOINTSNSBF (0x00000010)
#define PSS_DFTATBBF_PRERF0P6SNSBF (0x00080000)
#define PSS_DFTATBBF_PRERFVCSNSBF (0x00200000)
#define PSS_DFTATBBF_RF0P6SNSBF (0x80000000)
#define PSS_DFTATBBF_RFVCSNSBF (0x40000000)
#define PSS_DFTATBBF_UNUSED__M (0x00007fe0)
#define PSS_DFTATBUBF (HWREG32(0x40010F2C))
#define PSS_DFTATBUBF_ATBUBFDCDC (0x00000002)
#define PSS_DFTATBUBF_ATBUBFFLSH (0x00000004)
#define PSS_DFTATBUBF_ATBUBFGEN (0x00000001)
#define PSS_DFTATBUBF_BG0P6SNSUBF (0x00800000)
#define PSS_DFTATBUBF_BG1P2SNSUBF (0x00400000)
#define PSS_DFTATBUBF_BGINTSNSUBF (0x00008000)
#define PSS_DFTATBUBF_BUFCALUBF (0x00000008)
#define PSS_DFTATBUBF_DBGLDOCT0 (0x20000000)
#define PSS_DFTATBUBF_DBGLDOCT1 (0x40000000)
#define PSS_DFTATBUBF_DBGLDOCT2 (0x80000000)
#define PSS_DFTATBUBF_LDOINTSNSUBF (0x00000010)
#define PSS_DFTATBUBF_PRERF0P6SNSUBF (0x00080000)
#define PSS_DFTATBUBF_PRERFVCSNSUBF (0x00200000)
#define PSS_DFTATBUBF_REFCTFRC (0x00004000)
#define PSS_DFTATBUBF_REFGNDSNS (0x00001000)
#define PSS_DFTATBUBF_SVSLIPFRC (0x00000400)
#define PSS_DFTATBUBF_SVSLVCCDIVSNS (0x00000200)
#define PSS_DFTATBUBF_SVSMHIPFRC (0x00002000)
#define PSS_DFTATBUBF_SVSMHVCCDIVSNS (0x00000800)
#define PSS_DFTATBUBF_UNUSED__M (0x000001e0)
#define PSS_DFTCNFG (HWREG32(0x40010F10))
#define PSS_DFTCNFG_LOCAL_TP0_MUX_SEL__M (0x000f0000)
#define PSS_DFTCNFG_LOCAL_TP1_MUX_SEL__M (0x00f00000)
#define PSS_DFTCNFG_LOCAL_TP2_MUX_SEL__M (0x0f000000)
#define PSS_DFTCNFG_LOCAL_TP3_MUX_SEL__M (0xf0000000)
#define PSS_DFTCTRL1 (HWREG32(0x40010F20))
#define PSS_DFTCTRL1_BG_DIS (0x40000000)
#define PSS_DFTCTRL1_CORE_LPM_LDO_DIS (0x00800000)
#define PSS_DFTCTRL1_CORE_LPM_LDO_NO_HIZ_EN (0x04000000)
#define PSS_DFTCTRL1_DCDC_EN (0x00400000)
#define PSS_DFTCTRL1_DCDC_MNK_COMP_EN (0x00200000)
#define PSS_DFTCTRL1_DCDC_TRISTATE_DIS (0x00100000)
#define PSS_DFTCTRL1_DFT_MODE (0x80000000)
#define PSS_DFTCTRL1_DIS_DFT_FL_IREF (0x00000010)
#define PSS_DFTCTRL1_DIS_DFT_FL_LDO (0x00000004)
#define PSS_DFTCTRL1_DIS_DFT_FL_VREF (0x00000008)
#define PSS_DFTCTRL1_DIS_DFT_RHS (0x00000001)
#define PSS_DFTCTRL1_DIS_DFT_RLS (0x00000002)
#define PSS_DFTCTRL1_FLASH_IREF_DIS (0x00002000)
#define PSS_DFTCTRL1_FLASH_LDO_DIS (0x00010000)
#define PSS_DFTCTRL1_FLASH_LDO_TRISTATE_EN (0x00004000)
#define PSS_DFTCTRL1_FLASH_LPM_LDO_EN (0x00008000)
#define PSS_DFTCTRL1_FLASH_VREF_DIS (0x00001000)
#define PSS_DFTCTRL1_LONG_DLY_REQ (0x00000200)
#define PSS_DFTCTRL1_LPM_FAST_OSC_EN (0x00000800)
#define PSS_DFTCTRL1_LPM_SLOW_OSC_EN (0x00000400)
#define PSS_DFTCTRL1_REF_LPM_EN (0x00080000)
#define PSS_DFTCTRL1_REF_SMPL_DIS (0x00040000)
#define PSS_DFTCTRL1_REF_STDBY_EN (0x00020000)
#define PSS_DFTCTRL1_SHORT_DLY_REQ (0x00000100)
#define PSS_DFTCTRL1_SVSL_DIS (0x02000000)
#define PSS_DFTCTRL1_SVSL_LPM_EN (0x01000000)
#define PSS_DFTCTRL1_SVSMH_DIS (0x20000000)
#define PSS_DFTCTRL1_SVSMH_LPM_EN (0x10000000)
#define PSS_DFTCTRL1_VCORE_LDO_DIS (0x08000000)
#define PSS_DFTCTRL2 (HWREG32(0x40010F24))
#define PSS_DFTCTRL2_BG_MOD_OVRDE (0x00010000)
#define PSS_DFTCTRL2_DCDC_BIAS_RDY_OVRDE (0x02000000)
#define PSS_DFTCTRL2_FLASH_IREF_BIAS_RDY_OVRDE (0x00040000)
#define PSS_DFTCTRL2_FLASH_LDO_BIAS_RDY_OVRDE (0x00100000)
#define PSS_DFTCTRL2_FLASH_LDO_PGOOD_OVRDE (0x00080000)
#define PSS_DFTCTRL2_FLASH_VREF_BIAS_RDY_OVRDE (0x00020000)
#define PSS_DFTCTRL2_LDO_BIAS_RDY_OVRDE (0x10000000)
#define PSS_DFTCTRL2_LDO_LPM_BIAS_RDY_OVRDE (0x04000000)
#define PSS_DFTCTRL2_MNK_COMP_OK_OVRDE (0x00200000)
#define PSS_DFTCTRL2_REF_OK_OVRDE (0x80000000)
#define PSS_DFTCTRL2_SVSL_BIAS_RDY_OVRDE (0x00400000)
#define PSS_DFTCTRL2_SVSMH_BIAS_RDY_OVRDE (0x40000000)
#define PSS_DFTCTRL2_SVSMH_LP_OVRDE (0x00008000)
#define PSS_DFTCTRL2_SVS_LP_OVRDE (0x00004000)
#define PSS_DFTCTRL2_TRIM_DONE_OVRDE (0x00800000)
#define PSS_DFTCTRL2_TRIM_SET_OVRDE (0x01000000)
#define PSS_DFTCTRL2_VCC_OK_OVRDE (0x20000000)
#define PSS_DFTCTRL2_VCORE_OK_OVRDE (0x08000000)
#define PSS_DOCMCTL (HWREG32(0x40010808))
#define PSS_DOCMCTL_DOCMCM__0 (0x00000000)
#define PSS_DOCMCTL_DOCMCM__0_TBD (0x00000000)
#define PSS_DOCMCTL_DOCMCM__1 (0x00000008)
#define PSS_DOCMCTL_DOCMCM__1_TBD (0x00000008)
#define PSS_DOCMCTL_DOCMCM__M (0x000001f8)
#define PSS_DOCMCTL_DOCMON (0x00000001)
#define PSS_DOCMCTL_DOCMON__0 (0x00000000)
#define PSS_DOCMCTL_DOCMON__0_DISABLE_DOCM (0x00000000)
#define PSS_DOCMCTL_DOCMON__1 (0x00000001)
#define PSS_DOCMCTL_DOCMON__1_ENABLE_DOCM (0x00000001)
#define PSS_DOCMCTL_DOCMSAMP (0x00000002)
#define PSS_DOCMCTL_DOCMSAMP__0 (0x00000000)
#define PSS_DOCMCTL_DOCMSAMP__1 (0x00000002)
#define PSS_DOCMOUTR (HWREG32(0x4001080C))
#define PSS_DOCMOUTR_DOCMOUT__M (0x0000003f)
#define PSS_FLSHCNFG0 (HWREG32(0x40010B0C))
#define PSS_FLSHCNFG1 (HWREG32(0x40010B10))
#define PSS_FLSHCNFG1_FLLDOCNFG__M (0xffff0000)
#define PSS_FLSHCNFG1_FLLDOPRG__M (0x00000f00)
#define PSS_FLSHCNFG1_IREFFLTREN (0x00000080)
#define PSS_FLSHCNFG1_IRFFLCNFG__M (0x00000070)
#define PSS_FLSHCNFG1_VRFFLCNFG__M (0x0000000f)
#define PSS_IE (HWREG32(0x40010834))
#define PSS_IE_SVSLVLRIE (0x00000001)
#define PSS_IE_SVSLVLRIE__0 (0x00000000)
#define PSS_IE_SVSLVLRIE__1 (0x00000001)
#define PSS_IE_SVSMHIE (0x00000002)
#define PSS_IE_SVSMHIE__0 (0x00000000)
#define PSS_IE_SVSMHIE__1 (0x00000002)
#define PSS_IFG (HWREG32(0x40010838))
#define PSS_IFG_SVSLVLRIFG (0x00000001)
#define PSS_IFG_SVSLVLRIFG__0 (0x00000000)
#define PSS_IFG_SVSLVLRIFG__1 (0x00000001)
#define PSS_IFG_SVSMHIFG (0x00000002)
#define PSS_IFG_SVSMHIFG__0 (0x00000000)
#define PSS_IFG_SVSMHIFG__1 (0x00000002)
#define PSS_KEY (HWREG32(0x40010800))
#define PSS_KEY_KEY__M (0x0000ffff)
#define PSS_MISCCNFG (HWREG32(0x40010B14))
#define PSS_OPTEOP (HWREG32(0x40010B3C))
#define PSS_OSDLCNFG (HWREG32(0x40010B1C))
#define PSS_REFTRIM1 (HWREG32(0x40010B00))
#define PSS_REFTRIM2 (HWREG32(0x40010B04))
#define PSS_RSTFLG (HWREG32(0x40010B30))
#define PSS_SHCTR (HWREG32(0x40010B2C))
#define PSS_SVSCNFG (HWREG32(0x40010B08))
#define PSS_SVSMCTL (HWREG32(0x40010804))
#define PSS_SVSMCTL_DCDC_FORCE (0x00000400)
#define PSS_SVSMCTL_DCDC_FORCE__0 (0x00000000)
#define PSS_SVSMCTL_DCDC_FORCE__1 (0x00000400)
#define PSS_SVSMCTL_SVMHOE (0x00000040)
#define PSS_SVSMCTL_SVMHOE__0 (0x00000000)
#define PSS_SVSMCTL_SVMHOE__1 (0x00000040)
#define PSS_SVSMCTL_SVMHOUTPOLAL (0x00000080)
#define PSS_SVSMCTL_SVMHOUTPOLAL__0 (0x00000000)
#define PSS_SVSMCTL_SVMHOUTPOLAL__1 (0x00000080)
#define PSS_SVSMCTL_SVSLLP (0x00000200)
#define PSS_SVSMCTL_SVSLLP__0 (0x00000000)
#define PSS_SVSMCTL_SVSLLP__1 (0x00000200)
#define PSS_SVSMCTL_SVSLOFF (0x00000100)
#define PSS_SVSMCTL_SVSLOFF__0 (0x00000000)
#define PSS_SVSMCTL_SVSLOFF__0_THE_SVSL_IS_ON (0x00000000)
#define PSS_SVSMCTL_SVSLOFF__1 (0x00000100)
#define PSS_SVSMCTL_SVSLOFF__1_THE_SVSL_IS_OFF (0x00000100)
#define PSS_SVSMCTL_SVSMHLP (0x00000002)
#define PSS_SVSMCTL_SVSMHLP__0 (0x00000000)
#define PSS_SVSMCTL_SVSMHLP__1 (0x00000002)
#define PSS_SVSMCTL_SVSMHOFF (0x00000001)
#define PSS_SVSMCTL_SVSMHOFF__0 (0x00000000)
#define PSS_SVSMCTL_SVSMHOFF__0_THE_SVSMH_IS_ON (0x00000000)
#define PSS_SVSMCTL_SVSMHOFF__1 (0x00000001)
#define PSS_SVSMCTL_SVSMHS (0x00000004)
#define PSS_SVSMCTL_SVSMHS__0 (0x00000000)
#define PSS_SVSMCTL_SVSMHS__1 (0x00000004)
#define PSS_SVSMCTL_SVSMHTH__M (0x00000038)
#define PSS_SVSMHTH01 (HWREG32(0x40010F00))
#define PSS_SVSMHTH23 (HWREG32(0x40010F04))
#define PSS_SVSMHTH45 (HWREG32(0x40010F08))
#define PSS_SVSMHTH67 (HWREG32(0x40010F0C))
#define PSS_VCOREPROG (HWREG32(0x40010B18))
#define REFBGACT_H (0x0002)
#define REFBGOT_L (0x0080)
#define REFBGRDY_H (0x0020)
#define REFCNTPS__0 (0x00000000)
#define REFCNTPS__1 (0x00000008)
#define REFCNTPS__2 (0x00000010)
#define REFCNTPS__3 (0x00000018)
#define REFCNTPS__4 (0x00000020)
#define REFCNTPS__5 (0x00000028)
#define REFCNTPS__6 (0x00000030)
#define REFCNTPS__7 (0x00000038)
#define REFCNTSEL__0 (0x00000000)
#define REFCNTSEL__1 (0x00000001)
#define REFCNTSEL__2 (0x00000002)
#define REFCNTSEL__3 (0x00000003)
#define REFGENACT_H (0x0001)
#define REFGENBUSY_H (0x0004)
#define REFGENOT_L (0x0040)
#define REFGENRDY_H (0x0010)
#define REFON_L (0x0001)
#define REFOUT_L (0x0002)
#define REFTCOFF_L (0x0008)
#define REFVSEL0 (0x0010)
#define REFVSEL0_L (0x0010)
#define REFVSEL1 (0x0020)
#define REFVSEL1_L (0x0020)
#define REFVSEL_2 (0x0020)
#define REF_A_CTL0 (HWREG16(0x40003000))
#define REF_A_CTL0_BGACT (0x0200)
#define REF_A_CTL0_BGACT__0 (0x0000)
#define REF_A_CTL0_BGACT__1 (0x0200)
#define REF_A_CTL0_BGMODE (0x0800)
#define REF_A_CTL0_BGMODE__0 (0x0000)
#define REF_A_CTL0_BGMODE__0_STATIC_MODE (0x0000)
#define REF_A_CTL0_BGMODE__1 (0x0800)
#define REF_A_CTL0_BGMODE__1_SAMPLED_MODE (0x0800)
#define REF_A_CTL0_BGOT (0x0080)
#define REF_A_CTL0_BGOT__0 (0x0000)
#define REF_A_CTL0_BGOT__0_NO_TRIGGER (0x0000)
#define REF_A_CTL0_BGOT__1 (0x0080)
#define REF_A_CTL0_BGRDY (0x2000)
#define REF_A_CTL0_BGRDY__0 (0x0000)
#define REF_A_CTL0_BGRDY__1 (0x2000)
#define REF_A_CTL0_GENACT (0x0100)
#define REF_A_CTL0_GENACT__0 (0x0000)
#define REF_A_CTL0_GENACT__1 (0x0100)
#define REF_A_CTL0_GENBUSY (0x0400)
#define REF_A_CTL0_GENBUSY__0 (0x0000)
#define REF_A_CTL0_GENBUSY__1 (0x0400)
#define REF_A_CTL0_GENOT (0x0040)
#define REF_A_CTL0_GENOT__0 (0x0000)
#define REF_A_CTL0_GENOT__0_NO_TRIGGER (0x0000)
#define REF_A_CTL0_GENOT__1 (0x0040)
#define REF_A_CTL0_GENRDY (0x1000)
#define REF_A_CTL0_GENRDY__0 (0x0000)
#define REF_A_CTL0_GENRDY__1 (0x1000)
#define REF_A_CTL0_ON (0x0001)
#define REF_A_CTL0_ON__0 (0x0000)
#define REF_A_CTL0_ON__1 (0x0001)
#define REF_A_CTL0_OUT (0x0002)
#define REF_A_CTL0_OUT__0 (0x0000)
#define REF_A_CTL0_OUT__1 (0x0002)
#define REF_A_CTL0_TCOFF (0x0008)
#define REF_A_CTL0_TCOFF__0 (0x0000)
#define REF_A_CTL0_TCOFF__1 (0x0008)
#define REF_A_CTL0_VSEL__0 (0x0000)
#define REF_A_CTL0_VSEL__1 (0x0010)
#define REF_A_CTL0_VSEL__3 (0x0030)
#define REF_A_CTL0_VSEL__M (0x0030)
#define RSTCTL_RESETREQ_RSTKEY__M (0x0000ff00)
#define RT0IP0 (0x0004)
#define RT0IP0_L (0x00000004)
#define RT0IP1 (0x0008)
#define RT0IP1_L (0x00000008)
#define RT0IP2 (0x0010)
#define RT0IP2_L (0x00000010)
#define RT0PSDIV0 (0x0800)
#define RT0PSDIV0_H (0x00000008)
#define RT0PSDIV1 (0x1000)
#define RT0PSDIV1_H (0x00000010)
#define RT0PSDIV2 (0x2000)
#define RT0PSDIV2_H (0x00000020)
#define RT0PSHOLD (0x0100)
#define RT0PSHOLD_H (0x00000001)
#define RT0PSIE_L (0x00000002)
#define RT0PSIFG_L (0x00000001)
#define RT1IP0 (0x0004)
#define RT1IP0_L (0x00000004)
#define RT1IP1 (0x0008)
#define RT1IP1_L (0x00000008)
#define RT1IP2 (0x0010)
#define RT1IP2_L (0x00000010)
#define RT1PSDIV0 (0x0800)
#define RT1PSDIV0_H (0x00000008)
#define RT1PSDIV1 (0x1000)
#define RT1PSDIV1_H (0x00000010)
#define RT1PSDIV2 (0x2000)
#define RT1PSDIV2_H (0x00000020)
#define RT1PSHOLD (0x0100)
#define RT1PSHOLD_H (0x00000001)
#define RT1PSIE_L (0x00000002)
#define RT1PSIFG_L (0x00000001)
#define RT1SSEL0 (0x4000)
#define RT1SSEL0_H (0x00000040)
#define RT1SSEL1 (0x8000)
#define RT1SSEL1_H (0x00000080)
#define RTCAIE_L (0x00000020)
#define RTCAIFG_L (0x00000002)
#define RTCBCD_L (0x00000080)
#define RTCCALF0 (0x0100)
#define RTCCALF0_H (0x00000001)
#define RTCCALF1 (0x0200)
#define RTCCALF1_H (0x00000002)
#define RTCCAP0CTL (RTC_CAP0CTL)
#define RTCCAP1CTL (RTC_CAP1CTL)
#define RTCCAPDIR (0x0020)
#define RTCCAPIE (0x0002)
#define RTCCAPIFG (0x0001)
#define RTCCAPIN (0x0010)
#define RTCCAPOUT (0x0040)
#define RTCDAYBAK0 (RTC_DAYBAK0)
#define RTCDAYBAK1 (RTC_DAYBAK1)
#define RTCHOLD_L (0x00000040)
#define RTCHOURBAK0 (RTC_HOURBAK0)
#define RTCHOURBAK1 (RTC_HOURBAK1)
#define RTCIV_NONE (0x0000)
#define RTCIV_RT0PSIFG (0x000C)
#define RTCIV_RT1PSIFG (0x000E)
#define RTCIV_RTCAIFG (0x000A)
#define RTCIV_RTCCAPIFG (0x0004)
#define RTCIV_RTCOFIFG (0x0002)
#define RTCIV_RTCRDYIFG (0x0006)
#define RTCIV_RTCTEVIFG (0x0008)
#define RTCKEY (0xA500)
#define RTCKEY_H (0xA5)
#define RTCKEY_VAL (0xA500)
#define RTCMINBAK0 (RTC_MINBAK0)
#define RTCMINBAK1 (RTC_MINBAK1)
#define RTCMODE_L (0x00000020)
#define RTCMONBAK0 (RTC_MONBAK0)
#define RTCMONBAK1 (RTC_MONBAK1)
#define RTCOCAL0 (0x0001)
#define RTCOCAL0_L (0x00000001)
#define RTCOCAL1 (0x0002)
#define RTCOCAL1_L (0x00000002)
#define RTCOCAL2 (0x0004)
#define RTCOCAL2_L (0x00000004)
#define RTCOCAL3 (0x0008)
#define RTCOCAL3_L (0x00000008)
#define RTCOCAL4 (0x0010)
#define RTCOCAL4_L (0x00000010)
#define RTCOCAL5 (0x0020)
#define RTCOCAL5_L (0x00000020)
#define RTCOCAL6 (0x0040)
#define RTCOCAL6_L (0x00000040)
#define RTCOCAL7 (0x0080)
#define RTCOCAL7_L (0x00000080)
#define RTCOCALS_H (0x00000080)
#define RTCOFIE_L (0x00000080)
#define RTCOFIFG_L (0x00000008)
#define RTCRDYIE_L (0x00000010)
#define RTCRDYIFG_L (0x00000001)
#define RTCRDY_L (0x00000010)
#define RTCREN (0x0008)
#define RTCSECBAK0 (RTC_SECBAK0)
#define RTCSECBAK1 (RTC_SECBAK1)
#define RTCSSEL0 (0x0004)
#define RTCSSEL0_L (0x00000004)
#define RTCSSEL1 (0x0008)
#define RTCSSEL1_L (0x00000008)
#define RTCSSEL_1 (0x0004)
#define RTCSSEL_2 (0x0008)
#define RTCSSEL_3 (0x000C)
#define RTCSSEL_ACLK (0x0000)
#define RTCSSEL_RT1PS (0x0008)
#define RTCSSEL_SMCLK (0x0004)
#define RTCTCCTL0 (RTC_TCCTL0)
#define RTCTCCTL1 (RTC_TCCTL1)
#define RTCTCMP0 (0x0001)
#define RTCTCMP0_L (0x00000001)
#define RTCTCMP1 (0x0002)
#define RTCTCMP1_L (0x00000002)
#define RTCTCMP2 (0x0004)
#define RTCTCMP2_L (0x00000004)
#define RTCTCMP3 (0x0008)
#define RTCTCMP3_L (0x00000008)
#define RTCTCMP4 (0x0010)
#define RTCTCMP4_L (0x00000010)
#define RTCTCMP5 (0x0020)
#define RTCTCMP5_L (0x00000020)
#define RTCTCMP6 (0x0040)
#define RTCTCMP6_L (0x00000040)
#define RTCTCMP7 (0x0080)
#define RTCTCMP7_L (0x00000080)
#define RTCTCMPS_H (0x00000080)
#define RTCTCOK_H (0x00000020)
#define RTCTCRDY_H (0x00000040)
#define RTCTEV0 (0x0001)
#define RTCTEV0_L (0x00000001)
#define RTCTEV1 (0x0002)
#define RTCTEV1_L (0x00000002)
#define RTCTEVIE_L (0x00000040)
#define RTCTEVIFG_L (0x00000004)
#define RTCTEV_0000 (0x0002)
#define RTCTEV_1200 (0x0003)
#define RTCTEV_HOUR (0x0001)
#define RTCTEV_MIN (0x0000)
#define RTCYEARBAK0 (RTC_YEARBAK0)
#define RTCYEARBAK1 (RTC_YEARBAK1)
#define RTCYEAR_H (HWREG8_H(RTCYEAR))
#define RTCYEAR_L (HWREG8_L(RTCYEAR))
#define RTC_CTL0_KEY_VAL (0xA500)
//#define RTC_C_ADAY (HWREG8(0x4000441B))
#define RTC_C_ADAY_AE (0x0080)
#define RTC_C_ADAY_DAY_OF_MONTH__M (0x001f)
//#define RTC_C_ADOW (HWREG8(0x4000441A))
#define RTC_C_ADOW_AE (0x0080)
#define RTC_C_ADOW_DAY_OF_WEEK__M (0x0007)
//#define RTC_C_AHOUR (HWREG8(0x40004419))
#define RTC_C_AHOUR_AE (0x0080)
#define RTC_C_AHOUR_HOURS__M (0x001f)
//#define RTC_C_AMIN (HWREG8(0x40004418))
#define RTC_C_AMIN_AE (0x0080)
#define RTC_C_AMIN_MINUTES__M (0x003f)
#define RTC_C_BCD2BIN (HWREG16(0x4000441E))
#define RTC_C_BIN2BCD (HWREG16(0x4000441C))
#define RTC_C_CTL0 (HWREG16(0x40004400))
#define RTC_C_CTL0_AIE (0x0020)
#define RTC_C_CTL0_AIE__0 (0x0000)
#define RTC_C_CTL0_AIE__1 (0x0020)
#define RTC_C_CTL0_AIFG (0x0002)
#define RTC_C_CTL0_AIFG__0 (0x0000)
#define RTC_C_CTL0_AIFG__1 (0x0002)
#define RTC_C_CTL0_KEY__M (0xff00)
#define RTC_C_CTL0_OFIE (0x0080)
#define RTC_C_CTL0_OFIE__0 (0x0000)
#define RTC_C_CTL0_OFIE__1 (0x0080)
#define RTC_C_CTL0_OFIFG (0x0008)
#define RTC_C_CTL0_OFIFG__0 (0x0000)
#define RTC_C_CTL0_OFIFG__1 (0x0008)
#define RTC_C_CTL0_RDYIE (0x0010)
#define RTC_C_CTL0_RDYIE__0 (0x0000)
#define RTC_C_CTL0_RDYIE__1 (0x0010)
#define RTC_C_CTL0_RDYIFG (0x0001)
#define RTC_C_CTL0_RDYIFG__0 (0x0000)
#define RTC_C_CTL0_RDYIFG__1 (0x0001)
#define RTC_C_CTL0_TEVIE (0x0040)
#define RTC_C_CTL0_TEVIE__0 (0x0000)
#define RTC_C_CTL0_TEVIE__1 (0x0040)
#define RTC_C_CTL0_TEVIFG (0x0004)
#define RTC_C_CTL0_TEVIFG__0 (0x0000)
#define RTC_C_CTL0_TEVIFG__1 (0x0004)
//#define RTC_C_CTL1 (HWREG8(0x40004402))
#define RTC_C_CTL1_BCD (0x0080)
#define RTC_C_CTL1_BCD__0 (0x0000)
#define RTC_C_CTL1_BCD__1 (0x0080)
#define RTC_C_CTL1_HOLD (0x0040)
#define RTC_C_CTL1_HOLD__0 (0x0000)
#define RTC_C_CTL1_HOLD__1 (0x0040)
#define RTC_C_CTL1_MODE (0x0020)
#define RTC_C_CTL1_MODE__1 (0x0020)
#define RTC_C_CTL1_RDY (0x0010)
#define RTC_C_CTL1_RDY__0 (0x0000)
#define RTC_C_CTL1_RDY__1 (0x0010)
#define RTC_C_CTL1_SSEL__0 (0x0000)
#define RTC_C_CTL1_SSEL__0_BCLK (0x0000)
#define RTC_C_CTL1_SSEL__1 (0x0004)
#define RTC_C_CTL1_SSEL__2 (0x0008)
#define RTC_C_CTL1_SSEL__3 (0x000c)
#define RTC_C_CTL1_SSEL__M (0x000c)
#define RTC_C_CTL1_TEV__M (0x0003)
//#define RTC_C_CTL3 (HWREG8(0x40004403))
#define RTC_C_CTL3_CALF__0 (0x0000)
#define RTC_C_CTL3_CALF__1 (0x0001)
#define RTC_C_CTL3_CALF__1_512_HZ (0x0001)
#define RTC_C_CTL3_CALF__2 (0x0002)
#define RTC_C_CTL3_CALF__2_256_HZ (0x0002)
#define RTC_C_CTL3_CALF__3 (0x0003)
#define RTC_C_CTL3_CALF__3_1_HZ (0x0003)
#define RTC_C_CTL3_CALF__M (0x0003)
//#define RTC_C_DAY (HWREG8(0x40004414))
#define RTC_C_DAY_DAY_OF_MONTH__M (0x001f)
//#define RTC_C_DOW (HWREG8(0x40004413))
#define RTC_C_DOW_DAY_OF_WEEK__M (0x0007)
//#define RTC_C_HOUR (HWREG8(0x40004412))
#define RTC_C_HOUR_HOURS__M (0x001f)
#define RTC_C_IV (HWREG16(0x4000440E))
//#define RTC_C_MIN (HWREG8(0x40004411))
#define RTC_C_MIN_MINUTES__M (0x003f)
//#define RTC_C_MON (HWREG8(0x40004415))
#define RTC_C_MON_MONTH__M (0x000f)
#define RTC_C_OCAL (HWREG16(0x40004404))
#define RTC_C_OCAL_OCALS (0x8000)
#define RTC_C_OCAL_OCALS__0 (0x0000)
#define RTC_C_OCAL_OCALS__1 (0x8000)
#define RTC_C_OCAL_OCAL__M (0x00ff)
#define RTC_C_PS0 (HWREG8(0x4000440C))
#define RTC_C_PS0CTL (HWREG16(0x40004408))
#define RTC_C_PS0CTL_RT0IP__0 (0x0000)
#define RTC_C_PS0CTL_RT0IP__0_DIVIDE_BY_2 (0x0000)
#define RTC_C_PS0CTL_RT0IP__1 (0x0004)
#define RTC_C_PS0CTL_RT0IP__1_DIVIDE_BY_4 (0x0004)
#define RTC_C_PS0CTL_RT0IP__2 (0x0008)
#define RTC_C_PS0CTL_RT0IP__2_DIVIDE_BY_8 (0x0008)
#define RTC_C_PS0CTL_RT0IP__3 (0x000c)
#define RTC_C_PS0CTL_RT0IP__3_DIVIDE_BY_16 (0x000c)
#define RTC_C_PS0CTL_RT0IP__4 (0x0010)
#define RTC_C_PS0CTL_RT0IP__4_DIVIDE_BY_32 (0x0010)
#define RTC_C_PS0CTL_RT0IP__5 (0x0014)
#define RTC_C_PS0CTL_RT0IP__5_DIVIDE_BY_64 (0x0014)
#define RTC_C_PS0CTL_RT0IP__6 (0x0018)
#define RTC_C_PS0CTL_RT0IP__6_DIVIDE_BY_128 (0x0018)
#define RTC_C_PS0CTL_RT0IP__7 (0x001c)
#define RTC_C_PS0CTL_RT0IP__7_DIVIDE_BY_256 (0x001c)
#define RTC_C_PS0CTL_RT0IP__M (0x001c)
#define RTC_C_PS0CTL_RT0PSIE (0x0002)
#define RTC_C_PS0CTL_RT0PSIE__0 (0x0000)
#define RTC_C_PS0CTL_RT0PSIE__1 (0x0002)
#define RTC_C_PS0CTL_RT0PSIFG (0x0001)
#define RTC_C_PS0CTL_RT0PSIFG__0 (0x0000)
#define RTC_C_PS0CTL_RT0PSIFG__1 (0x0001)
#define RTC_C_PS1 (HWREG8(0x4000440D))
#define RTC_C_PS1CTL (HWREG16(0x4000440A))
#define RTC_C_PS1CTL_RT1IP__0 (0x0000)
#define RTC_C_PS1CTL_RT1IP__0_DIVIDE_BY_2 (0x0000)
#define RTC_C_PS1CTL_RT1IP__1 (0x0004)
#define RTC_C_PS1CTL_RT1IP__1_DIVIDE_BY_4 (0x0004)
#define RTC_C_PS1CTL_RT1IP__2 (0x0008)
#define RTC_C_PS1CTL_RT1IP__2_DIVIDE_BY_8 (0x0008)
#define RTC_C_PS1CTL_RT1IP__3 (0x000c)
#define RTC_C_PS1CTL_RT1IP__3_DIVIDE_BY_16 (0x000c)
#define RTC_C_PS1CTL_RT1IP__4 (0x0010)
#define RTC_C_PS1CTL_RT1IP__4_DIVIDE_BY_32 (0x0010)
#define RTC_C_PS1CTL_RT1IP__5 (0x0014)
#define RTC_C_PS1CTL_RT1IP__5_DIVIDE_BY_64 (0x0014)
#define RTC_C_PS1CTL_RT1IP__6 (0x0018)
#define RTC_C_PS1CTL_RT1IP__6_DIVIDE_BY_128 (0x0018)
#define RTC_C_PS1CTL_RT1IP__7 (0x001c)
#define RTC_C_PS1CTL_RT1IP__7_DIVIDE_BY_256 (0x001c)
#define RTC_C_PS1CTL_RT1IP__M (0x001c)
#define RTC_C_PS1CTL_RT1PSIE (0x0002)
#define RTC_C_PS1CTL_RT1PSIE__0 (0x0000)
#define RTC_C_PS1CTL_RT1PSIE__1 (0x0002)
#define RTC_C_PS1CTL_RT1PSIFG (0x0001)
#define RTC_C_PS1CTL_RT1PSIFG__0 (0x0000)
#define RTC_C_PS1CTL_RT1PSIFG__1 (0x0001)
//#define RTC_C_SEC (HWREG8(0x40004410))
#define RTC_C_SEC_SECONDS__M (0x003f)
#define RTC_C_TCMP (HWREG16(0x40004406))
#define RTC_C_TCMP_TCMPS (0x8000)
#define RTC_C_TCMP_TCMPS__0 (0x0000)
#define RTC_C_TCMP_TCMPS__1 (0x8000)
#define RTC_C_TCMP_TCMP__M (0x00ff)
#define RTC_C_TCMP_TCOK (0x2000)
#define RTC_C_TCMP_TCOK__0 (0x0000)
#define RTC_C_TCMP_TCOK__1 (0x2000)
#define RTC_C_TCMP_TCRDY (0x4000)
#define RTC_C_YEAR (HWREG16(0x40004416))
#define RTC_C_YEAR_YEAR_HIGH_BYTE__M (0x0f00)
#define RTC_C_YEAR_YEAR_LOW_BYTE__M (0x00ff)
#define RTC_NONE (0x0000)
#define RTC_RT0PSIFG (0x000C)
#define RTC_RT1PSIFG (0x000E)
#define RTC_RTCAIFG (0x000A)
#define RTC_RTCOFIFG (0x0002)
#define RTC_RTCRDYIFG (0x0006)
#define RTC_RTCTEVIFG (0x0008)
#define SCS_AIRCR_ENDIANESS__0 (0x00000000)
#define SCS_AIRCR_ENDIANESS__0_LITTLE_ENDIAN (0x00000000)
#define SCS_AIRCR_ENDIANESS__1 (0x00008000)
#define SCS_AIRCR_ENDIANESS__1_BIG_ENDIAN (0x00008000)
#define SCS_AIRCR_PRIGROUP__M (0x00000700)
#define SCS_AIRCR_VECTKEY__M (0xffff0000)
#define SCS_CCR_STKALIGN__0 (0x00000000)
#define SCS_CCR_STKALIGN__1 (0x00000200)
#define SCS_CPUID_CONSTANT__M (0x000f0000)
#define SCS_CPUID_IMPLEMENTER__M (0xff000000)
#define SCS_CPUID_PARTNO__M (0x0000fff0)
#define SCS_CPUID_REVISION__M (0x0000000f)
#define SCS_CPUID_VARIANT__M (0x00f00000)
#define SCS_DCRSR_REGSEL__0 (0x00000000)
#define SCS_DCRSR_REGSEL__0_R0 (0x00000000)
#define SCS_DCRSR_REGSEL__0_R11 (0x00000000)
#define SCS_DCRSR_REGSEL__1 (0x00000001)
#define SCS_DCRSR_REGSEL__10 (0x0000000a)
#define SCS_DCRSR_REGSEL__10_R10 (0x0000000a)
#define SCS_DCRSR_REGSEL__12 (0x0000000c)
#define SCS_DCRSR_REGSEL__12_R12 (0x0000000c)
#define SCS_DCRSR_REGSEL__13 (0x0000000d)
#define SCS_DCRSR_REGSEL__13_CURRENT_SP (0x0000000d)
#define SCS_DCRSR_REGSEL__14 (0x0000000e)
#define SCS_DCRSR_REGSEL__14_LR (0x0000000e)
#define SCS_DCRSR_REGSEL__15 (0x0000000f)
#define SCS_DCRSR_REGSEL__16 (0x00000010)
#define SCS_DCRSR_REGSEL__17 (0x00000011)
#define SCS_DCRSR_REGSEL__17_MSP__MAIN_SP (0x00000011)
#define SCS_DCRSR_REGSEL__18 (0x00000012)
#define SCS_DCRSR_REGSEL__18_PSP__PROCESS_SP (0x00000012)
#define SCS_DCRSR_REGSEL__1_R1 (0x00000001)
#define SCS_DCRSR_REGSEL__2 (0x00000002)
#define SCS_DCRSR_REGSEL__20 (0x00000014)
#define SCS_DCRSR_REGSEL__2_R2 (0x00000002)
#define SCS_DCRSR_REGSEL__3 (0x00000003)
#define SCS_DCRSR_REGSEL__3_R3 (0x00000003)
#define SCS_DCRSR_REGSEL__4 (0x00000004)
#define SCS_DCRSR_REGSEL__4_R4 (0x00000004)
#define SCS_DCRSR_REGSEL__5 (0x00000005)
#define SCS_DCRSR_REGSEL__5_R5 (0x00000005)
#define SCS_DCRSR_REGSEL__6 (0x00000006)
#define SCS_DCRSR_REGSEL__6_R6 (0x00000006)
#define SCS_DCRSR_REGSEL__7 (0x00000007)
#define SCS_DCRSR_REGSEL__7_R7 (0x00000007)
#define SCS_DCRSR_REGSEL__8 (0x00000008)
#define SCS_DCRSR_REGSEL__8_R8 (0x00000008)
#define SCS_DCRSR_REGSEL__9 (0x00000009)
#define SCS_DCRSR_REGSEL__9_R9 (0x00000009)
#define SCS_DCRSR_REGSEL__M (0x0000001f)
#define SCS_DEMCR_MON_REQ__0 (0x00000000)
#define SCS_DEMCR_MON_REQ__1 (0x00080000)
#define SCS_DFSR_BKPT__0 (0x00000000)
#define SCS_DFSR_BKPT__1 (0x00000002)
#define SCS_DFSR_DWTTRAP__0 (0x00000000)
#define SCS_DFSR_DWTTRAP__0_NO_DWT_MATCH (0x00000000)
#define SCS_DFSR_DWTTRAP__1 (0x00000004)
#define SCS_DFSR_DWTTRAP__1_DWT_MATCH (0x00000004)
#define SCS_DFSR_EXTERNAL__0 (0x00000000)
#define SCS_DFSR_EXTERNAL__1 (0x00000010)
#define SCS_DFSR_HALTED__0 (0x00000000)
#define SCS_DFSR_HALTED__0_NO_HALT_REQUEST (0x00000000)
#define SCS_DFSR_HALTED__1 (0x00000001)
#define SCS_DFSR_VCATCH__0 (0x00000000)
#define SCS_DFSR_VCATCH__1 (0x00000008)
#define SCS_ICSR_ISRPENDING__0 (0x00000000)
#define SCS_ICSR_ISRPENDING__1 (0x00400000)
#define SCS_ICSR_ISRPREEMPT__0 (0x00000000)
#define SCS_ICSR_ISRPREEMPT__1 (0x00800000)
#define SCS_ICSR_NMIPENDSET__0 (0x00000000)
#define SCS_ICSR_NMIPENDSET__1 (0x80000000)
#define SCS_ICSR_NMIPENDSET__1_SET_PENDING_NMI (0x80000000)
#define SCS_ICSR_PENDSTCLR__0 (0x00000000)
#define SCS_ICSR_PENDSTCLR__1 (0x02000000)
#define SCS_ICSR_PENDSTSET__0 (0x00000000)
#define SCS_ICSR_PENDSTSET__1 (0x04000000)
#define SCS_ICSR_PENDSVCLR__0 (0x00000000)
#define SCS_ICSR_PENDSVCLR__1 (0x08000000)
#define SCS_ICSR_PENDSVSET__0 (0x00000000)
#define SCS_ICSR_PENDSVSET__1 (0x10000000)
#define SCS_ICSR_VECTACTIVE__M (0x000001ff)
#define SCS_ICSR_VECTPENDING__M (0x0003f000)
#define SCS_ICTR_INTLINESNUM__M (0x0000001f)
#define SCS_ID_DFR0_MICROCONTROLLER_DEBUG_MODEL__0 (0x00000000)
#define SCS_ID_DFR0_MICROCONTROLLER_DEBUG_MODEL__0_NOT_SUPPORTED (0x00000000)
#define SCS_ID_DFR0_MICROCONTROLLER_DEBUG_MODEL__1 (0x00100000)
#define SCS_ID_DFR0_MICROCONTROLLER_DEBUG_MODEL__M (0x00f00000)
#define SCS_ID_ISAR1_ETEND_INSRS__0 (0x00000000)
#define SCS_ID_ISAR1_ETEND_INSRS__1 (0x00001000)
#define SCS_ID_ISAR1_ETEND_INSRS__2 (0x00002000)
#define SCS_ID_ISAR1_ETEND_INSRS__2_N_A (0x00002000)
#define SCS_ID_ISAR1_ETEND_INSRS__M (0x0000f000)
#define SCS_ID_ISAR1_IFTHEN_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR1_IFTHEN_INSTRS__1 (0x00010000)
#define SCS_ID_ISAR1_IFTHEN_INSTRS__M (0x000f0000)
#define SCS_ID_ISAR1_IMMEDIATE_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR1_IMMEDIATE_INSTRS__1 (0x00100000)
#define SCS_ID_ISAR1_IMMEDIATE_INSTRS__M (0x00f00000)
#define SCS_ID_ISAR1_INTERWORK_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR1_INTERWORK_INSTRS__1 (0x01000000)
#define SCS_ID_ISAR1_INTERWORK_INSTRS__2 (0x02000000)
#define SCS_ID_ISAR1_INTERWORK_INSTRS__3 (0x03000000)
#define SCS_ID_ISAR1_INTERWORK_INSTRS__3_N_A (0x03000000)
#define SCS_ID_ISAR1_INTERWORK_INSTRS__M (0x0f000000)
#define SCS_ID_ISAR2_LOADSTORE_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR2_LOADSTORE_INSTRS__1 (0x00000001)
#define SCS_ID_ISAR2_LOADSTORE_INSTRS__1_ADDS_LDRD_STRD (0x00000001)
#define SCS_ID_ISAR2_LOADSTORE_INSTRS__M (0x0000000f)
#define SCS_ID_ISAR2_MEMHINT_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR2_MEMHINT_INSTRS__1 (0x00000010)
#define SCS_ID_ISAR2_MEMHINT_INSTRS__1_ADDS_PLD (0x00000010)
#define SCS_ID_ISAR2_MEMHINT_INSTRS__2 (0x00000020)
#define SCS_ID_ISAR2_MEMHINT_INSTRS__3 (0x00000030)
#define SCS_ID_ISAR2_MEMHINT_INSTRS__3_ADDS_PLI (0x00000030)
#define SCS_ID_ISAR2_MEMHINT_INSTRS__M (0x000000f0)
#define SCS_ID_ISAR2_MULTIACCESSINT_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR2_MULTIACCESSINT_INSTRS__1 (0x00000100)
#define SCS_ID_ISAR2_MULTIACCESSINT_INSTRS__2 (0x00000200)
#define SCS_ID_ISAR2_MULTIACCESSINT_INSTRS__M (0x00000f00)
#define SCS_ID_ISAR2_MULTS_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR2_MULTS_INSTRS__1 (0x00010000)
#define SCS_ID_ISAR2_MULTS_INSTRS__2 (0x00020000)
#define SCS_ID_ISAR2_MULTS_INSTRS__2_N_A (0x00020000)
#define SCS_ID_ISAR2_MULTS_INSTRS__3 (0x00030000)
#define SCS_ID_ISAR2_MULTS_INSTRS__3_N_A (0x00030000)
#define SCS_ID_ISAR2_MULTS_INSTRS__M (0x000f0000)
#define SCS_ID_ISAR2_MULTU_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR2_MULTU_INSTRS__1 (0x00100000)
#define SCS_ID_ISAR2_MULTU_INSTRS__2 (0x00200000)
#define SCS_ID_ISAR2_MULTU_INSTRS__2_N_A (0x00200000)
#define SCS_ID_ISAR2_MULTU_INSTRS__M (0x00f00000)
#define SCS_ID_ISAR2_MULT_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR2_MULT_INSTRS__1 (0x00001000)
#define SCS_ID_ISAR2_MULT_INSTRS__1_ADDS_MLA (0x00001000)
#define SCS_ID_ISAR2_MULT_INSTRS__2 (0x00002000)
#define SCS_ID_ISAR2_MULT_INSTRS__2_ADDS_MLS (0x00002000)
#define SCS_ID_ISAR2_MULT_INSTRS__M (0x0000f000)
#define SCS_ID_ISAR2_REVERSAL_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR2_REVERSAL_INSTRS__1 (0x10000000)
#define SCS_ID_ISAR2_REVERSAL_INSTRS__2 (0x20000000)
#define SCS_ID_ISAR2_REVERSAL_INSTRS__2_ADDS_RBIT (0x20000000)
#define SCS_ID_ISAR2_REVERSAL_INSTRS__M (0xf0000000)
#define SCS_ID_ISAR3_SATRUATE_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR3_SATRUATE_INSTRS__1 (0x00000001)
#define SCS_ID_ISAR3_SATRUATE_INSTRS__1_N_A (0x00000001)
#define SCS_ID_ISAR3_SATRUATE_INSTRS__M (0x0000000f)
#define SCS_ID_ISAR3_SIMD_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR3_SIMD_INSTRS__1 (0x00000010)
#define SCS_ID_ISAR3_SIMD_INSTRS__3 (0x00000030)
#define SCS_ID_ISAR3_SIMD_INSTRS__3_N_A (0x00000030)
#define SCS_ID_ISAR3_SIMD_INSTRS__M (0x000000f0)
#define SCS_ID_ISAR3_SVC_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR3_SVC_INSTRS__1 (0x00000100)
#define SCS_ID_ISAR3_SVC_INSTRS__1_ADDS_SVC__SWI (0x00000100)
#define SCS_ID_ISAR3_SVC_INSTRS__M (0x00000f00)
#define SCS_ID_ISAR3_SYNCPRIM_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR3_SYNCPRIM_INSTRS__1 (0x00001000)
#define SCS_ID_ISAR3_SYNCPRIM_INSTRS__2 (0x00002000)
#define SCS_ID_ISAR3_SYNCPRIM_INSTRS__M (0x0000f000)
#define SCS_ID_ISAR3_TABBRANCH_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR3_TABBRANCH_INSTRS__1 (0x00010000)
#define SCS_ID_ISAR3_TABBRANCH_INSTRS__1_ADDS_TBB__TBH (0x00010000)
#define SCS_ID_ISAR3_TABBRANCH_INSTRS__M (0x000f0000)
#define SCS_ID_ISAR3_THUMBCOPY_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR3_THUMBCOPY_INSTRS__1 (0x00100000)
#define SCS_ID_ISAR3_THUMBCOPY_INSTRS__M (0x00f00000)
#define SCS_ID_ISAR3_TRUENOP_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR3_TRUENOP_INSTRS__1 (0x01000000)
#define SCS_ID_ISAR3_TRUENOP_INSTRS__M (0x0f000000)
#define SCS_ID_ISAR4_BARRIER_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR4_BARRIER_INSTRS__1 (0x00010000)
#define SCS_ID_ISAR4_BARRIER_INSTRS__M (0x000f0000)
#define SCS_ID_ISAR4_PSR_M_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR4_PSR_M_INSTRS__1 (0x01000000)
#define SCS_ID_ISAR4_PSR_M_INSTRS__M (0x0f000000)
#define SCS_ID_ISAR4_SYNCPRIM_INSTRS_FRAC__0 (0x00000000)
#define SCS_ID_ISAR4_SYNCPRIM_INSTRS_FRAC__3 (0x00300000)
#define SCS_ID_ISAR4_SYNCPRIM_INSTRS_FRAC__M (0x00f00000)
#define SCS_ID_ISAR4_UNPRIV_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR4_UNPRIV_INSTRS__1 (0x00000001)
#define SCS_ID_ISAR4_UNPRIV_INSTRS__2 (0x00000002)
#define SCS_ID_ISAR4_UNPRIV_INSTRS__M (0x0000000f)
#define SCS_ID_ISAR4_WITHSHIFTS_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR4_WITHSHIFTS_INSTRS__1 (0x00000010)
#define SCS_ID_ISAR4_WITHSHIFTS_INSTRS__3 (0x00000030)
#define SCS_ID_ISAR4_WITHSHIFTS_INSTRS__4 (0x00000040)
#define SCS_ID_ISAR4_WITHSHIFTS_INSTRS__M (0x000000f0)
#define SCS_ID_ISAR4_WRITEBACK_INSTRS__0 (0x00000000)
#define SCS_ID_ISAR4_WRITEBACK_INSTRS__1 (0x00000100)
#define SCS_ID_ISAR4_WRITEBACK_INSTRS__M (0x00000f00)
#define SCS_ID_MMFR0_AUILIARY_REGISTER_SUPPORT__0 (0x00000000)
#define SCS_ID_MMFR0_AUILIARY_REGISTER_SUPPORT__0_NOT_SUPPORTED (0x00000000)
#define SCS_ID_MMFR0_AUILIARY_REGISTER_SUPPORT__1 (0x00100000)
#define SCS_ID_MMFR0_AUILIARY_REGISTER_SUPPORT__M (0x00f00000)
#define SCS_ID_MMFR0_CACHE_COHERENCE_SUPPORT__0 (0x00000000)
#define SCS_ID_MMFR0_CACHE_COHERENCE_SUPPORT__1 (0x00000100)
#define SCS_ID_MMFR0_CACHE_COHERENCE_SUPPORT__2 (0x00000200)
#define SCS_ID_MMFR0_CACHE_COHERENCE_SUPPORT__3 (0x00000300)
#define SCS_ID_MMFR0_CACHE_COHERENCE_SUPPORT__M (0x00000f00)
#define SCS_ID_MMFR0_OUTER_NON_SHARABLE_SUPPORT__0 (0x00000000)
#define SCS_ID_MMFR0_OUTER_NON_SHARABLE_SUPPORT__1 (0x00001000)
#define SCS_ID_MMFR0_OUTER_NON_SHARABLE_SUPPORT__M (0x0000f000)
#define SCS_ID_MMFR0_PMSA_SUPPORT__0 (0x00000000)
#define SCS_ID_MMFR0_PMSA_SUPPORT__0_NOT_SUPPORTED (0x00000000)
#define SCS_ID_MMFR0_PMSA_SUPPORT__1 (0x00000010)
#define SCS_ID_MMFR0_PMSA_SUPPORT__2 (0x00000020)
#define SCS_ID_MMFR0_PMSA_SUPPORT__3 (0x00000030)
#define SCS_ID_MMFR0_PMSA_SUPPORT__M (0x000000f0)
#define SCS_ID_MMFR2_WAIT_FOR_INTERRUPT_STALLING__0 (0x00000000)
#define SCS_ID_MMFR2_WAIT_FOR_INTERRUPT_STALLING__0_NOT_SUPPORTED (0x00000000)
#define SCS_ID_MMFR2_WAIT_FOR_INTERRUPT_STALLING__1 (0x01000000)
#define SCS_ID_MMFR2_WAIT_FOR_INTERRUPT_STALLING__M (0x0f000000)
#define SCS_ID_PFR0_STATE0__0 (0x00000000)
#define SCS_ID_PFR0_STATE0__0_NO_ARM_ENCODING (0x00000000)
#define SCS_ID_PFR0_STATE0__1 (0x00000001)
#define SCS_ID_PFR0_STATE0__1_N_A (0x00000001)
#define SCS_ID_PFR0_STATE0__M (0x0000000f)
#define SCS_ID_PFR0_STATE1__0 (0x00000000)
#define SCS_ID_PFR0_STATE1__0_N_A (0x00000000)
#define SCS_ID_PFR0_STATE1__1 (0x00000010)
#define SCS_ID_PFR0_STATE1__1_N_A (0x00000010)
#define SCS_ID_PFR0_STATE1__2 (0x00000020)
#define SCS_ID_PFR0_STATE1__3 (0x00000030)
#define SCS_ID_PFR0_STATE1__M (0x000000f0)
#define SCS_ID_PFR1_MICROCONTROLLER_PROGRAMMERS_MODEL__0 (0x00000000)
#define SCS_ID_PFR1_MICROCONTROLLER_PROGRAMMERS_MODEL__0_NOT_SUPPORTED (0x00000000)
#define SCS_ID_PFR1_MICROCONTROLLER_PROGRAMMERS_MODEL__2 (0x00000200)
#define SCS_ID_PFR1_MICROCONTROLLER_PROGRAMMERS_MODEL__M (0x00000f00)
#define SCS_ISAR0_BITCOUNT_INSTRS__0 (0x00000000)
#define SCS_ISAR0_BITCOUNT_INSTRS__1 (0x00000010)
#define SCS_ISAR0_BITCOUNT_INSTRS__1_ADDS_CLZ (0x00000010)
#define SCS_ISAR0_BITCOUNT_INSTRS__M (0x000000f0)
#define SCS_ISAR0_BITFIELD_INSTRS__0 (0x00000000)
#define SCS_ISAR0_BITFIELD_INSTRS__1 (0x00000100)
#define SCS_ISAR0_BITFIELD_INSTRS__M (0x00000f00)
#define SCS_ISAR0_CMPBRANCH_INSTRS__0 (0x00000000)
#define SCS_ISAR0_CMPBRANCH_INSTRS__1 (0x00001000)
#define SCS_ISAR0_CMPBRANCH_INSTRS__1_ADDS_CB_N_Z (0x00001000)
#define SCS_ISAR0_CMPBRANCH_INSTRS__M (0x0000f000)
#define SCS_ISAR0_COPROC_INSTRS__0 (0x00000000)
#define SCS_ISAR0_COPROC_INSTRS__1 (0x00010000)
#define SCS_ISAR0_COPROC_INSTRS__2 (0x00020000)
#define SCS_ISAR0_COPROC_INSTRS__3 (0x00030000)
#define SCS_ISAR0_COPROC_INSTRS__4 (0x00040000)
#define SCS_ISAR0_COPROC_INSTRS__M (0x000f0000)
#define SCS_ISAR0_DEBUG_INSTRS__0 (0x00000000)
#define SCS_ISAR0_DEBUG_INSTRS__1 (0x00100000)
#define SCS_ISAR0_DEBUG_INSTRS__1_ADDS_BKPT (0x00100000)
#define SCS_ISAR0_DEBUG_INSTRS__M (0x00f00000)
#define SCS_ISAR0_DIVIDE_INSTRS__0 (0x00000000)
#define SCS_ISAR0_DIVIDE_INSTRS__1 (0x01000000)
#define SCS_ISAR0_DIVIDE_INSTRS__M (0x0f000000)
#define SCS_NVIC_IPR0_PRI_0__M (0x000000ff)
#define SCS_NVIC_IPR0_PRI_1__M (0x0000ff00)
#define SCS_NVIC_IPR0_PRI_2__M (0x00ff0000)
#define SCS_NVIC_IPR0_PRI_3__M (0xff000000)
#define SCS_NVIC_IPR10_PRI_40__M (0x000000ff)
#define SCS_NVIC_IPR10_PRI_41__M (0x0000ff00)
#define SCS_NVIC_IPR10_PRI_42__M (0x00ff0000)
#define SCS_NVIC_IPR10_PRI_43__M (0xff000000)
#define SCS_NVIC_IPR11_PRI_44__M (0x000000ff)
#define SCS_NVIC_IPR11_PRI_45__M (0x0000ff00)
#define SCS_NVIC_IPR11_PRI_46__M (0x00ff0000)
#define SCS_NVIC_IPR11_PRI_47__M (0xff000000)
#define SCS_NVIC_IPR12_PRI_48__M (0x000000ff)
#define SCS_NVIC_IPR12_PRI_49__M (0x0000ff00)
#define SCS_NVIC_IPR12_PRI_50__M (0x00ff0000)
#define SCS_NVIC_IPR12_PRI_51__M (0xff000000)
#define SCS_NVIC_IPR13_PRI_52__M (0x000000ff)
#define SCS_NVIC_IPR13_PRI_53__M (0x0000ff00)
#define SCS_NVIC_IPR13_PRI_54__M (0x00ff0000)
#define SCS_NVIC_IPR13_PRI_55__M (0xff000000)
#define SCS_NVIC_IPR14_PRI_56__M (0x000000ff)
#define SCS_NVIC_IPR14_PRI_57__M (0x0000ff00)
#define SCS_NVIC_IPR14_PRI_58__M (0x00ff0000)
#define SCS_NVIC_IPR14_PRI_59__M (0xff000000)
#define SCS_NVIC_IPR15_PRI_60__M (0x000000ff)
#define SCS_NVIC_IPR15_PRI_61__M (0x0000ff00)
#define SCS_NVIC_IPR15_PRI_62__M (0x00ff0000)
#define SCS_NVIC_IPR15_PRI_63__M (0xff000000)
#define SCS_NVIC_IPR1_PRI_4__M (0x000000ff)
#define SCS_NVIC_IPR1_PRI_5__M (0x0000ff00)
#define SCS_NVIC_IPR1_PRI_6__M (0x00ff0000)
#define SCS_NVIC_IPR1_PRI_7__M (0xff000000)
#define SCS_NVIC_IPR2_PRI_10__M (0x00ff0000)
#define SCS_NVIC_IPR2_PRI_11__M (0xff000000)
#define SCS_NVIC_IPR2_PRI_8__M (0x000000ff)
#define SCS_NVIC_IPR2_PRI_9__M (0x0000ff00)
#define SCS_NVIC_IPR3_PRI_12__M (0x000000ff)
#define SCS_NVIC_IPR3_PRI_13__M (0x0000ff00)
#define SCS_NVIC_IPR3_PRI_14__M (0x00ff0000)
#define SCS_NVIC_IPR3_PRI_15__M (0xff000000)
#define SCS_NVIC_IPR4_PRI_16__M (0x000000ff)
#define SCS_NVIC_IPR4_PRI_17__M (0x0000ff00)
#define SCS_NVIC_IPR4_PRI_18__M (0x00ff0000)
#define SCS_NVIC_IPR4_PRI_19__M (0xff000000)
#define SCS_NVIC_IPR5_PRI_20__M (0x000000ff)
#define SCS_NVIC_IPR5_PRI_21__M (0x0000ff00)
#define SCS_NVIC_IPR5_PRI_22__M (0x00ff0000)
#define SCS_NVIC_IPR5_PRI_23__M (0xff000000)
#define SCS_NVIC_IPR6_PRI_24__M (0x000000ff)
#define SCS_NVIC_IPR6_PRI_25__M (0x0000ff00)
#define SCS_NVIC_IPR6_PRI_26__M (0x00ff0000)
#define SCS_NVIC_IPR6_PRI_27__M (0xff000000)
#define SCS_NVIC_IPR7_PRI_28__M (0x000000ff)
#define SCS_NVIC_IPR7_PRI_29__M (0x0000ff00)
#define SCS_NVIC_IPR7_PRI_30__M (0x00ff0000)
#define SCS_NVIC_IPR7_PRI_31__M (0xff000000)
#define SCS_NVIC_IPR8_PRI_32__M (0x000000ff)
#define SCS_NVIC_IPR8_PRI_33__M (0x0000ff00)
#define SCS_NVIC_IPR8_PRI_34__M (0x00ff0000)
#define SCS_NVIC_IPR8_PRI_35__M (0xff000000)
#define SCS_NVIC_IPR9_PRI_36__M (0x000000ff)
#define SCS_NVIC_IPR9_PRI_37__M (0x0000ff00)
#define SCS_NVIC_IPR9_PRI_38__M (0x00ff0000)
#define SCS_NVIC_IPR9_PRI_39__M (0xff000000)
#define SCS_SCR_SLEEPDEEP__0 (0x00000000)
#define SCS_SCR_SLEEPDEEP__1 (0x00000004)
#define SCS_SCR_SLEEPONEXIT__0 (0x00000000)
#define SCS_SCR_SLEEPONEXIT__1 (0x00000002)
#define SCS_SHCSR_BUSFAULTACT__0 (0x00000000)
#define SCS_SHCSR_BUSFAULTACT__0_NOT_ACTIVE (0x00000000)
#define SCS_SHCSR_BUSFAULTACT__1 (0x00000002)
#define SCS_SHCSR_BUSFAULTACT__1_ACTIVE (0x00000002)
#define SCS_SHCSR_BUSFAULTENA__0 (0x00000000)
#define SCS_SHCSR_BUSFAULTENA__0_DISABLED (0x00000000)
#define SCS_SHCSR_BUSFAULTENA__1 (0x00020000)
#define SCS_SHCSR_BUSFAULTENA__1_ENABLED (0x00020000)
#define SCS_SHCSR_BUSFAULTPENDED__0 (0x00000000)
#define SCS_SHCSR_BUSFAULTPENDED__0_NOT_PENDED (0x00000000)
#define SCS_SHCSR_BUSFAULTPENDED__1 (0x00004000)
#define SCS_SHCSR_BUSFAULTPENDED__1_PENDED (0x00004000)
#define SCS_SHCSR_MEMFAULTACT__0 (0x00000000)
#define SCS_SHCSR_MEMFAULTACT__0_NOT_ACTIVE (0x00000000)
#define SCS_SHCSR_MEMFAULTACT__1 (0x00000001)
#define SCS_SHCSR_MEMFAULTACT__1_ACTIVE (0x00000001)
#define SCS_SHCSR_MEMFAULTENA__0 (0x00000000)
#define SCS_SHCSR_MEMFAULTENA__0_DISABLED (0x00000000)
#define SCS_SHCSR_MEMFAULTENA__1 (0x00010000)
#define SCS_SHCSR_MEMFAULTENA__1_ENABLED (0x00010000)
#define SCS_SHCSR_MEMFAULTPENDED__0 (0x00000000)
#define SCS_SHCSR_MEMFAULTPENDED__0_NOT_PENDED (0x00000000)
#define SCS_SHCSR_MEMFAULTPENDED__1 (0x00002000)
#define SCS_SHCSR_MEMFAULTPENDED__1_PENDED (0x00002000)
#define SCS_SHCSR_MONITORACT__0 (0x00000000)
#define SCS_SHCSR_MONITORACT__0_NOT_ACTIVE (0x00000000)
#define SCS_SHCSR_MONITORACT__1 (0x00000100)
#define SCS_SHCSR_MONITORACT__1_ACTIVE (0x00000100)
#define SCS_SHCSR_PENDSVACT__0 (0x00000000)
#define SCS_SHCSR_PENDSVACT__0_NOT_ACTIVE (0x00000000)
#define SCS_SHCSR_PENDSVACT__1 (0x00000400)
#define SCS_SHCSR_PENDSVACT__1_ACTIVE (0x00000400)
#define SCS_SHCSR_SVCALLACT__0 (0x00000000)
#define SCS_SHCSR_SVCALLACT__0_NOT_ACTIVE (0x00000000)
#define SCS_SHCSR_SVCALLACT__1 (0x00000080)
#define SCS_SHCSR_SVCALLACT__1_ACTIVE (0x00000080)
#define SCS_SHCSR_SVCALLPENDED__0 (0x00000000)
#define SCS_SHCSR_SVCALLPENDED__0_NOT_PENDED (0x00000000)
#define SCS_SHCSR_SVCALLPENDED__1 (0x00008000)
#define SCS_SHCSR_SVCALLPENDED__1_PENDED (0x00008000)
#define SCS_SHCSR_SYSTICKACT__0 (0x00000000)
#define SCS_SHCSR_SYSTICKACT__0_NOT_ACTIVE (0x00000000)
#define SCS_SHCSR_SYSTICKACT__1 (0x00000800)
#define SCS_SHCSR_SYSTICKACT__1_ACTIVE (0x00000800)
#define SCS_SHCSR_USGFAULTACT__0 (0x00000000)
#define SCS_SHCSR_USGFAULTACT__0_NOT_ACTIVE (0x00000000)
#define SCS_SHCSR_USGFAULTACT__1 (0x00000008)
#define SCS_SHCSR_USGFAULTACT__1_ACTIVE (0x00000008)
#define SCS_SHCSR_USGFAULTENA__0 (0x00000000)
#define SCS_SHCSR_USGFAULTENA__0_DISABLED (0x00000000)
#define SCS_SHCSR_USGFAULTENA__1 (0x00040000)
#define SCS_SHCSR_USGFAULTENA__1_ENABLED (0x00040000)
#define SCS_SHCSR_USGFAULTPENDED__0 (0x00000000)
#define SCS_SHCSR_USGFAULTPENDED__0_NOT_PENDED (0x00000000)
#define SCS_SHCSR_USGFAULTPENDED__1 (0x00001000)
#define SCS_SHCSR_USGFAULTPENDED__1_PENDED (0x00001000)
#define SCS_SHPR1_PRI_4__M (0x000000ff)
#define SCS_SHPR1_PRI_5__M (0x0000ff00)
#define SCS_SHPR1_PRI_6__M (0x00ff0000)
#define SCS_SHPR1_PRI_7__M (0xff000000)
#define SCS_SHPR2_PRI_10__M (0x00ff0000)
#define SCS_SHPR2_PRI_11__M (0xff000000)
#define SCS_SHPR2_PRI_8__M (0x000000ff)
#define SCS_SHPR2_PRI_9__M (0x0000ff00)
#define SCS_SHPR3_PRI_12__M (0x000000ff)
#define SCS_SHPR3_PRI_13__M (0x0000ff00)
#define SCS_SHPR3_PRI_14__M (0x00ff0000)
#define SCS_SHPR3_PRI_15__M (0xff000000)
#define SCS_STCR_TENMS__M (0x00ffffff)
#define SCS_STCSR_CLKSOURCE__0 (0x00000000)
#define SCS_STCSR_CLKSOURCE__1 (0x00000004)
#define SCS_STCSR_CLKSOURCE__1_CORE_CLOCK (0x00000004)
#define SCS_STCSR_ENABLE__0 (0x00000000)
#define SCS_STCSR_TICKINT__0 (0x00000000)
#define SCS_STCSR_TICKINT__1 (0x00000002)
#define SCS_STCVR_CURRENT__M (0x00ffffff)
#define SCS_STIR_INTID__M (0x000001ff)
#define SCS_STRVR_RELOAD__M (0x00ffffff)
#define SCS_VTOR_TBLOFF__M (0x1fffff80)
#define SELA__0 (0x00000000)
#define SELA__1 (0x00000100)
#define SELA__2 (0x00000200)
#define SELA__M (0x00000700)
#define SELM__0 (0x00000000)
#define SELM__1 (0x00000001)
#define SELM__2 (0x00000002)
#define SELM__3 (0x00000003)
#define SELM__4 (0x00000004)
#define SELM__5 (0x00000005)
#define SELM__6 (0x00000006)
#define SELM__7 (0x00000007)
#define SELM__M (0x00000007)
#define SELS__0 (0x00000000)
#define SELS__1 (0x00000010)
#define SELS__2 (0x00000020)
#define SELS__3 (0x00000030)
#define SELS__4 (0x00000040)
#define SELS__5 (0x00000050)
#define SELS__6 (0x00000060)
#define SELS__7 (0x00000070)
#define SELS__M (0x00000070)
#define SYSCTL_DIOGLTFLTCTL_GLTCH_EN__0 (0x00000000)
#define SYSCTL_DIOGLTFLTCTL_GLTCH_EN__1 (0x00000001)
#define SYSCTL_NMI_CTLSTAT_CS_FLG__0 (0x00000000)
#define SYSCTL_NMI_CTLSTAT_CS_FLG__1 (0x00010000)
#define SYSCTL_NMI_CTLSTAT_CS_SRC__0 (0x00000000)
#define SYSCTL_NMI_CTLSTAT_CS_SRC__1 (0x00000001)
#define SYSCTL_NMI_CTLSTAT_PCM_FLG__0 (0x00000000)
#define SYSCTL_NMI_CTLSTAT_PCM_FLG__1 (0x00040000)
#define SYSCTL_NMI_CTLSTAT_PCM_SRC__0 (0x00000000)
#define SYSCTL_NMI_CTLSTAT_PCM_SRC__1 (0x00000004)
#define SYSCTL_NMI_CTLSTAT_PIN_FLG__0 (0x00000000)
#define SYSCTL_NMI_CTLSTAT_PIN_FLG__1 (0x00080000)
#define SYSCTL_NMI_CTLSTAT_PIN_SRC__0 (0x00000000)
#define SYSCTL_NMI_CTLSTAT_PIN_SRC__1 (0x00000008)
#define SYSCTL_NMI_CTLSTAT_PSS_FLG__0 (0x00000000)
#define SYSCTL_NMI_CTLSTAT_PSS_FLG__1 (0x00020000)
#define SYSCTL_NMI_CTLSTAT_PSS_SRC__0 (0x00000000)
#define SYSCTL_NMI_CTLSTAT_PSS_SRC__1 (0x00000002)
#define SYSCTL_PERI_HALTCTL_ADC__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_ADC__1 (0x00002000)
#define SYSCTL_PERI_HALTCTL_DMA__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_DMA__1 (0x00008000)
#define SYSCTL_PERI_HALTCTL_EUA0__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_EUA0__1 (0x00000020)
#define SYSCTL_PERI_HALTCTL_EUA1__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_EUA1__1 (0x00000040)
#define SYSCTL_PERI_HALTCTL_EUA2__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_EUA2__1 (0x00000080)
#define SYSCTL_PERI_HALTCTL_EUA3__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_EUA3__1 (0x00000100)
#define SYSCTL_PERI_HALTCTL_EUB0__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_EUB0__1 (0x00000200)
#define SYSCTL_PERI_HALTCTL_EUB1__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_EUB1__1 (0x00000400)
#define SYSCTL_PERI_HALTCTL_EUB2__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_EUB2__1 (0x00000800)
#define SYSCTL_PERI_HALTCTL_EUB3__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_EUB3__1 (0x00001000)
#define SYSCTL_PERI_HALTCTL_T16_0__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_T16_0__1 (0x00000001)
#define SYSCTL_PERI_HALTCTL_T16_1__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_T16_1__1 (0x00000002)
#define SYSCTL_PERI_HALTCTL_T16_2__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_T16_2__1 (0x00000004)
#define SYSCTL_PERI_HALTCTL_T16_3__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_T16_3__1 (0x00000008)
#define SYSCTL_PERI_HALTCTL_T32_0__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_T32_0__1 (0x00000010)
#define SYSCTL_PERI_HALTCTL_WDT__0 (0x00000000)
#define SYSCTL_PERI_HALTCTL_WDT__1 (0x00004000)
#define SYSCTL_REBOOT_CTL_WKEY__M (0x0000ff00)
#define SYSCTL_SECDATA_UNLOCK_UNLKEY__M (0x0000ffff)
#define SYSCTL_SRAM_BANKEN_BNK1_EN__0 (0x00000000)
#define SYSCTL_SRAM_BANKEN_BNK1_EN__1 (0x00000002)
#define SYSCTL_SRAM_BANKEN_BNK2_EN__0 (0x00000000)
#define SYSCTL_SRAM_BANKEN_BNK2_EN__1 (0x00000004)
#define SYSCTL_SRAM_BANKEN_BNK3_EN__0 (0x00000000)
#define SYSCTL_SRAM_BANKEN_BNK3_EN__1 (0x00000008)
#define SYSCTL_SRAM_BANKEN_BNK4_EN__0 (0x00000000)
#define SYSCTL_SRAM_BANKEN_BNK4_EN__1 (0x00000010)
#define SYSCTL_SRAM_BANKEN_BNK5_EN__0 (0x00000000)
#define SYSCTL_SRAM_BANKEN_BNK5_EN__1 (0x00000020)
#define SYSCTL_SRAM_BANKEN_BNK6_EN__0 (0x00000000)
#define SYSCTL_SRAM_BANKEN_BNK6_EN__1 (0x00000040)
#define SYSCTL_SRAM_BANKEN_BNK7_EN__0 (0x00000000)
#define SYSCTL_SRAM_BANKEN_BNK7_EN__1 (0x00000080)
#define SYSCTL_SRAM_BANKEN_SRAM_RDY__0 (0x00000000)
#define SYSCTL_SRAM_BANKEN_SRAM_RDY__1 (0x00010000)
#define SYSCTL_SRAM_BANKRET_BNK1_RET__0 (0x00000000)
#define SYSCTL_SRAM_BANKRET_BNK1_RET__1 (0x00000002)
#define SYSCTL_SRAM_BANKRET_BNK2_RET__0 (0x00000000)
#define SYSCTL_SRAM_BANKRET_BNK2_RET__1 (0x00000004)
#define SYSCTL_SRAM_BANKRET_BNK3_RET__0 (0x00000000)
#define SYSCTL_SRAM_BANKRET_BNK3_RET__1 (0x00000008)
#define SYSCTL_SRAM_BANKRET_BNK4_RET__0 (0x00000000)
#define SYSCTL_SRAM_BANKRET_BNK4_RET__1 (0x00000010)
#define SYSCTL_SRAM_BANKRET_BNK5_RET__0 (0x00000000)
#define SYSCTL_SRAM_BANKRET_BNK5_RET__1 (0x00000020)
#define SYSCTL_SRAM_BANKRET_BNK6_RET__0 (0x00000000)
#define SYSCTL_SRAM_BANKRET_BNK6_RET__1 (0x00000040)
#define SYSCTL_SRAM_BANKRET_BNK7_RET__0 (0x00000000)
#define SYSCTL_SRAM_BANKRET_BNK7_RET__1 (0x00000080)
#define SYSCTL_SRAM_BANKRET_SRAM_RDY__0 (0x00000000)
#define SYSCTL_SRAM_BANKRET_SRAM_RDY__1 (0x00010000)
#define SYSCTL_WDT_RSTCTL_TIMEOUT__0 (0x00000000)
#define SYSCTL_WDT_RSTCTL_TIMEOUT__1 (0x00000001)
#define SYSCTL_WDT_RSTCTL_VIOLATION__0 (0x00000000)
#define SYSCTL_WDT_RSTCTL_VIOLATION__1 (0x00000002)
#define T32CONTROL1_ENABLE (0x00000080)
#define T32CONTROL1_ENABLE__0 (0x00000000)
#define T32CONTROL1_ENABLE__0_TIMER_DISABLED (0x00000000)
#define T32CONTROL1_ENABLE__1 (0x00000080)
#define T32CONTROL1_ENABLE__1_TIMER_ENABLED (0x00000080)
#define T32CONTROL1_IE (0x00000020)
#define T32CONTROL1_IE__0 (0x00000000)
#define T32CONTROL1_IE__1 (0x00000020)
#define T32CONTROL1_MODE (0x00000040)
#define T32CONTROL1_MODE__0 (0x00000000)
#define T32CONTROL1_MODE__1 (0x00000040)
#define T32CONTROL1_ONESHOT (0x00000001)
#define T32CONTROL1_ONESHOT__0 (0x00000000)
#define T32CONTROL1_ONESHOT__0_WRAPPING_MODE (0x00000000)
#define T32CONTROL1_ONESHOT__1 (0x00000001)
#define T32CONTROL1_ONESHOT__1_ONE_SHOT_MODE (0x00000001)
#define T32CONTROL1_PRESCALE__0 (0x00000000)
#define T32CONTROL1_PRESCALE__1 (0x00000004)
#define T32CONTROL1_PRESCALE__2 (0x00000008)
#define T32CONTROL1_PRESCALE__M (0x0000000c)
#define T32CONTROL1_SIZE (0x00000002)
#define T32CONTROL1_SIZE__0 (0x00000000)
#define T32CONTROL1_SIZE__0_16_BIT_COUNTER (0x00000000)
#define T32CONTROL1_SIZE__1 (0x00000002)
#define T32CONTROL1_SIZE__1_32_BIT_COUNTER (0x00000002)
#define T32CONTROL2_ENABLE (0x00000080)
#define T32CONTROL2_ENABLE__0 (0x00000000)
#define T32CONTROL2_ENABLE__0_TIMER_DISABLED (0x00000000)
#define T32CONTROL2_ENABLE__1 (0x00000080)
#define T32CONTROL2_ENABLE__1_TIMER_ENABLED (0x00000080)
#define T32CONTROL2_IE (0x00000020)
#define T32CONTROL2_IE__0 (0x00000000)
#define T32CONTROL2_IE__1 (0x00000020)
#define T32CONTROL2_MODE (0x00000040)
#define T32CONTROL2_MODE__0 (0x00000000)
#define T32CONTROL2_MODE__1 (0x00000040)
#define T32CONTROL2_ONESHOT (0x00000001)
#define T32CONTROL2_ONESHOT__0 (0x00000000)
#define T32CONTROL2_ONESHOT__0_WRAPPING_MODE (0x00000000)
#define T32CONTROL2_ONESHOT__1 (0x00000001)
#define T32CONTROL2_ONESHOT__1_ONE_SHOT_MODE (0x00000001)
#define T32CONTROL2_PRESCALE__0 (0x00000000)
#define T32CONTROL2_PRESCALE__1 (0x00000004)
#define T32CONTROL2_PRESCALE__2 (0x00000008)
#define T32CONTROL2_PRESCALE__M (0x0000000c)
#define T32CONTROL2_SIZE (0x00000002)
#define T32CONTROL2_SIZE__0 (0x00000000)
#define T32CONTROL2_SIZE__0_16_BIT_COUNTER (0x00000000)
#define T32CONTROL2_SIZE__1 (0x00000002)
#define T32CONTROL2_SIZE__1_32_BIT_COUNTER (0x00000002)
#define T32MIS1_IFG (0x00000001)
#define T32MIS2_IFG (0x00000001)
#define T32RIS1_RAW_IFG (0x00000001)
#define T32RIS2_RAW_IFG (0x00000001)
#define T32_BGLOAD1 (HWREG32(0x4000C018))
#define T32_BGLOAD2 (HWREG32(0x4000C038))
#define T32_CONTROL1 (HWREG32(0x4000C008))
#define T32_CONTROL1_ENABLE (0x00000080)
#define T32_CONTROL1_ENABLE__0 (0x00000000)
#define T32_CONTROL1_ENABLE__0_TIMER_DISABLED (0x00000000)
#define T32_CONTROL1_ENABLE__1 (0x00000080)
#define T32_CONTROL1_ENABLE__1_TIMER_ENABLED (0x00000080)
#define T32_CONTROL1_IE (0x00000020)
#define T32_CONTROL1_IE__0 (0x00000000)
#define T32_CONTROL1_IE__1 (0x00000020)
#define T32_CONTROL1_MODE (0x00000040)
#define T32_CONTROL1_MODE__0 (0x00000000)
#define T32_CONTROL1_MODE__1 (0x00000040)
#define T32_CONTROL1_ONESHOT (0x00000001)
#define T32_CONTROL1_ONESHOT__0 (0x00000000)
#define T32_CONTROL1_ONESHOT__0_WRAPPING_MODE (0x00000000)
#define T32_CONTROL1_ONESHOT__1 (0x00000001)
#define T32_CONTROL1_ONESHOT__1_ONE_SHOT_MODE (0x00000001)
#define T32_CONTROL1_PRESCALE__0 (0x00000000)
#define T32_CONTROL1_PRESCALE__1 (0x00000004)
#define T32_CONTROL1_PRESCALE__2 (0x00000008)
#define T32_CONTROL1_PRESCALE__M (0x0000000c)
#define T32_CONTROL1_SIZE (0x00000002)
#define T32_CONTROL1_SIZE__0 (0x00000000)
#define T32_CONTROL1_SIZE__0_16_BIT_COUNTER (0x00000000)
#define T32_CONTROL1_SIZE__1 (0x00000002)
#define T32_CONTROL1_SIZE__1_32_BIT_COUNTER (0x00000002)
#define T32_CONTROL2 (HWREG32(0x4000C028))
#define T32_CONTROL2_ENABLE (0x00000080)
#define T32_CONTROL2_ENABLE__0 (0x00000000)
#define T32_CONTROL2_ENABLE__0_TIMER_DISABLED (0x00000000)
#define T32_CONTROL2_ENABLE__1 (0x00000080)
#define T32_CONTROL2_ENABLE__1_TIMER_ENABLED (0x00000080)
#define T32_CONTROL2_IE (0x00000020)
#define T32_CONTROL2_IE__0 (0x00000000)
#define T32_CONTROL2_IE__1 (0x00000020)
#define T32_CONTROL2_MODE (0x00000040)
#define T32_CONTROL2_MODE__0 (0x00000000)
#define T32_CONTROL2_MODE__1 (0x00000040)
#define T32_CONTROL2_ONESHOT (0x00000001)
#define T32_CONTROL2_ONESHOT__0 (0x00000000)
#define T32_CONTROL2_ONESHOT__0_WRAPPING_MODE (0x00000000)
#define T32_CONTROL2_ONESHOT__1 (0x00000001)
#define T32_CONTROL2_ONESHOT__1_ONE_SHOT_MODE (0x00000001)
#define T32_CONTROL2_PRESCALE__0 (0x00000000)
#define T32_CONTROL2_PRESCALE__1 (0x00000004)
#define T32_CONTROL2_PRESCALE__2 (0x00000008)
#define T32_CONTROL2_PRESCALE__M (0x0000000c)
#define T32_CONTROL2_SIZE (0x00000002)
#define T32_CONTROL2_SIZE__0 (0x00000000)
#define T32_CONTROL2_SIZE__0_16_BIT_COUNTER (0x00000000)
#define T32_CONTROL2_SIZE__1 (0x00000002)
#define T32_CONTROL2_SIZE__1_32_BIT_COUNTER (0x00000002)
#define T32_INTCLR1 (HWREG32(0x4000C00C))
#define T32_INTCLR2 (HWREG32(0x4000C02C))
#define T32_LOAD1 (HWREG32(0x4000C000))
#define T32_LOAD2 (HWREG32(0x4000C020))
#define T32_MIS1 (HWREG32(0x4000C014))
#define T32_MIS1_IFG (0x00000001)
#define T32_MIS2 (HWREG32(0x4000C034))
#define T32_MIS2_IFG (0x00000001)
#define T32_RIS1 (HWREG32(0x4000C010))
#define T32_RIS1_RAW_IFG (0x00000001)
#define T32_RIS2 (HWREG32(0x4000C030))
#define T32_RIS2_RAW_IFG (0x00000001)
#define T32_VALUE1 (HWREG32(0x4000C004))
#define T32_VALUE2 (HWREG32(0x4000C024))
#define TA0IV_3 (0x0006)
#define TA0IV_4 (0x0008)
#define TA0IV_5 (0x000A)
#define TA0IV_6 (0x000C)
#define TA0IV_NONE (0x0000)
#define TA0IV_TA0CCR1 (0x0002)
#define TA0IV_TA0CCR2 (0x0004)
#define TA0IV_TA0IFG (0x000E)
#define TA0_CCR0 (HWREG16(0x40000012))
#define TA0_CCR1 (HWREG16(0x40000014))
#define TA0_CCR2 (HWREG16(0x40000016))
#define TA0_CCR3 (HWREG16(0x40000018))
#define TA0_CCR4 (HWREG16(0x4000001A))
#define TA0_CCR5 (HWREG16(0x4000001C))
#define TA0_CCR6 (HWREG16(0x4000001E))
#define TA0_CCTL0 (HWREG16(0x40000002))
#define TA0_CCTL1 (HWREG16(0x40000004))
#define TA0_CCTL2 (HWREG16(0x40000006))
#define TA0_CCTL3 (HWREG16(0x40000008))
#define TA0_CCTL4 (HWREG16(0x4000000A))
#define TA0_CCTL5 (HWREG16(0x4000000C))
#define TA0_CCTL6 (HWREG16(0x4000000E))
#define TA0_CCTL_CAP (0x0100)
#define TA0_CCTL_CAP__0 (0x0000)
#define TA0_CCTL_CAP__0_COMPARE_MODE (0x0000)
#define TA0_CCTL_CAP__1 (0x0100)
#define TA0_CCTL_CAP__1_CAPTURE_MODE (0x0100)
#define TA0_CCTL_CCI (0x0008)
#define TA0_CCTL_CCIE (0x0010)
#define TA0_CCTL_CCIE__0 (0x0000)
#define TA0_CCTL_CCIE__1 (0x0010)
#define TA0_CCTL_CCIFG (0x0001)
#define TA0_CCTL_CCIFG__0 (0x0000)
#define TA0_CCTL_CCIFG__1 (0x0001)
#define TA0_CCTL_CCIS__0 (0x0000)
#define TA0_CCTL_CCIS__0_CCIXA (0x0000)
#define TA0_CCTL_CCIS__1 (0x1000)
#define TA0_CCTL_CCIS__1_CCIXB (0x1000)
#define TA0_CCTL_CCIS__2 (0x2000)
#define TA0_CCTL_CCIS__2_GND (0x2000)
#define TA0_CCTL_CCIS__3 (0x3000)
#define TA0_CCTL_CCIS__3_VCC (0x3000)
#define TA0_CCTL_CCIS__M (0x3000)
#define TA0_CCTL_CM__0 (0x0000)
#define TA0_CCTL_CM__0_NO_CAPTURE (0x0000)
#define TA0_CCTL_CM__1 (0x4000)
#define TA0_CCTL_CM__2 (0x8000)
#define TA0_CCTL_CM__3 (0xc000)
#define TA0_CCTL_CM__M (0xc000)
#define TA0_CCTL_COV (0x0002)
#define TA0_CCTL_COV__0 (0x0000)
#define TA0_CCTL_COV__1 (0x0002)
#define TA0_CCTL_OUT (0x0004)
#define TA0_CCTL_OUTMOD__0 (0x0000)
#define TA0_CCTL_OUTMOD__0_OUT_BIT_VALUE (0x0000)
#define TA0_CCTL_OUTMOD__1 (0x0020)
#define TA0_CCTL_OUTMOD__1_SET (0x0020)
#define TA0_CCTL_OUTMOD__2 (0x0040)
#define TA0_CCTL_OUTMOD__2_TOGGLE_RESET (0x0040)
#define TA0_CCTL_OUTMOD__3 (0x0060)
#define TA0_CCTL_OUTMOD__3_SET_RESET (0x0060)
#define TA0_CCTL_OUTMOD__4 (0x0080)
#define TA0_CCTL_OUTMOD__4_TOGGLE (0x0080)
#define TA0_CCTL_OUTMOD__5 (0x00a0)
#define TA0_CCTL_OUTMOD__5_RESET (0x00a0)
#define TA0_CCTL_OUTMOD__6 (0x00c0)
#define TA0_CCTL_OUTMOD__6_TOGGLE_SET (0x00c0)
#define TA0_CCTL_OUTMOD__7 (0x00e0)
#define TA0_CCTL_OUTMOD__7_RESET_SET (0x00e0)
#define TA0_CCTL_OUTMOD__M (0x00e0)
#define TA0_CCTL_OUT__0 (0x0000)
#define TA0_CCTL_OUT__0_OUTPUT_LOW (0x0000)
#define TA0_CCTL_OUT__1 (0x0004)
#define TA0_CCTL_OUT__1_OUTPUT_HIGH (0x0004)
#define TA0_CCTL_SCCI (0x0400)
#define TA0_CCTL_SCS (0x0800)
#define TA0_CCTL_SCS__0 (0x0000)
#define TA0_CCTL_SCS__1 (0x0800)
#define TA0_CTL (HWREG16(0x40000000))
#define TA0_CTL_ID__0 (0x0000)
#define TA0_CTL_ID__0__1 (0x0000)
#define TA0_CTL_ID__1 (0x0040)
#define TA0_CTL_ID__1__2 (0x0040)
#define TA0_CTL_ID__2 (0x0080)
#define TA0_CTL_ID__2__4 (0x0080)
#define TA0_CTL_ID__3 (0x00c0)
#define TA0_CTL_ID__3__8 (0x00c0)
#define TA0_CTL_ID__M (0x00c0)
#define TA0_CTL_MC__0 (0x0000)
#define TA0_CTL_MC__1 (0x0010)
#define TA0_CTL_MC__2 (0x0020)
#define TA0_CTL_MC__3 (0x0030)
#define TA0_CTL_MC__M (0x0030)
#define TA0_CTL_TACLR (0x0004)
#define TA0_CTL_TAIE (0x0002)
#define TA0_CTL_TAIE__0 (0x0000)
#define TA0_CTL_TAIE__1 (0x0002)
#define TA0_CTL_TAIFG (0x0001)
#define TA0_CTL_TAIFG__0 (0x0000)
#define TA0_CTL_TAIFG__1 (0x0001)
#define TA0_CTL_TASSEL__0 (0x0000)
#define TA0_CTL_TASSEL__0_TAXCLK (0x0000)
#define TA0_CTL_TASSEL__1 (0x0100)
#define TA0_CTL_TASSEL__1_ACLK (0x0100)
#define TA0_CTL_TASSEL__2 (0x0200)
#define TA0_CTL_TASSEL__2_SMCLK (0x0200)
#define TA0_CTL_TASSEL__3 (0x0300)
#define TA0_CTL_TASSEL__3_INCLK (0x0300)
#define TA0_CTL_TASSEL__M (0x0300)
#define TA0_EX0 (HWREG16(0x40000020))
#define TA0_EX0_TAIDEX__0 (0x0000)
#define TA0_EX0_TAIDEX__0_DIVIDE_BY_1 (0x0000)
#define TA0_EX0_TAIDEX__1 (0x0001)
#define TA0_EX0_TAIDEX__1_DIVIDE_BY_2 (0x0001)
#define TA0_EX0_TAIDEX__2 (0x0002)
#define TA0_EX0_TAIDEX__2_DIVIDE_BY_3 (0x0002)
#define TA0_EX0_TAIDEX__3 (0x0003)
#define TA0_EX0_TAIDEX__3_DIVIDE_BY_4 (0x0003)
#define TA0_EX0_TAIDEX__4 (0x0004)
#define TA0_EX0_TAIDEX__4_DIVIDE_BY_5 (0x0004)
#define TA0_EX0_TAIDEX__5 (0x0005)
#define TA0_EX0_TAIDEX__5_DIVIDE_BY_6 (0x0005)
#define TA0_EX0_TAIDEX__6 (0x0006)
#define TA0_EX0_TAIDEX__6_DIVIDE_BY_7 (0x0006)
#define TA0_EX0_TAIDEX__7 (0x0007)
#define TA0_EX0_TAIDEX__7_DIVIDE_BY_8 (0x0007)
#define TA0_EX0_TAIDEX__M (0x0007)
#define TA0_IV (HWREG16(0x4000002E))
#define TA0_R (HWREG16(0x40000010))
#define TA1_CCR0 (HWREG16(0x40000412))
#define TA1_CCR1 (HWREG16(0x40000414))
#define TA1_CCR2 (HWREG16(0x40000416))
#define TA1_CCR3 (HWREG16(0x40000418))
#define TA1_CCR4 (HWREG16(0x4000041A))
#define TA1_CCR5 (HWREG16(0x4000041C))
#define TA1_CCR6 (HWREG16(0x4000041E))
#define TA1_CCTL0 (HWREG16(0x40000402))
#define TA1_CCTL1 (HWREG16(0x40000404))
#define TA1_CCTL2 (HWREG16(0x40000406))
#define TA1_CCTL3 (HWREG16(0x40000408))
#define TA1_CCTL4 (HWREG16(0x4000040A))
#define TA1_CCTL5 (HWREG16(0x4000040C))
#define TA1_CCTL6 (HWREG16(0x4000040E))
#define TA1_CCTL_CAP (0x0100)
#define TA1_CCTL_CAP__0 (0x0000)
#define TA1_CCTL_CAP__0_COMPARE_MODE (0x0000)
#define TA1_CCTL_CAP__1 (0x0100)
#define TA1_CCTL_CAP__1_CAPTURE_MODE (0x0100)
#define TA1_CCTL_CCI (0x0008)
#define TA1_CCTL_CCIE (0x0010)
#define TA1_CCTL_CCIE__0 (0x0000)
#define TA1_CCTL_CCIE__1 (0x0010)
#define TA1_CCTL_CCIFG (0x0001)
#define TA1_CCTL_CCIFG__0 (0x0000)
#define TA1_CCTL_CCIFG__1 (0x0001)
#define TA1_CCTL_CCIS__0 (0x0000)
#define TA1_CCTL_CCIS__0_CCIXA (0x0000)
#define TA1_CCTL_CCIS__1 (0x1000)
#define TA1_CCTL_CCIS__1_CCIXB (0x1000)
#define TA1_CCTL_CCIS__2 (0x2000)
#define TA1_CCTL_CCIS__2_GND (0x2000)
#define TA1_CCTL_CCIS__3 (0x3000)
#define TA1_CCTL_CCIS__3_VCC (0x3000)
#define TA1_CCTL_CCIS__M (0x3000)
#define TA1_CCTL_CM__0 (0x0000)
#define TA1_CCTL_CM__0_NO_CAPTURE (0x0000)
#define TA1_CCTL_CM__1 (0x4000)
#define TA1_CCTL_CM__2 (0x8000)
#define TA1_CCTL_CM__3 (0xc000)
#define TA1_CCTL_CM__M (0xc000)
#define TA1_CCTL_COV (0x0002)
#define TA1_CCTL_COV__0 (0x0000)
#define TA1_CCTL_COV__1 (0x0002)
#define TA1_CCTL_OUT (0x0004)
#define TA1_CCTL_OUTMOD__0 (0x0000)
#define TA1_CCTL_OUTMOD__0_OUT_BIT_VALUE (0x0000)
#define TA1_CCTL_OUTMOD__1 (0x0020)
#define TA1_CCTL_OUTMOD__1_SET (0x0020)
#define TA1_CCTL_OUTMOD__2 (0x0040)
#define TA1_CCTL_OUTMOD__2_TOGGLE_RESET (0x0040)
#define TA1_CCTL_OUTMOD__3 (0x0060)
#define TA1_CCTL_OUTMOD__3_SET_RESET (0x0060)
#define TA1_CCTL_OUTMOD__4 (0x0080)
#define TA1_CCTL_OUTMOD__4_TOGGLE (0x0080)
#define TA1_CCTL_OUTMOD__5 (0x00a0)
#define TA1_CCTL_OUTMOD__5_RESET (0x00a0)
#define TA1_CCTL_OUTMOD__6 (0x00c0)
#define TA1_CCTL_OUTMOD__6_TOGGLE_SET (0x00c0)
#define TA1_CCTL_OUTMOD__7 (0x00e0)
#define TA1_CCTL_OUTMOD__7_RESET_SET (0x00e0)
#define TA1_CCTL_OUTMOD__M (0x00e0)
#define TA1_CCTL_OUT__0 (0x0000)
#define TA1_CCTL_OUT__0_OUTPUT_LOW (0x0000)
#define TA1_CCTL_OUT__1 (0x0004)
#define TA1_CCTL_OUT__1_OUTPUT_HIGH (0x0004)
#define TA1_CCTL_SCCI (0x0400)
#define TA1_CCTL_SCS (0x0800)
#define TA1_CCTL_SCS__0 (0x0000)
#define TA1_CCTL_SCS__1 (0x0800)
#define TA1_CTL (HWREG16(0x40000400))
#define TA1_CTL_ID__0 (0x0000)
#define TA1_CTL_ID__0__1 (0x0000)
#define TA1_CTL_ID__1 (0x0040)
#define TA1_CTL_ID__1__2 (0x0040)
#define TA1_CTL_ID__2 (0x0080)
#define TA1_CTL_ID__2__4 (0x0080)
#define TA1_CTL_ID__3 (0x00c0)
#define TA1_CTL_ID__3__8 (0x00c0)
#define TA1_CTL_ID__M (0x00c0)
#define TA1_CTL_MC__0 (0x0000)
#define TA1_CTL_MC__1 (0x0010)
#define TA1_CTL_MC__2 (0x0020)
#define TA1_CTL_MC__3 (0x0030)
#define TA1_CTL_MC__M (0x0030)
#define TA1_CTL_TACLR (0x0004)
#define TA1_CTL_TAIE (0x0002)
#define TA1_CTL_TAIE__0 (0x0000)
#define TA1_CTL_TAIE__1 (0x0002)
#define TA1_CTL_TAIFG (0x0001)
#define TA1_CTL_TAIFG__0 (0x0000)
#define TA1_CTL_TAIFG__1 (0x0001)
#define TA1_CTL_TASSEL__0 (0x0000)
#define TA1_CTL_TASSEL__0_TAXCLK (0x0000)
#define TA1_CTL_TASSEL__1 (0x0100)
#define TA1_CTL_TASSEL__1_ACLK (0x0100)
#define TA1_CTL_TASSEL__2 (0x0200)
#define TA1_CTL_TASSEL__2_SMCLK (0x0200)
#define TA1_CTL_TASSEL__3 (0x0300)
#define TA1_CTL_TASSEL__3_INCLK (0x0300)
#define TA1_CTL_TASSEL__M (0x0300)
#define TA1_EX0 (HWREG16(0x40000420))
#define TA1_EX0_TAIDEX__0 (0x0000)
#define TA1_EX0_TAIDEX__0_DIVIDE_BY_1 (0x0000)
#define TA1_EX0_TAIDEX__1 (0x0001)
#define TA1_EX0_TAIDEX__1_DIVIDE_BY_2 (0x0001)
#define TA1_EX0_TAIDEX__2 (0x0002)
#define TA1_EX0_TAIDEX__2_DIVIDE_BY_3 (0x0002)
#define TA1_EX0_TAIDEX__3 (0x0003)
#define TA1_EX0_TAIDEX__3_DIVIDE_BY_4 (0x0003)
#define TA1_EX0_TAIDEX__4 (0x0004)
#define TA1_EX0_TAIDEX__4_DIVIDE_BY_5 (0x0004)
#define TA1_EX0_TAIDEX__5 (0x0005)
#define TA1_EX0_TAIDEX__5_DIVIDE_BY_6 (0x0005)
#define TA1_EX0_TAIDEX__6 (0x0006)
#define TA1_EX0_TAIDEX__6_DIVIDE_BY_7 (0x0006)
#define TA1_EX0_TAIDEX__7 (0x0007)
#define TA1_EX0_TAIDEX__7_DIVIDE_BY_8 (0x0007)
#define TA1_EX0_TAIDEX__M (0x0007)
#define TA1_IV (HWREG16(0x4000042E))
#define TA1_R (HWREG16(0x40000410))
#define TA2_CCR0 (HWREG16(0x40000812))
#define TA2_CCR1 (HWREG16(0x40000814))
#define TA2_CCR2 (HWREG16(0x40000816))
#define TA2_CCR3 (HWREG16(0x40000818))
#define TA2_CCR4 (HWREG16(0x4000081A))
#define TA2_CCR5 (HWREG16(0x4000081C))
#define TA2_CCR6 (HWREG16(0x4000081E))
#define TA2_CCTL0 (HWREG16(0x40000802))
#define TA2_CCTL1 (HWREG16(0x40000804))
#define TA2_CCTL2 (HWREG16(0x40000806))
#define TA2_CCTL3 (HWREG16(0x40000808))
#define TA2_CCTL4 (HWREG16(0x4000080A))
#define TA2_CCTL5 (HWREG16(0x4000080C))
#define TA2_CCTL6 (HWREG16(0x4000080E))
#define TA2_CCTL_CAP (0x0100)
#define TA2_CCTL_CAP__0 (0x0000)
#define TA2_CCTL_CAP__0_COMPARE_MODE (0x0000)
#define TA2_CCTL_CAP__1 (0x0100)
#define TA2_CCTL_CAP__1_CAPTURE_MODE (0x0100)
#define TA2_CCTL_CCI (0x0008)
#define TA2_CCTL_CCIE (0x0010)
#define TA2_CCTL_CCIE__0 (0x0000)
#define TA2_CCTL_CCIE__1 (0x0010)
#define TA2_CCTL_CCIFG (0x0001)
#define TA2_CCTL_CCIFG__0 (0x0000)
#define TA2_CCTL_CCIFG__1 (0x0001)
#define TA2_CCTL_CCIS__0 (0x0000)
#define TA2_CCTL_CCIS__0_CCIXA (0x0000)
#define TA2_CCTL_CCIS__1 (0x1000)
#define TA2_CCTL_CCIS__1_CCIXB (0x1000)
#define TA2_CCTL_CCIS__2 (0x2000)
#define TA2_CCTL_CCIS__2_GND (0x2000)
#define TA2_CCTL_CCIS__3 (0x3000)
#define TA2_CCTL_CCIS__3_VCC (0x3000)
#define TA2_CCTL_CCIS__M (0x3000)
#define TA2_CCTL_CM__0 (0x0000)
#define TA2_CCTL_CM__0_NO_CAPTURE (0x0000)
#define TA2_CCTL_CM__1 (0x4000)
#define TA2_CCTL_CM__2 (0x8000)
#define TA2_CCTL_CM__3 (0xc000)
#define TA2_CCTL_CM__M (0xc000)
#define TA2_CCTL_COV (0x0002)
#define TA2_CCTL_COV__0 (0x0000)
#define TA2_CCTL_COV__1 (0x0002)
#define TA2_CCTL_OUT (0x0004)
#define TA2_CCTL_OUTMOD__0 (0x0000)
#define TA2_CCTL_OUTMOD__0_OUT_BIT_VALUE (0x0000)
#define TA2_CCTL_OUTMOD__1 (0x0020)
#define TA2_CCTL_OUTMOD__1_SET (0x0020)
#define TA2_CCTL_OUTMOD__2 (0x0040)
#define TA2_CCTL_OUTMOD__2_TOGGLE_RESET (0x0040)
#define TA2_CCTL_OUTMOD__3 (0x0060)
#define TA2_CCTL_OUTMOD__3_SET_RESET (0x0060)
#define TA2_CCTL_OUTMOD__4 (0x0080)
#define TA2_CCTL_OUTMOD__4_TOGGLE (0x0080)
#define TA2_CCTL_OUTMOD__5 (0x00a0)
#define TA2_CCTL_OUTMOD__5_RESET (0x00a0)
#define TA2_CCTL_OUTMOD__6 (0x00c0)
#define TA2_CCTL_OUTMOD__6_TOGGLE_SET (0x00c0)
#define TA2_CCTL_OUTMOD__7 (0x00e0)
#define TA2_CCTL_OUTMOD__7_RESET_SET (0x00e0)
#define TA2_CCTL_OUTMOD__M (0x00e0)
#define TA2_CCTL_OUT__0 (0x0000)
#define TA2_CCTL_OUT__0_OUTPUT_LOW (0x0000)
#define TA2_CCTL_OUT__1 (0x0004)
#define TA2_CCTL_OUT__1_OUTPUT_HIGH (0x0004)
#define TA2_CCTL_SCCI (0x0400)
#define TA2_CCTL_SCS (0x0800)
#define TA2_CCTL_SCS__0 (0x0000)
#define TA2_CCTL_SCS__1 (0x0800)
#define TA2_CTL (HWREG16(0x40000800))
#define TA2_CTL_ID__0 (0x0000)
#define TA2_CTL_ID__0__1 (0x0000)
#define TA2_CTL_ID__1 (0x0040)
#define TA2_CTL_ID__1__2 (0x0040)
#define TA2_CTL_ID__2 (0x0080)
#define TA2_CTL_ID__2__4 (0x0080)
#define TA2_CTL_ID__3 (0x00c0)
#define TA2_CTL_ID__3__8 (0x00c0)
#define TA2_CTL_ID__M (0x00c0)
#define TA2_CTL_MC__0 (0x0000)
#define TA2_CTL_MC__1 (0x0010)
#define TA2_CTL_MC__2 (0x0020)
#define TA2_CTL_MC__3 (0x0030)
#define TA2_CTL_MC__M (0x0030)
#define TA2_CTL_TACLR (0x0004)
#define TA2_CTL_TAIE (0x0002)
#define TA2_CTL_TAIE__0 (0x0000)
#define TA2_CTL_TAIE__1 (0x0002)
#define TA2_CTL_TAIFG (0x0001)
#define TA2_CTL_TAIFG__0 (0x0000)
#define TA2_CTL_TAIFG__1 (0x0001)
#define TA2_CTL_TASSEL__0 (0x0000)
#define TA2_CTL_TASSEL__0_TAXCLK (0x0000)
#define TA2_CTL_TASSEL__1 (0x0100)
#define TA2_CTL_TASSEL__1_ACLK (0x0100)
#define TA2_CTL_TASSEL__2 (0x0200)
#define TA2_CTL_TASSEL__2_SMCLK (0x0200)
#define TA2_CTL_TASSEL__3 (0x0300)
#define TA2_CTL_TASSEL__3_INCLK (0x0300)
#define TA2_CTL_TASSEL__M (0x0300)
#define TA2_EX0 (HWREG16(0x40000820))
#define TA2_EX0_TAIDEX__0 (0x0000)
#define TA2_EX0_TAIDEX__0_DIVIDE_BY_1 (0x0000)
#define TA2_EX0_TAIDEX__1 (0x0001)
#define TA2_EX0_TAIDEX__1_DIVIDE_BY_2 (0x0001)
#define TA2_EX0_TAIDEX__2 (0x0002)
#define TA2_EX0_TAIDEX__2_DIVIDE_BY_3 (0x0002)
#define TA2_EX0_TAIDEX__3 (0x0003)
#define TA2_EX0_TAIDEX__3_DIVIDE_BY_4 (0x0003)
#define TA2_EX0_TAIDEX__4 (0x0004)
#define TA2_EX0_TAIDEX__4_DIVIDE_BY_5 (0x0004)
#define TA2_EX0_TAIDEX__5 (0x0005)
#define TA2_EX0_TAIDEX__5_DIVIDE_BY_6 (0x0005)
#define TA2_EX0_TAIDEX__6 (0x0006)
#define TA2_EX0_TAIDEX__6_DIVIDE_BY_7 (0x0006)
#define TA2_EX0_TAIDEX__7 (0x0007)
#define TA2_EX0_TAIDEX__7_DIVIDE_BY_8 (0x0007)
#define TA2_EX0_TAIDEX__M (0x0007)
#define TA2_IV (HWREG16(0x4000082E))
#define TA2_R (HWREG16(0x40000810))
#define TA3_CCR0 (HWREG16(0x40000C12))
#define TA3_CCR1 (HWREG16(0x40000C14))
#define TA3_CCR2 (HWREG16(0x40000C16))
#define TA3_CCR3 (HWREG16(0x40000C18))
#define TA3_CCR4 (HWREG16(0x40000C1A))
#define TA3_CCR5 (HWREG16(0x40000C1C))
#define TA3_CCR6 (HWREG16(0x40000C1E))
#define TA3_CCTL0 (HWREG16(0x40000C02))
#define TA3_CCTL1 (HWREG16(0x40000C04))
#define TA3_CCTL2 (HWREG16(0x40000C06))
#define TA3_CCTL3 (HWREG16(0x40000C08))
#define TA3_CCTL4 (HWREG16(0x40000C0A))
#define TA3_CCTL5 (HWREG16(0x40000C0C))
#define TA3_CCTL6 (HWREG16(0x40000C0E))
#define TA3_CCTL_CAP (0x0100)
#define TA3_CCTL_CAP__0 (0x0000)
#define TA3_CCTL_CAP__0_COMPARE_MODE (0x0000)
#define TA3_CCTL_CAP__1 (0x0100)
#define TA3_CCTL_CAP__1_CAPTURE_MODE (0x0100)
#define TA3_CCTL_CCI (0x0008)
#define TA3_CCTL_CCIE (0x0010)
#define TA3_CCTL_CCIE__0 (0x0000)
#define TA3_CCTL_CCIE__1 (0x0010)
#define TA3_CCTL_CCIFG (0x0001)
#define TA3_CCTL_CCIFG__0 (0x0000)
#define TA3_CCTL_CCIFG__1 (0x0001)
#define TA3_CCTL_CCIS__0 (0x0000)
#define TA3_CCTL_CCIS__0_CCIXA (0x0000)
#define TA3_CCTL_CCIS__1 (0x1000)
#define TA3_CCTL_CCIS__1_CCIXB (0x1000)
#define TA3_CCTL_CCIS__2 (0x2000)
#define TA3_CCTL_CCIS__2_GND (0x2000)
#define TA3_CCTL_CCIS__3 (0x3000)
#define TA3_CCTL_CCIS__3_VCC (0x3000)
#define TA3_CCTL_CCIS__M (0x3000)
#define TA3_CCTL_CM__0 (0x0000)
#define TA3_CCTL_CM__0_NO_CAPTURE (0x0000)
#define TA3_CCTL_CM__1 (0x4000)
#define TA3_CCTL_CM__2 (0x8000)
#define TA3_CCTL_CM__3 (0xc000)
#define TA3_CCTL_CM__M (0xc000)
#define TA3_CCTL_COV (0x0002)
#define TA3_CCTL_COV__0 (0x0000)
#define TA3_CCTL_COV__1 (0x0002)
#define TA3_CCTL_OUT (0x0004)
#define TA3_CCTL_OUTMOD__0 (0x0000)
#define TA3_CCTL_OUTMOD__0_OUT_BIT_VALUE (0x0000)
#define TA3_CCTL_OUTMOD__1 (0x0020)
#define TA3_CCTL_OUTMOD__1_SET (0x0020)
#define TA3_CCTL_OUTMOD__2 (0x0040)
#define TA3_CCTL_OUTMOD__2_TOGGLE_RESET (0x0040)
#define TA3_CCTL_OUTMOD__3 (0x0060)
#define TA3_CCTL_OUTMOD__3_SET_RESET (0x0060)
#define TA3_CCTL_OUTMOD__4 (0x0080)
#define TA3_CCTL_OUTMOD__4_TOGGLE (0x0080)
#define TA3_CCTL_OUTMOD__5 (0x00a0)
#define TA3_CCTL_OUTMOD__5_RESET (0x00a0)
#define TA3_CCTL_OUTMOD__6 (0x00c0)
#define TA3_CCTL_OUTMOD__6_TOGGLE_SET (0x00c0)
#define TA3_CCTL_OUTMOD__7 (0x00e0)
#define TA3_CCTL_OUTMOD__7_RESET_SET (0x00e0)
#define TA3_CCTL_OUTMOD__M (0x00e0)
#define TA3_CCTL_OUT__0 (0x0000)
#define TA3_CCTL_OUT__0_OUTPUT_LOW (0x0000)
#define TA3_CCTL_OUT__1 (0x0004)
#define TA3_CCTL_OUT__1_OUTPUT_HIGH (0x0004)
#define TA3_CCTL_SCCI (0x0400)
#define TA3_CCTL_SCS (0x0800)
#define TA3_CCTL_SCS__0 (0x0000)
#define TA3_CCTL_SCS__1 (0x0800)
#define TA3_CTL (HWREG16(0x40000C00))
#define TA3_CTL_ID__0 (0x0000)
#define TA3_CTL_ID__0__1 (0x0000)
#define TA3_CTL_ID__1 (0x0040)
#define TA3_CTL_ID__1__2 (0x0040)
#define TA3_CTL_ID__2 (0x0080)
#define TA3_CTL_ID__2__4 (0x0080)
#define TA3_CTL_ID__3 (0x00c0)
#define TA3_CTL_ID__3__8 (0x00c0)
#define TA3_CTL_ID__M (0x00c0)
#define TA3_CTL_MC__0 (0x0000)
#define TA3_CTL_MC__1 (0x0010)
#define TA3_CTL_MC__2 (0x0020)
#define TA3_CTL_MC__3 (0x0030)
#define TA3_CTL_MC__M (0x0030)
#define TA3_CTL_TACLR (0x0004)
#define TA3_CTL_TAIE (0x0002)
#define TA3_CTL_TAIE__0 (0x0000)
#define TA3_CTL_TAIE__1 (0x0002)
#define TA3_CTL_TAIFG (0x0001)
#define TA3_CTL_TAIFG__0 (0x0000)
#define TA3_CTL_TAIFG__1 (0x0001)
#define TA3_CTL_TASSEL__0 (0x0000)
#define TA3_CTL_TASSEL__0_TAXCLK (0x0000)
#define TA3_CTL_TASSEL__1 (0x0100)
#define TA3_CTL_TASSEL__1_ACLK (0x0100)
#define TA3_CTL_TASSEL__2 (0x0200)
#define TA3_CTL_TASSEL__2_SMCLK (0x0200)
#define TA3_CTL_TASSEL__3 (0x0300)
#define TA3_CTL_TASSEL__3_INCLK (0x0300)
#define TA3_CTL_TASSEL__M (0x0300)
#define TA3_EX0 (HWREG16(0x40000C20))
#define TA3_EX0_TAIDEX__0 (0x0000)
#define TA3_EX0_TAIDEX__0_DIVIDE_BY_1 (0x0000)
#define TA3_EX0_TAIDEX__1 (0x0001)
#define TA3_EX0_TAIDEX__1_DIVIDE_BY_2 (0x0001)
#define TA3_EX0_TAIDEX__2 (0x0002)
#define TA3_EX0_TAIDEX__2_DIVIDE_BY_3 (0x0002)
#define TA3_EX0_TAIDEX__3 (0x0003)
#define TA3_EX0_TAIDEX__3_DIVIDE_BY_4 (0x0003)
#define TA3_EX0_TAIDEX__4 (0x0004)
#define TA3_EX0_TAIDEX__4_DIVIDE_BY_5 (0x0004)
#define TA3_EX0_TAIDEX__5 (0x0005)
#define TA3_EX0_TAIDEX__5_DIVIDE_BY_6 (0x0005)
#define TA3_EX0_TAIDEX__6 (0x0006)
#define TA3_EX0_TAIDEX__6_DIVIDE_BY_7 (0x0006)
#define TA3_EX0_TAIDEX__7 (0x0007)
#define TA3_EX0_TAIDEX__7_DIVIDE_BY_8 (0x0007)
#define TA3_EX0_TAIDEX__M (0x0007)
#define TA3_IV (HWREG16(0x40000C2E))
#define TA3_R (HWREG16(0x40000C10))
#define TAIDEX0 (0x0001)
#define TAIDEX1 (0x0002)
#define TAIDEX2 (0x0004)
#define TASSEL0 (0x0100)
#define TASSEL1 (0x0200)
#define TCEN (0x0001)
#define UC7BIT_H (0x0010)
#define UCA0BRW_H (HWREG8_H(UCA0BRW))
#define UCA0BRW_L (HWREG8_L(UCA0BRW))
//#define UCA0CTLW0_H (HWREG8_H(UCA0CTLW0))
//#define UCA0CTLW0_L (HWREG8_L(UCA0CTLW0))
#define UCA0CTLW1_H (HWREG8_H(UCA0CTLW1))
#define UCA0CTLW1_L (HWREG8_L(UCA0CTLW1))
#define UCA0IE_H (HWREG8_H(UCA0IE))
#define UCA0IE_L (HWREG8_L(UCA0IE))
#define UCA0IFG_H (HWREG8_H(UCA0IFG))
#define UCA0IFG_L (HWREG8_L(UCA0IFG))
#define UCA0IRCTL_H (HWREG8_H(UCA0IRCTL))
#define UCA0IRCTL_L (HWREG8_L(UCA0IRCTL))
#define UCA0MCTLW_H (HWREG8_H(UCA0MCTLW))
#define UCA0MCTLW_L (HWREG8_L(UCA0MCTLW))
#define UCA0RXBUF_H (HWREG8_H(UCA0RXBUF))
#define UCA0RXBUF_L (HWREG8_L(UCA0RXBUF))
#define UCA0TXBUF_H (HWREG8_H(UCA0TXBUF))
#define UCA0TXBUF_L (HWREG8_L(UCA0TXBUF))
#define UCA10_H (0x0080)
#define UCA1BRW_H (HWREG8_H(UCA1BRW))
#define UCA1BRW_L (HWREG8_L(UCA1BRW))
//#define UCA1CTLW0_H (HWREG8_H(UCA1CTLW0))
//#define UCA1CTLW0_L (HWREG8_L(UCA1CTLW0))
#define UCA1CTLW1_H (HWREG8_H(UCA1CTLW1))
#define UCA1CTLW1_L (HWREG8_L(UCA1CTLW1))
#define UCA1IE_H (HWREG8_H(UCA1IE))
#define UCA1IE_L (HWREG8_L(UCA1IE))
#define UCA1IFG_H (HWREG8_H(UCA1IFG))
#define UCA1IFG_L (HWREG8_L(UCA1IFG))
#define UCA1IRCTL_H (HWREG8_H(UCA1IRCTL))
#define UCA1IRCTL_L (HWREG8_L(UCA1IRCTL))
#define UCA1MCTLW_H (HWREG8_H(UCA1MCTLW))
#define UCA1MCTLW_L (HWREG8_L(UCA1MCTLW))
#define UCA1RXBUF_H (HWREG8_H(UCA1RXBUF))
#define UCA1RXBUF_L (HWREG8_L(UCA1RXBUF))
#define UCA1TXBUF_H (HWREG8_H(UCA1TXBUF))
#define UCA1TXBUF_L (HWREG8_L(UCA1TXBUF))
#define UCA2BRW_H (HWREG8_H(UCA2BRW))
#define UCA2BRW_L (HWREG8_L(UCA2BRW))
//#define UCA2CTLW0_H (HWREG8_H(UCA2CTLW0))
//#define UCA2CTLW0_L (HWREG8_L(UCA2CTLW0))
#define UCA2CTLW1_H (HWREG8_H(UCA2CTLW1))
#define UCA2CTLW1_L (HWREG8_L(UCA2CTLW1))
#define UCA2IE_H (HWREG8_H(UCA2IE))
#define UCA2IE_L (HWREG8_L(UCA2IE))
#define UCA2IFG_H (HWREG8_H(UCA2IFG))
#define UCA2IFG_L (HWREG8_L(UCA2IFG))
#define UCA2IRCTL_H (HWREG8_H(UCA2IRCTL))
#define UCA2IRCTL_L (HWREG8_L(UCA2IRCTL))
#define UCA2MCTLW_H (HWREG8_H(UCA2MCTLW))
#define UCA2MCTLW_L (HWREG8_L(UCA2MCTLW))
#define UCA2RXBUF_H (HWREG8_H(UCA2RXBUF))
#define UCA2RXBUF_L (HWREG8_L(UCA2RXBUF))
#define UCA2TXBUF_H (HWREG8_H(UCA2TXBUF))
#define UCA2TXBUF_L (HWREG8_L(UCA2TXBUF))
#define UCA3BRW_H (HWREG8_H(UCA3BRW))
#define UCA3BRW_L (HWREG8_L(UCA3BRW))
//#define UCA3CTLW0_H (HWREG8_H(UCA3CTLW0))
//#define UCA3CTLW0_L (HWREG8_L(UCA3CTLW0))
#define UCA3CTLW1_H (HWREG8_H(UCA3CTLW1))
#define UCA3CTLW1_L (HWREG8_L(UCA3CTLW1))
#define UCA3IE_H (HWREG8_H(UCA3IE))
#define UCA3IE_L (HWREG8_L(UCA3IE))
#define UCA3IFG_H (HWREG8_H(UCA3IFG))
#define UCA3IFG_L (HWREG8_L(UCA3IFG))
#define UCA3IRCTL_H (HWREG8_H(UCA3IRCTL))
#define UCA3IRCTL_L (HWREG8_L(UCA3IRCTL))
#define UCA3MCTLW_H (HWREG8_H(UCA3MCTLW))
#define UCA3MCTLW_L (HWREG8_L(UCA3MCTLW))
#define UCA3RXBUF_H (HWREG8_H(UCA3RXBUF))
#define UCA3RXBUF_L (HWREG8_L(UCA3RXBUF))
#define UCA3TXBUF_H (HWREG8_H(UCA3TXBUF))
#define UCA3TXBUF_L (HWREG8_L(UCA3TXBUF))
#define UCADDMASK0 (0x0001)
#define UCADDMASK0_L (0x0001)
#define UCADDMASK1 (0x0002)
#define UCADDMASK1_L (0x0002)
#define UCADDMASK2 (0x0004)
#define UCADDMASK2_L (0x0004)
#define UCADDMASK3 (0x0008)
#define UCADDMASK3_L (0x0008)
#define UCADDMASK4 (0x0010)
#define UCADDMASK4_L (0x0010)
#define UCADDMASK5 (0x0020)
#define UCADDMASK5_L (0x0020)
#define UCADDMASK6 (0x0040)
#define UCADDMASK6_L (0x0040)
#define UCADDMASK7 (0x0080)
#define UCADDMASK7_L (0x0080)
#define UCADDMASK8 (0x0100)
#define UCADDMASK8_H (0x0001)
#define UCADDMASK9 (0x0200)
#define UCADDMASK9_H (0x0002)
#define UCADDR (0x0002)
#define UCADDRX0 (0x0001)
#define UCADDRX0_L (0x0001)
#define UCADDRX1 (0x0002)
#define UCADDRX1_L (0x0002)
#define UCADDRX2 (0x0004)
#define UCADDRX2_L (0x0004)
#define UCADDRX3 (0x0008)
#define UCADDRX3_L (0x0008)
#define UCADDRX4 (0x0010)
#define UCADDRX4_L (0x0010)
#define UCADDRX5 (0x0020)
#define UCADDRX5_L (0x0020)
#define UCADDRX6 (0x0040)
#define UCADDRX6_L (0x0040)
#define UCADDRX7 (0x0080)
#define UCADDRX7_L (0x0080)
#define UCADDRX8 (0x0100)
#define UCADDRX8_H (0x0001)
#define UCADDRX9 (0x0200)
#define UCADDRX9_H (0x0002)
#define UCASTP0 (0x0004)
#define UCASTP0_L (0x0004)
#define UCASTP1 (0x0008)
#define UCASTP1_L (0x0008)
#define UCASTP_3 (0x000C)
#define UCB0ADDMASK_H (HWREG8_H(UCB0ADDMASK))
#define UCB0ADDMASK_L (HWREG8_L(UCB0ADDMASK))
#define UCB0ADDRX_H (HWREG8_H(UCB0ADDRX))
#define UCB0ADDRX_L (HWREG8_L(UCB0ADDRX))
#define UCB0BRW_H (HWREG8_H(UCB0BRW))
#define UCB0BRW_L (HWREG8_L(UCB0BRW))
//#define UCB0CTLW0_H (HWREG8_H(UCB0CTLW0))
//#define UCB0CTLW0_L (HWREG8_L(UCB0CTLW0))
#define UCB0I2COA0_H (HWREG8_H(UCB0I2COA0))
#define UCB0I2COA0_L (HWREG8_L(UCB0I2COA0))
#define UCB0I2COA1_H (HWREG8_H(UCB0I2COA1))
#define UCB0I2COA1_L (HWREG8_L(UCB0I2COA1))
#define UCB0I2COA2_H (HWREG8_H(UCB0I2COA2))
#define UCB0I2COA2_L (HWREG8_L(UCB0I2COA2))
#define UCB0I2COA3_H (HWREG8_H(UCB0I2COA3))
#define UCB0I2COA3_L (HWREG8_L(UCB0I2COA3))
#define UCB0I2CSA_H (HWREG8_H(UCB0I2CSA))
#define UCB0I2CSA_L (HWREG8_L(UCB0I2CSA))
#define UCB0IE_H (HWREG8_H(UCB0IE))
#define UCB0IE_L (HWREG8_L(UCB0IE))
#define UCB0IFG_H (HWREG8_H(UCB0IFG))
#define UCB0IFG_L (HWREG8_L(UCB0IFG))
#define UCB0RXBUF_H (HWREG8_H(UCB0RXBUF))
#define UCB0RXBUF_L (HWREG8_L(UCB0RXBUF))
#define UCB0STATW_H (HWREG8_H(UCB0STATW))
#define UCB0STATW_L (HWREG8_L(UCB0STATW))
#define UCB0TXBUF_H (HWREG8_H(UCB0TXBUF))
#define UCB0TXBUF_L (HWREG8_L(UCB0TXBUF))
#define UCB1ADDMASK_H (HWREG8_H(UCB1ADDMASK))
#define UCB1ADDMASK_L (HWREG8_L(UCB1ADDMASK))
#define UCB1ADDRX_H (HWREG8_H(UCB1ADDRX))
#define UCB1ADDRX_L (HWREG8_L(UCB1ADDRX))
#define UCB1BRW_H (HWREG8_H(UCB1BRW))
#define UCB1BRW_L (HWREG8_L(UCB1BRW))
//#define UCB1CTLW0_H (HWREG8_H(UCB1CTLW0))
//#define UCB1CTLW0_L (HWREG8_L(UCB1CTLW0))
#define UCB1I2COA0_H (HWREG8_H(UCB1I2COA0))
#define UCB1I2COA0_L (HWREG8_L(UCB1I2COA0))
#define UCB1I2COA1_H (HWREG8_H(UCB1I2COA1))
#define UCB1I2COA1_L (HWREG8_L(UCB1I2COA1))
#define UCB1I2COA2_H (HWREG8_H(UCB1I2COA2))
#define UCB1I2COA2_L (HWREG8_L(UCB1I2COA2))
#define UCB1I2COA3_H (HWREG8_H(UCB1I2COA3))
#define UCB1I2COA3_L (HWREG8_L(UCB1I2COA3))
#define UCB1I2CSA_H (HWREG8_H(UCB1I2CSA))
#define UCB1I2CSA_L (HWREG8_L(UCB1I2CSA))
#define UCB1IE_H (HWREG8_H(UCB1IE))
#define UCB1IE_L (HWREG8_L(UCB1IE))
#define UCB1IFG_H (HWREG8_H(UCB1IFG))
#define UCB1IFG_L (HWREG8_L(UCB1IFG))
#define UCB1RXBUF_H (HWREG8_H(UCB1RXBUF))
#define UCB1RXBUF_L (HWREG8_L(UCB1RXBUF))
#define UCB1STATW_H (HWREG8_H(UCB1STATW))
#define UCB1STATW_L (HWREG8_L(UCB1STATW))
#define UCB1TXBUF_H (HWREG8_H(UCB1TXBUF))
#define UCB1TXBUF_L (HWREG8_L(UCB1TXBUF))
#define UCB2ADDMASK_H (HWREG8_H(UCB2ADDMASK))
#define UCB2ADDMASK_L (HWREG8_L(UCB2ADDMASK))
#define UCB2ADDRX_H (HWREG8_H(UCB2ADDRX))
#define UCB2ADDRX_L (HWREG8_L(UCB2ADDRX))
#define UCB2BRW_H (HWREG8_H(UCB2BRW))
#define UCB2BRW_L (HWREG8_L(UCB2BRW))
//#define UCB2CTLW0_H (HWREG8_H(UCB2CTLW0))
//#define UCB2CTLW0_L (HWREG8_L(UCB2CTLW0))
#define UCB2I2COA0_H (HWREG8_H(UCB2I2COA0))
#define UCB2I2COA0_L (HWREG8_L(UCB2I2COA0))
#define UCB2I2COA1_H (HWREG8_H(UCB2I2COA1))
#define UCB2I2COA1_L (HWREG8_L(UCB2I2COA1))
#define UCB2I2COA2_H (HWREG8_H(UCB2I2COA2))
#define UCB2I2COA2_L (HWREG8_L(UCB2I2COA2))
#define UCB2I2COA3_H (HWREG8_H(UCB2I2COA3))
#define UCB2I2COA3_L (HWREG8_L(UCB2I2COA3))
#define UCB2I2CSA_H (HWREG8_H(UCB2I2CSA))
#define UCB2I2CSA_L (HWREG8_L(UCB2I2CSA))
#define UCB2IE_H (HWREG8_H(UCB2IE))
#define UCB2IE_L (HWREG8_L(UCB2IE))
#define UCB2IFG_H (HWREG8_H(UCB2IFG))
#define UCB2IFG_L (HWREG8_L(UCB2IFG))
#define UCB2RXBUF_H (HWREG8_H(UCB2RXBUF))
#define UCB2RXBUF_L (HWREG8_L(UCB2RXBUF))
#define UCB2STATW_H (HWREG8_H(UCB2STATW))
#define UCB2STATW_L (HWREG8_L(UCB2STATW))
#define UCB2TXBUF_H (HWREG8_H(UCB2TXBUF))
#define UCB2TXBUF_L (HWREG8_L(UCB2TXBUF))
#define UCB3ADDMASK_H (HWREG8_H(UCB3ADDMASK))
#define UCB3ADDMASK_L (HWREG8_L(UCB3ADDMASK))
#define UCB3ADDRX_H (HWREG8_H(UCB3ADDRX))
#define UCB3ADDRX_L (HWREG8_L(UCB3ADDRX))
#define UCB3BRW_H (HWREG8_H(UCB3BRW))
#define UCB3BRW_L (HWREG8_L(UCB3BRW))
//#define UCB3CTLW0_H (HWREG8_H(UCB3CTLW0))
//#define UCB3CTLW0_L (HWREG8_L(UCB3CTLW0))
#define UCB3I2COA0_H (HWREG8_H(UCB3I2COA0))
#define UCB3I2COA0_L (HWREG8_L(UCB3I2COA0))
#define UCB3I2COA1_H (HWREG8_H(UCB3I2COA1))
#define UCB3I2COA1_L (HWREG8_L(UCB3I2COA1))
#define UCB3I2COA2_H (HWREG8_H(UCB3I2COA2))
#define UCB3I2COA2_L (HWREG8_L(UCB3I2COA2))
#define UCB3I2COA3_H (HWREG8_H(UCB3I2COA3))
#define UCB3I2COA3_L (HWREG8_L(UCB3I2COA3))
#define UCB3I2CSA_H (HWREG8_H(UCB3I2CSA))
#define UCB3I2CSA_L (HWREG8_L(UCB3I2CSA))
#define UCB3IE_H (HWREG8_H(UCB3IE))
#define UCB3IE_L (HWREG8_L(UCB3IE))
#define UCB3IFG_H (HWREG8_H(UCB3IFG))
#define UCB3IFG_L (HWREG8_L(UCB3IFG))
#define UCB3RXBUF_H (HWREG8_H(UCB3RXBUF))
#define UCB3RXBUF_L (HWREG8_L(UCB3RXBUF))
#define UCB3STATW_H (HWREG8_H(UCB3STATW))
#define UCB3STATW_L (HWREG8_L(UCB3STATW))
#define UCB3TXBUF_H (HWREG8_H(UCB3TXBUF))
#define UCB3TXBUF_L (HWREG8_L(UCB3TXBUF))
#define UCBCNT0 (0x0100)
#define UCBCNT1 (0x0200)
#define UCBCNT2 (0x0400)
#define UCBCNT3 (0x0800)
#define UCBCNT4 (0x1000)
#define UCBCNT5 (0x2000)
#define UCBCNT6 (0x4000)
#define UCBCNT7 (0x8000)
#define UCBRF0 (0x0010)
#define UCBRF0_L (0x0010)
#define UCBRF1 (0x0020)
#define UCBRF1_L (0x0020)
#define UCBRF2 (0x0040)
#define UCBRF2_L (0x0040)
#define UCBRF3 (0x0080)
#define UCBRF3_L (0x0080)
#define UCBRF_0 (0x00)
#define UCBRF_1 (0x10)
#define UCBRF_10 (0xA0)
#define UCBRF_11 (0xB0)
#define UCBRF_12 (0xC0)
#define UCBRF_13 (0xD0)
#define UCBRF_14 (0xE0)
#define UCBRF_15 (0xF0)
#define UCBRF_2 (0x20)
#define UCBRF_3 (0x30)
#define UCBRF_4 (0x40)
#define UCBRF_5 (0x50)
#define UCBRF_6 (0x60)
#define UCBRF_7 (0x70)
#define UCBRF_8 (0x80)
#define UCBRF_9 (0x90)
#define UCBRKIE_L (0x0010)
#define UCBRS0 (0x0100)
#define UCBRS0_H (0x0001)
#define UCBRS1 (0x0200)
#define UCBRS1_H (0x0002)
#define UCBRS2 (0x0400)
#define UCBRS2_H (0x0004)
#define UCBRS3 (0x0800)
#define UCBRS3_H (0x0008)
#define UCBRS4 (0x1000)
#define UCBRS4_H (0x0010)
#define UCBRS5 (0x2000)
#define UCBRS5_H (0x0020)
#define UCBRS6 (0x4000)
#define UCBRS6_H (0x0040)
#define UCBRS7 (0x8000)
#define UCBRS7_H (0x0080)
#define UCCLTO0 (0x0040)
#define UCCLTO0_L (0x0040)
#define UCCLTO1 (0x0080)
#define UCCLTO1_L (0x0080)
#define UCDELIM0 (0x10)
#define UCDELIM1 (0x20)
#define UCDORM_L (0x0008)
#define UCETXINT_H (0x0001)
#define UCGCEN_H (0x0080)
#define UCGLIT0 (0x0001)
#define UCGLIT0_L (0x0001)
#define UCGLIT1 (0x0002)
#define UCGLIT1_L (0x0002)
#define UCIDLE (0x0002)
#define UCIREN_L (0x0001)
#define UCIRRXFE_H (0x0001)
#define UCIRRXFL0 (0x0400)
#define UCIRRXFL0_H (0x0004)
#define UCIRRXFL1 (0x0800)
#define UCIRRXFL1_H (0x0008)
#define UCIRRXFL2 (0x1000)
#define UCIRRXFL2_H (0x0010)
#define UCIRRXFL3 (0x2000)
#define UCIRRXFL3_H (0x0020)
#define UCIRRXFL4 (0x4000)
#define UCIRRXFL4_H (0x0040)
#define UCIRRXFL5 (0x8000)
#define UCIRRXFL5_H (0x0080)
#define UCIRRXPL_H (0x0002)
#define UCIRTXCLK_L (0x0002)
#define UCIRTXPL0 (0x0004)
#define UCIRTXPL0_L (0x0004)
#define UCIRTXPL1 (0x0008)
#define UCIRTXPL1_L (0x0008)
#define UCIRTXPL2 (0x0010)
#define UCIRTXPL2_L (0x0010)
#define UCIRTXPL3 (0x0020)
#define UCIRTXPL3_L (0x0020)
#define UCIRTXPL4 (0x0040)
#define UCIRTXPL4_L (0x0040)
#define UCIRTXPL5 (0x0080)
#define UCIRTXPL5_L (0x0080)
#define UCMM_H (0x0020)
#define UCMODE0 (0x0200)
#define UCMODE0_H (0x0002)
#define UCMODE1 (0x0400)
#define UCMODE1_H (0x0004)
#define UCMSB_H (0x0020)
#define UCOA0 (0x0001)
#define UCOA0_L (0x0001)
#define UCOA1 (0x0002)
#define UCOA1_L (0x0002)
#define UCOA2 (0x0004)
#define UCOA2_L (0x0004)
#define UCOA3 (0x0008)
#define UCOA3_L (0x0008)
#define UCOA4 (0x0010)
#define UCOA4_L (0x0010)
#define UCOA5 (0x0020)
#define UCOA5_L (0x0020)
#define UCOA6 (0x0040)
#define UCOA6_L (0x0040)
#define UCOA7 (0x0080)
#define UCOA7_L (0x0080)
#define UCOA8 (0x0100)
#define UCOA8_H (0x0001)
#define UCOA9 (0x0200)
#define UCOA9_H (0x0002)
#define UCOAEN_H (0x0004)
#define UCOS16_L (0x0001)
#define UCPAR_H (0x0040)
#define UCPEN_H (0x0080)
#define UCRXEIE_L (0x0020)
#define UCSA0 (0x0001)
#define UCSA0_L (0x0001)
#define UCSA1 (0x0002)
#define UCSA1_L (0x0002)
#define UCSA2 (0x0004)
#define UCSA2_L (0x0004)
#define UCSA3 (0x0008)
#define UCSA3_L (0x0008)
#define UCSA4 (0x0010)
#define UCSA4_L (0x0010)
#define UCSA5 (0x0020)
#define UCSA5_L (0x0020)
#define UCSA6 (0x0040)
#define UCSA6_L (0x0040)
#define UCSA7 (0x0080)
#define UCSA7_L (0x0080)
#define UCSA8 (0x0100)
#define UCSA8_H (0x0001)
#define UCSA9 (0x0200)
#define UCSA9_H (0x0002)
#define UCSLA10_H (0x0040)
#define UCSPB_H (0x0008)
#define UCSSEL0 (0x0040)
#define UCSSEL0_L (0x0040)
#define UCSSEL1 (0x0080)
#define UCSSEL1_L (0x0080)
#define UCSTPNACK_L (0x0020)
#define UCSWACK_L (0x0010)
#define UCSWRST_L (0x0001)
#define UCSYNC_H (0x0001)
#define UCTBCNT0 (0x0001)
#define UCTBCNT1 (0x0002)
#define UCTBCNT2 (0x0004)
#define UCTBCNT3 (0x0008)
#define UCTBCNT4 (0x0010)
#define UCTBCNT5 (0x0020)
#define UCTBCNT6 (0x0040)
#define UCTBCNT7 (0x0080)
#define UCTR_L (0x0010)
#define UCTXACK_L (0x0020)
#define UCTXADDR_L (0x0004)
#define UCTXBRK_L (0x0002)
#define UCTXNACK_L (0x0008)
#define UCTXSTP_L (0x0004)
#define UCTXSTT_L (0x0002)
#define UDMA_ALTBASE (HWREG32(0x4000F00C))
#define UDMA_ALTCLR (HWREG32(0x4000F034))
#define UDMA_ALTSET (HWREG32(0x4000F030))
#define UDMA_CFG (HWREG32(0x4000F004))
#define UDMA_CTLBASE (HWREG32(0x4000F008))
#define UDMA_ENACLR (HWREG32(0x4000F02C))
#define UDMA_ENASET (HWREG32(0x4000F028))
#define UDMA_ERRCLR (HWREG32(0x4000F04C))
#define UDMA_PCELL_ID_0 (HWREG32(0x4000FFF0))
#define UDMA_PCELL_ID_1 (HWREG32(0x4000FFF4))
#define UDMA_PCELL_ID_2 (HWREG32(0x4000FFF8))
#define UDMA_PCELL_ID_3 (HWREG32(0x4000FFFC))
#define UDMA_PERIPH_ID_0 (HWREG32(0x4000FFE0))
#define UDMA_PERIPH_ID_1 (HWREG32(0x4000FFE4))
#define UDMA_PERIPH_ID_2 (HWREG32(0x4000FFE8))
#define UDMA_PERIPH_ID_3 (HWREG32(0x4000FFEC))
#define UDMA_PERIPH_ID_4 (HWREG32(0x4000FFD0))
#define UDMA_PRIOCLR (HWREG32(0x4000F03C))
#define UDMA_PRIOSET (HWREG32(0x4000F038))
#define UDMA_REQMASKCLR (HWREG32(0x4000F024))
#define UDMA_REQMASKSET (HWREG32(0x4000F020))
#define UDMA_STAT (HWREG32(0x4000F000))
#define UDMA_SWREQ (HWREG32(0x4000F014))
#define UDMA_USEBURSTCLR (HWREG32(0x4000F01C))
#define UDMA_USEBURSTSET (HWREG32(0x4000F018))
#define UDMA_WAITSTAT (HWREG32(0x4000F010))
#define USCI_I2C_UCALIFG (0x0002)
#define USCI_I2C_UCBCNTIFG (0x001A)
#define USCI_I2C_UCBIT9IFG (0x001E)
#define USCI_I2C_UCCLTOIFG (0x001C)
#define USCI_I2C_UCNACKIFG (0x0004)
#define USCI_I2C_UCRXIFG0 (0x0016)
#define USCI_I2C_UCRXIFG1 (0x0012)
#define USCI_I2C_UCRXIFG2 (0x000E)
#define USCI_I2C_UCRXIFG3 (0x000A)
#define USCI_I2C_UCSTPIFG (0x0008)
#define USCI_I2C_UCSTTIFG (0x0006)
#define USCI_I2C_UCTXIFG0 (0x0018)
#define USCI_I2C_UCTXIFG1 (0x0014)
#define USCI_I2C_UCTXIFG2 (0x0010)
#define USCI_I2C_UCTXIFG3 (0x000C)
#define USCI_NONE (0x0000)
#define USCI_SPI_UCRXIFG (0x0002)
#define USCI_SPI_UCTXIFG (0x0004)
#define USCI_UART_UCRXIFG (0x0002)
#define USCI_UART_UCSTTIFG (0x0006)
#define USCI_UART_UCTXCPTIFG (0x0008)
#define USCI_UART_UCTXIFG (0x0004)
#define WDTCNTCL_L (0x0008)
#define WDTCTL_H (HWREG8_H(WDTCTL))
#define WDTCTL_L (HWREG8_L(WDTCTL))
#define WDTHOLD_L (0x0080)
#define WDTIS0 (0x0001)
#define WDTIS0_L (0x0001)
#define WDTIS1 (0x0002)
#define WDTIS1_L (0x0002)
#define WDTIS2 (0x0004)
#define WDTIS2_L (0x0004)
#define WDTIS__128M (1*0x0001u)
#define WDTIS__2G (0*0x0001u)
#define WDTIS__32K (4*0x0001u)
#define WDTIS__512 (6*0x0001u)
#define WDTIS__512K (3*0x0001u)
#define WDTIS__64 (7*0x0001u)
#define WDTIS__8192 (5*0x0001u)
#define WDTIS__8192K (2*0x0001u)
#define WDTPW_VAL (0x5A00)
#define WDTSSEL0 (0x0020)
#define WDTSSEL0_L (0x0020)
#define WDTSSEL1 (0x0040)
#define WDTSSEL1_L (0x0040)
#define WDTSSEL__VLO (2*0x0020u)
#define WDTTMSEL_L (0x0010)
#define WDT_ADLY_1000 (WDTPW+WDTTMSEL+WDTCNTCL+WDTIS2+WDTSSEL0)
#define WDT_ADLY_16 (WDTPW+WDTTMSEL+WDTCNTCL+WDTIS2+WDTSSEL0+WDTIS1)
#define WDT_ADLY_1_9 (WDTPW+WDTTMSEL+WDTCNTCL+WDTIS2+WDTSSEL0+WDTIS1+WDTIS0)
#define WDT_ADLY_250 (WDTPW+WDTTMSEL+WDTCNTCL+WDTIS2+WDTSSEL0+WDTIS0)
#define WDT_ARST_1000 (WDTPW+WDTCNTCL+WDTSSEL0+WDTIS2)
#define WDT_ARST_16 (WDTPW+WDTCNTCL+WDTSSEL0+WDTIS2+WDTIS1)
#define WDT_ARST_1_9 (WDTPW+WDTCNTCL+WDTSSEL0+WDTIS2+WDTIS1+WDTIS0)
#define WDT_ARST_250 (WDTPW+WDTCNTCL+WDTSSEL0+WDTIS2+WDTIS0)
#define WDT_A_CTL (HWREG16(0x4000480C))
#define WDT_A_CTL_CNTCL (0x0008)
#define WDT_A_CTL_CNTCL__0 (0x0000)
#define WDT_A_CTL_CNTCL__0_NO_ACTION (0x0000)
#define WDT_A_CTL_CNTCL__1 (0x0008)
#define WDT_A_CTL_CNTCL__1_CLEAR (0x0008)
#define WDT_A_CTL_HOLD (0x0080)
#define WDT_A_CTL_HOLD__0 (0x0000)
#define WDT_A_CTL_HOLD__1 (0x0080)
#define WDT_A_CTL_IS__0 (0x0000)
#define WDT_A_CTL_IS__1 (0x0001)
#define WDT_A_CTL_IS__2 (0x0002)
#define WDT_A_CTL_IS__3 (0x0003)
#define WDT_A_CTL_IS__4 (0x0004)
#define WDT_A_CTL_IS__5 (0x0005)
#define WDT_A_CTL_IS__6 (0x0006)
#define WDT_A_CTL_IS__7 (0x0007)
#define WDT_A_CTL_IS__M (0x0007)
#define WDT_A_CTL_PW__M (0xff00)
#define WDT_A_CTL_SSEL__0 (0x0000)
#define WDT_A_CTL_SSEL__0_SMCLK (0x0000)
#define WDT_A_CTL_SSEL__1 (0x0020)
#define WDT_A_CTL_SSEL__1_ACLK (0x0020)
#define WDT_A_CTL_SSEL__2 (0x0040)
#define WDT_A_CTL_SSEL__2_VLOCLK (0x0040)
#define WDT_A_CTL_SSEL__3 (0x0060)
#define WDT_A_CTL_SSEL__3_BCLK (0x0060)
#define WDT_A_CTL_SSEL__M (0x0060)
#define WDT_A_CTL_TMSEL (0x0010)
#define WDT_A_CTL_TMSEL__0 (0x0000)
#define WDT_A_CTL_TMSEL__0_WATCHDOG_MODE (0x0000)
#define WDT_A_CTL_TMSEL__1 (0x0010)
#define WDT_MDLY_0_064 (WDTPW+WDTTMSEL+WDTCNTCL+WDTIS2+WDTIS1+WDTIS0)
#define WDT_MDLY_0_5 (WDTPW+WDTTMSEL+WDTCNTCL+WDTIS2+WDTIS1)
#define WDT_MDLY_32 (WDTPW+WDTTMSEL+WDTCNTCL+WDTIS2)
#define WDT_MDLY_8 (WDTPW+WDTTMSEL+WDTCNTCL+WDTIS2+WDTIS0)
#define WDT_MRST_0_064 (WDTPW+WDTCNTCL+WDTIS2+WDTIS1+WDTIS0)
#define WDT_MRST_0_5 (WDTPW+WDTCNTCL+WDTIS2+WDTIS1)
#define WDT_MRST_32 (WDTPW+WDTCNTCL+WDTIS2)
#define WDT_MRST_8 (WDTPW+WDTCNTCL+WDTIS2+WDTIS0)
#define WDT_PW_VAL (0x5A00)
#define __ADC14_BASE__ (0x40012000)
#define __AES256_BASE__ (0x40003C00)
#define __CAPTIO0_BASE__ (0x40005400)
#define __CAPTIO1_BASE__ (0x40005800)
#define __COMP_E0_BASE__ (0x40003400)
#define __COMP_E1_BASE__ (0x40003800)
#define __CRC32_BASE__ (0x40004000)
#define __CRC_BASE__ (__CRC32_BASE__)
#define __CS_BASE__ (0x40010400)
#define __DDDS_BASE__ (0x00203000)
#define __DMA_BASE__ (0x4000E000)
#define __DWT_BASE__ (0xE0001000)
#define __EUSCI_A0_BASE__ (__EUSCI_A0_SPI_BASE__)
#define __EUSCI_A0_SPI_BASE__ (0x40001000)
#define __EUSCI_A0_UART_BASE__ (0x40001000)
#define __EUSCI_A1_BASE__ (__EUSCI_A1_SPI_BASE__)
#define __EUSCI_A1_SPI_BASE__ (0x40001400)
#define __EUSCI_A1_UART_BASE__ (0x40001400)
#define __EUSCI_A2_BASE__ (__EUSCI_A2_SPI_BASE__)
#define __EUSCI_A2_SPI_BASE__ (0x40001800)
#define __EUSCI_A2_UART_BASE__ (0x40001800)
#define __EUSCI_A3_BASE__ (__EUSCI_A3_SPI_BASE__)
#define __EUSCI_A3_SPI_BASE__ (0x40001C00)
#define __EUSCI_A3_UART_BASE__ (0x40001C00)
#define __EUSCI_B0_BASE__ (__EUSCI_B0_SPI_BASE__)
#define __EUSCI_B0_I2C_BASE__ (0x40002000)
#define __EUSCI_B0_SPI_BASE__ (0x40002000)
#define __EUSCI_B1_BASE__ (__EUSCI_B1_SPI_BASE__)
#define __EUSCI_B1_I2C_BASE__ (0x40002400)
#define __EUSCI_B1_SPI_BASE__ (0x40002400)
#define __EUSCI_B2_BASE__ (__EUSCI_B2_SPI_BASE__)
#define __EUSCI_B2_I2C_BASE__ (0x40002800)
#define __EUSCI_B2_SPI_BASE__ (0x40002800)
#define __EUSCI_B3_BASE__ (__EUSCI_B3_SPI_BASE__)
#define __EUSCI_B3_I2C_BASE__ (0x40002C00)
#define __EUSCI_B3_SPI_BASE__ (0x40002C00)
#define __FLASH_END__ (0x0003FFFF)
#define __FLASH_START__ (0x00000000)
#define __FLCTL_BASE__ (0x40011000)
#define __FPB_BASE__ (0xE0002000)
#define __FPU_BASE__ (0xE000E000)
#define __INFO_FLASH_END__ (0x00203FFF)
#define __INFO_FLASH_START__ (0x00200000)
#define __ITM_BASE__ (0xE0000000)
#define __MPU_BASE__ (0xE000E000)
#define __MSP430_BASEADDRESS_CRC__ (__CRC32_BASE__)
#define __MSP430_BASEADDRESS_PORT10_R__ (__P10_BASE__)
#define __MSP430_BASEADDRESS_PORT1_R__ (__P1_BASE__)
#define __MSP430_BASEADDRESS_PORT2_R__ (__P2_BASE__)
#define __MSP430_BASEADDRESS_PORT3_R__ (__P3_BASE__)
#define __MSP430_BASEADDRESS_PORT4_R__ (__P4_BASE__)
#define __MSP430_BASEADDRESS_PORT5_R__ (__P5_BASE__)
#define __MSP430_BASEADDRESS_PORT6_R__ (__P6_BASE__)
#define __MSP430_BASEADDRESS_PORT7_R__ (__P7_BASE__)
#define __MSP430_BASEADDRESS_PORT8_R__ (__P8_BASE__)
#define __MSP430_BASEADDRESS_PORT9_R__ (__P9_BASE__)
#define __MSP430_BASEADDRESS_PORTA_R__ (__PA_BASE__)
#define __MSP430_BASEADDRESS_PORTB_R__ (__PB_BASE__)
#define __MSP430_BASEADDRESS_PORTC_R__ (__PC_BASE__)
#define __MSP430_BASEADDRESS_PORTD_R__ (__PD_BASE__)
#define __MSP430_BASEADDRESS_PORTE_R__ (__PE_BASE__)
#define __MSP430_BASEADDRESS_PORTJ_R__ (__PJ_BASE__)
#define __MSP430_BASEADDRESS_REF__ (__REF_A_BASE__)
#define __MSP430_BASEADDRESS_RTC_CE__ (__RTC_C_BASE__)
#define __MSP430_BASEADDRESS_WDT_A__ (__WDT_A_BASE__)
#define __P10_BASE__ (0x40004C81)
#define __P1_BASE__ (0x40004C00)
#define __P2_BASE__ (0x40004C01)
#define __P3_BASE__ (0x40004C20)
#define __P4_BASE__ (0x40004C21)
#define __P5_BASE__ (0x40004C40)
#define __P6_BASE__ (0x40004C41)
#define __P7_BASE__ (0x40004C60)
#define __P8_BASE__ (0x40004C61)
#define __P9_BASE__ (0x40004C80)
#define __PA_BASE__ (0x40004C00)
#define __PB_BASE__ (0x40004C20)
#define __PCM_BASE__ (0x40010000)
#define __PC_BASE__ (0x40004C40)
#define __PD_BASE__ (0x40004C60)
#define __PE_BASE__ (0x40004C80)
#define __PJ_BASE__ (0x40004D20)
#define __PMAP_BASE__ (0x40005000)
#define __PSS_BASE__ (0x40010800)
#define __REF_A_BASE__ (0x40003000)
#define __RSTCTL_BASE__ (0xE0042000)
#define __RTC_C_BASE__ (0x40004400)
#define __SCS_BASE__ (0xE000E000)
#define __SYSCTL_BASE__ (0xE0043000)
#define __T32_BASE__ (0x4000C000)
#define __TA0_BASE__ (0x40000000)
#define __TA1_BASE__ (0x40000400)
#define __TA2_BASE__ (0x40000800)
#define __TA3_BASE__ (0x40000C00)
#define __UDMA_BASE__ (0x4000F000)
#define __WDT_A_BASE__ (0x40004800)
